Package: Rcpi
Type: Package
Version: 1.48.0
Title: Molecular Informatics Toolkit for Compound-Protein Interaction
        in Drug Discovery
Authors@R: c(
    person("Nan", "Xiao", email = "me@nanx.me", role = c("aut", "cre"),
    comment = c(ORCID = "0000-0002-0250-5673")),
    person("Dong-Sheng", "Cao", role = "aut"),
    person("Qing-Song", "Xu", email = "qsxu@csu.edu.cn", role = c("aut"))
    )
Description: A molecular informatics toolkit with an integration of
    bioinformatics and chemoinformatics tools for drug discovery.
License: Artistic-2.0 | file LICENSE
URL: https://nanx.me/Rcpi/, https://github.com/nanxstats/Rcpi
BugReports: https://github.com/nanxstats/Rcpi/issues
Encoding: UTF-8
LazyData: true
VignetteBuilder: knitr
Depends: R (>= 3.0.2)
Imports: Biostrings, GOSemSim, curl, doParallel, foreach, httr2,
        jsonlite, methods, rlang, stats, utils
Suggests: knitr, rmarkdown, testthat (>= 3.0.0)
biocViews: Software, DataImport, DataRepresentation, FeatureExtraction,
        Cheminformatics, BiomedicalInformatics, Proteomics, GO,
        SystemsBiology
Config/testthat/edition: 3
RoxygenNote: 7.3.2
git_url: https://git.bioconductor.org/packages/Rcpi
git_branch: RELEASE_3_23
git_last_commit: 7b08591
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.23
Date/Publication: 2026-04-28
NeedsCompilation: no
Packaged: 2026-04-29 00:08:03 UTC; biocbuild
Author: Nan Xiao [aut, cre] (ORCID: <https://orcid.org/0000-0002-0250-5673>),
  Dong-Sheng Cao [aut],
  Qing-Song Xu [aut]
Maintainer: Nan Xiao <me@nanx.me>

# Rcpi <img src="man/figures/logo.png" align="right" width="120" />

<!-- badges: start -->
[![bioc](https://www.bioconductor.org/shields/years-in-bioc/Rcpi.svg)](https://bioconductor.org/packages/release/bioc/html/Rcpi.html#since)
[![downloads](https://bioconductor.org/shields/downloads/release/Rcpi.svg)](https://bioconductor.org/packages/stats/bioc/Rcpi/)
[![R-CMD-check](https://github.com/nanxstats/Rcpi/actions/workflows/R-CMD-check.yaml/badge.svg)](https://github.com/nanxstats/Rcpi/actions/workflows/R-CMD-check.yaml)
<!-- badges: end -->

## Overview

Rcpi offers a molecular informatics toolkit with a comprehensive integration of bioinformatics and cheminformatics tools for drug discovery. For more information, please see our paper <[DOI:10.1093/bioinformatics/btu624](https://doi.org/10.1093/bioinformatics/btu624)> ([PDF](https://nanx.me/papers/Rcpi.pdf)).

## Paper Citation

Formatted citation:

Dong-Sheng Cao, Nan Xiao, Qing-Song Xu, and Alex F. Chen. (2015). Rcpi: R/Bioconductor package to generate various descriptors of proteins, compounds and their interactions. _Bioinformatics_ 31 (2), 279-281.

BibTeX entry:

```bibtex
@article{Rcpi2015,
  author  = {Cao, Dong-Sheng and Xiao, Nan and Xu, Qing-Song and Chen, Alex F.},
  title   = {{Rcpi: R/Bioconductor package to generate various descriptors of proteins, compounds and their interactions}},
  journal = {Bioinformatics},
  year    = {2015},
  volume  = {31},
  number  = {2},
  pages   = {279--281},
  doi     = {10.1093/bioinformatics/btu624}
}
```

Browse the [workflow](https://nanx.me/Rcpi/articles/Rcpi.html) and
[cheatsheet](https://nanx.me/Rcpi/articles/Rcpi-quickref.html)
vignettes to get started.

## Installation

### Install Rcpi

Install the Rcpi package via BiocManager. If BiocManager is not already installed:

```r
install.packages("BiocManager")
```

Then install Rcpi:

```r
BiocManager::install("Rcpi")
```

### Manage dependencies

Some features in the Rcpi package rely on certain R packages which may
require specific system configurations to install from source.
To make the build process robust, these dependencies have been configured
as runtime dependencies. Here are some instructions for installing such
dependencies to enable the features in Rcpi.

#### Install rcdk

rcdk can be installed from either CRAN or GitHub:

```r
install.packages("rcdk", type = "source")
remotes::install_github("CDK-R/cdkr", subdir = "rcdk")
```

rcdk requires JDK and rJava to be installed and configured on your system.
Check out the [rJava readme](https://github.com/s-u/rJava) for installation
and troubleshooting instructions.

#### Install cheminformatics packages

Additional packages for cheminformatics capabilities are available
from Bioconductor:

```r
BiocManager::install(c("fmcsR", "ChemmineR", "ChemmineOB"))
```

ChemmineOB requires Open Babel to compile from source.
Ensure Open Babel is properly installed on your system.

## Features

Rcpi implemented and integrated the state-of-the-art protein sequence descriptors and molecular descriptors/fingerprints with R. For protein sequences, the Rcpi package could

- Calculate six protein descriptor groups composed of fourteen types of commonly used structural and physicochemical descriptors that include 9920 descriptors.

- Calculate six types of generalized scales-based descriptors derived by various dimensionality reduction methods for proteochemometric (PCM) modeling.

- Parallelized pairwise similarity computation derived by protein sequence alignment and Gene Ontology (GO) semantic similarity measures within a list of proteins.

For small molecules, the Rcpi package could

- Calculate 307 molecular descriptors (2D/3D), including constitutional, topological, geometrical, and electronic descriptors, etc.

- Calculate more than ten types of molecular fingerprints, including FP4 keys, E-state fingerprints, MACCS keys, etc., and parallelized chemical similarity search.

- Parallelized pairwise similarity computation derived by fingerprints and maximum common substructure search within a list of small molecules.

By combining various types of descriptors for drugs and proteins in different methods, interaction descriptors representing protein-protein or compound-protein interactions could be conveniently generated with Rcpi, including:

- Two types of compound-protein interaction (CPI) descriptors

- Three types of protein-protein interaction (PPI) descriptors

Several useful auxiliary utilities are also shipped with Rcpi:

- Parallelized molecule and protein sequence retrieval from several online databases, like PubChem, ChEMBL, KEGG, DrugBank, UniProt, RCSB PDB, etc.

- Loading molecules stored in SMILES/SDF files and loading protein sequences from FASTA/PDB files

- Molecular file format conversion

The computed protein sequence descriptors, molecular descriptors/fingerprints, interaction descriptors and pairwise similarities are widely used in various research fields relevant to drug discovery, primarily bioinformatics, cheminformatics, proteochemometrics, and chemogenomics.

## Contribute

To contribute to this project, please take a look at the
[Contributing Guidelines](https://nanx.me/Rcpi/CONTRIBUTING.html) first.
Please note that the Rcpi project is released with a
[Contributor Code of Conduct](https://nanx.me/Rcpi/CODE_OF_CONDUCT.html).
By contributing to this project, you agree to abide by its terms.

library("magick")
library("showtext")

font_add_google("Zilla Slab", "pf", regular.wt = 500)

hexSticker::sticker(
    subplot = ~ plot.new(), s_x = 1, s_y = 1, s_width = 0.1, s_height = 0.1,
    package = "Rcpi", p_x = 1, p_y = 1, p_size = 11, h_size = 1.2, p_family = "pf",
    p_color = "#7DBC8E", h_fill = "#FFF9F2", h_color = "#7DBC8E",
    dpi = 320, filename = "man/figures/logo.png"
)

image_read("man/figures/logo.png")

rstudioapi::restartSession()

#' Check if the protein sequence's amino acid types are the 20 default types
#'
#' Check if the protein sequence's amino acid types are the 20 default types
#'
#' This function checks if the protein sequence's amino acid types are
#' the 20 default types.
#'
#' @param x A character vector, as the input protein sequence.
#'
#' @return Logical. \code{TRUE} if all of the amino acid types of the sequence
#'         are within the 20 default types.
#'
#' @export checkProt
#'
#' @examples
#' x = readFASTA(system.file('protseq/P00750.fasta', package = 'Rcpi'))[[1]]
#' checkProt(x)  # TRUE
#' checkProt(paste(x, 'Z', sep = ''))  # FALSE

checkProt = function (x) {

    AADict = c('A', 'R', 'N', 'D', 'C', 'E', 'Q', 'G', 'H', 'I',
               'L', 'K', 'M', 'F', 'P', 'S', 'T', 'W', 'Y', 'V')

    return(all(strsplit(x, split = '')[[1]] %in% AADict))

}

#' Descriptor that Calculates the Number of Nonrotatable Bonds on A Molecule
#'
#' Descriptor that Calculates the Number of Nonrotatable Bonds on A Molecule
#'
#' The number of rotatable bonds is given by the SMARTS specified by
#' Daylight on SMARTS tutorial
#' (\url{https://www.daylight.com/dayhtml_tutorials/languages/smarts/smarts_examples.html})
#'
#' @param molecules Parsed molucule object.
#' @param silent Logical. Whether the calculating process
#' should be shown or not, default is \code{TRUE}.
#'
#' @return A data frame, each row represents one of the molecules,
#' each column represents one feature.
#' This function returns one column named \code{nRotB}.
#'
#' @export extractDrugRotatableBondsCount
#'
#' @examples
#' smi = system.file('vignettedata/FDAMDD.smi', package = 'Rcpi')
#' \donttest{
#' mol = readMolFromSmi(smi, type = 'mol')
#' dat = extractDrugRotatableBondsCount(mol)
#' head(dat)}

extractDrugRotatableBondsCount = function (molecules, silent = TRUE) {
    evaluateDescriptor(molecules, type = 'RotatableBondsCountDescriptor', silent = silent)
}

#' Retrieve Drug Molecules in InChI Format from the CAS Database
#'
#' Retrieve Drug Molecules in InChI Format from the CAS Database
#'
#' This function retrieves drug molecules in InChI format from the CAS database.
#' CAS database only provides InChI data, so here we return the molecule
#' in InChI format, users could convert them to SMILES format using
#' Open Babel or other third-party tools.
#'
#' @param id A character vector, as the CAS drug ID.
#' @param parallel An integer, the parallel parameter, indicates how many
#'                 process the user would like to use for retrieving
#'                 the data (using RCurl), default is \code{5}.
#'                 For regular cases, we recommend a number less than \code{20}.
#'
#' @return A length of \code{id} character vector,
#' each element containing the corresponding drug molecule.
#'
#' @seealso See \code{\link{getDrug}} for retrieving drug molecules
#' in MOL and SMILES Format from other databases.
#'
#' @export getMolFromCAS
#'
#' @examples
#' id = '52-67-5'  # Penicillamine
#' \donttest{
#' getMolFromCAS(id)}

getMolFromCAS = function (id, parallel = 5) {

    # CAS only provides InChI, so here we return InChI
    # users could convert to SMILES using Open Babel

    # example id : 52-67-5 (Penicillamine)
    # example url: http://www.chemnet.com/cas/supplier.cgi?terms=52-67-5&exact=dict

    InChIURL = paste0('http://www.chemnet.com/cas/supplier.cgi?terms=', id,
                      '&exact=dict')

    InChITxt = get_url_parallel(url = InChIURL, total_con = parallel)

    n = length(id)
    tmp1 = rep(NA, n)
    tmp2 = rep(NA, n)
    for (i in 1:n) tmp1[i] = strsplit(InChITxt[[i]], 'InChI=')[[1]][2]
    for (i in 1:n) tmp2[i] = strsplit(tmp1[i], '</td>')[[1]][1]

    InChI = paste0('InChI=', tmp2)

    return(InChI)

}

#' Profile-based protein representation derived by PSSM
#' (Position-Specific Scoring Matrix) and auto cross covariance
#'
#' Profile-based protein representation derived by PSSM
#' (Position-Specific Scoring Matrix) and auto cross covariance
#'
#' This function calculates the feature vector based on the PSSM
#' by running PSI-Blast and auto cross covariance tranformation.
#'
#' @param pssmmat The PSSM computed by \code{\link{extractProtPSSM}}.
#' @param lag The lag parameter. Must be less than the number of amino acids
#' in the sequence (i.e. the number of columns in the PSSM matrix).
#'
#' @return A length \code{lag * 20^2} named numeric vector,
#' the element names are derived by the amino acid name abbreviation
#' (crossed amino acid name abbreviation) and lag index.
#'
#' @seealso \link{extractProtPSSM} \link{extractProtPSSMFeature}
#'
#' @export extractProtPSSMAcc
#'
#' @references
#' Wold, S., Jonsson, J., Sjörström, M., Sandberg, M., & Rännar, S. (1993).
#' DNA and peptide sequences and chemical processes multivariately modelled
#' by principal component analysis and partial least-squares projections
#' to latent structures.
#' \emph{Analytica chimica acta}, 277(2), 239--253.
#'
#' @examples
#' x = readFASTA(system.file('protseq/P00750.fasta', package = 'Rcpi'))[[1]]
#' \donttest{
#' dbpath = tempfile('tempdb', fileext = '.fasta')
#' invisible(file.copy(from = system.file('protseq/Plasminogen.fasta', package = 'Rcpi'), to = dbpath))
#' pssmmat = extractProtPSSM(seq = x, database.path = dbpath)
#' pssmacc = extractProtPSSMAcc(pssmmat, lag = 3)
#' tail(pssmacc)}

extractProtPSSMAcc = function(pssmmat, lag) {

    # Normalize PSSM scores to (0, 1)
    mat = 1/(1 + exp(pssmmat))

    accpssm = function (mat, lag) {

        p = nrow(mat)
        n = ncol(mat)

        if (lag > n) stop('lag must be smaller than the amino acids in the sequence')

        # auto covariance: p elements

        acc1 = matrix(0, nrow = p, ncol = lag)

        for (j in 1:p) {
            for (i in 1:lag) {
                acc1[j, i] = sum(mat[j, 1:(n - i)] * mat[j, ((1:(n - i)) + i)]) / (n - i)
            }
        }

        acc1 = as.vector(acc1)

        AADict = c('A', 'R', 'N', 'D', 'C', 'Q', 'E', 'G', 'H', 'I',
                   'L', 'K', 'M', 'F', 'P', 'S', 'T', 'W', 'Y', 'V')
        names(acc1) = as.vector(outer(AADict, paste0('lag', 1:lag),
                                      paste, sep = '.'))

        # auto cross covariance: p^2 - p elements

        acc2 = matrix(0, nrow = p^2 - p, ncol = lag)

        idx = cbind(combn(1:p, 2), combn(1:p, 2)[2:1, ])

        for (j in 1:ncol(idx)) {
            for (i in 1:lag) {
                acc2[j, i] = sum(mat[idx[1, j], 1:(n - i)] * mat[idx[2, j], ((1:(n - i)) + i)]) / (n - i)
            }
        }

        acc2 = as.vector(acc2)
        names(acc2) = as.vector(outer(paste(AADict[idx[1, ]], AADict[idx[2, ]],
                                            sep = '.'),
                                      paste0('lag', 1:lag), paste, sep = '.'))

        ACC = c(acc1, acc2)

        return(ACC)

    }

    result = accpssm(mat, lag)

    return(result)

}

#' CTD Descriptors - Composition
#'
#' CTD Descriptors - Composition
#'
#' This function calculates the Composition descriptor of the
#' CTD descriptors (Dim: 21).
#'
#' @param x A character vector, as the input protein sequence.
#'
#' @return A length 21 named vector
#'
#' @seealso See \code{\link{extractProtCTDT}} and \code{\link{extractProtCTDD}}
#' for the Transition and Distribution descriptors.
#'
#' @export extractProtCTDC
#'
#' @references
#' Inna Dubchak, Ilya Muchink, Stephen R. Holbrook and Sung-Hou Kim.
#' Prediction of protein folding class using global description of
#' amino acid sequence. \emph{Proceedings of the National Academy of Sciences}.
#' USA, 1995, 92, 8700-8704.
#'
#' Inna Dubchak, Ilya Muchink, Christopher Mayor, Igor Dralyuk and Sung-Hou Kim.
#' Recognition of a Protein Fold in the Context of the SCOP classification.
#' \emph{Proteins: Structure, Function and Genetics}, 1999, 35, 401-407.
#'
#' @examples
#' x = readFASTA(system.file('protseq/P00750.fasta', package = 'Rcpi'))[[1]]
#' extractProtCTDC(x)

extractProtCTDC = function (x) {

    if (checkProt(x) == FALSE) stop('x has unrecognized amino acid type')

    group1 = list(
        hydrophobicity  = c('R', 'K', 'E', 'D', 'Q', 'N'),
        normwaalsvolume = c('G', 'A', 'S', 'T', 'P', 'D', 'C'),
        polarity        = c('L', 'I', 'F', 'W', 'C', 'M', 'V', 'Y'),
        polarizability  = c('G', 'A', 'S', 'D', 'T'),
        charge          = c('K', 'R'),
        secondarystruct = c('E', 'A', 'L', 'M', 'Q', 'K', 'R', 'H'),
        solventaccess   = c('A', 'L', 'F', 'C', 'G', 'I', 'V', 'W'))

    group2 = list(
        hydrophobicity  = c('G', 'A', 'S', 'T', 'P', 'H', 'Y'),
        normwaalsvolume = c('N', 'V', 'E', 'Q', 'I', 'L'),
        polarity        = c('P', 'A', 'T', 'G', 'S'),
        polarizability  = c('C', 'P', 'N', 'V', 'E', 'Q', 'I', 'L'),
        charge          = c('A', 'N', 'C', 'Q', 'G', 'H', 'I', 'L',
                            'M', 'F', 'P', 'S', 'T', 'W', 'Y', 'V'),
        secondarystruct = c('V', 'I', 'Y', 'C', 'W', 'F', 'T'),
        solventaccess   = c('R', 'K', 'Q', 'E', 'N', 'D'))

    group3 = list(
        hydrophobicity  = c('C', 'L', 'V', 'I', 'M', 'F', 'W'),
        normwaalsvolume = c('M', 'H', 'K', 'F', 'R', 'Y', 'W'),
        polarity        = c('H', 'Q', 'R', 'K', 'N', 'E', 'D'),
        polarizability  = c('K', 'M', 'H', 'F', 'R', 'Y', 'W'),
        charge          = c('D', 'E'),
        secondarystruct = c('G', 'N', 'P', 'S', 'D'),
        solventaccess   = c('M', 'S', 'P', 'T', 'H', 'Y'))

    xSplitted = strsplit(x, split = '')[[1]]
    n  = nchar(x)

    # Get groups for each property & each amino acid

    g1 = lapply(group1, function(g) length(which(xSplitted %in% g)))
    names(g1) = paste(names(g1), 'Group1', sep = '.')
    g2 = lapply(group2, function(g) length(which(xSplitted %in% g)))
    names(g2) = paste(names(g2), 'Group2', sep = '.')
    g3 = lapply(group3, function(g) length(which(xSplitted %in% g)))
    names(g3) = paste(names(g3), 'Group3', sep = '.')
    CTDC = unlist(c(g1, g2, g3))/n
    ids = unlist(lapply(1:7, function(x) x + c(0, 7, 14)))

    return(CTDC[ids])

}

#' Descriptor that Calculates the Number of Atoms in the Largest Chain
#'
#' Descriptor that Calculates the Number of Atoms in the Largest Chain
#'
#' This descriptor calculates the number of atoms in the largest chain.
#' Note that a chain exists if there are two or more atoms.
#' Thus single atom molecules will return \code{0}.
#'
#' @param molecules Parsed molucule object.
#' @param silent Logical. Whether the calculating process
#' should be shown or not, default is \code{TRUE}.
#'
#' @return A data frame, each row represents one of the molecules,
#' each column represents one feature.
#' This function returns one column named \code{nAtomLC}.
#'
#' @export extractDrugLargestChain
#'
#' @examples
#' smi = system.file('vignettedata/FDAMDD.smi', package = 'Rcpi')
#' \donttest{
#' mol = readMolFromSmi(smi, type = 'mol')
#' dat = extractDrugLargestChain(mol)
#' head(dat)}

extractDrugLargestChain = function (molecules, silent = TRUE) {
    evaluateDescriptor(molecules, type = 'LargestChainDescriptor', silent = silent)
}

#' Scales-Based Descriptors with 20+ classes of Molecular Descriptors
#'
#' Scales-Based Descriptors with 20+ classes of Molecular Descriptors
#'
#' This function calculates the scales-based descriptors with
#' molecular descriptors sets calculated by
#' Dragon, Discovery Studio and MOE.
#' Users could specify which molecular descriptors to select from one of these
#' deseriptor sets by specify the numerical or character index of the
#' molecular descriptors in the descriptor set.
#'
#' @param x A character vector, as the input protein sequence.
#' @param propmat The matrix containing the descriptor set for the amino acids,
#'        which could be chosen from
#'        \code{AAMOE2D}, \code{AAMOE3D}, \code{AACPSA},
#'        \code{AADescAll}, \code{AA2DACOR}, \code{AA3DMoRSE},
#'        \code{AAACF}, \code{AABurden}, \code{AAConn},
#'        \code{AAConst}, \code{AAEdgeAdj}, \code{AAEigIdx},
#'        \code{AAFGC}, \code{AAGeom}, \code{AAGETAWAY},
#'        \code{AAInfo}, \code{AAMolProp}, \code{AARandic},
#'        \code{AARDF}, \code{AATopo}, \code{AATopoChg},
#'        \code{AAWalk}, \code{AAWHIM}.
#' @param index Integer vector or character vector. Specify which molecular
#'        descriptors to select from one of these deseriptor sets by specify the
#'        numerical or character index of the molecular descriptors in the
#'        descriptor set.
#'        Default is \code{NULL}, means selecting all the molecular descriptors
#'        in this descriptor set.
#' @param pc Integer. The maximum dimension of the space which the data
#'        are to be represented in.
#'        Must be no greater than the number of AA properties provided.
#' @param lag The lag parameter. Must be less than the amino acids.
#' @param scale Logical. Should we auto-scale the property matrix
#'        (\code{propmat}) before doing MDS? Default is \code{TRUE}.
#' @param silent Logical. Whether we print the standard deviation,
#'        proportion of variance and the cumulative proportion of
#'        the selected principal components or not.
#'        Default is \code{TRUE}.
#'
#' @return A length \code{lag * p^2} named vector,
#'         \code{p} is the number of scales selected.
#'
#' @seealso See \code{\link{extractPCMScales}} for generalized
#' AA-descriptor based scales descriptors.
#'
#' @export extractPCMDescScales
#'
#' @examples
#' x = readFASTA(system.file('protseq/P00750.fasta', package = 'Rcpi'))[[1]]
#' descscales = extractPCMDescScales(x, propmat = 'AATopo', index = c(37:41, 43:47),
#'                                   pc = 5, lag = 7, silent = FALSE)
#'

extractPCMDescScales = function (x, propmat, index = NULL, pc, lag,
                                 scale = TRUE, silent = TRUE) {

    propmat = get(propmat)
    if (!is.null(index)) propmat = propmat[, index]

    result = extractPCMScales(x = x, propmat = propmat, pc = pc, lag = lag,
                              scale = scale, silent = silent)

    return(result)

}

## ----eval = FALSE-------------------------------------------------------------
# install.packages("BiocManager")
# BiocManager::install("Rcpi")

## ----eval = FALSE-------------------------------------------------------------
# BiocManager::install("Rcpi", dependencies = c("Imports", "Enhances"))

## ----eval = FALSE-------------------------------------------------------------
# library("Rcpi")
# 
# # Load FASTA files
# extracell <- readFASTA(system.file(
#   "vignettedata/extracell.fasta",
#   package = "Rcpi"
# ))
# mitonchon <- readFASTA(system.file(
#   "vignettedata/mitochondrion.fasta",
#   package = "Rcpi"
# ))

## ----eval = FALSE-------------------------------------------------------------
# length(extracell)

## ----eval = FALSE-------------------------------------------------------------
# length(mitonchon)

## ----eval = FALSE-------------------------------------------------------------
# extracell <- extracell[(sapply(extracell, checkProt))]
# mitonchon <- mitonchon[(sapply(mitonchon, checkProt))]

## ----eval = FALSE-------------------------------------------------------------
# length(extracell)

## ----eval = FALSE-------------------------------------------------------------
# length(mitonchon)

## ----eval = FALSE-------------------------------------------------------------
# # Calculate APAAC descriptors
# x1 <- t(sapply(extracell, extractProtAPAAC))
# x2 <- t(sapply(mitonchon, extractProtAPAAC))
# x <- rbind(x1, x2)
# 
# # Make class labels
# labels <- as.factor(c(rep(0, length(extracell)), rep(1, length(mitonchon))))

## ----eval = FALSE-------------------------------------------------------------
# set.seed(1001)
# 
# # Split training and test set
# tr.idx <- c(
#   sample(1:nrow(x1), round(nrow(x1) * 0.75)),
#   sample(nrow(x1) + 1:nrow(x2), round(nrow(x2) * 0.75))
# )
# te.idx <- setdiff(1:nrow(x), tr.idx)
# 
# x.tr <- x[tr.idx, ]
# x.te <- x[te.idx, ]
# y.tr <- labels[tr.idx]
# y.te <- labels[te.idx]

## ----eval = FALSE-------------------------------------------------------------
# library("randomForest")
# rf.fit <- randomForest(x.tr, y.tr, cv.fold = 5)
# print(rf.fit)

## ----eval = FALSE-------------------------------------------------------------
# # Predict on test set
# rf.pred <- predict(rf.fit, newdata = x.te, type = "prob")[, 1]
# 
# # Plot ROC curve
# library("pROC")
# plot.roc(y.te, rf.pred, grid = TRUE, print.auc = TRUE)

## ----echo=FALSE, out.width="65%", fig.cap="Figure 1: ROC curve for the test set of protein subcellular localization data."----
knitr::include_graphics("figures/ex1-1.png")

## ----eval = FALSE-------------------------------------------------------------
# library("Rcpi")
# 
# RI.smi <- system.file(
#   "vignettedata/RI.smi",
#   package = "Rcpi"
# )
# RI.csv <- system.file(
#   "vignettedata/RI.csv",
#   package = "Rcpi"
# )
# 
# x.mol <- readMolFromSmi(RI.smi, type = "mol")
# x.tab <- read.table(RI.csv, sep = "\t", header = TRUE)
# y <- x.tab$RI

## ----eval = FALSE-------------------------------------------------------------
# # Calculate selected molecular descriptors
# x <- suppressWarnings(cbind(
#   extractDrugALOGP(x.mol),
#   extractDrugApol(x.mol),
#   extractDrugECI(x.mol),
#   extractDrugTPSA(x.mol),
#   extractDrugWeight(x.mol),
#   extractDrugWienerNumbers(x.mol),
#   extractDrugZagrebIndex(x.mol)
# ))

## ----eval = FALSE-------------------------------------------------------------
# # Run regression on training set
# library("caret")
# library("pls")
# 
# # Cross-validation settings
# ctrl <- trainControl(
#   method = "repeatedcv", number = 5, repeats = 10,
#   summaryFunction = defaultSummary
# )
# 
# # Train a PLS model
# set.seed(1002)
# pls.fit <- train(
#   x, y,
#   method = "pls", tuneLength = 10, trControl = ctrl,
#   metric = "RMSE", preProc = c("center", "scale")
# )
# 
# # Print cross-validation results
# print(pls.fit)

## ----eval = FALSE-------------------------------------------------------------
# # Number of components vs. RMSE
# print(plot(pls.fit, asp = 0.5))

## ----echo=FALSE, out.width="85%", fig.cap="Figure 2: Number of principal components vs. RMSE for the PLS regression model."----
knitr::include_graphics("figures/ex2-1.png")

## ----eval = FALSE-------------------------------------------------------------
# # Plot experimental RIs vs predicted RIs
# plot(y, predict(pls.fit, x),
#   xlim = range(y), ylim = range(y),
#   xlab = "Experimental RIs", ylab = "Predicted RIs"
# )
# abline(a = 0, b = 1)

## ----echo=FALSE, out.width="65%", fig.cap="Figure 3: Experimental RIs vs. predicted RIs."----
knitr::include_graphics("figures/ex2-2.png")

## ----eval = FALSE-------------------------------------------------------------
# library("Rcpi")
# 
# fdamdd.smi <- system.file("vignettedata/FDAMDD.smi", package = "Rcpi")
# fdamdd.csv <- system.file("vignettedata/FDAMDD.csv", package = "Rcpi")
# 
# x.mol <- readMolFromSmi(fdamdd.smi, type = "mol")
# x.smi <- readMolFromSmi(fdamdd.smi, type = "text")
# y <- as.factor(paste0("class", scan(fdamdd.csv)))

## ----eval = FALSE-------------------------------------------------------------
# # Calculate molecular fingerprints
# x1 <- extractDrugEstateComplete(x.mol)
# x2 <- extractDrugMACCSComplete(x.mol)
# x3 <- extractDrugOBFP4(x.smi, type = "smile")

## ----eval = FALSE-------------------------------------------------------------
# library("caret")
# 
# # Remove near-zero variance variables
# x1 <- x1[, -nearZeroVar(x1)]
# x2 <- x2[, -nearZeroVar(x2)]
# x3 <- x3[, -nearZeroVar(x3)]
# 
# # Split training and test set
# set.seed(1003)
# tr.idx <- sample(1:nrow(x1), round(nrow(x1) * 0.75))
# te.idx <- setdiff(1:nrow(x1), tr.idx)
# x1.tr <- x1[tr.idx, ]
# x1.te <- x1[te.idx, ]
# x2.tr <- x2[tr.idx, ]
# x2.te <- x2[te.idx, ]
# x3.tr <- x3[tr.idx, ]
# x3.te <- x3[te.idx, ]
# y.tr <- y[tr.idx]
# y.te <- y[te.idx]

## ----eval = FALSE-------------------------------------------------------------
# # SVM classification on training sets
# library("kernlab")
# 
# # Cross-validation settings
# ctrl <- trainControl(
#   method = "cv", number = 5, repeats = 10,
#   classProbs = TRUE,
#   summaryFunction = twoClassSummary
# )
# 
# # SVM with RBF kernel
# svm.fit1 <- train(
#   x1.tr, y.tr,
#   method = "svmRadial", trControl = ctrl,
#   metric = "ROC", preProc = c("center", "scale")
# )
# svm.fit2 <- train(
#   x2.tr, y.tr,
#   method = "svmRadial", trControl = ctrl,
#   metric = "ROC", preProc = c("center", "scale")
# )
# svm.fit3 <- train(
#   x3.tr, y.tr,
#   method = "svmRadial", trControl = ctrl,
#   metric = "ROC", preProc = c("center", "scale")
# )
# 
# # Print cross-validation results
# print(svm.fit1)
# print(svm.fit2)
# print(svm.fit3)

## ----eval = FALSE-------------------------------------------------------------
# # Predict on test set
# svm.pred1 <- predict(svm.fit1, newdata = x1.te, type = "prob")[, 1]
# svm.pred2 <- predict(svm.fit2, newdata = x2.te, type = "prob")[, 1]
# svm.pred3 <- predict(svm.fit3, newdata = x3.te, type = "prob")[, 1]
# 
# # Generate colors
# library("RColorBrewer")
# pal <- brewer.pal(3, "Set1")
# 
# # ROC curves of different fingerprints
# library("pROC")
# plot(smooth(roc(y.te, svm.pred1)), col = pal[1], grid = TRUE)
# plot(smooth(roc(y.te, svm.pred2)), col = pal[2], grid = TRUE, add = TRUE)
# plot(smooth(roc(y.te, svm.pred3)), col = pal[3], grid = TRUE, add = TRUE)

## ----echo=FALSE, out.width="65%", fig.cap="Figure 4: Smoothed ROC curves for different fingerprint types."----
knitr::include_graphics("figures/ex3-1.png")

## ----eval = FALSE-------------------------------------------------------------
# library("Rcpi")
# mols <- readMolFromSDF(system.file(
#   "compseq/tyrphostin.sdf",
#   package = "Rcpi"
# ))

## ----eval = FALSE-------------------------------------------------------------
# simmat <- diag(length(mols))
# 
# for (i in 1:length(mols)) {
#   for (j in i:length(mols)) {
#     fp1 <- extractDrugEstate(mols[[i]])
#     fp2 <- extractDrugEstate(mols[[j]])
#     tmp <- calcDrugFPSim(fp1, fp2, fptype = "compact", metric = "tanimoto")
#     simmat[i, j] <- tmp
#     simmat[j, i] <- tmp
#   }
# }

## ----eval = FALSE-------------------------------------------------------------
# mol.hc <- hclust(as.dist(1 - simmat), method = "ward.D")
# 
# library("ape") # Tree visualization of clusters
# clus5 <- cutree(mol.hc, 5) # Cut dendrogram into 5 clusters
# 
# # Generate colors
# library("RColorBrewer")
# pal5 <- brewer.pal(5, "Set1")
# plot(as.phylo(mol.hc),
#   type = "fan",
#   tip.color = pal5[clus5],
#   label.offset = 0.1, cex = 0.7
# )

## ----echo=FALSE, out.width="65%", fig.cap="Figure 5: Tree visualization of the molecular clustering result."----
knitr::include_graphics("figures/ex4-1.png")

## ----eval = FALSE-------------------------------------------------------------
# library("Rcpi")
# 
# mol <- system.file("compseq/DB00530.sdf", package = "Rcpi")
# moldb <- system.file("compseq/tyrphostin.sdf", package = "Rcpi")

## ----eval = FALSE-------------------------------------------------------------
# rank1 <- searchDrug(
#   mol, moldb,
#   cores = 4, method = "fp",
#   fptype = "maccs", fpsim = "tanimoto"
# )
# rank2 <- searchDrug(
#   mol, moldb,
#   cores = 4, method = "fp",
#   fptype = "fp2", fpsim = "cosine"
# )
# rank3 <- searchDrug(
#   mol, moldb,
#   cores = 4, method = "mcs",
#   mcssim = "tanimoto"
# )

## ----eval = FALSE-------------------------------------------------------------
# head(rank1)

## ----eval = FALSE-------------------------------------------------------------
# head(rank2)

## ----eval = FALSE-------------------------------------------------------------
# head(rank3)

## ----eval = FALSE-------------------------------------------------------------
# # Convert SDF format to SMILES format
# convMolFormat(
#   infile = mol, outfile = "DB00530.smi", from = "sdf", to = "smiles"
# )
# convMolFormat(
#   infile = moldb, outfile = "tyrphostin.smi", from = "sdf", to = "smiles"
# )
# 
# smi1 <- readLines("DB00530.smi")
# smi2 <- readLines("tyrphostin.smi")[92] # Select the #92 molecule
# calcDrugMCSSim(smi1, smi2, type = "smile", plot = TRUE)

## ----echo=FALSE, out.width="50%", fig.cap="Figure 6: Maximum common structure of the query molecule and the #92 molecule in the chemical database."----
knitr::include_graphics("figures/ex5-1.png")

## ----eval = FALSE-------------------------------------------------------------
# library("Rcpi")
# 
# gpcr <- read.table(system.file(
#   "vignettedata/GPCR.csv",
#   package = "Rcpi"
# ),
# header = FALSE, as.is = TRUE
# )

## ----eval = FALSE-------------------------------------------------------------
# head(gpcr)

## ----eval = FALSE-------------------------------------------------------------
# library("igraph")
# library("reshape")
# # remotes::install_github("gastonstat/arcdiagram")
# library("arcdiagram")
# 
# g <- graph.data.frame(gpcr[1:(nrow(gpcr) / 2), ], directed = FALSE)
# edgelist <- get.edgelist(g)
# vlabels <- V(g)$name
# vgroups <- c(rep(0, 95), rep(1, 223))
# vfill <- c(rep("#8B91D4", 95), rep("#B2C771", 223))
# vborders <- c(rep("#6F74A9", 95), rep("#8E9F5A", 223))
# degrees <- degree(g)
# 
# xx <- data.frame(vgroups, degrees, vlabels, ind = 1:vcount(g))
# yy <- arrange(xx, desc(vgroups), desc(degrees))
# new.ord <- yy$ind
# 
# arcplot(
#   edgelist,
#   ordering = new.ord, labels = vlabels,
#   cex.labels = 0.1, show.nodes = TRUE,
#   col.nodes = vborders, bg.nodes = vfill,
#   cex.nodes = log10(degrees) + 0.1,
#   pch.nodes = 21, line = -0.5, col.arcs = hsv(0, 0, 0.2, 0.25)
# )

## ----echo=FALSE, out.width="85%", fig.cap="Figure 7: Arc diagram visualization of the GPCR drug-target interaction network."----
knitr::include_graphics("figures/ex6-1.png")

## ----eval = FALSE-------------------------------------------------------------
# library("Rcpi")
# 
# gpcr <- read.table(system.file(
#   "vignettedata/GPCR.csv",
#   package = "Rcpi"
# ),
# header = FALSE, as.is = TRUE
# )
# 
# protid <- unique(gpcr[, 1])
# drugid <- unique(gpcr[, 2])
# 
# protseq <- getSeqFromKEGG(protid, parallel = 5)
# drugseq <- getSmiFromKEGG(drugid, parallel = 50)

## ----eval = FALSE-------------------------------------------------------------
# x0.prot <- cbind(
#   t(sapply(unlist(protseq), extractProtAPAAC)),
#   t(sapply(unlist(protseq), extractProtCTriad))
# )
# 
# x0.drug <- cbind(
#   extractDrugEstateComplete(readMolFromSmi(textConnection(drugseq))),
#   extractDrugMACCSComplete(readMolFromSmi(textConnection(drugseq))),
#   extractDrugOBFP4(drugseq, type = "smile")
# )

## ----eval = FALSE-------------------------------------------------------------
# # Generate drug x / protein x / y
# x.prot <- matrix(NA, nrow = nrow(gpcr), ncol = ncol(x0.prot))
# x.drug <- matrix(NA, nrow = nrow(gpcr), ncol = ncol(x0.drug))
# for (i in 1:nrow(gpcr)) x.prot[i, ] <- x0.prot[which(gpcr[, 1][i] == protid), ]
# for (i in 1:nrow(gpcr)) x.drug[i, ] <- x0.drug[which(gpcr[, 2][i] == drugid), ]
# 
# y <- as.factor(c(rep("pos", nrow(gpcr) / 2), rep("neg", nrow(gpcr) / 2)))

## ----eval = FALSE-------------------------------------------------------------
# x <- getCPI(x.prot, x.drug, type = "combine")

## ----eval = FALSE-------------------------------------------------------------
# library("caret")
# x <- x[, -nearZeroVar(x)]
# 
# # Cross-validation settings
# ctrl <- trainControl(
#   method = "cv", number = 5, repeats = 10,
#   classProbs = TRUE,
#   summaryFunction = twoClassSummary
# )
# 
# # Train a random forest classifier
# library("randomForest")
# 
# set.seed(1006)
# rf.fit <- train(
#   x, y,
#   method = "rf", trControl = ctrl,
#   metric = "ROC", preProc = c("center", "scale")
# )

## ----eval = FALSE-------------------------------------------------------------
# rf.pred <- predict(rf.fit$finalModel, x, type = "prob")[, 1]
# 
# library("pROC")
# plot(smooth(roc(y, rf.pred)), grid = TRUE, print.auc = TRUE)

## ----echo=FALSE, out.width="65%", fig.cap="Figure 8: ROC curve for predicting on the training set of the GPCR drug-target interaction dataset using random forest."----
knitr::include_graphics("figures/ex6-2.png")

#' Calculate Atom Additive logP and Molar Refractivity Values Descriptor
#'
#' Calculate Atom Additive logP and Molar Refractivity Values Descriptor
#'
#' Calculates ALOGP (Ghose-Crippen LogKow) and the Ghose-Crippen molar
#' refractivity as described by Ghose, A.K. and Crippen, G.M.
#' Note the underlying code in CDK assumes that aromaticity
#' has been detected before evaluating this descriptor.
#' The code also expects that the molecule will have
#' hydrogens explicitly set. For SD files, this is
#' usually not a problem since hydrogens are explicit.
#' But for the case of molecules obtained from SMILES,
#' hydrogens must be made explicit.
#'
#' @param molecules Parsed molucule object.
#' @param silent Logical. Whether the calculating process
#' should be shown or not, default is \code{TRUE}.
#'
#' @return A data frame, each row represents one of the molecules,
#' each column represents one feature. This function returns three columns
#' named \code{ALogP}, \code{ALogp2} and \code{AMR}.
#'
#' @export extractDrugALOGP
#'
#' @references
#' Ghose, A.K. and Crippen, G.M. ,
#' Atomic physicochemical parameters for three-dimensional structure-directed
#' quantitative structure-activity relationships.
#' I. Partition coefficients as a measure of hydrophobicity,
#' Journal of Computational Chemistry, 1986, 7:565-577.
#'
#' Ghose, A.K. and Crippen, G.M. ,
#' Atomic physicochemical parameters for three-dimensional-structure-directed
#' quantitative structure-activity relationships.
#' 2. Modeling dispersive and hydrophobic interactions,
#' Journal of Chemical Information and Computer Science, 1987, 27:21-35.
#'
#' @examples
#' smi = system.file('vignettedata/FDAMDD.smi', package = 'Rcpi')
#' \donttest{
#' mol = readMolFromSmi(smi, type = 'mol')
#' dat = extractDrugALOGP(mol)
#' head(dat)}

extractDrugALOGP = function (molecules, silent = TRUE) {
    evaluateDescriptor(molecules, type = 'ALOGPDescriptor', silent = silent)
}

#' Evaluates the Kier and Hall Chi cluster indices of orders 3, 4, 5 and 6
#'
#' Evaluates the Kier and Hall Chi cluster indices of orders 3, 4, 5 and 6
#'
#' Evaluates chi cluster descriptors.
#' It utilizes the graph isomorphism code of the CDK
#' to find fragments matching SMILES strings
#' representing the fragments corresponding to each type of chain.
#'
#' @param molecules Parsed molucule object.
#' @param silent Logical. Whether the calculating process
#' should be shown or not, default is \code{TRUE}.
#'
#' @return A data frame, each row represents one of the molecules,
#' each column represents one feature.
#' This function returns 8 columns,
#' the order and names of the columns returned is:
#' \itemize{
#' \item SC.3 - Simple cluster, order 3
#' \item SC.4 - Simple cluster, order 4
#' \item SC.5 - Simple cluster, order 5
#' \item SC.6 - Simple cluster, order 6
#' \item VC.3 - Valence cluster, order 3
#' \item VC.4 - Valence cluster, order 4
#' \item VC.5 - Valence cluster, order 5
#' \item VC.6 - Valence cluster, order 6
#' }
#'
#' @note These descriptors are calculated using graph isomorphism to identify
#' the various fragments. As a result calculations may be slow.
#' In addition, recent versions of Molconn-Z use simplified fragment
#' definitions (i.e., rings without branches etc.)
#' whereas these descriptors use the older more complex fragment definitions.
#'
#' @export extractDrugChiCluster
#'
#' @examples
#' smi = system.file('vignettedata/FDAMDD.smi', package = 'Rcpi')
#' \donttest{
#' mol = readMolFromSmi(smi, type = 'mol')
#' dat = extractDrugChiCluster(mol)
#' head(dat)}

extractDrugChiCluster = function (molecules, silent = TRUE) {
    evaluateDescriptor(molecules, type = 'ChiClusterDescriptor', silent = silent)
}

#' Descriptor Characterizing the Mass Distribution of the Molecule.
#'
#' Descriptor Characterizing the Mass Distribution of the Molecule.
#'
#' Descriptor characterizing the mass distribution of the molecule described by
#' Katritzky et al. For modelling purposes the value of the descriptor is
#' calculated both with and without H atoms.
#' Furthermore the square and cube roots of the descriptor
#' are also generated as described by Wessel et al.
#'
#' @param molecules Parsed molucule object.
#' @param silent Logical. Whether the calculating process
#' should be shown or not, default is \code{TRUE}.
#'
#' @return A data frame, each row represents one of the molecules,
#' each column represents one feature.
#' This function returns 9 columns:
#' \itemize{
#' \item \code{GRAV.1} - gravitational index of heavy atoms
#' \item \code{GRAV.2} - square root of gravitational index of heavy atoms
#' \item \code{GRAV.3} - cube root of gravitational index of heavy atoms
#' \item \code{GRAVH.1} - gravitational index - hydrogens included
#' \item \code{GRAVH.2} - square root of hydrogen-included gravitational index
#' \item \code{GRAVH.3} - cube root of hydrogen-included gravitational index
#' \item \code{GRAV.4} - grav1 for all pairs of atoms (not just bonded pairs)
#' \item \code{GRAV.5} - grav2 for all pairs of atoms (not just bonded pairs)
#' \item \code{GRAV.6} - grav3 for all pairs of atoms (not just bonded pairs)
#' }
#'
#' @export extractDrugGravitationalIndex
#'
#' @references
#' Katritzky, A.R. and Mu, L. and Lobanov, V.S. and Karelson, M.,
#' Correlation of Boiling Points With Molecular Structure.
#' 1. A Training Set of 298 Diverse Organics and a
#' Test Set of 9 Simple Inorganics,
#' J. Phys. Chem., 1996, 100:10400-10407.
#'
#' Wessel, M.D. and Jurs, P.C. and Tolan, J.W. and Muskal, S.M. ,
#' Prediction of Human Intestinal Absorption of Drug Compounds
#' From Molecular Structure,
#' Journal of Chemical Information and Computer Sciences, 1998, 38:726-735.
#'
#' @examples
#' sdf = system.file('sysdata/OptAA3d.sdf', package = 'Rcpi')
#' \donttest{
#' mol = readMolFromSDF(sdf)
#' dat = extractDrugGravitationalIndex(mol)
#' head(dat)}

extractDrugGravitationalIndex = function (molecules, silent = TRUE) {
    evaluateDescriptor(molecules, type = 'GravitationalIndexDescriptor', silent = silent)
}

#' BCUT -- Eigenvalue Based Descriptor
#'
#' BCUT -- Eigenvalue Based Descriptor
#'
#' Eigenvalue based descriptor noted for its utility in chemical diversity.
#' Described by Pearlman et al.
#' The descriptor is based on a weighted version of the Burden matrix which
#' takes into account both the connectivity as well as atomic properties
#' of a molecule. The weights are a variety of atom properties placed along
#' the diagonal of the Burden matrix.
#' Currently three weighting schemes are employed:
#' \itemize{
#' \item Atomic Weight
#' \item Partial Charge (Gasteiger Marsilli)
#' \item Polarizability (Kang et al.)
#' }
#'
#' @param molecules Parsed molucule object.
#' @param silent Logical. Whether the calculating process
#' should be shown or not, default is \code{TRUE}.
#'
#' @return A data frame, each row represents one of the molecules,
#' each column represents one feature. This function returns 6 columns:
#' \itemize{
#' \item \code{BCUTw-1l, BCUTw-2l ...} - n high lowest atom weighted BCUTS
#' \item \code{BCUTw-1h, BCUTw-2h ...} - n low highest atom weighted BCUTS
#' \item \code{BCUTc-1l, BCUTc-2l ...} - n high lowest partial charge weighted BCUTS
#' \item \code{BCUTc-1h, BCUTc-2h ...} - n low highest partial charge weighted BCUTS
#' \item \code{BCUTp-1l, BCUTp-2l ...} - n high lowest polarizability weighted BCUTS
#' \item \code{BCUTp-1h, BCUTp-2h ...} - n low highest polarizability weighted BCUTS
#' }
#'
#' @export extractDrugBCUT
#'
#' @references
#' Pearlman, R.S. and Smith, K.M.,
#' Metric Validation and the Receptor-Relevant Subspace Concept,
#' J. Chem. Inf. Comput. Sci., 1999, 39:28-35.
#'
#' Burden, F.R., Molecular identification number for substructure searches,
#' J. Chem. Inf. Comput. Sci., 1989, 29:225-227.
#'
#' Burden, F.R., Chemically Intuitive Molecular Index,
#' Quant. Struct. -Act. Relat., 1997, 16:309-314
#'
#' Kang, Y.K. and Jhon, M.S.,
#' Additivity of Atomic Static Polarizabilities and Dispersion Coefficients,
#' Theoretica Chimica Acta, 1982, 61:41-48
#'
#' @note
#' By default, the descriptor will return the highest and lowest eigenvalues
#' for the three classes of descriptor in a single ArrayList
#' (in the order shown above). However it is also possible to supply a parameter
#' list indicating how many of the highest and lowest eigenvalues
#' (for each class of descriptor) are required. The descriptor works with
#' the hydrogen depleted molecule.
#'
#' A side effect of specifying the number of highest and lowest eigenvalues
#' is that it is possible to get two copies of all the eigenvalues. That is,
#' if a molecule has 5 heavy atoms, then specifying the 5 highest eigenvalues
#' returns all of them, and specifying the 5 lowest eigenvalues returns all of
#' them, resulting in two copies of all the eigenvalues.
#'
#' Note that it is possible to specify an arbitrarily large number of
#' eigenvalues to be returned. However if the number (i.e., nhigh or nlow)
#' is larger than the number of heavy atoms, the remaining eignevalues
#' will be \code{NaN}.
#'
#' Given the above description, if the aim is to gt all the eigenvalues for
#' a molecule, you should set nlow to 0 and specify the number of heavy atoms
#' (or some large number) for nhigh (or vice versa).
#'
#' @examples
#' smi = system.file('vignettedata/FDAMDD.smi', package = 'Rcpi')
#' \donttest{
#' mol = readMolFromSmi(smi, type = 'mol')
#' dat = extractDrugBCUT(mol)
#' head(dat)}

extractDrugBCUT = function (molecules, silent = TRUE) {
    evaluateDescriptor(molecules, type = 'BCUTDescriptor', silent = silent)
}

#' Retrieve Protein Sequence in PDB Format from RCSB PDB
#'
#' Retrieve Protein Sequence in PDB Format from RCSB PDB
#'
#' This function retrieves protein sequences in PDB format from RCSB PDB.
#'
#' @param id A character vector, as the protein ID.
#' @param parallel An integer, the parallel parameter, indicates how many
#'                 process the user would like to use for retrieving
#'                 the data (using RCurl), default is \code{5}.
#'                 For regular cases, we recommend a number less than \code{20}.
#'
#' @return A list, each component contains one of the protein sequences
#' in PDB format.
#'
#' @seealso See \code{\link{getSeqFromRCSBPDB}} for retrieving protein
#' represented by amino acid sequence from the RCSB PDB database.
#'
#' @export getPDBFromRCSBPDB
#'
#' @examples
#' id = c('4HHB', '4FF9')
#' \donttest{
#' getPDBFromRCSBPDB(id)}

getPDBFromRCSBPDB = function (id, parallel = 5) {

  # example id : 4HHB
  # example url: https://files.rcsb.org/view/4HHB.pdb

  pdbURL = paste0('https://files.rcsb.org/view/', id, '.pdb')

  pdbTxt = get_url_parallel(url = pdbURL, total_con = parallel)

  return(pdbTxt)

}

#' Retrieve Protein Sequence from RCSB PDB
#'
#' Retrieve Protein Sequence from RCSB PDB
#'
#' This function retrieves protein sequences from RCSB PDB.
#'
#' @param id A character vector, as the protein ID.
#' @param parallel An integer, the parallel parameter, indicates how many
#'                 process the user would like to use for retrieving
#'                 the data (using RCurl), default is \code{5}.
#'                 For regular cases, we recommend a number less than \code{20}.
#'
#' @return A list, each component contains one of the protein represented by
#' amino acid sequence(s).
#'
#' @seealso See \code{\link{getPDBFromRCSBPDB}} for retrieving protein
#' in PDB format from the RCSB PDB database.
#'
#' @export getSeqFromRCSBPDB
#'
#' @examples
#' id = c('4HHB', '4FF9')
#' \donttest{
#' getSeqFromRCSBPDB(id)}

getSeqFromRCSBPDB = function (id, parallel = 5) {

  # example id : 4HHB
  # example url: https://www.rcsb.org/fasta/entry/4HHB/download

  fastaURL = paste0('https://www.rcsb.org/fasta/entry/', id, '/download')

  fastaTxt = get_url_parallel(url = fastaURL, total_con = parallel)

  tmpfile = tempfile(pattern = paste0(id, '-'), fileext = '.fasta')
  for (i in 1:length(id)) write(fastaTxt[[i]], tmpfile[i])

  AASeq = lapply(tmpfile, readFASTA)

  unlink(tmpfile)

  return(AASeq)

}

#' Calculate Drug Molecule Similarity Derived by Molecular Fingerprints
#'
#' Calculate Drug Molecule Similarity Derived by Molecular Fingerprints
#'
#' This function calculate drug molecule fingerprints similarity.
#' Define \code{a} as the features of object A, \code{b} is the
#' features of object B, \code{c} is the number of common features to A and B:
#' \itemize{
#' \item Tanimoto: aka Jaccard - \eqn{c/a+b+c}
#' \item Euclidean: \eqn{\sqrt(a + b)}
#' \item Dice: aka Sorensen, Czekanowski, Hodgkin-Richards -
#' \eqn{c/0.5[(a+c) + (b+c)]}
#' \item Cosine: aka Ochiai, Carbo - \eqn{c/\sqrt((a + c)(b + c))}
#' \item Hamming: aka Manhattan, taxi-cab, city-block distance - \eqn{(a + b)}
#' }
#'
#' @param fp1 The first molecule's fingerprints,
#'            could be extracted by \code{extractDrugMACCS()},
#'            \code{extractDrugMACCSComplete()} etc.
#' @param fp2 The second molecule's fingerprints.
#' @param fptype The fingerprint type, must be one of \code{"compact"} or
#' \code{"complete"}.
#' @param metric The similarity metric,
#'               one of \code{"tanimoto"}, \code{"euclidean"}, \code{"cosine"},
#'               \code{"dice"} and \code{"hamming"}.
#'
#' @return The numeric similarity value.
#'
#' @export calcDrugFPSim
#'
#' @references
#' Gasteiger, Johann, and Thomas Engel, eds.
#' Chemoinformatics. Wiley.com, 2006.
#'
#' @examples
#' \donttest{
#' mols = readMolFromSDF(system.file('compseq/tyrphostin.sdf', package = 'Rcpi'))
#'
#' fp1 = extractDrugEstate(mols[[1]])
#' fp2 = extractDrugEstate(mols[[2]])
#' calcDrugFPSim(fp1, fp2, fptype = 'compact', metric = 'tanimoto')
#' calcDrugFPSim(fp1, fp2, fptype = 'compact', metric = 'euclidean')
#' calcDrugFPSim(fp1, fp2, fptype = 'compact', metric = 'cosine')
#' calcDrugFPSim(fp1, fp2, fptype = 'compact', metric = 'dice')
#' calcDrugFPSim(fp1, fp2, fptype = 'compact', metric = 'hamming')
#'
#' fp3 = extractDrugEstateComplete(mols[[1]])
#' fp4 = extractDrugEstateComplete(mols[[2]])
#' calcDrugFPSim(fp3, fp4, fptype = 'complete', metric = 'tanimoto')
#' calcDrugFPSim(fp3, fp4, fptype = 'complete', metric = 'euclidean')
#' calcDrugFPSim(fp3, fp4, fptype = 'complete', metric = 'cosine')
#' calcDrugFPSim(fp3, fp4, fptype = 'complete', metric = 'dice')
#' calcDrugFPSim(fp3, fp4, fptype = 'complete', metric = 'hamming')}

calcDrugFPSim = function(
    fp1, fp2, fptype = c('compact', 'complete'),
    metric = c('tanimoto', 'euclidean', 'cosine', 'dice', 'hamming')) {

    fptype = match.arg(fptype)
    metric = match.arg(metric)

    if ( !(fptype %in% c('compact', 'complete')) )
        stop('fptype must be one of "compact" or "complete"')
    if ( !(metric %in% c('tanimoto', 'euclidean', 'cosine', 'dice', 'hamming')) )
        stop('metric must be one of "tanimoto", "euclidean", "cosine", "dice", "hamming"')

    if (fptype == 'compact') {
        fp1ext = integer(as.integer(names(fp1)))
        fp1ext[fp1[[1]]] = 1L
        fp2ext = integer(as.integer(names(fp2)))
        fp2ext[fp2[[1]]] = 1L

        fp1 = fp1ext
        fp2 = fp2ext

        if ( length(fp1) != length(fp2) )
            stop('fingerprint vectors must have the same length')

        fp1 = as.logical(fp1)
        fp2 = as.logical(fp2)

        A = sum( (fp1 | fp2) & !fp2 )
        B = sum( (fp1 | fp2) & !fp1 )
        C = sum( fp1 & fp2 )
        D = sum( !(fp1 | fp2) )

        if (metric == 'tanimoto') dis = C/(A + B + C)

        if (metric == 'euclidean') dis = sqrt( (C + D) / (A + B + C + D) )

        if (metric == 'cosine') dis = C / sqrt( ( A + C ) * ( B + C ) )

        if (metric == 'dice') dis = C / ( 0.5 * ( (A + C) + (B + C) ) )

        if (metric == 'hamming') dis = (A + B) / (A + B + C + D)

    }

    if (fptype == 'complete') {

        if ( length(fp1) != length(fp2) )
            stop('fingerprint vectors must have the same length')

        fp1 = as.logical(fp1)
        fp2 = as.logical(fp2)

        A = sum( (fp1 | fp2) & !fp2 )
        B = sum( (fp1 | fp2) & !fp1 )
        C = sum( fp1 & fp2 )
        D = sum( !(fp1 | fp2) )

        if (metric == 'tanimoto') dis = C/(A + B + C)

        if (metric == 'euclidean') dis = sqrt( (C + D) / (A + B + C + D) )

        if (metric == 'cosine') dis = C / sqrt( ( A + C ) * ( B + C ) )

        if (metric == 'dice') dis = C / ( 0.5 * ( (A + C) + (B + C) ) )

        if (metric == 'hamming') dis = (A + B) / (A + B + C + D)

    }

    return(dis)

}

#' Calculate the Kier and Hall Chi Chain Indices of Orders 3, 4, 5, 6 and 7
#'
#' Calculate the Kier and Hall Chi Chain Indices of Orders 3, 4, 5, 6 and 7
#'
#' Evaluates chi chain descriptors.
#' The code currently evluates the simple and valence chi chain descriptors
#' of orders 3, 4, 5, 6 and 7.
#' It utilizes the graph isomorphism code of the CDK to find fragments matching
#' SMILES strings representing the fragments corresponding to each type of chain.
#'
#' @param molecules Parsed molucule object.
#' @param silent Logical. Whether the calculating process
#' should be shown or not, default is \code{TRUE}.
#'
#' @return A data frame, each row represents one of the molecules,
#' each column represents one feature.
#' This function returns 10 columns, in the following order:
#' \itemize{
#' \item \code{SCH.3} - Simple chain, order 3
#' \item \code{SCH.4} - Simple chain, order 4
#' \item \code{SCH.5} - Simple chain, order 5
#' \item \code{SCH.6} - Simple chain, order 6
#' \item \code{SCH.7} - Simple chain, order 7
#' \item \code{VCH.3} - Valence chain, order 3
#' \item \code{VCH.4} - Valence chain, order 4
#' \item \code{VCH.5} - Valence chain, order 5
#' \item \code{VCH.6} - Valence chain, order 6
#' \item \code{VCH.7} - Valence chain, order 7
#' }
#'
#' @note These descriptors are calculated using graph isomorphism to identify
#' the various fragments. As a result calculations may be slow. In addition,
#' recent versions of Molconn-Z use simplified fragment definitions
#' (i.e., rings without branches etc.) whereas these descriptors use
#' the older more complex fragment definitions.
#'
#' @export extractDrugChiChain
#'
#' @examples
#' smi = system.file('vignettedata/FDAMDD.smi', package = 'Rcpi')
#' \donttest{
#' mol = readMolFromSmi(smi, type = 'mol')
#' dat = extractDrugChiChain(mol)
#' head(dat)}

extractDrugChiChain = function (molecules, silent = TRUE) {
    evaluateDescriptor(molecules, type = 'ChiChainDescriptor', silent = silent)
}

#' Calculate the Moreau-Broto Autocorrelation Descriptors using Atomic Weight
#'
#' Calculate the Moreau-Broto Autocorrelation Descriptors using Atomic Weight
#'
#' Calculates the ATS autocorrelation descriptor,
#' where the weight equal to the scaled atomic mass.
#'
#' @param molecules Parsed molucule object.
#' @param silent Logical. Whether the calculating process
#' should be shown or not, default is \code{TRUE}.
#'
#' @return A data frame, each row represents one of the molecules,
#' each column represents one feature. This function returns 5 columns named
#' \code{ATSm1}, \code{ATSm2}, \code{ATSm3}, \code{ATSm4}, \code{ATSm5}.
#'
#' @export extractDrugAutocorrelationMass
#'
#' @references
#' Moreau, Gilles, and Pierre Broto.
#' The autocorrelation of a topological structure: a new molecular descriptor.
#' Nouv. J. Chim 4 (1980): 359-360.
#'
#' @examples
#' smi = system.file('vignettedata/FDAMDD.smi', package = 'Rcpi')
#' \donttest{
#' mol = readMolFromSmi(smi, type = 'mol')
#' dat = extractDrugAutocorrelationMass(mol)
#' head(dat)}

extractDrugAutocorrelationMass = function (molecules, silent = TRUE) {
    evaluateDescriptor(molecules, type = 'AutocorrelationDescriptorMass', silent = silent)
}

#' Descriptor that Calculates the Sum of the Squared Atom Degrees
#' of All Heavy Atoms
#'
#' Descriptor that Calculates the Sum of the Squared Atom Degrees
#' of All Heavy Atoms
#'
#' Zagreb index: the sum of the squares of atom degree over
#' all heavy atoms \code{i}.
#'
#' @param molecules Parsed molucule object.
#' @param silent Logical. Whether the calculating process
#' should be shown or not, default is \code{TRUE}.
#'
#' @return A data frame, each row represents one of the molecules,
#' each column represents one feature.
#' This function returns one column named \code{Zagreb}.
#'
#' @export extractDrugZagrebIndex
#'
#' @examples
#' smi = system.file('vignettedata/FDAMDD.smi', package = 'Rcpi')
#' \donttest{
#' mol = readMolFromSmi(smi, type = 'mol')
#' dat = extractDrugZagrebIndex(mol)
#' head(dat)}

extractDrugZagrebIndex = function (molecules, silent = TRUE) {
    evaluateDescriptor(molecules, type = 'ZagrebIndexDescriptor', silent = silent)
}

#' Calculate Molecular Descriptors Provided by OpenBabel
#'
#' Calculate Molecular Descriptors Provided by OpenBabel
#'
#' This function calculates 14 types of the \emph{numerical}
#' molecular descriptors provided in OpenBabel.
#'
#' @param molecules R character string object containing the molecules.
#' See the example section for details.
#' @param type \code{'smile'} or \code{'sdf'}.
#'
#' @return A data frame, each row represents one of the molecules,
#' each column represents one descriptor.
#' This function returns 14 columns named
#' \code{abonds}, \code{atoms}, \code{bonds}, \code{dbonds},
#' \code{HBA1}, \code{HBA2}, \code{HBD}, \code{logP},
#' \code{MR}, \code{MW}, \code{nF}, \code{sbonds}, \code{tbonds}, \code{TPSA}:
#'         \itemize{
#'         \item \code{abonds} - Number of aromatic bonds
#'         \item \code{atoms} - Number of atoms
#'         \item \code{bonds} - Number of bonds
#'         \item \code{dbonds} - Number of double bonds
#'         \item \code{HBA1} - Number of Hydrogen Bond Acceptors 1
#'         \item \code{HBA2} - Number of Hydrogen Bond Acceptors 2
#'         \item \code{HBD} - Number of Hydrogen Bond Donors
#'         \item \code{logP} - Octanol/Water Partition Coefficient
#'         \item \code{MR} - Molar Refractivity
#'         \item \code{MW} - Molecular Weight Filter
#'         \item \code{nF} - Number of Fluorine Atoms
#'         \item \code{sbonds} - Number of single bonds
#'         \item \code{tbonds} - Number of triple bonds
#'         \item \code{TPSA} - Topological Polar Surface Area
#'         }
#'
#' @export extractDrugDescOB
#'
#' @examples
#' mol1 = 'CC(=O)NCCC1=CNc2c1cc(OC)cc2'  # one molecule SMILE in a vector
#' mol2 = c('OCCc1c(C)[n+](=cs1)Cc2cnc(C)nc(N)2',
#'          'CCc(c1)ccc2[n+]1ccc3c2Nc4c3cccc4',
#'          '[Cu+2].[O-]S(=O)(=O)[O-]')  # multiple SMILEs in a vector
#' mol3 = readChar(system.file('compseq/DB00860.sdf', package = 'Rcpi'),
#'                 nchars = 1e+6)  # single molecule in a sdf file
#' mol4 = readChar(system.file('sysdata/OptAA3d.sdf', package = 'Rcpi'),
#'                 nchars = 1e+6)  # multiple molecules in a sdf file
#'
#' \dontrun{
#' smidesc0 = extractDrugDescOB(mol1, type = 'smile')
#' smidesc1 = extractDrugDescOB(mol2, type = 'smile')
#' sdfdesc0 = extractDrugDescOB(mol3, type = 'sdf')
#' sdfdesc1 = extractDrugDescOB(mol4, type = 'sdf')}

extractDrugDescOB = function (molecules, type = c('smile', 'sdf')) {

    check_ob()

    if (type == 'smile') {

        if ( length(molecules) == 1L ) {

            molRefs = eval(parse(text = "ChemmineOB::forEachMol('SMILES', molecules, identity)"))
            x = eval(parse(text = "ChemmineOB::prop_OB(molRefs)"))

        } else if ( length(molecules) > 1L ) {

            x = matrix(NA, nrow = length(molecules), ncol = 16)

            for ( i in 1:length(molecules) ) {
                molRefs = eval(parse(text = "ChemmineOB::forEachMol('SMILES', molecules[i], identity)"))
                fp[i, ] = eval(parse(text = "ChemmineOB::prop_OB(molRefs)"))
            }

        }

    } else if (type == 'sdf') {

        smi = eval(parse(text = "ChemmineOB::convertFormat(from = 'SDF', to = 'SMILES', source = molecules)"))
        smiclean = strsplit(smi, '\\t.*?\\n')[[1]]

        if ( length(smiclean) == 1L ) {

            molRefs = eval(parse(text = "ChemmineOB::forEachMol('SMILES', smiclean, identity)"))
            fp = eval(parse(text = "ChemmineOB::prop_OB(molRefs)"))

        } else if ( length(smiclean) > 1L ) {

            x = matrix(NA, nrow = length(smiclean), ncol = 16)

            for ( i in 1:length(smiclean) ) {
                molRefs = eval(parse(text = "ChemmineOB::forEachMol('SMILES', smiclean[i], identity)"))
                fp[i, ] = eval(parse(text = "ChemmineOB::prop_OB(molRefs)"))
            }

        }

    } else {

        stop('Molecule type must be "smile" or "sdf"')

    }

    return(x)

}

#' Calculate the PubChem Molecular Fingerprints (in Compact Format)
#'
#' Calculate the PubChem Molecular Fingerprints (in Compact Format)
#'
#' Calculate the 881 bit fingerprints defined by PubChem.
#'
#' @param molecules Parsed molucule object.
#' @param silent Logical. Whether the calculating process
#' should be shown or not, default is \code{TRUE}.
#'
#' @return A list, each component represents one of the molecules, each element
#' in the component represents the index of which element in the fingerprint is 1.
#' Each component's name is the length of the fingerprints.
#'
#' @export extractDrugPubChem
#'
#' @seealso \link{extractDrugPubChemComplete}
#'
#' @examples
#' smi = system.file('vignettedata/FDAMDD.smi', package = 'Rcpi')
#' \donttest{
#' mol = readMolFromSmi(smi, type = 'mol')
#' fp  = extractDrugPubChem(mol)
#' head(fp)}

extractDrugPubChem = function (molecules, silent = TRUE) {

    if (length(molecules) == 1) {

        x = getFingerprint(molecules, type = 'pubchem', silent = silent)

        fp = vector('list', 1)
        fp[[1]] = x@bits
        names(fp) = x@nbit

    } else {

        x = lapply(molecules, getFingerprint, type = 'pubchem', silent = silent)

        fp = vector('list', length(molecules))

        for (i in 1:length(molecules)) {

            fp[[i]] = x[[i]]@bits
            names(fp)[i] = x[[i]]@nbit

        }

    }

    return(fp)

}

#' Calculate the PubChem Molecular Fingerprints (in Complete Format)
#'
#' Calculate the PubChem Molecular Fingerprints (in Complete Format)
#'
#' Calculate the 881 bit fingerprints defined by PubChem.
#'
#' @param molecules Parsed molucule object.
#' @param silent Logical. Whether the calculating process
#' should be shown or not, default is \code{TRUE}.
#'
#' @return An integer vector or a matrix. Each row represents one molecule,
#' the columns represent the fingerprints.
#'
#' @export extractDrugPubChemComplete
#'
#' @seealso \link{extractDrugPubChem}
#'
#' @examples
#' smi = system.file('vignettedata/FDAMDD.smi', package = 'Rcpi')
#' \donttest{
#' mol = readMolFromSmi(smi, type = 'mol')
#' fp  = extractDrugPubChemComplete(mol)
#' dim(fp)}

extractDrugPubChemComplete = function (molecules, silent = TRUE) {

    if (length(molecules) == 1) {

        x = getFingerprint(molecules, type = 'pubchem', silent = silent)

        fp = integer(881)
        fp[x@bits] = 1L

    } else {

        x = lapply(molecules, getFingerprint, type = 'pubchem', silent = silent)

        fp = matrix(0L, nrow = length(molecules), ncol = 881)

        for (i in 1:length(molecules)) fp[ i, x[[i]]@bits ] = 1L

    }

    return(fp)

}

#' Calculate the Descriptor Based on the Number of Bonds of a
#' Certain Bond Order
#'
#' Calculate the Descriptor Based on the Number of Bonds of a
#' Certain Bond Order
#'
#' Calculates the descriptor based on the number of bonds of a
#' certain bond order.
#'
#' @param molecules Parsed molucule object.
#' @param silent Logical. Whether the calculating process
#' should be shown or not, default is \code{TRUE}.
#'
#' @return A data frame, each row represents one of the molecules,
#' each column represents one feature.
#' This function returns one column named \code{nB}.
#'
#' @keywords extractDrugBondCount Bond Count
#'
#' @aliases extractDrugBondCount
#'
#' @author Nan Xiao <\url{https://nanx.me}>
#'
#' @export extractDrugBondCount
#'
#' @importFrom rcdk eval.desc
#'
#' @examples
#' smi = system.file('vignettedata/FDAMDD.smi', package = 'Rcpi')
#' \donttest{
#' mol = readMolFromSmi(smi, type = 'mol')
#' dat = extractDrugBondCount(mol)
#' head(dat)}

extractDrugBondCount = function (molecules, silent = TRUE) {

    x = eval.desc(
        molecules,
        'org.openscience.cdk.qsar.descriptors.molecular.BondCountDescriptor',
        verbose = !silent)

    return(x)

}

#' Generalized BLOSUM and PAM Matrix-Derived Descriptors
#'
#' Generalized BLOSUM and PAM Matrix-Derived Descriptors
#'
#' This function calculates the generalized BLOSUM matrix-derived descriptors.
#' For users' convenience, \code{Rcpi} provides the
#' BLOSUM45, BLOSUM50, BLOSUM62, BLOSUM80, BLOSUM100,
#' PAM30, PAM40, PAM70, PAM120, and PAM250 matrices
#' for the 20 amino acids to select.
#'
#' @param x A character vector, as the input protein sequence.
#' @param submat Substitution matrix for the 20 amino acids. Should be one of
#'        \code{AABLOSUM45}, \code{AABLOSUM50}, \code{AABLOSUM62},
#'        \code{AABLOSUM80}, \code{AABLOSUM100}, \code{AAPAM30},
#'        \code{AAPAM40}, \code{AAPAM70}, \code{AAPAM120}, \code{AAPAM250}.
#'        Default is \code{'AABLOSUM62'}.
#' @param k Integer. The number of selected scales (i.e. the first
#'        \code{k} scales) derived by the substitution matrix.
#'        This could be selected according to the printed relative
#'        importance values.
#' @param lag The lag parameter. Must be less than the amino acids.
#' @param scale Logical. Should we auto-scale the substitution matrix
#'        (\code{submat}) before doing eigen decomposition? Default is
#'        \code{TRUE}.
#' @param silent Logical. Whether we print the relative importance of
#'        each scales (diagnal value of the eigen decomposition result matrix B)
#'        or not.
#'        Default is \code{TRUE}.
#' @return  A length \code{lag * p^2} named vector,
#'         \code{p} is the number of scales selected.
#'
#' @export extractPCMBLOSUM
#'
#' @references
#' Georgiev, A. G. (2009).
#' Interpretable numerical descriptors of amino acid space.
#' Journal of Computational Biology, 16(5), 703--723.
#'
#' @examples
#' x = readFASTA(system.file('protseq/P00750.fasta', package = 'Rcpi'))[[1]]
#' blosum = extractPCMBLOSUM(x, submat = 'AABLOSUM62', k = 5, lag = 7, scale = TRUE, silent = FALSE)
#'

extractPCMBLOSUM = function (x, submat = 'AABLOSUM62', k, lag,
                             scale = TRUE, silent = TRUE) {

    if (checkProt(x) == FALSE) stop('x has unrecognized amino acid type')

    k = min(k, 20)

    submat = get(submat)
    if (scale) submat = scale(submat)

    eig = eigen(submat)
    A = eig$vectors
    B = eig$values
    rownames(A) = rownames(submat)
    # the equation: submat == A %*% diag(B) %*% t(A)

    accmat = matrix(0, k, nchar(x))
    x.split = strsplit(x, '')[[1]]

    for (i in 1:nchar(x)) {
        accmat[, i] = A[x.split[i], 1:k]
    }

    result = acc(accmat, lag)

    if (!silent) {
        cat('Relative importance of all the possible 20 scales:\n')
        print(B)
    }

    return(result)

}

test_that("`extractPCMBLOSUM()` works", {
    x = paste0(
        'MDAMKRGLCCVLLLCGAVFVSPSQEIHARFRRGARSYQVICRDEKTQMIYQQHQSWLRP',
        'VLRSNRVEYCWCNSGRAQCHSVPVKSCSEPRCFNGGTCQQALYFSDFVCQCPEGFAGKCC',
        'EIDTRATCYEDQGISYRGTWSTAESGAECTNWNSSALAQKPYSGRRPDAIRLGLGNHNYC',
        'RNPDRDSKPWCYVFKAGKYSSEFCSTPACSEGNSDCYFGNGSAYRGTHSLTESGASCLPW',
        'NSMILIGKVYTAQNPSAQALGLGKHNYCRNPDGDAKPWCHVLKNRRLTWEYCDVPSCSTC',
        'GLRQYSQPQFRIKGGLFADIASHPWQAAIFAKHRRSPGERFLCGGILISSCWILSAAHCF',
        'QERFPPHHLTVILGRTYRVVPGEEEQKFEVEKYIVHKEFDDDTYDNDIALLQLKSDSSRC',
        'AQESSVVRTVCLPPADLQLPDWTECELSGYGKHEALSPFYSERLKEAHVRLYPSSRCTSQ',
        'HLLNRTVTDNMLCAGDTRSGGPQANLHDACQGDSGGPLVCLNDGRMTLVGIISWGLGCGQ',
        'KDVPGVYTKVTNYLDWIRDNMRP'
    )
    blosum = extractPCMBLOSUM(
        x, submat = 'AABLOSUM62', k = 5, lag = 7,
        scale = TRUE, silent = TRUE
    )
    pam = extractPCMBLOSUM(
        x, submat = 'AAPAM250', k = 3, lag = 9,
        scale = TRUE, silent = TRUE
    )

    expect_equal(length(blosum), 175L)
    expect_equal(length(pam), 81L)
})

test_extractPCMBLOSUM = function() {
    x = paste(
        'MDAMKRGLCCVLLLCGAVFVSPSQEIHARFRRGARSYQVICRDEKTQMIYQQHQSWLRP',
        'VLRSNRVEYCWCNSGRAQCHSVPVKSCSEPRCFNGGTCQQALYFSDFVCQCPEGFAGKCC',
        'EIDTRATCYEDQGISYRGTWSTAESGAECTNWNSSALAQKPYSGRRPDAIRLGLGNHNYC',
        'RNPDRDSKPWCYVFKAGKYSSEFCSTPACSEGNSDCYFGNGSAYRGTHSLTESGASCLPW',
        'NSMILIGKVYTAQNPSAQALGLGKHNYCRNPDGDAKPWCHVLKNRRLTWEYCDVPSCSTC',
        'GLRQYSQPQFRIKGGLFADIASHPWQAAIFAKHRRSPGERFLCGGILISSCWILSAAHCF',
        'QERFPPHHLTVILGRTYRVVPGEEEQKFEVEKYIVHKEFDDDTYDNDIALLQLKSDSSRC',
        'AQESSVVRTVCLPPADLQLPDWTECELSGYGKHEALSPFYSERLKEAHVRLYPSSRCTSQ',
        'HLLNRTVTDNMLCAGDTRSGGPQANLHDACQGDSGGPLVCLNDGRMTLVGIISWGLGCGQ',
        'KDVPGVYTKVTNYLDWIRDNMRP', sep = '')
    blosum = extractPCMBLOSUM(x, submat = 'AABLOSUM62', k = 5, lag = 7,
                              scale = TRUE, silent = TRUE)
    pam = extractPCMBLOSUM(x, submat = 'AAPAM250', k = 3, lag = 9,
                           scale = TRUE, silent = TRUE)
    checkEquals(length(blosum), 175L)
    checkEquals(length(pam), 81L)
}

#' Generalized AA-Properties Based Scales Descriptors
#'
#' Generalized AA-Properties Based Scales Descriptors
#'
#' This function calculates the generalized amino acid properties based
#' scales descriptors.
#' Users could specify which AAindex properties to select from the
#' AAindex database by specify the numerical or character index of
#' the properties in the AAindex database.
#'
#' @param x A character vector, as the input protein sequence.
#' @param index Integer vector or character vector. Specify which
#'        AAindex properties to select from the AAindex database by
#'        specify the numerical or character index of the properties
#'        in the AAindex database.
#'        Default is \code{NULL}, means selecting all the AA properties
#'        in the AAindex database.
#' @param pc Integer. Use the first pc principal components as the scales.
#'        Must be no greater than the number of AA properties provided.
#' @param lag The lag parameter. Must be less than the amino acids.
#' @param scale Logical. Should we auto-scale the property matrix
#'        before PCA? Default is \code{TRUE}.
#' @param silent Logical. Whether we print the standard deviation,
#'        proportion of variance and the cumulative proportion of
#'        the selected principal components or not.
#'        Default is \code{TRUE}.
#'
#' @return A length \code{lag * p^2} named vector,
#'         \code{p} is the number of scales (principal components) selected.
#'
#' @seealso See \code{\link{extractPCMScales}} for
#' generalized scales-based descriptors.
#'
#' @export extractPCMPropScales
#'
#' @examples
#' x = readFASTA(system.file('protseq/P00750.fasta', package = 'Rcpi'))[[1]]
#' propscales = extractPCMPropScales(x, index = c(160:165, 258:296), pc = 5, lag = 7, silent = FALSE)
#'

extractPCMPropScales = function (x, index = NULL, pc, lag,
                                 scale = TRUE, silent = TRUE) {

    aaidx = get('AAindex')
    if (!is.null(index)) propmat = t(na.omit(as.matrix(aaidx[index, 7:26])))

    result = extractPCMScales(x = x, propmat = propmat, pc = pc, lag = lag,
                              scale = scale, silent = silent)

    return(result)

}

#' Calculate Complexity of a System
#'
#' Calculate Complexity of a System
#'
#' This descriptor calculates the complexity of a system.
#' The complexity is defined in Nilakantan, R. et al. as:
#' \deqn{C = abs(B^2 - A^2 + A) + \frac{H}{100}}
#' where C is complexity, A is the number of non-hydrogen atoms,
#' B is the number of bonds and H is the number of heteroatoms.
#'
#' @param molecules Parsed molucule object.
#' @param silent Logical. Whether the calculating process
#' should be shown or not, default is \code{TRUE}.
#'
#' @return A data frame, each row represents one of the molecules,
#' each column represents one feature.
#' This function returns one column named \code{fragC}.
#'
#' @export extractDrugFragmentComplexity
#'
#' @references
#' Nilakantan, R. and Nunn, D.S. and Greenblatt,
#' L. and Walker, G. and Haraki, K. and Mobilio, D.,
#' A family of ring system-based structural fragments
#' for use in structure-activity studies:
#' database mining and recursive partitioning.,
#' Journal of chemical information and modeling, 2006, 46:1069-1077
#'
#' @examples
#' smi = system.file('vignettedata/FDAMDD.smi', package = 'Rcpi')
#' \donttest{
#' mol = readMolFromSmi(smi, type = 'mol')
#' dat = extractDrugFragmentComplexity(mol)
#' head(dat)}

extractDrugFragmentComplexity = function (molecules, silent = TRUE) {
    evaluateDescriptor(molecules, type = 'FragmentComplexityDescriptor', silent = silent)
}

#' Descriptor that Calculates the Weighted Path (Molecular ID)
#'
#' Descriptor that Calculates the Weighted Path (Molecular ID)
#'
#' This descriptor calculates the weighted path (molecular ID)
#' described by Randic, characterizing molecular branching.
#' Five descriptors are calculated, based on the implementation in the ADAPT
#' software package. Note that the descriptor is based on identifying all paths
#' between pairs of atoms and so is NP-hard.
#' This means that it can take some time for large, complex molecules.
#'
#' @param molecules Parsed molucule object.
#' @param silent Logical. Whether the calculating process
#' should be shown or not, default is \code{TRUE}.
#'
#' @return A data frame, each row represents one of the molecules,
#' each column represents one feature.
#' This function returns 5 columns named
#' \code{WTPT.1}, \code{WTPT.2}, \code{WTPT.3}, \code{WTPT.4}, \code{WTPT.5}:
#' \itemize{
#' \item \code{WTPT.1} - molecular ID
#' \item \code{WTPT.2} - molecular ID / number of atoms
#' \item \code{WTPT.3} - sum of path lengths starting from heteroatoms
#' \item \code{WTPT.4} - sum of path lengths starting from oxygens
#' \item \code{WTPT.5} - sum of path lengths starting from nitrogens
#' }
#'
#' @export extractDrugWeightedPath
#'
#' @references
#' Randic, M., On molecular identification numbers (1984).
#' Journal of Chemical Information and Computer Science, 24:164-175.
#'
#' @examples
#' smi = system.file('vignettedata/FDAMDD.smi', package = 'Rcpi')
#' \donttest{
#' mol = readMolFromSmi(smi, type = 'mol')
#' dat = extractDrugWeightedPath(mol)
#' head(dat)}

extractDrugWeightedPath = function (molecules, silent = TRUE) {
    evaluateDescriptor(molecules, type = 'WeightedPathDescriptor', silent = silent)
}

#' Read Molecules from SDF Files and Return Parsed Java Molecular Object
#'
#' Read Molecules from SDF Files and Return Parsed Java Molecular Object
#'
#' This function reads molecules from SDF files and return
#' parsed Java molecular object needed by \code{extractDrug...} functions.
#'
#' @param sdffile Character vector, containing SDF file location(s).
#'
#' @return A list, containing parsed Java molecular object.
#'
#' @seealso See \code{\link{readMolFromSmi}} for reading molecules by SMILES
#' string and returning parsed Java molecular object.
#'
#' @export readMolFromSDF
#'
#' @examples
#' sdf  = system.file('compseq/DB00859.sdf', package = 'Rcpi')
#' sdfs = c(system.file('compseq/DB00859.sdf', package = 'Rcpi'),
#'          system.file('compseq/DB00860.sdf', package = 'Rcpi'))
#' \donttest{
#' mol  = readMolFromSDF(sdf)
#' mols = readMolFromSDF(sdfs)}

readMolFromSDF = function (sdffile) {

  mol = loadMolecules(normalizePath(sdffile))

  return(mol)

}

#' Descriptor that Counts the Number of Occurrences of the E-State Fragments
#'
#' Descriptor that Counts the Number of Occurrences of the E-State Fragments
#'
#' A fragment count descriptor that uses e-state fragments.
#' Traditionally the e-state descriptors identify the relevant
#' fragments and then evaluate the actual e-state value.
#' However it has been shown in Butina et al.
#' that simply using the counts of the e-state fragments can
#' lead to QSAR models that exhibit similar performance to those
#' built using the actual e-state indices.
#'
#' Atom typing and aromaticity perception should be
#' performed prior to calling this descriptor.
#' The atom type definitions are taken from Hall et al.
#' The SMARTS definitions were obtained from RDKit.
#'
#' @param molecules Parsed molucule object.
#' @param silent Logical. Whether the calculating process
#' should be shown or not, default is \code{TRUE}.
#'
#' @return A data frame, each row represents one of the molecules,
#' each column represents one feature.
#' This function returns 79 columns:
#' \tabular{ccc}{
#' ID \tab Name \tab Pattern\cr
#' \code{0} \tab \code{khs.sLi} \tab \code{[LiD1]-*}\cr
#' \code{1} \tab \code{khs.ssBe} \tab \code{[BeD2](-*)-*}\cr
#' \code{2} \tab \code{khs.ssssBe} \tab \code{[BeD4](-*)(-*)(-*)-*}\cr
#' \code{3} \tab \code{khs.ssBH} \tab \code{[BD2H](-*)-*}\cr
#' \code{4} \tab \code{khs.sssB} \tab \code{[BD3](-*)(-*)-*}\cr
#' \code{5} \tab \code{khs.ssssB} \tab \code{[BD4](-*)(-*)(-*)-*}\cr
#' \code{6} \tab \code{khs.sCH3} \tab \code{[CD1H3]-*}\cr
#' \code{7} \tab \code{khs.dCH2} \tab \code{[CD1H2]=*}\cr
#' \code{8} \tab \code{khs.ssCH2} \tab \code{[CD2H2](-*)-*}\cr
#' \code{9} \tab \code{khs.tCH} \tab \code{[CD1H]#*}\cr
#' \code{10} \tab \code{khs.dsCH} \tab \code{[CD2H](=*)-*}\cr
#' \code{11} \tab \code{khs.aaCH} \tab \code{[C,c;D2H](:*):*}\cr
#' \code{12} \tab \code{khs.sssCH} \tab \code{[CD3H](-*)(-*)-*}\cr
#' \code{13} \tab \code{khs.ddC} \tab \code{[CD2H0](=*)=*}\cr
#' \code{14} \tab \code{khs.tsC} \tab \code{[CD2H0](#*)-*}\cr
#' \code{15} \tab \code{khs.dssC} \tab \code{[CD3H0](=*)(-*)-*}\cr
#' \code{16} \tab \code{khs.aasC} \tab \code{[C,c;D3H0](:*)(:*)-*}\cr
#' \code{17} \tab \code{khs.aaaC} \tab \code{[C,c;D3H0](:*)(:*):*}\cr
#' \code{18} \tab \code{khs.ssssC} \tab \code{[CD4H0](-*)(-*)(-*)-*}\cr
#' \code{19} \tab \code{khs.sNH3} \tab \code{[ND1H3]-*}\cr
#' \code{20} \tab \code{khs.sNH2} \tab \code{[ND1H2]-*}\cr
#' \code{21} \tab \code{khs.ssNH2} \tab \code{[ND2H2](-*)-*}\cr
#' \code{22} \tab \code{khs.dNH} \tab \code{[ND1H]=*}\cr
#' \code{23} \tab \code{khs.ssNH} \tab \code{[ND2H](-*)-*}\cr
#' \code{24} \tab \code{khs.aaNH} \tab \code{[N,nD2H](:*):*}\cr
#' \code{25} \tab \code{khs.tN} \tab \code{[ND1H0]#*}\cr
#' \code{26} \tab \code{khs.sssNH} \tab \code{[ND3H](-*)(-*)-*}\cr
#' \code{27} \tab \code{khs.dsN} \tab \code{[ND2H0](=*)-*}\cr
#' \code{28} \tab \code{khs.aaN} \tab \code{[N,nD2H0](:*):*}\cr
#' \code{29} \tab \code{khs.sssN} \tab \code{[ND3H0](-*)(-*)-*}\cr
#' \code{30} \tab \code{khs.ddsN} \tab \code{[ND3H0](~[OD1H0])(~[OD1H0])-,:*}\cr
#' \code{31} \tab \code{khs.aasN} \tab \code{[N,nD3H0](:*)(:*)-,:*}\cr
#' \code{32} \tab \code{khs.ssssN} \tab \code{[ND4H0](-*)(-*)(-*)-*}\cr
#' \code{33} \tab \code{khs.sOH} \tab \code{[OD1H]-*}\cr
#' \code{34} \tab \code{khs.dO} \tab \code{[OD1H0]=*}\cr
#' \code{35} \tab \code{khs.ssO} \tab \code{[OD2H0](-*)-*}\cr
#' \code{36} \tab \code{khs.aaO} \tab \code{[O,oD2H0](:*):*}\cr
#' \code{37} \tab \code{khs.sF} \tab \code{[FD1]-*}\cr
#' \code{38} \tab \code{khs.sSiH3} \tab \code{[SiD1H3]-*}\cr
#' \code{39} \tab \code{khs.ssSiH2} \tab \code{[SiD2H2](-*)-*}\cr
#' \code{40} \tab \code{khs.sssSiH} \tab \code{[SiD3H1](-*)(-*)-*}\cr
#' \code{41} \tab \code{khs.ssssSi} \tab \code{[SiD4H0](-*)(-*)(-*)-*}\cr
#' \code{42} \tab \code{khs.sPH2} \tab \code{[PD1H2]-*}\cr
#' \code{43} \tab \code{khs.ssPH} \tab \code{[PD2H1](-*)-*}\cr
#' \code{44} \tab \code{khs.sssP} \tab \code{[PD3H0](-*)(-*)-*}\cr
#' \code{45} \tab \code{khs.dsssP} \tab \code{[PD4H0](=*)(-*)(-*)-*}\cr
#' \code{46} \tab \code{khs.sssssP} \tab \code{[PD5H0](-*)(-*)(-*)(-*)-*}\cr
#' \code{47} \tab \code{khs.sSH} \tab \code{[SD1H1]-*}\cr
#' \code{48} \tab \code{khs.dS} \tab \code{[SD1H0]=*}\cr
#' \code{49} \tab \code{khs.ssS} \tab \code{[SD2H0](-*)-*}\cr
#' \code{50} \tab \code{khs.aaS} \tab \code{[S,sD2H0](:*):*}\cr
#' \code{51} \tab \code{khs.dssS} \tab \code{[SD3H0](=*)(-*)-*}\cr
#' \code{52} \tab \code{khs.ddssS} \tab \code{[SD4H0](~[OD1H0])(~[OD1H0])(-*)-*}\cr
#' \code{53} \tab \code{khs.sCl} \tab \code{[ClD1]-*}\cr
#' \code{54} \tab \code{khs.sGeH3} \tab \code{[GeD1H3](-*)}\cr
#' \code{55} \tab \code{khs.ssGeH2} \tab \code{[GeD2H2](-*)-*}\cr
#' \code{56} \tab \code{khs.sssGeH} \tab \code{[GeD3H1](-*)(-*)-*}\cr
#' \code{57} \tab \code{khs.ssssGe} \tab \code{[GeD4H0](-*)(-*)(-*)-*}\cr
#' \code{58} \tab \code{khs.sAsH2} \tab \code{[AsD1H2]-*}\cr
#' \code{59} \tab \code{khs.ssAsH} \tab \code{[AsD2H1](-*)-*}\cr
#' \code{60} \tab \code{khs.sssAs} \tab \code{[AsD3H0](-*)(-*)-*}\cr
#' \code{61} \tab \code{khs.sssdAs} \tab \code{[AsD4H0](=*)(-*)(-*)-*}\cr
#' \code{62} \tab \code{khs.sssssAs} \tab \code{[AsD5H0](-*)(-*)(-*)(-*)-*}\cr
#' \code{63} \tab \code{khs.sSeH} \tab \code{[SeD1H1]-*}\cr
#' \code{64} \tab \code{khs.dSe} \tab \code{[SeD1H0]=*}\cr
#' \code{65} \tab \code{khs.ssSe} \tab \code{[SeD2H0](-*)-*}\cr
#' \code{66} \tab \code{khs.aaSe} \tab \code{[SeD2H0](:*):*}\cr
#' \code{67} \tab \code{khs.dssSe} \tab \code{[SeD3H0](=*)(-*)-*}\cr
#' \code{68} \tab \code{khs.ddssSe} \tab \code{[SeD4H0](=*)(=*)(-*)-*}\cr
#' \code{69} \tab \code{khs.sBr} \tab \code{[BrD1]-*}\cr
#' \code{70} \tab \code{khs.sSnH3} \tab \code{[SnD1H3]-*}\cr
#' \code{71} \tab \code{khs.ssSnH2} \tab \code{[SnD2H2](-*)-*}\cr
#' \code{72} \tab \code{khs.sssSnH} \tab \code{[SnD3H1](-*)(-*)-*}\cr
#' \code{73} \tab \code{khs.ssssSn} \tab \code{[SnD4H0](-*)(-*)(-*)-*}\cr
#' \code{74} \tab \code{khs.sI} \tab \code{[ID1]-*}\cr
#' \code{75} \tab \code{khs.sPbH3} \tab \code{[PbD1H3]-*}\cr
#' \code{76} \tab \code{khs.ssPbH2} \tab \code{[PbD2H2](-*)-*}\cr
#' \code{77} \tab \code{khs.sssPbH} \tab \code{[PbD3H1](-*)(-*)-*}\cr
#' \code{78} \tab \code{khs.ssssPb} \tab \code{[PbD4H0](-*)(-*)(-*)-*}
#' }
#'
#' @export extractDrugKierHallSmarts
#'
#' @references
#' Butina, D. ,
#' Performance of Kier-Hall E-state Descriptors
#' in Quantitative Structure Activity Relationship (QSAR)
#' Studies of Multifunctional Molecules,
#' Molecules, 2004, 9:1004-1009.
#'
#' Hall, L.H. and Kier, L.B. ,
#' Electrotopological State Indices for Atom Types:
#' A Novel Combination of Electronic, Topological,
#' and Valence State Information,
#' Journal of Chemical Information and Computer Science, 1995, 35:1039-1045.
#'
#' @examples
#' smi = system.file('vignettedata/FDAMDD.smi', package = 'Rcpi')
#' \donttest{
#' mol = readMolFromSmi(smi, type = 'mol')
#' dat = extractDrugKierHallSmarts(mol)
#' head(dat)}

extractDrugKierHallSmarts = function (molecules, silent = TRUE) {
    evaluateDescriptor(molecules, type = 'KierHallSmartsDescriptor', silent = silent)
}

#' Calculate Drug Molecule Similarity Derived by
#' Maximum Common Substructure Search
#'
#' Calculate Drug Molecule Similarity Derived by
#' Maximum Common Substructure Search
#'
#' This function calculate drug molecule similarity derived by
#' maximum common substructure search. The maximum common substructure
#' search algorithm is provided by the \code{fmcsR} package.
#'
#' @param mol1 The first molecule. R character string object
#' containing the molecule. See examples.
#' @param mol2 The second molecule. R character string object
#' containing the molecule. See examples.
#' @param type The input molecule format, 'smile' or 'sdf'.
#' @param plot Logical. Should we plot the two molecules and
#' their maximum common substructure?
#' @param al Lower bound for the number of atom mismatches. Default is 0.
#' @param au Upper bound for the number of atom mismatches. Default is 0.
#' @param bl Lower bound for the number of bond mismatches. Default is 0.
#' @param bu Upper bound for the number of bond mismatches. Default is 0.
#' @param matching.mode Three modes for bond matching are supported:
#'                      \code{'static'}, \code{'aromatic'}, and \code{'ring'}.
#' @param ... Other graphical parameters
#'
#' @return A list containing the detail MCS information and similarity values.
#'         The numeric similarity value includes Tanimoto coefficient
#'         and overlap coefficient.
#'
#' @export calcDrugMCSSim
#'
#' @references
#' Wang, Y., Backman, T. W., Horan, K., & Girke, T. (2013).
#' fmcsR: mismatch tolerant maximum common substructure searching in R.
#' Bioinformatics, 29(21), 2792--2794.
#'
#' @examples
#' mol1 = 'CC(C)CCCCCC(=O)NCC1=CC(=C(C=C1)O)OC'
#' mol2 = 'O=C(NCc1cc(OC)c(O)cc1)CCCC/C=C/C(C)C'
#' mol3 = readChar(system.file('compseq/DB00859.sdf', package = 'Rcpi'), nchars = 1e+6)
#' mol4 = readChar(system.file('compseq/DB00860.sdf', package = 'Rcpi'), nchars = 1e+6)
#' \dontrun{
#' sim1 = calcDrugMCSSim(mol1, mol2, type = 'smile')
#' sim2 = calcDrugMCSSim(mol3, mol4, type = 'sdf', plot = TRUE)
#' print(sim1[[2]])  # Tanimoto Coefficient
#' print(sim2[[3]])  # Overlap Coefficient
#' }

calcDrugMCSSim = function(
    mol1, mol2, type = c('smile', 'sdf'), plot = FALSE,
    al = 0, au = 0, bl = 0, bu = 0,
    matching.mode = 'static', ...) {

    if (!is_pkg_available("ChemmineR")) {
        stop ("Must install the `ChemmineR` package to calculate the similarity.", call. = FALSE)
    }

    if (!is_pkg_available("fmcsR")) {
        stop ("Must install the `fmcsR` package to calculate the similarity.", call. = FALSE)
    }

    if (type == 'smile') {

        # smile to sdfset
        sdfset1 = eval(parse(text = "ChemmineR::smiles2sdf(mol1)"))
        sdfset2 = eval(parse(text = "ChemmineR::smiles2sdf(mol2)"))

    } else if (type == 'sdf') {

        # sdf to sdfset
        sdfstr1 = eval(parse(text = "ChemmineR::read.SDFstr(textConnection(mol1))"))
        sdfstr2 = eval(parse(text = "ChemmineR::read.SDFstr(textConnection(mol2))"))
        sdfset1 = as(sdfstr1, 'SDFset')
        sdfset2 = as(sdfstr2, 'SDFset')

    } else {

        stop('Molecule type must be "smile" or "sdf"')

    }

    mcs = eval(parse(text = "fmcsR::fmcs(sdfset1, sdfset2, al = al, au = au, bl = bl, bu = bu, matching.mode = matching.mode, fast = FALSE)"))

    if (plot == TRUE) eval(parse(text = "fmcsR::plotMCS(mcs, ...)"))

    x = list(mcs,
             mcs@stats['Tanimoto_Coefficient'],
             mcs@stats['Overlap_Coefficient'])

    return(x)

}

#' Descriptor that Calculates the LogP Based on a Simple Equation
#' Using the Number of Carbons and Hetero Atoms
#'
#' Descriptor that Calculates the LogP Based on a Simple Equation
#' Using the Number of Carbons and Hetero Atoms
#'
#' This descriptor calculates the LogP based on a simple equation using
#' the number of carbons and hetero atoms.
#' The implemented equation was proposed in Mannhold et al.
#'
#' @param molecules Parsed molucule object.
#' @param silent Logical. Whether the calculating process
#' should be shown or not, default is \code{TRUE}.
#'
#' @return A data frame, each row represents one of the molecules,
#' each column represents one feature.
#' This function returns one column named \code{MLogP}.
#'
#' @export extractDrugMannholdLogP
#'
#' @references
#' Mannhold, R., Poda, G. I., Ostermann, C., & Tetko, I. V. (2009).
#' Calculation of molecular lipophilicity: State-of-the-art and
#' comparison of log P methods on more than 96,000 compounds.
#' Journal of pharmaceutical sciences, 98(3), 861-893.
#'
#' @examples
#' smi = system.file('vignettedata/FDAMDD.smi', package = 'Rcpi')
#' \donttest{
#' mol = readMolFromSmi(smi, type = 'mol')
#' dat = extractDrugMannholdLogP(mol)
#' head(dat)}

extractDrugMannholdLogP = function (molecules, silent = TRUE) {
    evaluateDescriptor(molecules, type = 'MannholdLogPDescriptor', silent = silent)
}

.orgdb = c(
    'anopheles' = 'org.Ag.eg.db',
    'arabidopsis' = 'org.At.tair.db',
    'bovine' = 'org.Bt.eg.db',
    'canine' = 'org.Cf.eg.db',
    'chicken' = 'org.Gg.eg.db',
    'chimp' = 'org.Pt.eg.db',
    'coelicolor' = 'org.Sco.eg.db',
    'ecolik12' = 'org.EcK12.eg.db',
    'ecsakai' = 'org.EcSakai.eg.db',
    'fly' = 'org.Dm.eg.db',
    'human' = 'org.Hs.eg.db',
    'malaria' = 'org.Pf.plasmo.db',
    'mouse' = 'org.Mm.eg.db',
    'pig' = 'org.Ss.eg.db',
    'rat' = 'org.Rn.eg.db',
    'rhesus' = 'org.Mmu.eg.db',
    'worm' = 'org.Ce.eg.db',
    'xenopus' = 'org.Xl.eg.db',
    'yeast' = 'org.Sc.sgd.db',
    'zebrafish' = 'org.Dr.eg.db'
)

.calcgoPairSim = function(twoid, golist, godb, measure, combine) {

    id1 = twoid[1]
    id2 = twoid[2]

    if ( all(golist[[id1]] == '') | all(golist[[id2]] == '') ) {

        sim = 0L

    } else {

        id1good = 1:length(golist[[id1]])
        id2good = 1:length(golist[[id2]])

        gid1 = as.character(golist[[id1]][id1good])
        gid2 = as.character(golist[[id2]][id2good])

        res = try(suppressWarnings(GOSemSim::mgoSim(
            gid1, gid2, semData = godb, measure = measure, combine = combine
        )),
        silent = TRUE)

        if ( is.numeric(res) ) {
            sim = res
        } else {
            sim = 0L
        }

    }

    sim

}

#' Protein Sequence Similarity Calculation based on Gene Ontology (GO) Similarity
#'
#' Protein Sequence Similarity Calculation based on Gene Ontology (GO) Similarity
#'
#' This function calculates
#' protein sequence similarity based on Gene Ontology (GO) similarity.
#'
#' @param golist A character vector, each component contains
#' a character vector of GO terms or one Entrez Gene ID.
#' @param type Input type of \code{golist}, \code{'go'} for GO Terms,
#' \code{'gene'} for gene ID.
#' @param ont Default is \code{'MF'}, could be one of
#' \code{'MF'}, \code{'BP'}, or \code{'CC'} subontologies.
#' @param organism Default is \code{'human'}, could be one of
#' \code{'anopheles'}, \code{'arabidopsis'}, \code{'bovine'}, \code{'canine'},
#' \code{'chicken'}, \code{'chimp'}, \code{'coelicolor'}, \code{'ecolik12'},
#' \code{'ecsakai'}, \code{'fly'}, \code{'human'}, \code{'malaria'},
#' \code{'mouse'}, \code{'pig'}, \code{'rat'}, \code{'rhesus'},
#' \code{'worm'}, \code{'xenopus'}, \code{'yeast'} or \code{'zebrafish'}.
#' @param measure Default is \code{'Resnik'}, could be one of
#' \code{'Resnik'}, \code{'Lin'}, \code{'Rel'}, \code{'Jiang'} or \code{'Wang'}.
#' @param combine Default is \code{'BMA'}, could be one of
#' \code{'max'}, \code{'average'}, \code{'rcmax'} or \code{'BMA'}
#' for combining semantic similarity scores of multiple GO terms
#' associated with protein.
#' @return A \code{n} x \code{n} similarity matrix.
#'
#' @seealso See \code{\link{calcTwoProtGOSim}} for calculating the
#' GO semantic similarity between two groups of GO terms or two Entrez gene IDs.
#' See \code{\link{calcParProtSeqSim}} for paralleled protein similarity
#' calculation based on sequence alignment.
#'
#' @export calcParProtGOSim
#'
#' @examples
#' # By GO Terms
#' go1 = c('GO:0005215', 'GO:0005488', 'GO:0005515', 'GO:0005625', 'GO:0005802', 'GO:0005905')  # AP4B1
#' go2 = c('GO:0005515', 'GO:0005634', 'GO:0005681', 'GO:0008380', 'GO:0031202')  # BCAS2
#' go3 = c('GO:0003735', 'GO:0005622', 'GO:0005840', 'GO:0006412')  # PDE4DIP
#' glist = list(go1, go2, go3)
#' \donttest{calcParProtGOSim(glist, type = 'go', ont = 'CC', measure = 'Wang')}
#'
#' # By Entrez gene id
#' genelist = list(c('150', '151', '152', '1814', '1815', '1816'))
#' \donttest{calcParProtGOSim(genelist, type = 'gene', ont = 'BP', measure = 'Wang')}

calcParProtGOSim = function(
    golist, type = c('go', 'gene'),
    ont = c('MF', 'BP', 'CC'), organism = 'human',
    measure = 'Resnik', combine = 'BMA') {

    type = match.arg(type)
    ont = match.arg(ont)

    godb = suppressMessages(GOSemSim::godata(OrgDb = .orgdb[organism], ont = ont, computeIC = TRUE))

    if ( type == 'gene' ) {
        gosimmat = GOSemSim::mgeneSim(
            unlist(golist), godb,
            measure = measure, combine = combine, verbose = FALSE)
    }

    if ( type == 'go' ) {

        # generate lower matrix index
        idx = combn(1:length(golist), 2)

        # input is all pair combination
        gosimlist = vector('list', ncol(idx))

        for ( i in 1:ncol(idx) ) {
            gosimlist[[i]] = .calcgoPairSim(
                rev(idx[, i]), golist = golist, godb,
                measure = measure, combine = combine)
        }

        # convert list to matrix
        gosimmat = matrix(0, length(golist), length(golist))
        for (i in 1:length(gosimlist)) gosimmat[idx[2, i], idx[1, i]] = gosimlist[[i]]
        gosimmat[upper.tri(gosimmat)] = t(gosimmat)[upper.tri(t(gosimmat))]
        diag(gosimmat) = 1

    }

    gosimmat

}

#' Protein Similarity Calculation based on Gene Ontology (GO) Similarity
#'
#' Protein Similarity Calculation based on Gene Ontology (GO) Similarity
#'
#' This function calculates the Gene Ontology (GO) similarity
#' between two groups of GO terms or two Entrez gene IDs.
#'
#' @param id1 A character vector. length > 1: each element is a GO term;
#' length = 1: the Entrez Gene ID.
#' @param id2 A character vector. length > 1: each element is a GO term;
#' length = 1: the Entrez Gene ID.
#' @param type Input type of id1 and id2, \code{'go'} for GO Terms,
#' \code{'gene'} for gene ID.
#' @param ont Default is \code{'MF'}, could be one of
#' \code{'MF'}, \code{'BP'}, or \code{'CC'} subontologies.
#' @param organism Default is \code{'human'}, could be one of
#' \code{'anopheles'}, \code{'arabidopsis'}, \code{'bovine'}, \code{'canine'},
#' \code{'chicken'}, \code{'chimp'}, \code{'coelicolor'}, \code{'ecolik12'},
#' \code{'ecsakai'}, \code{'fly'}, \code{'human'}, \code{'malaria'},
#' \code{'mouse'}, \code{'pig'}, \code{'rat'}, \code{'rhesus'},
#' \code{'worm'}, \code{'xenopus'}, \code{'yeast'} or \code{'zebrafish'}.
#' @param measure Default is \code{'Resnik'}, could be one of
#' \code{'Resnik'}, \code{'Lin'}, \code{'Rel'}, \code{'Jiang'} or \code{'Wang'}.
#' @param combine Default is \code{'BMA'}, could be one of
#' \code{'max'}, \code{'average'}, \code{'rcmax'} or \code{'BMA'}
#' for combining semantic similarity scores of multiple GO terms
#' associated with protein.
#' @return A n x n matrix.
#'
#' @seealso See \code{\link{calcParProtGOSim}} for
#' protein similarity calculation based on
#' Gene Ontology (GO) semantic similarity.
#' See \code{\link{calcParProtSeqSim}} for paralleled protein similarity
#' calculation based on sequence alignment.
#'
#' @export calcTwoProtGOSim
#'
#' @examples
#' # By GO terms
#' go1 = c("GO:0004022", "GO:0004024", "GO:0004023")
#' go2 = c("GO:0009055", "GO:0020037")
#' \donttest{calcTwoProtGOSim(go1, go2, type = 'go', ont = 'MF', measure = 'Wang')}
#'
#' # By Entrez gene id
#' gene1 = '241'
#' gene2 = '251'
#' \donttest{calcTwoProtGOSim(gene1, gene2, type = 'gene', ont = 'CC', measure = 'Lin')}

calcTwoProtGOSim = function(
    id1, id2, type = c('go', 'gene'),
    ont = c('MF', 'BP', 'CC'), organism = 'human',
    measure = 'Resnik', combine = 'BMA') {

    type = match.arg(type)
    ont = match.arg(ont)

    godb = suppressMessages(GOSemSim::godata(OrgDb = .orgdb[organism], ont = ont, computeIC = TRUE))

    if ( type == 'go' ) {
        sim = GOSemSim::mgoSim(
            id1, id2,
            semData = godb,
            measure = measure, combine = combine)
    }

    if ( type == 'gene' ) {
        sim = GOSemSim::geneSim(
            id1, id2,
            semData = godb,
            measure = measure, combine = combine)
        if ("geneSim" %in% names(sim)) sim = sim$geneSim
    }

    sim

}

#' Calculate the Moreau-Broto Autocorrelation Descriptors using Partial Charges
#'
#' Calculate the Moreau-Broto Autocorrelation Descriptors using Partial Charges
#'
#' Calculates the ATS autocorrelation descriptor,
#' where the weight equal to the charges.
#'
#' @param molecules Parsed molucule object.
#' @param silent Logical. Whether the calculating process
#' should be shown or not, default is \code{TRUE}.
#'
#' @return A data frame, each row represents one of the molecules,
#' each column represents one feature.
#' This function returns 5 columns named
#' \code{ATSc1}, \code{ATSc2}, \code{ATSc3}, \code{ATSc4}, \code{ATSc5}.
#'
#' @export extractDrugAutocorrelationCharge
#'
#' @examples
#' smi = system.file('vignettedata/FDAMDD.smi', package = 'Rcpi')
#' \donttest{
#' mol = readMolFromSmi(smi, type = 'mol')
#' dat = extractDrugAutocorrelationCharge(mol)
#' head(dat)}

extractDrugAutocorrelationCharge = function (molecules, silent = TRUE) {
    evaluateDescriptor(molecules, type = 'AutocorrelationDescriptorCharge', silent = silent)
}

#' @keywords internal
"_PACKAGE"

#' @import foreach doParallel Biostrings GOSemSim
#' @importFrom methods as
#' @importFrom stats cmdscale dist factanal na.omit prcomp predict sd
#' @importFrom utils capture.output combn read.csv
NULL

#' Retrieve Drug Molecules in MOL Format from the DrugBank Database
#'
#' Retrieve Drug Molecules in MOL Format from the DrugBank Database
#'
#' This function retrieves drug molecules in MOL format from the
#' DrugBank database.
#'
#' @param id A character vector, as the DrugBank drug ID.
#' @param parallel An integer, the parallel parameter, indicates how many
#'                 process the user would like to use for retrieving
#'                 the data (using RCurl), default is \code{5}.
#'                 For regular cases, we recommend a number less than \code{20}.
#'
#' @return A length of \code{id} character vector,
#' each element containing the corresponding drug molecule.
#'
#' @seealso See \code{\link{getSmiFromDrugBank}} for retrieving drug molecules
#' in SMILES format from the DrugBank database.
#'
#' @export getMolFromDrugBank
#'
#' @examples
#' id = 'DB00859'  # Penicillamine
#' \donttest{
#' getMolFromDrugBank(id)}

getMolFromDrugBank = function (id, parallel = 5) {

    # example id : DB00859 (Penicillamine)
    # example url: https://go.drugbank.com/structures/small_molecule_drugs/DB00859.sdf

    SdfURL = paste0('https://go.drugbank.com/structures/small_molecule_drugs/', id, '.sdf')

    SdfTxt = get_url_parallel(url = SdfURL, total_con = parallel)

    return(SdfTxt)

}

#' Retrieve Drug Molecules in SMILES Format from the DrugBank Database
#'
#' Retrieve Drug Molecules in SMILES Format from the DrugBank Database
#'
#' This function retrieves drug molecules in SMILES format from the
#' DrugBank database.
#'
#' @param id A character vector, as the DrugBank drug ID.
#' @param parallel An integer, the parallel parameter, indicates how many
#'                 process the user would like to use for retrieving
#'                 the data (using RCurl), default is \code{5}.
#'                 For regular cases, we recommend a number less than \code{20}.
#'
#' @return A length of \code{id} character vector, each element containing
#' the corresponding drug molecule.
#'
#' @seealso See \code{\link{getMolFromDrugBank}} for retrieving drug molecules
#' in MOL format from the DrugBank database.
#'
#' @export getSmiFromDrugBank
#'
#' @examples
#' id = 'DB00859'  # Penicillamine
#' \donttest{
#' getSmiFromDrugBank(id)}

getSmiFromDrugBank = function (id, parallel = 5) {

    # example id : DB00859 (Penicillamine)
    # example url: https://go.drugbank.com/structures/small_molecule_drugs/DB00859.sdf

    SdfTxt = getMolFromDrugBank(id, parallel)

    tmpfile = tempfile(pattern = paste0(id, '-'), fileext = 'sdf')
    for (i in 1:length(id)) cat(SdfTxt[[i]], file = tmpfile[i])

    Mol = loadMolecules(tmpfile)
    Smi = sapply(Mol, getSmiles)

    unlink(tmpfile)

    return(Smi)

}

#' Generalized Scales-Based Descriptors derived by Factor Analysis
#'
#' Generalized Scales-Based Descriptors derived by Factor Analysis
#'
#' This function calculates the generalized scales-based descriptors
#' derived by Factor Analysis (FA).
#' Users could provide customized amino acid property matrices.
#'
#' @param x A character vector, as the input protein sequence.
#' @param propmat A matrix containing the properties for the amino acids.
#'        Each row represent one amino acid type, each column represents
#'        one property.
#'        Note that the one-letter row names must be provided for we need
#'        them to seek the properties for each AA type.
#' @param factors Integer. The number of factors to be fitted.
#'        Must be no greater than the number of AA properties provided.
#' @param scores Type of scores to produce. The default is \code{"regression"},
#'        which gives Thompson's scores, \code{"Bartlett"} given
#'        Bartlett's weighted least-squares scores.
#' @param lag The lag parameter. Must be less than the amino acids number
#'            in the protein sequence.
#' @param scale Logical. Should we auto-scale the property matrix
#'        (\code{propmat}) before doing Factor Analysis? Default is \code{TRUE}.
#' @param silent Logical. Whether we print the SS loadings,
#'        proportion of variance and the cumulative proportion of
#'        the selected factors or not.
#'        Default is \code{TRUE}.
#'
#' @return A length \code{lag * p^2} named vector,
#'         \code{p} is the number of scales (factors) selected.
#'
#' @export extractPCMFAScales
#'
#' @references
#' Atchley, W. R., Zhao, J., Fernandes, A. D., & Druke, T. (2005).
#' Solving the protein sequence metric problem.
#' Proceedings of the National Academy of Sciences of the
#' United States of America,
#' 102(18), 6395-6400.
#'
#' @examples
#' x = readFASTA(system.file('protseq/P00750.fasta', package = 'Rcpi'))[[1]]
#' data(AATopo)
#' tprops = AATopo[, c(37:41, 43:47)]  # select a set of topological descriptors
#' fa = extractPCMFAScales(x, propmat = tprops, factors = 5, lag = 7, silent = FALSE)
#'

extractPCMFAScales = function (x, propmat, factors, scores = 'regression', lag,
                               scale = TRUE, silent = TRUE) {

    if (checkProt(x) == FALSE) stop('x has unrecognized amino acid type')

    factors = min(factors, ncol(propmat), nrow(propmat))

    if (scale) propmat = scale(propmat)

    prop.fa = factanal(propmat, factors = factors, scores = scores)
    prop.scores = prop.fa$scores

    accmat = matrix(0, factors, nchar(x))
    x.split = strsplit(x, '')[[1]]

    for (i in 1:nchar(x)) {
        accmat[, i] = prop.scores[x.split[i], 1:factors]
    }

    result = acc(accmat, lag)

    if (!silent) {
        cat('Summary of the factor analysis result:\n')
        print(prop.fa)
    }

    return(result)

}

#' Descriptor that Calculates Kier and Hall Kappa Molecular Shape Indices
#'
#' Descriptor that Calculates Kier and Hall Kappa Molecular Shape Indices
#'
#' Kier and Hall Kappa molecular shape indices compare the molecular graph
#' with minimal and maximal molecular graphs;
#' see \url{https://bit.ly/3ramdBy} for details:
#' "they are intended to capture different aspects of molecular shape.
#' Note that hydrogens are ignored. In the following description,
#' n denotes the number of atoms in the hydrogen suppressed graph,
#' m is the number of bonds in the hydrogen suppressed graph.
#' Also, let p2 denote the number of paths of length 2
#' and let p3 denote the number of paths of length 3".
#'
#' @param molecules Parsed molucule object.
#' @param silent Logical. Whether the calculating process
#' should be shown or not, default is \code{TRUE}.
#'
#' @return A data frame, each row represents one of the molecules,
#' each column represents one feature.
#' This function returns 3 columns named
#' \code{Kier1}, \code{Kier2} and \code{Kier3}:
#' \itemize{
#' \item \code{Kier1} - First kappa shape index
#' \item \code{Kier2} - Second kappa shape index
#' \item \code{Kier3} - Third kappa shape index
#' }
#'
#' @export extractDrugKappaShapeIndices
#'
#' @examples
#' smi = system.file('vignettedata/FDAMDD.smi', package = 'Rcpi')
#' \donttest{
#' mol = readMolFromSmi(smi, type = 'mol')
#' dat = extractDrugKappaShapeIndices(mol)
#' head(dat)}

extractDrugKappaShapeIndices = function (molecules, silent = TRUE) {
    evaluateDescriptor(molecules, type = 'KappaShapeIndicesDescriptor', silent = silent)
}

#' Retrieve Protein Sequence in various Formats from Databases
#'
#' Retrieve Protein Sequence in various Formats from Databases
#'
#' This function retrieves protein sequence in various formats from
#' three databases.
#'
#' @param id A character vector, as the protein ID(s).
#' @param from The database, one of \code{'uniprot'}, \code{'kegg'},
#' or \code{'pdb'}.
#' @param type The returned protein format, one of \code{fasta}, \code{pdb},
#' or \code{aaseq}.
#' @param parallel An integer, the parallel parameter, indicates how many
#'                 process the user would like to use for retrieving
#'                 the data (using RCurl), default is \code{5}.
#'                 For regular cases, we recommend a number less than \code{20}.
#'
#' @return A length of \code{id} character list, each element
#' containing the corresponding protein sequence(s) or file(s).
#'
#' @seealso See \code{\link{getDrug}} for retrieving drug molecules
#' from five databases.
#'
#' @export getProt
#'
#' @examples
#' id = c('P00750', 'P00751', 'P00752')
#' \donttest{
#' getProt(id, from = 'uniprot', type = 'aaseq')}

getProt = function(
    id,
    from = c('uniprot', 'kegg', 'pdb'),
    type = c('fasta', 'pdb', 'aaseq'),
    parallel = 5) {

    if (is.null(from)) stop('Must specify a data source')
    if (is.null(type)) stop('Must specify a data type')

    # Exclude 3 special case from total 9 possible combinations

    if (from == 'uniprot' & type == 'pdb')
        stop('UniProt only supports type = "fasta" or type = "aaseq"')
    if (from == 'kegg' & type == 'pdb')
        stop('KEGG only supports type = "fasta" or type = "aaseq"')
    if (from == 'pdb' & type == 'fasta')
        stop('RCSB PDB only supports type = "pdb" or type = "aaseq"')

    FromDict = c('uniprot' = 'UniProt', 'kegg' = 'KEGG', 'pdb' = 'RCSBPDB')
    TypeDict = c('fasta' = 'FASTA', 'pdb' = 'PDB', 'aaseq' = 'Seq')

    NamePart1 = TypeDict[type]
    NamePart2 = FromDict[from]

    FunctionName = paste('get', NamePart1, 'From', NamePart2, sep = '')

    Prot = eval(parse(text = paste(
        FunctionName, '(',
        gsub('\\"', '\'', capture.output(dput(id))),
        ', ', parallel, ')', sep = '')))

    return(Prot)

}

#' Tripeptide Composition Descriptor
#'
#' Tripeptide Composition Descriptor
#'
#' This function calculates the Tripeptide Composition descriptor (Dim: 8000).
#'
#' @param x A character vector, as the input protein sequence.
#'
#' @return A length 8000 named vector
#'
#' @seealso See \code{\link{extractProtAAC}} and \code{\link{extractProtDC}}
#'          for Amino Acid Composition and Dipeptide Composition descriptors.
#'
#' @export extractProtTC
#'
#' @references
#' M. Bhasin, G. P. S. Raghava.
#' Classification of Nuclear Receptors Based on
#' Amino Acid Composition and Dipeptide Composition.
#' \emph{Journal of Biological Chemistry}, 2004, 279, 23262.
#'
#' @examples
#' x = readFASTA(system.file('protseq/P00750.fasta', package = 'Rcpi'))[[1]]
#' extractProtTC(x)
#'

extractProtTC = function (x) {

    if (checkProt(x) == FALSE) stop('x has unrecognized amino acid type')

    AADict = c('A', 'R', 'N', 'D', 'C', 'E', 'Q', 'G', 'H', 'I',
               'L', 'K', 'M', 'F', 'P', 'S', 'T', 'W', 'Y', 'V')
    DCDict = as.vector((outer(AADict, AADict, paste, sep = '')))
    TCDict = as.vector((outer(DCDict, AADict, paste, sep = '')))

    xSplitted = strsplit(x, split = '')[[1]]
    n  = nchar(x)
    TC = summary(factor(paste(paste(xSplitted[-c(n, n-1)],
                                    xSplitted[-c(1, n)], sep = ''),
                              xSplitted[-c(1, 2)], sep = ''),
                        levels = TCDict), maxsum = 8001)/(n-2)

    return(TC)

}

#' Generalized Scales-Based Descriptors derived by Principal Components Analysis
#'
#' Generalized Scales-Based Descriptors derived by Principal Components Analysis
#'
#' This function calculates the generalized scales-based descriptors
#' derived by Principal Components Analysis (PCA).
#' Users could provide customized amino acid property matrices.
#' This function implements the core computation procedure needed for
#' the generalized scales-based descriptors derived by AA-Properties (AAindex)
#' and generalized scales-based descriptors derived by 20+ classes of 2D and 3D
#' molecular descriptors (Topological, WHIM, VHSE, etc.).
#'
#' @param x A character vector, as the input protein sequence.
#' @param propmat A matrix containing the properties for the amino acids.
#'        Each row represent one amino acid type, each column represents
#'        one property.
#'        Note that the one-letter row names must be provided for we need
#'        them to seek the properties for each AA type.
#' @param pc Integer. Use the first pc principal components as the scales.
#'        Must be no greater than the number of AA properties provided.
#' @param lag The lag parameter. Must be less than the amino acids.
#' @param scale Logical. Should we auto-scale the property matrix
#'        (\code{propmat}) before PCA? Default is \code{TRUE}.
#' @param silent Logical. Whether we print the standard deviation,
#'        proportion of variance and the cumulative proportion of
#'        the selected principal components or not.
#'        Default is \code{TRUE}.
#'
#' @return A length \code{lag * p^2} named vector,
#' \code{p} is the number of scales (principal components) selected.
#'
#' @seealso See \code{\link{extractPCMDescScales}} for generalized
#' AA property based scales descriptors, and \code{\link{extractPCMPropScales}}
#' for (19 classes) AA descriptor based scales descriptors.
#'
#' @export extractPCMScales
#'
#' @examples
#' x = readFASTA(system.file('protseq/P00750.fasta', package = 'Rcpi'))[[1]]
#' data(AAindex)
#' AAidxmat = t(na.omit(as.matrix(AAindex[, 7:26])))
#' scales = extractPCMScales(x, propmat = AAidxmat, pc = 5, lag = 7, silent = FALSE)

extractPCMScales = function (x, propmat, pc, lag, scale = TRUE, silent = TRUE) {

    if (checkProt(x) == FALSE) stop('x has unrecognized amino acid types')

    pc = min(pc, ncol(propmat), nrow(propmat))

    prop.pr = prcomp(propmat, scale = scale)
    prop.pred = predict(prop.pr)

    accmat = matrix(0, pc, nchar(x))
    x.split = strsplit(x, '')[[1]]

    for (i in 1:nchar(x)) {
        accmat[, i] = prop.pred[x.split[i], 1:pc]
    }

    result = acc(accmat, lag)

    if (!silent) {
        cat('Summary of the first', pc,'principal components:\n')
        print(summary(prop.pr)$importance[, 1:pc])
    }

    return(result)

}

#' Toolkit for Compound-Protein Interaction in Drug Discovery
#'
#' Rcpi offers a molecular informatics toolkit with a
#' comprehensive integration of bioinformatics and
#' cheminformatics tools for drug discovery.
#'
#' The package vignette can be opened with \code{vignette('Rcpi')}.
#'
#' \tabular{ll}{
#' Package: \tab Rcpi\cr
#' Type: \tab Package\cr
#' License: \tab Artistic-2.0}
#'
#' @name Rcpi-package
#' @aliases Rcpi
#' @docType package
#'
#' @note
#' Bug reports and feature requests should be sent to
#' \url{https://github.com/nanxstats/Rcpi/issues}.
#'
#' @import foreach doParallel Biostrings GOSemSim ChemmineR fmcsR
#' @importFrom methods as
#' @importFrom stats cmdscale dist factanal na.omit prcomp predict sd
#' @importFrom utils capture.output combn read.csv
#'
NULL

is_pwalign_needed <- function() {
    rlang::is_installed("Biostrings", version = "2.72.0")
}

is_pwalign_installed <- function() {
    rlang::is_installed("pwalign")
}

#' @importFrom utils getFromNamespace
get_pwa <- function(ns) {
    getFromNamespace("pairwiseAlignment", ns = ns)
}

resolve_pwa <- function() {
    if (!is_pwalign_needed()) {
        return(get_pwa("Biostrings"))
    }

    if (!is_pwalign_installed()) {
        stop("The package \"pwalign\" is required. Please install it from Bioconductor.", call. = FALSE)
    }

    get_pwa("pwalign")
}

.inner = function (a, b, f, ...) {

    # For computing column-by-column (pseudo)-tensor product type interactions

    f = match.fun(f)
    apply(b, 2, function (x) apply(a, 1, function (y) f(x, y, ...)))

}

.getCPICombine = function (drugmat, protmat) {

    return(cbind(drugmat, protmat))

}

.getCPITensor = function (drugmat, protmat, row, dcol, pcol) {

    return(array(.inner(t(drugmat), protmat, '*'), c(row, dcol * pcol)))

}

#' Generating Compound-Protein Interaction Descriptors
#'
#' Generating Compound-Protein Interaction Descriptors
#'
#' This function calculates the compound-protein interaction descriptors
#' by three types of interaction:
#' \itemize{
#' \item \code{combine} - combine the two descriptor matrix,
#' result has \code{(p1 + p2)} columns
#' \item \code{tensorprod} - calculate column-by-column
#' (pseudo)-tensor product type interactions, result has
#' \code{(p1 * p2)} columns
#' }
#'
#' @param drugmat The compound descriptor matrix.
#' @param protmat The protein descriptor matrix.
#' @param type The interaction type, one or two of
#' \code{"combine"} and \code{"tensorprod"}.
#'
#' @return A matrix containing the compound-protein interaction descriptors
#'
#' @seealso See \code{\link{getPPI}} for generating
#' protein-protein interaction descriptors.
#'
#' @export getCPI
#'
#' @examples
#' x = matrix(1:10, ncol = 2)
#' y = matrix(1:15, ncol = 3)
#'
#' getCPI(x, y, 'combine')
#' getCPI(x, y, 'tensorprod')
#' getCPI(x, y, type = c('combine', 'tensorprod'))
#' getCPI(x, y, type = c('tensorprod', 'combine'))
#'

getCPI = function (drugmat, protmat, type = c('combine', 'tensorprod')) {

    if (!is.matrix(drugmat)) drugmat = as.matrix(drugmat)
    if (!is.matrix(protmat)) protmat = as.matrix(protmat)

    drugrow = nrow(drugmat)
    protrow = nrow(protmat)

    if (drugrow != protrow) stop('Matrix row count must match')

    drugcol = ncol(drugmat)
    protcol = ncol(protmat)

    if (missing(type)) stop('Must provide at least one interaction type')

    if (all(type == 'combine')) {

        result = .getCPICombine(drugmat, protmat)

    } else if (all(type == 'tensorprod')) {

        result = .getCPITensor(drugmat, protmat, row = drugrow,
                               dcol = drugcol, pcol = protcol)

    } else if (length(setdiff(type, c('tensorprod', 'combine'))) == 0L) {

        result = cbind(.getCPICombine(drugmat, protmat),
                       .getCPITensor(drugmat, protmat, row = drugrow,
                                     dcol = drugcol, pcol = protcol))

    } else {

        stop('Interaction type must be in "tensorprod" and "combine" or both')

    }

    return(result)

}

test_that("`getCPI()` works", {
    x = matrix(1:10, ncol = 2)
    y = matrix(1:15, ncol = 3)

    expect_equal(ncol(getCPI(x, y, 'combine')), 5L)
    expect_equal(ncol(getCPI(x, y, 'tensorprod')), 6L)
    expect_equal(ncol(getCPI(x, y, type = c('combine', 'tensorprod'))), 11L)
    expect_equal(ncol(getCPI(x, y, type = c('tensorprod', 'combine'))), 11L)
})

#' Pseudo Amino Acid Composition Descriptor
#'
#' Pseudo Amino Acid Composition Descriptor
#'
#' This function calculates the Pseudo Amino Acid Composition (PAAC) descriptor
#' (Dim: \code{20 + lambda}, default is 50).
#'
#' @param x A character vector, as the input protein sequence.
#'
#' @param props A character vector, specifying the properties used.
#'              3 properties are used by default, as listed below:
#'              \describe{
#'              \item{\code{'Hydrophobicity'}}{Hydrophobicity value
#'              of the 20 amino acids}
#'              \item{\code{'Hydrophilicity'}}{Hydrophilicity value
#'              of the 20 amino acids}
#'              \item{\code{'SideChainMass'}}{Side-chain mass
#'              of the 20 amino acids}}
#'
#' @param lambda The lambda parameter for the PAAC descriptors, default is 30.
#'
#' @param w The weighting factor, default is 0.05.
#'
#' @param customprops A \code{n x 21} named data frame contains \code{n}
#'                    customize property. Each row contains one property.
#'                    The column order for different amino acid types is
#'                    \code{'AccNo'}, \code{'A'}, \code{'R'}, \code{'N'},
#'                    \code{'D'}, \code{'C'}, \code{'E'}, \code{'Q'},
#'                    \code{'G'}, \code{'H'}, \code{'I'}, \code{'L'},
#'                    \code{'K'}, \code{'M'}, \code{'F'}, \code{'P'},
#'                    \code{'S'}, \code{'T'}, \code{'W'}, \code{'Y'},
#'                    \code{'V'}, and the columns should also be \emph{exactly}
#'                    named like this.
#'                    The \code{AccNo} column contains the properties' names.
#'                    Then users should explicitly specify these properties
#'                    with these names in the argument \code{props}.
#'                    See the examples below for a demonstration.
#'                    The default value for \code{customprops} is \code{NULL}.
#'
#' @return A length \code{20 + lambda} named vector
#'
#' @note Note the default \code{20 * 3} \code{prop} values have been already
#'       independently given in the function. Users could also specify
#'       other (up to 544) properties with the Accession Number in
#'       the \code{\link{AAindex}} data, with or without the default
#'       three properties, which means users should explicitly specify
#'       the properties to use.
#'
#' @seealso See \code{\link{extractProtAPAAC}} for amphiphilic pseudo
#'          amino acid composition descriptor.
#'
#' @export extractProtPAAC
#'
#' @references
#' Kuo-Chen Chou. Prediction of Protein Cellular Attributes
#' Using Pseudo-Amino Acid Composition.
#' \emph{PROTEINS: Structure, Function, and Genetics}, 2001, 43: 246-255.
#'
#' Type 1 pseudo amino acid composition.
#' \url{http://www.csbio.sjtu.edu.cn/bioinf/PseAAC/type1.htm}
#'
#' Kuo-Chen Chou. Using Amphiphilic Pseudo Amino Acid Composition
#' to Predict Enzyme Subfamily Classes. \emph{Bioinformatics}, 2005, 21, 10-19.
#'
#' JACS, 1962, 84: 4240-4246. (C. Tanford). (The hydrophobicity data)
#'
#' PNAS, 1981, 78:3824-3828 (T.P.Hopp & K.R.Woods). (The hydrophilicity data)
#'
#' CRC Handbook of Chemistry and Physics, 66th ed.,
#' CRC Press, Boca Raton, Florida (1985). (The side-chain mass data)
#'
#' R.M.C. Dawson, D.C. Elliott, W.H. Elliott, K.M. Jones,
#' Data for Biochemical Research 3rd ed., Clarendon Press Oxford (1986).
#' (The side-chain mass data)
#'
#' @examples
#' x = readFASTA(system.file('protseq/P00750.fasta', package = 'Rcpi'))[[1]]
#' extractProtPAAC(x)
#'
#' myprops = data.frame(AccNo = c("MyProp1", "MyProp2", "MyProp3"),
#'                      A = c(0.62,  -0.5, 15),  R = c(-2.53,   3, 101),
#'                      N = c(-0.78,  0.2, 58),  D = c(-0.9,    3, 59),
#'                      C = c(0.29,    -1, 47),  E = c(-0.74,   3, 73),
#'                      Q = c(-0.85,  0.2, 72),  G = c(0.48,    0, 1),
#'                      H = c(-0.4,  -0.5, 82),  I = c(1.38, -1.8, 57),
#'                      L = c(1.06,  -1.8, 57),  K = c(-1.5,    3, 73),
#'                      M = c(0.64,  -1.3, 75),  F = c(1.19, -2.5, 91),
#'                      P = c(0.12,     0, 42),  S = c(-0.18, 0.3, 31),
#'                      T = c(-0.05, -0.4, 45),  W = c(0.81, -3.4, 130),
#'                      Y = c(0.26,  -2.3, 107), V = c(1.08, -1.5, 43))
#'
#' # Use 3 default properties, 4 properties in the AAindex database,
#' # and 3 cutomized properties
#' extractProtPAAC(x, customprops = myprops,
#'                 props = c('Hydrophobicity', 'Hydrophilicity', 'SideChainMass',
#'                           'CIDH920105', 'BHAR880101',
#'                           'CHAM820101', 'CHAM820102',
#'                           'MyProp1', 'MyProp2', 'MyProp3'))
#'

extractProtPAAC = function (x, props = c('Hydrophobicity', 'Hydrophilicity', 'SideChainMass'),
                            lambda = 30, w = 0.05, customprops = NULL) {

    if (checkProt(x) == FALSE) stop('x has unrecognized amino acid type')

    if (nchar(x) <= lambda) stop('Length of the protein sequence must be greater than "lambda"')

    AAidx = read.csv(system.file('sysdata/AAidx.csv', package = 'Rcpi'), header = TRUE)

    tmp = data.frame(AccNo = c("Hydrophobicity", "Hydrophilicity", "SideChainMass"),
                     A = c(0.62,  -0.5, 15),  R = c(-2.53,   3, 101),
                     N = c(-0.78,  0.2, 58),  D = c(-0.9,    3, 59),
                     C = c(0.29,    -1, 47),  E = c(-0.74,   3, 73),
                     Q = c(-0.85,  0.2, 72),  G = c(0.48,    0, 1),
                     H = c(-0.4,  -0.5, 82),  I = c(1.38, -1.8, 57),
                     L = c(1.06,  -1.8, 57),  K = c(-1.5,    3, 73),
                     M = c(0.64,  -1.3, 75),  F = c(1.19, -2.5, 91),
                     P = c(0.12,     0, 42),  S = c(-0.18, 0.3, 31),
                     T = c(-0.05, -0.4, 45),  W = c(0.81, -3.4, 130),
                     Y = c(0.26,  -2.3, 107), V = c(1.08, -1.5, 43))

    AAidx = rbind(AAidx, tmp)

    if (!is.null(customprops)) AAidx = rbind(AAidx, customprops)

    aaidx = AAidx[, -1]
    row.names(aaidx) = AAidx[, 1]

    n = length(props)

    # Standardize H0 to H

    H0 = as.matrix(aaidx[props, ])

    H  = matrix(ncol = 20, nrow = n)
    for (i in 1:n) H[i, ] = (H0[i, ] - mean(H0[i, ]))/(sqrt(sum((H0[i, ] - mean(H0[i, ]))^2)/20))
    AADict = c('A', 'R', 'N', 'D', 'C', 'E', 'Q', 'G', 'H', 'I',
               'L', 'K', 'M', 'F', 'P', 'S', 'T', 'W', 'Y', 'V')
    dimnames(H) = list(props, AADict)

    # Compute (big) Theta

    Theta = vector('list', lambda)

    xSplitted = strsplit(x, split = '')[[1]]

    N = length(xSplitted)

    for (i in 1:lambda) {
        for (j in 1:(N-i)) {
            Theta[[i]][j] = mean((H[, xSplitted[j]] - H[, xSplitted[j + i]])^2)
        }
    }

    # Compute (small) theta

    theta = sapply(Theta, mean)

    # Compute first 20 features

    fc  = summary(factor(xSplitted, levels = AADict), maxsum = 21)
    Xc1 = fc/(1 + (w * sum(theta)))
    names(Xc1) = paste('Xc1.', names(Xc1), sep = '')

    # Compute last lambda features

    Xc2 = (w * theta)/(1 + (w * sum(theta)))
    names(Xc2) = paste('Xc2.lambda.', 1:lambda, sep = '')

    # Combine (20 + lambda) features

    Xc = c(Xc1, Xc2)

    return(Xc)

}

#' Descriptor that Calculates the Prediction of logP
#' Based on the Atom-Type Method Called XLogP
#'
#' Descriptor that Calculates the Prediction of logP
#' Based on the Atom-Type Method Called XLogP
#'
#' Prediction of logP based on the atom-type method called XLogP.
#'
#' @param molecules Parsed molucule object.
#' @param silent Logical. Whether the calculating process
#' should be shown or not, default is \code{TRUE}.
#'
#' @return A data frame, each row represents one of the molecules,
#' each column represents one feature.
#' This function returns one column named \code{XLogP}.
#'
#' @export extractDrugXLogP
#'
#' @references
#' Wang, R., Fu, Y., and Lai, L.,
#' A New Atom-Additive Method for Calculating Partition Coefficients,
#' Journal of Chemical Information and Computer Sciences, 1997, 37:615-621.
#'
#' Wang, R., Gao, Y., and Lai, L.,
#' Calculating partition coefficient by atom-additive method,
#' Perspectives in Drug Discovery and Design, 2000, 19:47-66.
#'
#' @examples
#' smi = system.file('vignettedata/FDAMDD.smi', package = 'Rcpi')
#' \donttest{
#' mol = readMolFromSmi(smi, type = 'mol')
#' dat = extractDrugXLogP(mol)
#' head(dat)}

extractDrugXLogP = function (molecules, silent = TRUE) {
    evaluateDescriptor(molecules, type = 'XLogPDescriptor', silent = silent)
}

#' Retrieve Drug Molecules in MOL Format from the ChEMBL Database
#'
#' Retrieve Drug Molecules in MOL Format from the ChEMBL Database
#'
#' This function retrieves drug molecules in MOL format from the
#' ChEMBL database.
#'
#' @param id A character vector, as the ChEMBL drug ID.
#' @param parallel An integer, the parallel parameter, indicates how many
#'                 process the user would like to use for
#'                 retrieving the data (using RCurl), default is \code{5}.
#'                 For regular cases, we recommend a number less than \code{20}.
#'
#' @return A length of \code{id} character vector,
#' each element containing the corresponding drug molecule.
#'
#' @seealso See \code{\link{getSmiFromChEMBL}} for retrieving drug molecules
#' in SMILES format from the ChEMBL database.
#'
#' @export getMolFromChEMBL
#'
#' @examples
#' id = 'CHEMBL1430'  # Penicillamine
#' \donttest{
#' getMolFromChEMBL(id)}

getMolFromChEMBL = function (id, parallel = 5) {

    # example id : CHEMBL1430 (Penicillamine)
    # example url: https://www.ebi.ac.uk/chembldb/compound/inspect/CHEMBL1430
    # then we get: https://www.ebi.ac.uk/chembldb/download_helper/getmol/369179

    MolPageURL = paste0('https://www.ebi.ac.uk/chembldb/compound/inspect/', id)
    MolPageTxt = get_url_parallel(url = MolPageURL, total_con = parallel)

    n = length(id)
    tmp1 = rep(NA, n)
    tmp2 = rep(NA, n)

    for (i in 1:n) {
        tmp1[i] = strsplit(MolPageTxt,
                           "<a href='/chembl/download_helper/getmol/")[[1]][2]
    }

    for (i in 1:n) {
        tmp2[i] = strsplit(tmp1[i], "'>Download MolFile")[[1]][1]
    }

    MolURL = paste0('https://www.ebi.ac.uk/chembldb/download_helper/getmol/', tmp2)
    MolTxt = get_url_parallel(url = MolURL, total_con = parallel)

    return(MolTxt)

}

#' Retrieve Drug Molecules in SMILES Format from the ChEMBL Database
#'
#' Retrieve Drug Molecules in SMILES Format from the ChEMBL Database
#'
#' This function retrieves drug molecules in SMILES format from the
#' ChEMBL database.
#'
#' @param id A character vector, as the ChEMBL drug ID.
#' @param parallel An integer, the parallel parameter, indicates how many
#'                 process the user would like to use for retrieving
#'                 the data (using RCurl), default is \code{5}.
#'                 For regular cases, we recommend a number less than \code{20}.
#'
#' @return A length of \code{id} character vector,
#' each element containing the corresponding drug molecule.
#'
#' @seealso See \code{\link{getMolFromChEMBL}} for retrieving drug molecules
#' in MOL format from the ChEMBL database.
#'
#' @export getSmiFromChEMBL
#'
#' @examples
#' id = 'CHEMBL1430'  # Penicillamine
#' \donttest{
#' getSmiFromChEMBL(id)}

getSmiFromChEMBL = function (id, parallel = 5) {

    # example id : CHEMBL1430 (Penicillamine)
    # example url: https://www.ebi.ac.uk/chembl/api/data/molecule?molecule_chembl_id__in=CHEMBL1430&format=json

    MolURL = paste0('https://www.ebi.ac.uk/chembl/api/data/molecule?molecule_chembl_id__in=', id, '&format=json')

    MolTxt = get_url_parallel(url = MolURL, total_con = parallel)

    SmiTxt = lapply(MolTxt, jsonlite::fromJSON, simplifyVector = FALSE)
    SmiTxt = sapply(SmiTxt, `[[`, 'molecules')

    Smi = sapply(lapply(SmiTxt, `[[`, 'molecule_structures'), `[[`, 'canonical_smiles')

    names(Smi) = NULL

    return(Smi)

}

#' Retrieve Drug Molecules in MOL Format from the PubChem Database
#'
#' Retrieve Drug Molecules in MOL Format from the PubChem Database
#'
#' This function retrieves drug molecules in MOL format from the
#' PubChem database.
#'
#' @param id A character vector, as the PubChem drug ID.
#' @param parallel An integer, the parallel parameter, indicates how many
#' processes the user would like to use for retrieving
#' the data (using RCurl), default is \code{5}.
#' For regular cases, we recommend a number less than \code{20}.
#'
#' @return A length of \code{id} character vector,
#' each element containing the corresponding drug molecule.
#'
#' @seealso See \code{\link{getSmiFromPubChem}} for retrieving drug molecules
#' in SMILES format from the PubChem database.
#'
#' @export getMolFromPubChem
#'
#' @examples
#' id = c('7847562', '7847563')  # Penicillamine
#' \donttest{
#' getMolFromPubChem(id)}

getMolFromPubChem = function (id, parallel = 5) {

    # example id : 7847562 (Penicillamine)
    # example url: https://pubchem.ncbi.nlm.nih.gov/rest/pug/substance/sid/7847562/record/SDF/?record_type=2d

    SdfURL = paste0('https://pubchem.ncbi.nlm.nih.gov/rest/pug/substance/sid/',
                    id, '/record/SDF/?record_type=2d')

    SdfTxt = get_url_parallel(url = SdfURL, total_con = parallel)

    return(SdfTxt)

}

#' Retrieve Drug Molecules in SMILES Format from the PubChem Database
#'
#' Retrieve Drug Molecules in SMILES Format from the PubChem Database
#'
#' This function retrieves drug molecules in SMILES format from
#' the PubChem database.
#'
#' @param id A character vector, as the PubChem drug ID.
#' @param parallel An integer, the parallel parameter, indicates how many
#' processes the user would like to use for retrieving
#' the data (using RCurl), default is \code{5}.
#' For regular cases, we recommend a number less than \code{20}.
#'
#' @return A length of \code{id} character vector,
#' each element containing the corresponding drug molecule.
#'
#' @seealso See \code{\link{getMolFromPubChem}} for retrieving drug molecules
#' in MOL format from the PubChem database.
#'
#' @export getSmiFromPubChem
#'
#' @examples
#' id = c('7847562', '7847563')  # Penicillamine
#' \donttest{
#' getSmiFromPubChem(id)}

getSmiFromPubChem = function (id, parallel = 5) {

    # example id : 7847562 (Penicillamine)
    # example url: https://pubchem.ncbi.nlm.nih.gov/rest/pug/substance/sid/7847562/record/SDF/?record_type=2d

    SdfTxt = getMolFromPubChem(id, parallel)

    tmpfile = tempfile(pattern = paste0(id, '-'), fileext = '.sdf')
    for (i in 1:length(id)) cat(SdfTxt[[i]], file = tmpfile[i])
    Mol = readMolFromSDF(tmpfile)
    Smi = sapply(Mol, getSmiles)
    unlink(tmpfile)

    return(Smi)

}

#' Calculate the Sum of the Atomic Polarizabilities Descriptor
#'
#' Calculate the Sum of the Atomic Polarizabilities Descriptor
#'
#' Calculates the sum of the atomic polarizabilities
#' (including implicit hydrogens) descriptor.
#' Polarizabilities are taken from \url{https://bit.ly/3PvNbhe}.
#'
#' @param molecules Parsed molucule object.
#' @param silent Logical. Whether the calculating process
#' should be shown or not, default is \code{TRUE}.
#'
#' @return A data frame, each row represents one of the molecules,
#' each column represents one feature.
#' This function returns one column named \code{apol}.
#'
#' @export extractDrugApol
#'
#' @examples
#' smi = system.file('vignettedata/FDAMDD.smi', package = 'Rcpi')
#' \donttest{
#' mol = readMolFromSmi(smi, type = 'mol')
#' dat = extractDrugApol(mol)
#' head(dat)}

extractDrugApol = function (molecules, silent = TRUE) {
    evaluateDescriptor(molecules, type = 'APolDescriptor', silent = silent)
}

#' Compute PSSM (Position-Specific Scoring Matrix) for given protein sequence
#'
#' Compute PSSM (Position-Specific Scoring Matrix) for given protein sequence
#'
#' This function calculates the PSSM (Position-Specific Scoring Matrix) derived
#' by PSI-Blast for given protein sequence or peptides.
#' For given protein sequences or peptides, PSSM represents the
#' log-likelihood of the substitution of the 20 types of amino acids at that
#' position in the sequence. Note that the output value is not normalized.
#'
#' @param seq Character vector, as the input protein sequence.
#' @param start.pos Optional integer denoting the start position of the
#' fragment window. Default is \code{1},
#' i.e. the first amino acid of the given sequence.
#' @param end.pos Optional integer denoting the end position of the
#' fragment window. Default is \code{nchar(seq)},
#' i.e. the last amino acid of the given sequence.
#' @param psiblast.path Character string indicating the path of the
#' \code{psiblast} program.
#' If NCBI Blast+ was previously installed in the operation system,
#' the path will be automatically detected.
#' @param makeblastdb.path Character string indicating the path of the
#' \code{makeblastdb} program.
#' If NCBI Blast+ was previously installed in the system,
#' the path will be automatically detected.
#' @param database.path Character string indicating the path of
#' a reference database (a FASTA file).
#' @param iter Number of iterations to perform for PSI-Blast.
#' @param silent Logical. Whether the PSI-Blast running output
#' should be shown or not (May not work on some Windows versions and
#' PSI-Blast versions), default is \code{TRUE}.
#'
#' @param evalue Expectation value (E) threshold for saving hits.
#' Default is \code{10}.
#' @param word.size Word size for wordfinder algorithm. An integer >= 2.
#' @param gapopen Integer. Cost to open a gap.
#' @param gapextend Integer. Cost to extend a gap.
#' @param matrix Character string. The scoring matrix name
#' (default is \code{'BLOSUM62'}).
#' @param threshold Minimum word score such that the word is added to
#' the BLAST lookup table. A real value >= 0.
#' @param seg Character string. Filter query sequence with SEG (\code{'yes'},
#' \code{'window locut hicut'}, or \code{'no'} to disable) Default is \code{'no'}.
#' @param soft.masking Logical. Apply filtering locations as soft masks?
#' Default is \code{FALSE}.
#' @param culling.limit An integer >= 0. If the query range of a hit is
#' enveloped by that of at least this many higher-scoring hits,
#' delete the hit. Incompatible with \code{best.hit.overhang} and
#' \code{best_hit_score_edge}.
#' @param best.hit.overhang Best Hit algorithm overhang value
#' (A real value >= 0 and =< 0.5, recommended value: 0.1).
#' Incompatible with \code{culling_limit}.
#' @param best.hit.score.edge Best Hit algorithm score edge value
#' (A real value >=0 and =< 0.5, recommended value: 0.1).
#' Incompatible with \code{culling_limit}.
#' @param xdrop.ungap X-dropoff value (in bits) for ungapped extensions.
#' @param xdrop.gap X-dropoff value (in bits) for preliminary gapped extensions.
#' @param xdrop.gap.final X-dropoff value (in bits) for final gapped alignment.
#' @param window.size An integer >= 0. Multiple hits window size,
#' To specify 1-hit algorithm, use \code{0}.
#' @param gap.trigger Number of bits to trigger gapping. Default is \code{22}.
#' @param num.threads Integer. Number of threads (CPUs) to use in the
#' BLAST search. Default is \code{1}.
#' @param pseudocount Integer. Pseudo-count value used when constructing PSSM.
#' Default is \code{0}.
#' @param inclusion.ethresh E-value inclusion threshold for pairwise alignments.
#' Default is \code{0.002}.
#'
#' @return The original PSSM, a numeric matrix which has
#' \code{end.pos - start.pos + 1} columns and \code{20} named rows.
#'
#' @note
#' The function requires the \code{makeblastdb} and \code{psiblast} programs
#' to be properly installed in the operation system or
#' their paths provided.
#'
#' The two command-line programs are included in the NCBI-BLAST+
#' software package. To install NCBI Blast+, just open the NCBI FTP site
#' using web browser or FTP software:
#' \url{ftp://anonymous@@ftp.ncbi.nlm.nih.gov:21/blast/executables/blast+/LATEST/}
#' then download the executable version of BLAST+ according to your
#' operation system, and compile or install the downloaded
#' source code or executable program.
#'
#' Ubuntu/Debian users can directly use the command
#' \code{sudo apt-get install ncbi-blast+} to install NCBI Blast+.
#' For OS X users, download \code{ncbi-blast- ... .dmg} then install.
#' For Windows users, download \code{ncbi-blast- ... .exe} then install.
#'
#' @seealso \link{extractProtPSSMFeature} \link{extractProtPSSMAcc}
#'
#' @export extractProtPSSM
#'
#' @references
#' Altschul, Stephen F., et al.
#' "Gapped BLAST and PSI-BLAST: a new generation of protein database search programs."
#' \emph{Nucleic acids research} 25.17 (1997): 3389--3402.
#'
#' Ye, Xugang, Guoli Wang, and Stephen F. Altschul.
#' "An assessment of substitution scores for protein profile-profile comparison."
#' \emph{Bioinformatics} 27.24 (2011): 3356--3363.
#'
#' Rangwala, Huzefa, and George Karypis.
#' "Profile-based direct kernels for remote homology detection and fold recognition."
#' \emph{Bioinformatics} 21.23 (2005): 4239--4247.
#'
#' @examples
#' x = readFASTA(system.file('protseq/P00750.fasta', package = 'Rcpi'))[[1]]
#' \donttest{
#' dbpath = tempfile('tempdb', fileext = '.fasta')
#' invisible(file.copy(from = system.file('protseq/Plasminogen.fasta', package = 'Rcpi'), to = dbpath))
#' pssmmat = extractProtPSSM(seq = x, database.path = dbpath)
#' dim(pssmmat)  # 20 x 562 (P00750: length 562, 20 Amino Acids)}

extractProtPSSM = function(seq, start.pos = 1L, end.pos = nchar(seq),
                           psiblast.path = NULL, makeblastdb.path = NULL,
                           database.path = NULL, iter = 5, silent = TRUE,
                           evalue = 10L, word.size = NULL,
                           gapopen = NULL, gapextend = NULL,
                           matrix = 'BLOSUM62', threshold = NULL,
                           seg = 'no', soft.masking = FALSE,
                           culling.limit = NULL, best.hit.overhang = NULL,
                           best.hit.score.edge = NULL,
                           xdrop.ungap = NULL, xdrop.gap = NULL,
                           xdrop.gap.final = NULL,
                           window.size = NULL, gap.trigger = 22L,
                           num.threads = 1L, pseudocount = 0L,
                           inclusion.ethresh = 0.002) {

    if (Sys.which('makeblastdb') == '' & is.null(makeblastdb.path))
        stop('Please install makeblastdb (included in the NCBI BLAST+) or specify makeblastdb.path.')

    if (Sys.which('psiblast') == '' & is.null(psiblast.path))
        stop('Please install psiblast (included in the NCBI BLAST+) or specify psiblast.path.')

    makeblastdb.path = if (!is.null(makeblastdb.path)) makeblastdb.path else Sys.which('makeblastdb')
    psiblast.path = if (!is.null(psiblast.path)) psiblast.path else Sys.which('psiblast')

    if (is.null(database.path)) stop('Must specify the database (a FASTA file) path')

    N = end.pos - start.pos + 1L

    # Prepare data for PSI-Blast

    tmpdb = tempfile('RcpiPSIBlastDB')

    cmddb = paste0(shQuote(makeblastdb.path), ' -dbtype prot -in ',
                   shQuote(database.path), ' -out ', shQuote(tmpdb))

    if (silent == TRUE) system(cmddb, ignore.stdout = TRUE) else system(cmddb)

    # Basic parameters for PSI-Blast

    tmp = tempfile('RcpiPSIBlast')
    queryFasta = paste0(tmp, '.fasta')
    PSSMfile = paste0(tmp, '.pssm')
    querySeq = AAStringSet(seq)
    writeXStringSet(querySeq, queryFasta)

    # Additional parameters for PSI-Blast

    if (!is.null(evalue)) {
        if (evalue <= 0L) {
            stop('evalue must be > 0')
        }
    }

    evalue.arg = ifelse(evalue == 10L, ' ', paste0(' -evalue ', evalue))

    if (!is.null(word.size)) {
        if (word.size < 2L | word.size >= 6L) {
            stop('word.size must be an integer >= 2 and < 6')
        }
    }

    word.size.arg = ifelse(is.null(word.size), ' ', paste0(' -word_size ', word.size))

    gapopen.arg = ifelse(is.null(gapopen), ' ', paste0(' -gapopen ', gapopen))
    gapextend.arg = ifelse(is.null(gapextend), ' ', paste0(' -gapextend ', gapextend))

    matrix.arg = ifelse(matrix == 'BLOSUM62', ' ', paste0(' -matrix ', matrix))

    if (!is.null(threshold)) {
        if (threshold < 0L) {
            stop('threshold must be a real number >= 0')
        }
    }

    threshold.arg = ifelse(is.null(threshold), ' ', paste0(' -threshold ', threshold))

    seg.arg = ifelse(seg == 'no', ' ', paste0(' -seg ', seg))
    soft.masking.arg = ifelse(soft.masking == FALSE, ' ', ' -soft_masking true')

    if (!is.null(culling.limit)) {
        if (culling.limit < 0L) {
            stop('culling.limit must be an integer >= 0')
        }
    }

    culling.limit.arg = ifelse(is.null(culling.limit), ' ', paste0(' -culling_limit ', culling.limit))

    if (!is.null(best.hit.overhang)) {
        if (best.hit.overhang < 0L | best.hit.overhang > 1.5) {
            stop('best.hit.overhang must be a real number >= 0 and =< 0.5')
        }
    }

    best.hit.overhang.arg = ifelse(is.null(best.hit.overhang), ' ', paste0(' -best_hit_overhang ', best.hit.overhang))

    if (!is.null(best.hit.score.edge)) {
        if (best.hit.score.edge < 0L | best.hit.score.edge > 1.5) {
            stop('best.hit.score.edge must be a real number >= 0 and =< 0.5')
        }
    }

    best.hit.score.edge.arg = ifelse(is.null(best.hit.score.edge), ' ', paste0(' -best_hit_score_edge ', best.hit.score.edge))

    xdrop.ungap.arg = ifelse(is.null(xdrop.ungap), ' ', paste0(' -xdrop_ungap ', xdrop.ungap))
    xdrop.gap.arg = ifelse(is.null(xdrop.gap), ' ', paste0(' -xdrop_gap ', xdrop.gap))
    xdrop.gap.final.arg = ifelse(is.null(xdrop.gap.final), ' ', paste0(' -xdrop_gap_final ', xdrop.gap.final))
    window.size.arg = ifelse(is.null(window.size), ' ', paste0(' -window_size ', window.size))
    gap.trigger.arg = ifelse(gap.trigger == 22L, ' ', paste0(' -gap_trigger ', gap.trigger))
    num.threads.arg = ifelse(num.threads == 1L, ' ', paste0(' -num_threads ', num.threads))
    pseudocount.arg = ifelse(pseudocount == 0L, ' ', paste0(' -pseudocount ', pseudocount))
    inclusion.ethresh.arg = ifelse(inclusion.ethresh == 0.002, ' ', paste0(' -inclusion_ethresh ', inclusion.ethresh))

    # Run PSI-Blast

    cmdpsi = paste(
        paste0(shQuote(psiblast.path),
               ' -comp_based_stats 1 -db ', shQuote(tmpdb),
               ' -query ', shQuote(queryFasta), ' -num_iterations ', iter,
               ' -out_ascii_pssm ', shQuote(PSSMfile)),
        paste0(evalue.arg, word.size.arg, gapopen.arg, gapextend.arg,
               matrix.arg, threshold.arg, seg.arg, soft.masking.arg,
               culling.limit.arg, best.hit.overhang.arg, best.hit.score.edge.arg,
               xdrop.ungap.arg, xdrop.gap.arg, xdrop.gap.final.arg, window.size.arg,
               gap.trigger.arg, num.threads.arg, pseudocount.arg,
               inclusion.ethresh.arg))

    if (silent == TRUE) system(cmdpsi, ignore.stdout = TRUE) else system(cmdpsi)

    PSSMraw = readLines(PSSMfile)

    PSSMClean = function(x) {
        y = unlist(strsplit(PSSMraw[x + 3], split = '\\s+'))
        return(-as.numeric(y[4L:23L]))
    }

    PSSMmat = sapply(start.pos:end.pos, PSSMClean)

    AADict = c('A', 'R', 'N', 'D', 'C', 'Q', 'E', 'G', 'H', 'I',
               'L', 'K', 'M', 'F', 'P', 'S', 'T', 'W', 'Y', 'V')
    rownames(PSSMmat) = AADict

    return(PSSMmat)

}

#' Sequence-Order-Coupling Numbers
#'
#' Sequence-Order-Coupling Numbers
#'
#' This function calculates the Sequence-Order-Coupling Numbers
#' (Dim: \code{nlag * 2}, default is 60).
#'
#' @param x A character vector, as the input protein sequence.
#'
#' @param nlag The maximum lag, defualt is 30.
#'
#' @return A length \code{nlag * 2} named vector
#'
#' @seealso See \code{\link{extractProtQSO}} for
#' quasi-sequence-order descriptors.
#'
#' @export extractProtSOCN
#'
#' @references
#' Kuo-Chen Chou. Prediction of Protein Subcellar Locations by
#' Incorporating Quasi-Sequence-Order Effect.
#' \emph{Biochemical and Biophysical Research Communications},
#' 2000, 278, 477-483.
#'
#' Kuo-Chen Chou and Yu-Dong Cai. Prediction of Protein Sucellular Locations by
#' GO-FunD-PseAA Predictor.
#' \emph{Biochemical and Biophysical Research Communications},
#' 2004, 320, 1236-1239.
#'
#' Gisbert Schneider and Paul Wrede. The Rational Design of
#' Amino Acid Sequences by Artifical Neural Networks and Simulated
#' Molecular Evolution: Do Novo Design of an Idealized Leader Cleavge Site.
#' \emph{Biophys Journal}, 1994, 66, 335-344.
#'
#' @examples
#' x = readFASTA(system.file('protseq/P00750.fasta', package = 'Rcpi'))[[1]]
#' extractProtSOCN(x)
#'

extractProtSOCN = function (x, nlag = 30) {

    if (checkProt(x) == FALSE) stop('x has unrecognized amino acid type')

    N = nchar(x)
    if (N <= nlag) stop('Length of the protein sequence must be greater than "nlag"')

    DistMat1 = read.csv(system.file('sysdata/Schneider-Wrede.csv', package = 'Rcpi'), header = TRUE)
    DistMat2 = read.csv(system.file('sysdata/Grantham.csv', package = 'Rcpi'), header = TRUE)
    row.names(DistMat1) = as.character(DistMat1[, 1])
    DistMat1 = DistMat1[, -1]
    row.names(DistMat2) = as.character(DistMat2[, 1])
    DistMat2 = DistMat2[, -1]

    xSplitted = strsplit(x, split = '')[[1]]

    # Compute Schneider.tau_d

    tau1 = vector('list', nlag)

    for (d in 1:nlag) {
        for (i in 1:(N - d)) {
            tau1[[d]][i] = (DistMat1[xSplitted[i], xSplitted[i + d]])^2
        }
    }

    tau1 = sapply(tau1, sum)

    names(tau1) = paste('Schneider.lag', 1:nlag, sep = '')

    # Compute Grantham.tau_d

    tau2 = vector('list', nlag)

    for (d in 1:nlag) {
        for (i in 1:(N - d)) {
            tau2[[d]][i] = (DistMat2[xSplitted[i], xSplitted[i + d]])^2
        }
    }

    tau2 = sapply(tau2, sum)

    names(tau2) = paste('Grantham.lag', 1:nlag, sep = '')

    tau = c(tau1, tau2)

    return(tau)

}

#' Retrieve Drug Molecules in MOL Format from the KEGG Database
#'
#' Retrieve Drug Molecules in MOL Format from the KEGG Database
#'
#' This function retrieves drug molecules in MOL format from the KEGG database.
#'
#' @param id A character vector, as the KEGG drug ID.
#' @param parallel An integer, the parallel parameter, indicates how many
#'                 process the user would like to use for retrieving
#'                 the data (using RCurl), default is \code{5}.
#'                 For regular cases, we recommend a number less than \code{20}.
#'
#' @return A length of \code{id} character vector,
#' each element containing the corresponding drug molecule.
#'
#' @seealso See \code{\link{getSmiFromKEGG}} for retrieving drug molecules
#' in SMILES format from the KEGG database.
#'
#' @export getMolFromKEGG
#'
#' @examples
#' id = 'D00496'  # Penicillamine
#' \donttest{
#' getMolFromKEGG(id)}

getMolFromKEGG = function (id, parallel = 5) {

    # example id     : D00496 (Penicillamine)
    # example url    : http://rest.kegg.jp/get/D00496/mol
    # KEGG API Intro : http://www.kegg.jp/kegg/rest/keggapi.html

    MolURL = paste0('http://rest.kegg.jp/get/', id, '/mol')

    MolTxt = get_url_parallel(url = MolURL, total_con = parallel)

    return(MolTxt)

}

#' Retrieve Drug Molecules in SMILES Format from the KEGG Database
#'
#' Retrieve Drug Molecules in SMILES Format from the KEGG Database
#'
#' This function retrieves drug molecules in SMILES format from the
#' KEGG database.
#'
#' @param id A character vector, as the KEGG drug ID.
#' @param parallel An integer, the parallel parameter, indicates how many
#'                 process the user would like to use for retrieving
#'                 the data (using RCurl), default is \code{5}.
#'                 For regular cases, we recommend a number less than \code{20}.
#'
#' @return A length of \code{id} character vector,
#' each element containing the corresponding drug molecule.
#'
#' @seealso See \code{\link{getMolFromKEGG}} for retrieving drug molecules
#' in MOL format from the KEGG database.
#'
#' @export getSmiFromKEGG
#'
#' @examples
#' id = 'D00496'  # Penicillamine
#' \donttest{
#' getSmiFromKEGG(id)}

getSmiFromKEGG = function (id, parallel = 5) {

    # example id     : D00496 (Penicillamine)
    # example url    : http://rest.kegg.jp/get/D00496/mol
    # KEGG API Intro : http://www.kegg.jp/kegg/rest/keggapi.html

    MolTxt = getMolFromKEGG(id, parallel)

    tmpfile = tempfile(pattern = paste0(id, '-'), fileext = 'mol')
    for (i in 1:length(id)) cat(MolTxt[[i]], file = tmpfile[i])

    Mol = loadMolecules(tmpfile)
    Smi = sapply(Mol, getSmiles)

    unlink(tmpfile)

    return(Smi)

}

#' Descriptor that Calculates Wiener Path Number and Wiener Polarity Number
#'
#' Descriptor that Calculates Wiener Path Number and Wiener Polarity Number
#'
#' This descriptor calculates the Wiener numbers, including the
#' Wiener Path number and the Wiener Polarity Number. Wiener path number:
#' half the sum of all the distance matrix entries; Wiener polarity number:
#' half the sum of all the distance matrix entries with a value of 3.
#'
#' @param molecules Parsed molucule object.
#' @param silent Logical. Whether the calculating process
#' should be shown or not, default is \code{TRUE}.
#'
#' @return A data frame, each row represents one of the molecules,
#' each column represents one feature.
#' This function returns two columns named
#' \code{WPATH} (weiner path number) and \code{WPOL} (weiner polarity number).
#'
#' @export extractDrugWienerNumbers
#'
#' @references
#' Wiener, H. (1947).
#' Structural determination of paraffin boiling points.
#' Journal of the American Chemical Society, 69(1), 17-20.
#'
#' @examples
#' smi = system.file('vignettedata/FDAMDD.smi', package = 'Rcpi')
#' \donttest{
#' mol = readMolFromSmi(smi, type = 'mol')
#' dat = extractDrugWienerNumbers(mol)
#' head(dat)}

extractDrugWienerNumbers = function (molecules, silent = TRUE) {
    evaluateDescriptor(molecules, type = 'WienerNumbersDescriptor', silent = silent)
}

#' Descriptor that Calculates the Principal Moments of
#' Inertia and Ratios of the Principal Moments
#'
#' Descriptor that Calculates the Principal Moments of
#' Inertia and Ratios of the Principal Moments
#'
#' A descriptor that calculates the moment of inertia and radius of gyration.
#' Moment of inertia (MI) values characterize the mass distribution of a molecule.
#' Related to the MI values, ratios of the MI values along the three principal
#' axes are also well know modeling variables.
#' This descriptor calculates the MI values along the
#' X, Y and Z axes as well as the ratio's X/Y, X/Z and Y/Z.
#' Finally it also calculates the radius of
#' gyration of the molecule.
#'
#' @param molecules Parsed molucule object.
#' @param silent Logical. Whether the calculating process
#' should be shown or not, default is \code{TRUE}.
#'
#' @return A data frame, each row represents one of the molecules,
#' each column represents one feature.
#' This function returns 7 columns named
#' \code{MOMI.X}, \code{MOMI.Y}, \code{MOMI.Z},
#' \code{MOMI.XY}, \code{MOMI.XZ}, \code{MOMI.YZ}, \code{MOMI.R}:
#' \itemize{
#' \item \code{MOMI.X} - MI along X axis
#' \item \code{MOMI.Y} - MI along Y axis
#' \item \code{MOMI.Z} - MI along Z axis
#' \item \code{MOMI.XY} - X/Y
#' \item \code{MOMI.XZ} - X/Z
#' \item \code{MOMI.YZ} - Y/Z
#' \item \code{MOMI.R} - Radius of gyration
#' }
#' One important aspect of the algorithm is that if the eigenvalues
#' of the MI tensor are below \code{1e-3},
#' then the ratio's are set to a default of 1000.
#'
#' @export extractDrugMomentOfInertia
#'
#' @examples
#' sdf = system.file('sysdata/OptAA3d.sdf', package = 'Rcpi')
#' \donttest{
#' mol = readMolFromSDF(sdf)
#' dat = extractDrugMomentOfInertia(mol)
#' head(dat)}

extractDrugMomentOfInertia = function (molecules, silent = TRUE) {
    evaluateDescriptor(molecules, type = 'MomentOfInertiaDescriptor', silent = silent)
}

#' Calculate the FP4 Molecular Fingerprints
#'
#' Calculate the FP4 Molecular Fingerprints
#'
#' Calculate the 512 bit FP4 fingerprints provided by OpenBabel.
#'
#' @param molecules R character string object containing the molecules.
#' See the example section for details.
#' @param type \code{'smile'} or \code{'sdf'}.
#'
#' @return A matrix. Each row represents one molecule,
#' the columns represent the fingerprints.
#'
#' @export extractDrugOBFP4
#'
#' @examples
#' mol1 = 'C1CCC1CC(CN(C)(C))CC(=O)CC'  # one molecule SMILE in a vector
#' mol2 = c('CCC', 'CCN', 'CCN(C)(C)', 'c1ccccc1Cc1ccccc1',
#'          'C1CCC1CC(CN(C)(C))CC(=O)CC')  # multiple SMILEs in a vector
#' mol3 = readChar(system.file('compseq/DB00860.sdf', package = 'Rcpi'),
#'                 nchars = 1e+6)  # single molecule in a sdf file
#' mol4 = readChar(system.file('sysdata/OptAA3d.sdf', package = 'Rcpi'),
#'                 nchars = 1e+6)  # multiple molecules in a sdf file
#'
#' \dontrun{
#' smifp0 = extractDrugOBFP4(mol1, type = 'smile')
#' smifp1 = extractDrugOBFP4(mol2, type = 'smile')
#' sdffp0 = extractDrugOBFP4(mol3, type = 'sdf')
#' sdffp1 = extractDrugOBFP4(mol4, type = 'sdf')}

extractDrugOBFP4 = function (molecules, type = c('smile', 'sdf')) {

    check_ob()

    if (type == 'smile') {

        if ( length(molecules) == 1L ) {

            molRefs = eval(parse(text = "ChemmineOB::forEachMol('SMILES', molecules, identity)"))
            fp = eval(parse(text = "ChemmineOB::fingerprint_OB(molRefs, 'FP4')"))

        } else if ( length(molecules) > 1L ) {

            fp = matrix(0L, nrow = length(molecules), ncol = 512L)

            for ( i in 1:length(molecules) ) {
                molRefs = eval(parse(text = "ChemmineOB::forEachMol('SMILES', molecules[i], identity)"))
                fp[i, ] = eval(parse(text = "ChemmineOB::fingerprint_OB(molRefs, 'FP4')"))
            }

        }

    } else if (type == 'sdf') {

        smi = eval(parse(text = "ChemmineOB::convertFormat(from = 'SDF', to = 'SMILES', source = molecules)"))
        smiclean = strsplit(smi, '\\t.*?\\n')[[1]]

        if ( length(smiclean) == 1L ) {

            molRefs = eval(parse(text = "ChemmineOB::forEachMol('SMILES', smiclean, identity)"))
            fp = eval(parse(text = "ChemmineOB::fingerprint_OB(molRefs, 'FP4')"))

        } else if ( length(smiclean) > 1L ) {

            fp = matrix(0L, nrow = length(smiclean), ncol = 512L)
            for ( i in 1:length(smiclean) ) {
                molRefs = eval(parse(text = "ChemmineOB::forEachMol('SMILES', smiclean[i], identity)"))
                fp[i, ] = eval(parse(text = "ChemmineOB::fingerprint_OB(molRefs, 'FP4')"))
            }

        }

    } else {

        stop('Molecule type must be "smile" or "sdf"')

    }

    return(fp)

}

#' Generalized Scales-Based Descriptors derived by Multidimensional Scaling
#'
#' Generalized Scales-Based Descriptors derived by Multidimensional Scaling
#'
#' This function calculates the generalized scales-based descriptors
#' derived by Multidimensional Scaling (MDS).
#' Users could provide customized amino acid property matrices.
#'
#' @param x A character vector, as the input protein sequence.
#' @param propmat A matrix containing the properties for the amino acids.
#'        Each row represent one amino acid type, each column represents
#'        one property.
#'        Note that the one-letter row names must be provided for we
#'        need them to seek the properties for each AA type.
#' @param k Integer. The maximum dimension of the space which the data
#'        are to be represented in.
#'        Must be no greater than the number of AA properties provided.
#' @param lag The lag parameter. Must be less than the amino acids.
#' @param scale Logical. Should we auto-scale the property matrix
#'        (\code{propmat}) before doing MDS? Default is \code{TRUE}.
#' @param silent Logical. Whether we print the \code{k} eigenvalues
#'        computed during the scaling process or not.
#'        Default is \code{TRUE}.
#'
#' @return A length \code{lag * p^2} named vector,
#'         \code{p} is the number of scales (dimensionality) selected.
#'
#' @seealso See \code{\link{extractPCMScales}} for generalized scales-based
#' descriptors derived by Principal Components Analysis.
#'
#' @export extractPCMMDSScales
#'
#' @references
#' Venkatarajan, M. S., & Braun, W. (2001).
#' New quantitative descriptors of amino acids based on multidimensional scaling
#' of a large number of physical-chemical properties.
#' Molecular modeling annual, 7(12), 445--453.
#'
#' @examples
#' x = readFASTA(system.file('protseq/P00750.fasta', package = 'Rcpi'))[[1]]
#' data(AATopo)
#' tprops = AATopo[, c(37:41, 43:47)]  # select a set of topological descriptors
#' mds = extractPCMMDSScales(x, propmat = tprops, k = 5, lag = 7, silent = FALSE)
#'

extractPCMMDSScales = function (x, propmat, k, lag,
                                scale = TRUE, silent = TRUE) {

    if (checkProt(x) == FALSE) stop('x has unrecognized amino acid type')

    k = min(k, ncol(propmat) - 1, nrow(propmat) - 1)

    if (scale) propmat = scale(propmat)

    d = dist(propmat)  # euclidean distances between the rows
    mds = cmdscale(d, k = k, eig = TRUE)

    accmat = matrix(0, k, nchar(x))
    x.split = strsplit(x, '')[[1]]

    for (i in 1:nchar(x)) {
        accmat[, i] = mds$points[x.split[i], 1:k]
    }

    result = acc(accmat, lag)

    if (!silent) {
        cat('Eigenvalues computed during the scaling process:\n')
        print(mds$eig)
    }

    return(result)

}

#' Descriptor that Calculates the Vertex Adjacency Information of A Molecule
#'
#' Descriptor that Calculates the Vertex Adjacency Information of A Molecule
#'
#' Vertex adjacency information (magnitude):
#' \eqn{1 + \log_2^m} where \eqn{m} is the number of heavy-heavy bonds.
#' If \eqn{m} is zero, then \code{0} is returned.
#'
#' @param molecules Parsed molucule object.
#' @param silent Logical. Whether the calculating process
#' should be shown or not, default is \code{TRUE}.
#'
#' @return A data frame, each row represents one of the molecules,
#' each column represents one feature.
#' This function returns one column named \code{VAdjMat}.
#'
#' @export extractDrugVAdjMa
#'
#' @examples
#' smi = system.file('vignettedata/FDAMDD.smi', package = 'Rcpi')
#' \donttest{
#' mol = readMolFromSmi(smi, type = 'mol')
#' dat = extractDrugVAdjMa(mol)
#' head(dat)}

extractDrugVAdjMa = function (molecules, silent = TRUE) {
    evaluateDescriptor(molecules, type = 'VAdjMaDescriptor', silent = silent)
}

#' Retrieve Protein Sequence in FASTA Format from the KEGG Database
#'
#' Retrieve Protein Sequence in FASTA Format from the KEGG Database
#'
#' This function retrieves protein sequences in FASTA format
#' from the KEGG database.
#'
#' @param id A character vector, as the protein ID.
#' @param parallel An integer, the parallel parameter, indicates how many
#'                 process the user would like to use for retrieving
#'                 the data (using RCurl), default is \code{5}.
#'                 For regular cases, we recommend a number less than \code{20}.
#'
#' @return A list, each component contains one of the protein sequences
#' in FASTA format.
#'
#' @seealso See \code{\link{getSeqFromKEGG}} for retrieving protein
#' represented by amino acid sequence from the KEGG database.
#' See \code{\link{readFASTA}} for reading FASTA format files.
#'
#' @export getFASTAFromKEGG
#'
#' @examples
#' id = c('hsa:10161', 'hsa:10162')
#' \donttest{
#' getFASTAFromKEGG(id)}

getFASTAFromKEGG = function (id, parallel = 5) {

    # example id : hsa:10161
    # example url: http://rest.kegg.jp/get/hsa:10161/aaseq

    fastaURL = paste0('http://rest.kegg.jp/get/', id, '/aaseq')

    fastaTxt = get_url_parallel(url = fastaURL, total_con = parallel)

    return(fastaTxt)

}

#' Retrieve Protein Sequence from the KEGG Database
#'
#' Retrieve Protein Sequence from the KEGG Database
#'
#' This function retrieves protein represented by amino acid sequence
#' from the KEGG database.
#'
#' @param id A character vector, as the protein ID.
#' @param parallel An integer, the parallel parameter, indicates how many
#'                 process the user would like to use for retrieving
#'                 the data (using RCurl), default is \code{5}.
#'                 For regular cases, we recommend a number less than \code{20}.
#'
#' @return A list, each component contains one of the protein represented by
#' amino acid sequence(s).
#'
#' @seealso See \code{\link{getFASTAFromKEGG}} for retrieving protein sequence
#' in FASTA format from the KEGG database.
#'
#' @export getSeqFromKEGG
#'
#' @examples
#' id = c('hsa:10161', 'hsa:10162')
#' \donttest{
#' getSeqFromKEGG(id)}

getSeqFromKEGG = function (id, parallel = 5) {

    # example id : hsa:10161
    # example url: http://rest.kegg.jp/get/hsa:10161/aaseq

    fastaTxt = getFASTAFromKEGG(id, parallel)

    tmpfile = tempfile(pattern = paste0(id, '-'), fileext = 'fasta')
    for (i in 1:length(id)) write(fastaTxt[[i]], tmpfile[i])

    AASeq = lapply(tmpfile, readFASTA)

    unlink(tmpfile)

    return(AASeq)

}

#' Calculate the Number of Amino Acids Descriptor
#'
#' Calculate the Number of Amino Acids Descriptor
#'
#' Calculates the number of each amino acids (total 20 types)
#' found in the molecues.
#'
#' @param molecules Parsed molucule object.
#' @param silent Logical. Whether the calculating process
#' should be shown or not, default is \code{TRUE}.
#'
#' @return A data frame, each row represents one of the molecules,
#' each column represents one feature.
#' This function returns 20 columns named
#' \code{nA}, \code{nR}, \code{nN}, \code{nD}, \code{nC},
#' \code{nF}, \code{nQ}, \code{nE}, \code{nG}, \code{nH},
#' \code{nI}, \code{nP}, \code{nL} \code{nK}, \code{nM},
#' \code{nS}, \code{nT}, \code{nY} \code{nV}, \code{nW}.
#'
#' @export extractDrugAminoAcidCount
#'
#' @examples
#' smi = system.file('vignettedata/FDAMDD.smi', package = 'Rcpi')
#' \donttest{
#' mol = readMolFromSmi(smi, type = 'mol')
#' dat = extractDrugAminoAcidCount(mol)
#' head(dat)}

extractDrugAminoAcidCount = function (molecules, silent = TRUE) {
    evaluateDescriptor(molecules, type = 'AminoAcidCountDescriptor', silent = silent)
}

#' Calculate the Kier and Hall Chi Path Cluster Indices of Orders 4, 5 and 6
#'
#' Calculate the Kier and Hall Chi Path Cluster Indices of Orders 4, 5 and 6
#'
#' Evaluates chi path cluster descriptors.
#' The code currently evluates the simple and
#' valence chi chain descriptors of orders 4, 5 and 6.
#' It utilizes the graph isomorphism code of the CDK to find
#' fragments matching SMILES strings representing the fragments
#' corresponding to each type of chain.
#'
#' @param molecules Parsed molucule object.
#' @param silent Logical. Whether the calculating process
#' should be shown or not, default is \code{TRUE}.
#'
#' @return A data frame, each row represents one of the molecules,
#' each column represents one feature.
#' This function returns 6 columns named
#' \code{SPC.4}, \code{SPC.5}, \code{SPC.6},
#' \code{VPC.4}, \code{VPC.5}, \code{VPC.6}:
#' \itemize{
#' \item \code{SPC.4} - Simple path cluster, order 4
#' \item \code{SPC.5} - Simple path cluster, order 5
#' \item \code{SPC.6} - Simple path cluster, order 6
#' \item \code{VPC.4} - Valence path cluster, order 4
#' \item \code{VPC.5} - Valence path cluster, order 5
#' \item \code{VPC.6} - Valence path cluster, order 6
#' }
#'
#' @note These descriptors are calculated using graph isomorphism
#'       to identify the various fragments. As a result calculations may
#'       be slow. In addition, recent versions of Molconn-Z use simplified
#'       fragment definitions (i.e., rings without branches etc.)
#'       whereas these descriptors use the older more complex
#'       fragment definitions.
#'
#' @export extractDrugChiPathCluster
#'
#' @examples
#' smi = system.file('vignettedata/FDAMDD.smi', package = 'Rcpi')
#' \donttest{
#' mol = readMolFromSmi(smi, type = 'mol')
#' dat = extractDrugChiPathCluster(mol)
#' head(dat)}

extractDrugChiPathCluster = function (molecules, silent = TRUE) {
    evaluateDescriptor(molecules, type = 'ChiPathClusterDescriptor', silent = silent)
}

#' Quasi-Sequence-Order (QSO) Descriptor
#'
#' Quasi-Sequence-Order (QSO) Descriptor
#'
#' This function calculates the Quasi-Sequence-Order (QSO) descriptor
#' (Dim: \code{20 + 20 + (2 * nlag)}, default is 100).
#'
#' @param x A character vector, as the input protein sequence.
#'
#' @param nlag The maximum lag, defualt is 30.
#'
#' @param w The weighting factor, default is 0.1.
#'
#' @return A length \code{20 + 20 + (2 * nlag)} named vector
#'
#' @seealso See \code{\link{extractProtSOCN}}
#' for sequence-order-coupling numbers.
#'
#' @export extractProtQSO
#'
#' @references
#' Kuo-Chen Chou. Prediction of Protein Subcellar Locations by
#' Incorporating Quasi-Sequence-Order Effect.
#' \emph{Biochemical and Biophysical Research Communications},
#' 2000, 278, 477-483.
#'
#' Kuo-Chen Chou and Yu-Dong Cai. Prediction of Protein Sucellular Locations by
#' GO-FunD-PseAA Predictor.
#' \emph{Biochemical and Biophysical Research Communications},
#' 2004, 320, 1236-1239.
#'
#' Gisbert Schneider and Paul Wrede. The Rational Design of
#' Amino Acid Sequences by Artifical Neural Networks and Simulated
#' Molecular Evolution: Do Novo Design of an Idealized Leader Cleavge Site.
#' \emph{Biophys Journal}, 1994, 66, 335-344.
#'
#' @examples
#' x = readFASTA(system.file('protseq/P00750.fasta', package = 'Rcpi'))[[1]]
#' extractProtQSO(x)
#'

extractProtQSO = function (x, nlag = 30, w = 0.1) {

    if (checkProt(x) == FALSE) stop('x has unrecognized amino acid type')

    N = nchar(x)
    if (N <= nlag) stop('Length of the protein sequence must be greater than "nlag"')

    DistMat1 = read.csv(system.file('sysdata/Schneider-Wrede.csv', package = 'Rcpi'), header = TRUE)
    DistMat2 = read.csv(system.file('sysdata/Grantham.csv', package = 'Rcpi'), header = TRUE)
    row.names(DistMat1) = as.character(DistMat1[, 1])
    DistMat1 = DistMat1[, -1]
    row.names(DistMat2) = as.character(DistMat2[, 1])
    DistMat2 = DistMat2[, -1]

    xSplitted = strsplit(x, split = '')[[1]]

    # Compute Schneider.tau_d

    tau1 = vector('list', nlag)

    for (d in 1:nlag) {
        for (i in 1:(N - d)) {
            tau1[[d]][i] = (DistMat1[xSplitted[i], xSplitted[i + d]])^2
        }
    }

    tau1 = sapply(tau1, sum)

    # Compute Grantham.tau_d

    tau2 = vector('list', nlag)

    for (d in 1:nlag) {
        for (i in 1:(N - d)) {
            tau2[[d]][i] = (DistMat2[xSplitted[i], xSplitted[i + d]])^2
        }
    }

    tau2 = sapply(tau2, sum)

    # Compute fr

    AADict = c('A', 'R', 'N', 'D', 'C', 'E', 'Q', 'G', 'H', 'I',
               'L', 'K', 'M', 'F', 'P', 'S', 'T', 'W', 'Y', 'V')

    fr = summary(factor(xSplitted, levels = AADict), maxsum = 21)

    # Compute Schneider.Xr Grantham.Xr Schneider.Xd Grantham.Xd

    Xr1 = fr/(1 + (w * sum(tau1)))
    names(Xr1) = paste('Schneider.Xr.', names(Xr1), sep = '')

    Xr2 = fr/(1 + (w * sum(tau2)))
    names(Xr2) = paste('Grantham.Xr.', names(Xr2), sep = '')

    Xd1 = (w * tau1)/(1 + (w * sum(tau1)))
    names(Xd1) = paste('Schneider.Xd.', 1:nlag, sep = '')

    Xd2 = (w * tau2)/(1 + (w * sum(tau2)))
    names(Xd2) = paste('Grantham.Xd.', 1:nlag, sep = '')

    QSO = c(Xr1, Xr2, Xd1, Xd2)

    return(QSO)

}

#' Auto Cross Covariance (ACC) for Generating Scales-Based Descriptors
#' of the Same Length
#'
#' Calculates auto covariance and auto cross covariance
#' for generating scale-based descriptors of the same length.
#'
#' @param mat A \code{p * n} matrix. Each row represents one scale
#'   (total \code{p} scales), each column represents one amino acid position
#'   (total \code{n} amino acids).
#'
#' @param lag The lag parameter. Must be less than the amino acids.
#'
#' @return A length \code{lag * p^2} named vector, the element names are
#'   constructed by: the scales index (crossed scales index) and
#'   lag index.
#'
#' @note To see more details about auto cross covariance, check the references.
#'
#' @seealso
#' See \code{\link{extractPCMScales}} for
#' generalized scales-based descriptors.
#' For more details, see \code{\link{extractPCMDescScales}}
#' and \code{\link{extractPCMPropScales}}.
#'
#' @export acc
#'
#' @references
#' Wold, S., Jonsson, J., Sjörström, M., Sandberg, M., & Rännar, S. (1993).
#' DNA and peptide sequences and chemical processes multivariately modelled
#' by principal component analysis and partial least-squares projections
#' to latent structures.
#' \emph{Analytica chimica acta}, 277(2), 239--253.
#'
#' Sjöström, M., Rännar, S., & Wieslander, Å. (1995).
#' Polypeptide sequence property relationships in \emph{Escherichia coli}
#' based on auto cross covariances.
#' \emph{Chemometrics and intelligent laboratory systems}, 29(2), 295--305.
#'
#' @examples
#' p = 8    # p is the scales number
#' n = 200  # n is the amino acid number
#' lag = 7  # lag parameter
#' mat = matrix(rnorm(p * n), nrow = p, ncol = n)
#' acc(mat, lag)
acc = function (mat, lag) {

    p = nrow(mat)
    n = ncol(mat)

    if (lag > n) stop('lag must be smaller than the amino acids in the sequence')

    # auto covariance: p elements

    acc1 = matrix(0, nrow = p, ncol = lag)

    for (j in 1:p) {
        for (i in 1:lag) {
            acc1[j, i] = sum(mat[j, 1:(n - i)] * mat[j, ((1:(n - i)) + i)]) / (n - i)
        }
    }

    acc1 = as.vector(acc1)
    names(acc1) = as.vector(outer(paste0('scl', 1:p), paste0('lag', 1:lag),
                                  paste, sep = '.'))

    # auto cross covariance: p^2 - p elements

    acc2 = matrix(0, nrow = p^2 - p, ncol = lag)

    idx = cbind(combn(1:p, 2), combn(1:p, 2)[2:1, ])

    for (j in 1:ncol(idx)) {
        for (i in 1:lag) {
            acc2[j, i] = sum(mat[idx[1, j], 1:(n - i)] * mat[idx[2, j], ((1:(n - i)) + i)]) / (n - i)
        }
    }

    acc2 = as.vector(acc2)
    names(acc2) = as.vector(outer(
        paste0('scl', paste(idx[1, ], idx[2, ], sep = '.')),
        paste0('lag', 1:lag), paste, sep = '.'))

    ACC = c(acc1, acc2)

    return(ACC)

}

test_that("`acc()` works", {
    p   = 8    # p is the scales number
    n   = 200  # n is the amino acid number
    lag = 7    # the lag paramter
    mat = matrix(rnorm(p * n), nrow = p, ncol = n)

    expect_equal(length(acc(mat, lag)), 448L)
})

test_acc = function() {
    p   = 8    # p is the scales number
    n   = 200  # n is the amino acid number
    lag = 7    # the lag paramter
    mat = matrix(rnorm(p * n), nrow = p, ncol = n)
    checkEquals(length(acc(mat, lag)), 448L)
}

#' Descriptor of Topological Polar Surface Area Based on
#' Fragment Contributions (TPSA)
#'
#' Descriptor of Topological Polar Surface Area Based on
#' Fragment Contributions (TPSA)
#'
#' Calculate the descriptor of topological polar surface area
#' based on fragment contributions (TPSA).
#'
#' @param molecules Parsed molucule object.
#' @param silent Logical. Whether the calculating process
#' should be shown or not, default is \code{TRUE}.
#'
#' @return A data frame, each row represents one of the molecules,
#' each column represents one feature.
#' This function returns one column named \code{TopoPSA}.
#'
#' @export extractDrugTPSA
#'
#' @references
#' Ertl, P., Rohde, B., & Selzer, P. (2000).
#' Fast calculation of molecular polar surface area as a sum of
#' fragment-based contributions and its application to the prediction
#' of drug transport properties.
#' Journal of medicinal chemistry, 43(20), 3714-3717.
#'
#' @examples
#' smi = system.file('vignettedata/FDAMDD.smi', package = 'Rcpi')
#' \donttest{
#' mol = readMolFromSmi(smi, type = 'mol')
#' dat = extractDrugTPSA(mol)
#' head(dat)}

extractDrugTPSA = function (molecules, silent = TRUE) {
    evaluateDescriptor(molecules, type = 'TPSADescriptor', silent = silent)
}

#' Calculate the Ratio of Length to Breadth Descriptor
#'
#' Calculate the Ratio of Length to Breadth Descriptor
#'
#' Calculates the Ratio of Length to Breadth, as a result ti does not perform
#' any orientation and only considers the X & Y
#' extents for a series of rotations about the Z axis
#' (in 10 degree increments).
#'
#' @param molecules Parsed molucule object.
#' @param silent Logical. Whether the calculating process
#' should be shown or not, default is \code{TRUE}.
#'
#' @return A data frame, each row represents one of the molecules,
#' each column represents one feature.
#' This function returns two columns named \code{LOBMAX} and \code{LOBMIN}:
#' \itemize{
#' \item \code{LOBMAX} - The maximum L/B ratio;
#' \item \code{LOBMIN} - The L/B ratio for the rotation that results in the
#' minimum area (defined by the product of the X & Y extents for that orientation).
#' }
#'
#' @export extractDrugLengthOverBreadth
#'
#' @note The descriptor assumes that the atoms have been configured.
#'
#' @examples
#' sdf = system.file('sysdata/OptAA3d.sdf', package = 'Rcpi')
#' \donttest{
#' mol = readMolFromSDF(sdf)
#' dat = extractDrugLengthOverBreadth(mol)
#' head(dat)}

extractDrugLengthOverBreadth = function (molecules, silent = TRUE) {
    evaluateDescriptor(molecules, type = 'LengthOverBreadthDescriptor', silent = silent)
}

loadMolecules <- function(molfiles, ...) {
    rlang::check_installed("rcdk", reason = "to load molecular structures")
    cl <- rlang::call2("load.molecules", .ns = "rcdk", molfiles = molfiles, ...)
    rlang::eval_tidy(cl)
}

getSmiles <- function(molecule, ...) {
    rlang::check_installed("rcdk", reason = "to generate SMILES representation")
    cl <- rlang::call2("get.smiles", .ns = "rcdk", molecule = molecule, ...)
    rlang::eval_tidy(cl)
}

parseSmiles <- function(smiles, ...) {
    rlang::check_installed("rcdk", reason = "to parse SMILES")
    cl <- rlang::call2("parse.smiles", .ns = "rcdk", smiles = smiles, ...)
    rlang::eval_tidy(cl)
}

evaluateDescriptor <- function(molecules, type, silent = TRUE) {
    rlang::check_installed("rcdk", reason = "to compute molecular descriptors")
    cl <- rlang::call2(
        "eval.desc",
        .ns = "rcdk",
        molecules = molecules,
        which.desc = paste0(
            "org.openscience.cdk.",
            "qsar.descriptors.molecular.",
            type
        ),
        verbose = !silent
    )
    rlang::eval_tidy(cl)
}

getFingerprint <- function(molecule, type, depth = 6, size = 1024, silent = TRUE) {
    rlang::check_installed("rcdk", reason = "to generate molecular fingerprints")
    cl <- rlang::call2(
        "get.fingerprint",
        .ns = "rcdk",
        molecule = molecule,
        type = type,
        depth = depth,
        size = size,
        verbose = !silent
    )
    rlang::eval_tidy(cl)
}

#' A Variety of Descriptors Combining Surface Area and Partial Charge Information
#'
#' A Variety of Descriptors Combining Surface Area and Partial Charge Information
#'
#' Calculates 29 Charged Partial Surface Area (CPSA) descriptors.
#' The CPSA's were developed by Stanton et al.
#'
#' @param molecules Parsed molucule object.
#' @param silent Logical. Whether the calculating process
#' should be shown or not, default is \code{TRUE}.
#'
#' @return A data frame, each row represents one of the molecules,
#' each column represents one feature. This function returns 29 columns:
#' \itemize{
#' \item \code{PPSA.1} - partial positive surface area --
#' sum of surface area on positive parts of molecule
#' \item \code{PPSA.2} - partial positive surface area *
#' total positive charge on the molecule
#' \item \code{PPSA.3} - charge weighted partial positive surface area
#' \item \code{PNSA.1} - partial negative surface area --
#' sum of surface area on negative parts of molecule
#' \item \code{PNSA.2} - partial negative surface area *
#' total negative charge on the molecule
#' \item \code{PNSA.3} - charge weighted partial negative surface area
#' \item \code{DPSA.1} - difference of PPSA.1 and PNSA.1
#' \item \code{DPSA.2} - difference of FPSA.2 and PNSA.2
#' \item \code{DPSA.3} - difference of PPSA.3 and PNSA.3
#' \item \code{FPSA.1} - PPSA.1 / total molecular surface area
#' \item \code{FFSA.2} - PPSA.2 / total molecular surface area
#' \item \code{FPSA.3} - PPSA.3 / total molecular surface area
#' \item \code{FNSA.1} - PNSA.1 / total molecular surface area
#' \item \code{FNSA.2} - PNSA.2 / total molecular surface area
#' \item \code{FNSA.3} - PNSA.3 / total molecular surface area
#' \item \code{WPSA.1} - PPSA.1 * total molecular surface area / 1000
#' \item \code{WPSA.2} - PPSA.2 * total molecular surface area /1000
#' \item \code{WPSA.3} - PPSA.3 * total molecular surface area / 1000
#' \item \code{WNSA.1} - PNSA.1 * total molecular surface area /1000
#' \item \code{WNSA.2} - PNSA.2 * total molecular surface area / 1000
#' \item \code{WNSA.3} - PNSA.3 * total molecular surface area / 1000
#' \item \code{RPCG} - relative positive charge --
#' most positive charge / total positive charge
#' \item \code{RNCG} - relative negative charge --
#' most negative charge / total negative charge
#' \item \code{RPCS} - relative positive charge surface area --
#' most positive surface area * RPCG
#' \item \code{RNCS} - relative negative charge surface area --
#' most negative surface area * RNCG
#' \item \code{THSA} - sum of solvent accessible surface areas of
#' atoms with absolute value of partial charges less than 0.2
#' \item \code{TPSA} - sum of solvent accessible surface areas of
#' atoms with absolute value of partial charges greater than or equal 0.2
#' \item \code{RHSA} - THSA / total molecular surface area
#' \item \code{RPSA} - TPSA / total molecular surface area
#' }
#'
#' @export extractDrugCPSA
#'
#' @references
#' Stanton, D.T. and Jurs, P.C. ,
#' Development and Use of Charged Partial Surface
#' Area Structural Descriptors in Computer Assissted
#' Quantitative Structure Property Relationship Studies,
#' Analytical Chemistry, 1990, 62:2323.2329.
#'
#' @examples
#' sdf = system.file('sysdata/OptAA3d.sdf', package = 'Rcpi')
#' \donttest{
#' mol = readMolFromSDF(sdf)
#' dat = extractDrugCPSA(mol)
#' head(dat)}

extractDrugCPSA = function (molecules, silent = TRUE) {
    evaluateDescriptor(molecules, type = 'CPSADescriptor', silent = silent)
}

#' Topological Descriptor Characterizing the Carbon Connectivity
#' in Terms of Hybridization
#'
#' Topological Descriptor Characterizing the Carbon Connectivity
#' in Terms of Hybridization
#'
#' Calculates the carbon connectivity in terms of hybridization.
#' The function calculates 9 descriptors in the following order:
#'
#' \itemize{
#' \item \code{C1SP1} - triply hound carbon bound to one other carbon
#' \item \code{C2SP1} - triply bound carbon bound to two other carbons
#' \item \code{C1SP2} - doubly hound carbon bound to one other carbon
#' \item \code{C2SP2} - doubly bound carbon bound to two other carbons
#' \item \code{C3SP2} - doubly bound carbon bound to three other carbons
#' \item \code{C1SP3} - singly bound carbon bound to one other carbon
#' \item \code{C2SP3} - singly bound carbon bound to two other carbons
#' \item \code{C3SP3} - singly bound carbon bound to three other carbons
#' \item \code{C4SP3} - singly bound carbon bound to four other carbons
#' }
#'
#' @param molecules Parsed molucule object.
#' @param silent Logical. Whether the calculating process
#' should be shown or not, default is \code{TRUE}.
#'
#' @return A data frame, each row represents one of the molecules,
#' each column represents one feature.
#' This function returns 9 columns named
#' \code{C1SP1}, \code{C2SP1}, \code{C1SP2}, \code{C2SP2}, \code{C3SP2},
#' \code{C1SP3}, \code{C2SP3}, \code{C3SP3} and \code{C4SP3}.
#'
#' @export extractDrugCarbonTypes
#'
#' @examples
#' smi = system.file('vignettedata/FDAMDD.smi', package = 'Rcpi')
#' \donttest{
#' mol = readMolFromSmi(smi, type = 'mol')
#' dat = extractDrugCarbonTypes(mol)
#' head(dat)}

extractDrugCarbonTypes = function (molecules, silent = TRUE) {
    evaluateDescriptor(molecules, type = 'CarbonTypesDescriptor', silent = silent)
}

#' Calculate All Molecular Descriptors in Rcpi at Once
#'
#' Calculate All Molecular Descriptors in Rcpi at Once
#'
#' This function calculates all the molecular descriptors
#' in the Rcpi package at once.
#'
#' @param molecules Parsed molucule object.
#' @param silent Logical. Whether the calculating process should be
#' shown or not, default is \code{TRUE}.
#' @param warn Logical. Whether the warning about some descriptors
#' need the 3D coordinates should be shown or not after the calculation,
#' default is \code{TRUE}.
#'
#' @return A data frame, each row represents one of the molecules,
#' each column represents one descriptor.
#' Currently, this function returns total 293 descriptors
#' composed of 48 descriptor types.
#'
#' @export extractDrugAIO
#'
#' @note
#' Note that we need 3-D coordinates of the molecules to calculate
#' some of the descriptors, if not provided, these descriptors
#' values will be \code{NA}.
#'
#' @examples
#' # Load 20 small molecules that have 3D coordinates
#' sdf = system.file('sysdata/OptAA3d.sdf', package = 'Rcpi')
#' \donttest{
#' mol = readMolFromSDF(sdf)
#' dat = extractDrugAIO(mol, warn = FALSE)}

extractDrugAIO = function (molecules, silent = TRUE, warn = TRUE) {

    if (warn == TRUE)
        warning('Note that we need 3-D coordinates of the molecules to calculate some of the descriptors, if not provided, these descriptors will be NA')

    descNames = c(
        'ALOGPDescriptor',
        'APolDescriptor',
        'AminoAcidCountDescriptor',
        'AromaticAtomsCountDescriptor',
        'AromaticBondsCountDescriptor',
        'AtomCountDescriptor',
        'AutocorrelationDescriptorCharge',
        'AutocorrelationDescriptorMass',
        'AutocorrelationDescriptorPolarizability',
        'BCUTDescriptor',
        'BPolDescriptor',
        'BondCountDescriptor',
        'CPSADescriptor',
        'CarbonTypesDescriptor',
        'ChiChainDescriptor',
        'ChiClusterDescriptor',
        'ChiPathClusterDescriptor',
        'ChiPathDescriptor',
        'EccentricConnectivityIndexDescriptor',
        'FMFDescriptor',
        'FragmentComplexityDescriptor',
        'GravitationalIndexDescriptor',
        'HBondAcceptorCountDescriptor',
        'HBondDonorCountDescriptor',
        'HybridizationRatioDescriptor',
        'IPMolecularLearningDescriptor',
        'KappaShapeIndicesDescriptor',
        'KierHallSmartsDescriptor',
        'LargestChainDescriptor',
        'LargestPiSystemDescriptor',
        'LengthOverBreadthDescriptor',
        'LongestAliphaticChainDescriptor',
        'MDEDescriptor',
        'MannholdLogPDescriptor',
        'MomentOfInertiaDescriptor',
        'PetitjeanNumberDescriptor',
        'PetitjeanShapeIndexDescriptor',
        'RotatableBondsCountDescriptor',
        'RuleOfFiveDescriptor',
        'TPSADescriptor',
        'VABCDescriptor',
        'VAdjMaDescriptor',
        'WHIMDescriptor',
        'WeightDescriptor',
        'WeightedPathDescriptor',
        'WienerNumbersDescriptor',
        'XLogPDescriptor',
        'ZagrebIndexDescriptor')

    evaluateDescriptor(molecules, type = descNames, silent = silent)
}

#' Descriptor that Calculates the Volume of A Molecule
#'
#' Descriptor that Calculates the Volume of A Molecule
#'
#' This descriptor calculates the volume of a molecule.
#'
#' @param molecules Parsed molucule object.
#' @param silent Logical. Whether the calculating process
#' should be shown or not, default is \code{TRUE}.
#'
#' @return A data frame, each row represents one of the molecules,
#' each column represents one feature.
#' This function returns one column named \code{VABC}.
#'
#' @keywords extractDrugVABC Volume VABC
#'
#' @aliases extractDrugVABC
#'
#' @author Nan Xiao <\url{https://nanx.me}>
#'
#' @export extractDrugVABC
#'
#' @importFrom rcdk eval.desc
#'
#' @examples
#' smi = system.file('vignettedata/FDAMDD.smi', package = 'Rcpi')
#' \donttest{
#' mol = readMolFromSmi(smi, type = 'mol')
#' dat = extractDrugVABC(mol)
#' head(dat)}

extractDrugVABC = function (molecules, silent = TRUE) {

    x = eval.desc(
        molecules,
        'org.openscience.cdk.qsar.descriptors.molecular.VABCDescriptor',
        verbose = !silent)

    return(x)

}

#' Read Molecules from SMILES Files and Return Parsed Java
#' Molecular Object or Plain Text List
#'
#' Read Molecules from SMILES Files and Return Parsed Java
#' Molecular Object or Plain Text List
#'
#' This function reads molecules from SMILES strings and return
#' parsed Java molecular object or plain text list
#' needed by \code{extractDrug...()} functions.
#'
#' @param smifile Character vector, containing SMILES file location(s).
#' @param type \code{'mol'} or \code{'text'}. \code{'mol'} returns parsed
#'        Java molecular object, used for \code{'text'} returns (plain-text)
#'        character string list. For common molecular descriptors and
#'        fingerprints, use \code{'mol'}.
#'        For descriptors and fingerprints calculated by OpenBabel,
#'        i.e. functions named \code{extractDrugOB...()} , use \code{'text'}.
#'
#' @return A list, containing parsed Java molecular object or character strings.
#'
#' @seealso See \code{\link{readMolFromSDF}} for reading molecules
#' from SDF files and returning parsed Java molecular object.
#'
#' @export readMolFromSmi
#'
#' @examples
#' smi = system.file('vignettedata/FDAMDD.smi', package = 'Rcpi')
#' \donttest{
#' mol1 = readMolFromSmi(smi, type = 'mol')
#' mol2 = readMolFromSmi(smi, type = 'text')}

readMolFromSmi = function (smifile, type = c('mol', 'text')) {

    if (type == 'mol') {

        txt = scan(smifile, what = 'complex', quiet = TRUE)
        smi = as.character(txt)
        mol = parseSmiles(smi)

    } else if (type == 'text') {

        mol = scan(smifile, what = 'complex', quiet = TRUE)

    } else {

        stop('type must be one of "mol" or "text"')

    }

    return(mol)

}

test_that("`extractDrugRuleOfFive()` works", {
    skip_if_not_installed("rcdk")

    smi = c(
        'c1ccc2c(c1)oc(=O)c(C(CC(=O)C)c1ccc([N+](=O)[O-])cc1)c2O',
        'c1(ccc(cc1)O)NC(=O)C',
        'c1ccccc1NC(=O)C',
        'n1nc(S(=O)(=O)N)sc1NC(=O)C',
        'O=S(=O)(c1ccc(cc1)C(=O)C)NC(=O)NC1CCCCC1',
        'CC(=O)NO'
    )
    mol = readMolFromSmi(textConnection(smi), type = 'mol')
    dat = extractDrugRuleOfFive(mol)

    expect_equal(sum(as.matrix(dat)), 0, tolerance = 1e+0)
})

#' Profile-based protein representation derived by PSSM
#' (Position-Specific Scoring Matrix)
#'
#' Profile-based protein representation derived by PSSM
#' (Position-Specific Scoring Matrix)
#'
#' This function calculates the profile-based protein representation
#' derived by PSSM. The feature vector is based on the PSSM computed by
#' \code{\link{extractProtPSSM}}. For a given sequence,
#' The PSSM feature represents the log-likelihood of the substitution of the
#' 20 types of amino acids at that position in the sequence.
#' Each PSSM feature value in the vector represents the degree of conservation
#' of a given amino acid type. The value is normalized to
#' interval (0, 1) by the transformation 1/(1+e^(-x)).
#'
#' @param pssmmat The PSSM computed by \code{\link{extractProtPSSM}}.
#'
#' @return A numeric vector which has \code{20 x N} named elements,
#' where \code{N} is the size of the window (number of rows of the PSSM).
#'
#' @seealso \link{extractProtPSSM} \link{extractProtPSSMAcc}
#'
#' @export extractProtPSSMFeature
#'
#' @references
#' Ye, Xugang, Guoli Wang, and Stephen F. Altschul.
#' "An assessment of substitution scores for protein profile-profile comparison."
#' \emph{Bioinformatics} 27.24 (2011): 3356--3363.
#'
#' Rangwala, Huzefa, and George Karypis.
#' "Profile-based direct kernels for remote homology detection and fold recognition."
#' \emph{Bioinformatics} 21.23 (2005): 4239--4247.
#'
#' @examples
#' x = readFASTA(system.file('protseq/P00750.fasta', package = 'Rcpi'))[[1]]
#' \donttest{
#' dbpath = tempfile('tempdb', fileext = '.fasta')
#' invisible(file.copy(from = system.file('protseq/Plasminogen.fasta', package = 'Rcpi'), to = dbpath))
#' pssmmat = extractProtPSSM(seq = x, database.path = dbpath)
#' pssmfeature = extractProtPSSMFeature(pssmmat)
#' head(pssmfeature)}

extractProtPSSMFeature = function(pssmmat) {

    # Normalize PSSM scores to (0, 1)
    result = as.vector(1/(1 + exp(pssmmat)))

    AADict = c('A', 'R', 'N', 'D', 'C', 'Q', 'E', 'G', 'H', 'I',
               'L', 'K', 'M', 'F', 'P', 'S', 'T', 'W', 'Y', 'V')
    names(result) = paste0('PSSM_', paste0(rep(1L:ncol(pssmmat), each = 20L),
                                           '_', AADict))

    return(result)

}

#' Protein Sequence Segmentation
#'
#' Protein Sequence Segmentation
#'
#' This function extracts the segmentations from the protein sequence.
#'
#' @param x A character vector, as the input protein sequence.
#'
#' @param aa A character, the amino acid type. one of
#'           \code{'A'}, \code{'R'}, \code{'N'}, \code{'D'}, \code{'C'},
#'           \code{'E'}, \code{'Q'}, \code{'G'}, \code{'H'},
#'           \code{'I'}, \code{'L'}, \code{'K'}, \code{'M'},
#'           \code{'F'}, \code{'P'}, \code{'S'}, \code{'T'},
#'           \code{'W'}, \code{'Y'}, \code{'V'}.
#'
#' @param k A positive integer, specifys the window size (half of the window),
#'          default is 7.
#'
#' @return A named list, each component contains one of the
#'         segmentations (a character string), names of the list components
#'         are the positions of the specified amino acid in the sequence.
#'
#' @export segProt
#'
#' @examples
#' x = readFASTA(system.file('protseq/P00750.fasta', package = 'Rcpi'))[[1]]
#' segProt(x, aa = 'R', k = 5)
#'

segProt = function (x, aa = c('A', 'R', 'N', 'D', 'C',
                              'E', 'Q', 'G', 'H', 'I',
                              'L', 'K', 'M', 'F', 'P',
                              'S', 'T', 'W', 'Y', 'V'), k = 7) {

    aa = match.arg(aa)

    xSplitted = strsplit(x, split = '')[[1]]
    n = nchar(x)

    CenterIdx = which(xSplitted == aa)

    if (length(CenterIdx) < 0.5)
        stop(paste('Did not find AA', aa, 'in the sequence'))

    CenterIdx = CenterIdx[(CenterIdx - k) > 0.5 & (CenterIdx + k) < (n + 0.5)]

    if (length(CenterIdx) < 0.5)
        stop(paste('Segmentation does not exist for AA', aa, 'and step', k))

    Segments = vector('list', length(CenterIdx))

    for (i in 1:length(CenterIdx)) {
        Segments[[i]] = paste(xSplitted[(CenterIdx[i] - k):(CenterIdx[i] + k)],
                              collapse = '')
    }

    names(Segments) = as.character(CenterIdx)

    return(Segments)

}

#' CTD Descriptors - Distribution
#'
#' CTD Descriptors - Distribution
#'
#' This function calculates the Distribution descriptor of the
#' CTD descriptors (Dim: 105).
#'
#' @param x A character vector, as the input protein sequence.
#'
#' @return A length 105 named vector
#'
#' @seealso See \code{\link{extractProtCTDC}} and \code{\link{extractProtCTDT}}
#' for the Composition and Transition descriptors.
#'
#' @export extractProtCTDD
#'
#' @references
#' Inna Dubchak, Ilya Muchink, Stephen R. Holbrook and Sung-Hou Kim.
#' Prediction of protein folding class using global description of
#' amino acid sequence. \emph{Proceedings of the National Academy of Sciences}.
#' USA, 1995, 92, 8700-8704.
#'
#' Inna Dubchak, Ilya Muchink, Christopher Mayor, Igor Dralyuk and Sung-Hou Kim.
#' Recognition of a Protein Fold in the Context of the SCOP classification.
#' \emph{Proteins: Structure, Function and Genetics}, 1999, 35, 401-407.
#'
#' @examples
#' x = readFASTA(system.file('protseq/P00750.fasta', package = 'Rcpi'))[[1]]
#' extractProtCTDD(x)

extractProtCTDD = function (x) {

    if (checkProt(x) == FALSE) stop('x has unrecognized amino acid type')

    group1 = list(
        hydrophobicity  = c('R', 'K', 'E', 'D', 'Q', 'N'),
        normwaalsvolume = c('G', 'A', 'S', 'T', 'P', 'D', 'C'),
        polarity        = c('L', 'I', 'F', 'W', 'C', 'M', 'V', 'Y'),
        polarizability  = c('G', 'A', 'S', 'D', 'T'),
        charge          = c('K', 'R'),
        secondarystruct = c('E', 'A', 'L', 'M', 'Q', 'K', 'R', 'H'),
        solventaccess   = c('A', 'L', 'F', 'C', 'G', 'I', 'V', 'W'))

    group2 = list(
        hydrophobicity  = c('G', 'A', 'S', 'T', 'P', 'H', 'Y'),
        normwaalsvolume = c('N', 'V', 'E', 'Q', 'I', 'L'),
        polarity        = c('P', 'A', 'T', 'G', 'S'),
        polarizability  = c('C', 'P', 'N', 'V', 'E', 'Q', 'I', 'L'),
        charge          = c('A', 'N', 'C', 'Q', 'G', 'H', 'I', 'L',
                            'M', 'F', 'P', 'S', 'T', 'W', 'Y', 'V'),
        secondarystruct = c('V', 'I', 'Y', 'C', 'W', 'F', 'T'),
        solventaccess   = c('R', 'K', 'Q', 'E', 'N', 'D'))

    group3 = list(
        hydrophobicity  = c('C', 'L', 'V', 'I', 'M', 'F', 'W'),
        normwaalsvolume = c('M', 'H', 'K', 'F', 'R', 'Y', 'W'),
        polarity        = c('H', 'Q', 'R', 'K', 'N', 'E', 'D'),
        polarizability  = c('K', 'M', 'H', 'F', 'R', 'Y', 'W'),
        charge          = c('D', 'E'),
        secondarystruct = c('G', 'N', 'P', 'S', 'D'),
        solventaccess   = c('M', 'S', 'P', 'T', 'H', 'Y'))

    xSplitted = strsplit(x, split = '')[[1]]
    n  = nchar(x)

    G = vector('list', 7)
    for (i in 1:7) G[[i]] = rep(NA, n)

    # Get groups for each property & each amino acid

    for (i in 1:7) {
        try(G[[i]][which(xSplitted %in% group1[[i]])] <- 'G1')
        try(G[[i]][which(xSplitted %in% group2[[i]])] <- 'G2')
        try(G[[i]][which(xSplitted %in% group3[[i]])] <- 'G3')
    }

    # Compute Distribution

    D = vector('list', 7)
    for (i in 1:7) D[[i]] = matrix(ncol = 5, nrow = 3)

    for (i in 1:7) {
        for (j in 1:3) {
            inds = which(G[[i]] == paste0('G', j))
            quartiles = floor(length(inds) * c(0.25, 0.5, 0.75))

            quartiles[which(quartiles <= 0)] = 1

            D[[i]][j, ] = if (length(inds) > 0)
                (inds[c(1, quartiles, length(inds))]) * 100/n else 0
        }
    }

    D = do.call(rbind, D)
    D = as.vector(t(D))

    names(D) = paste(
        rep(paste('prop', 1:7, sep = ''), each = 15),
        rep(rep(c('.G1', '.G2', '.G3'), each = 5), times = 7),
        rep(paste('.residue', c('0', '25', '50', '75', '100'),
                  sep = ''), times = 21), sep = '')

    return(D)

}

#' Descriptor that Calculates the Total Weight of Atoms
#'
#' Descriptor that Calculates the Total Weight of Atoms
#'
#' This descriptor calculates the molecular weight.
#'
#' @param molecules Parsed molucule object.
#' @param silent Logical. Whether the calculating process
#' should be shown or not, default is \code{TRUE}.
#'
#' @return A data frame, each row represents one of the molecules,
#' each column represents one feature.
#' This function returns one column named \code{MW}.
#'
#' @export extractDrugWeight
#'
#' @examples
#' smi = system.file('vignettedata/FDAMDD.smi', package = 'Rcpi')
#' \donttest{
#' mol = readMolFromSmi(smi, type = 'mol')
#' dat = extractDrugWeight(mol)
#' head(dat)}

extractDrugWeight = function (molecules, silent = TRUE) {
    evaluateDescriptor(molecules, type = 'WeightDescriptor', silent = silent)
}

#' Calculate the Kier and Hall Chi Path Indices of Orders 0 to 7
#'
#' Calculate the Kier and Hall Chi Path Indices of Orders 0 to 7
#'
#' Evaluates chi path descriptors. This function utilizes the graph isomorphism
#' code of the CDK to find fragments matching SMILES strings representing the
#' fragments corresponding to each type of chain.
#'
#' @param molecules Parsed molucule object.
#' @param silent Logical. Whether the calculating process
#' should be shown or not, default is \code{TRUE}.
#'
#' @return A data frame, each row represents one of the molecules,
#' each column represents one feature.
#' This function returns 16 columns,
#' The order and names of the columns returned is:
#' \itemize{
#' \item \code{SP.0, SP.1, ..., SP.7} - Simple path, orders 0 to 7
#' \item \code{VP.0, VP.1, ..., VP.7} - Valence path, orders 0 to 7
#' }
#'
#' @note These descriptors are calculated using graph isomorphism to identify
#' the various fragments. As a result calculations may be slow.
#' In addition, recent versions of Molconn-Z use simplified fragment definitions
#' (i.e., rings without branches etc.) whereas these descriptors use the older
#' more complex fragment definitions.
#'
#' @export extractDrugChiPath
#'
#' @examples
#' smi = system.file('vignettedata/FDAMDD.smi', package = 'Rcpi')
#' \donttest{
#' mol = readMolFromSmi(smi, type = 'mol')
#' dat = extractDrugChiPath(mol)
#' head(dat)}

extractDrugChiPath = function (molecules, silent = TRUE) {
    evaluateDescriptor(molecules, type = 'ChiPathDescriptor', silent = silent)
}

#' Chemical File Formats Conversion
#'
#' Chemical File Formats Conversion
#'
#' This function converts between various chemical file formats via OpenBabel.
#' The complete supported file format list could be found at
#' \url{https://openbabel.org/docs/FileFormats/Overview.html}.
#'
#' @param infile A character string. Indicating the input file location.
#' @param outfile A character string. Indicating the output file location.
#' @param from The format of \code{infile}.
#'             A character string supported by OpenBabel.
#'             See the note section for the supported formats.
#' @param to The desired format of \code{outfile}.
#'           A character string supported by OpenBabel.
#'           See the note section for the supported formats.
#'
#' @return \code{NULL}
#'
#' @export convMolFormat
#'
#' @note The supported formats include:
#'             \itemize{
#'             \item abinit -- ABINIT Output Format [Read-only]
#'             \item acr -- ACR format [Read-only]
#'             \item adf -- ADF cartesian input format [Write-only]
#'             \item adfout -- ADF output format [Read-only]
#'             \item alc -- Alchemy format
#'             \item arc -- Accelrys/MSI Biosym/Insight II CAR format [Read-only]
#'             \item axsf -- XCrySDen Structure Format [Read-only]
#'             \item bgf -- MSI BGF format
#'             \item box -- Dock 3.5 Box format
#'             \item bs -- Ball and Stick format
#'             \item c3d1 -- Chem3D Cartesian 1 format
#'             \item c3d2 -- Chem3D Cartesian 2 format
#'             \item cac -- CAChe MolStruct format [Write-only]
#'             \item caccrt -- Cacao Cartesian format
#'             \item cache -- CAChe MolStruct format [Write-only]
#'             \item cacint -- Cacao Internal format [Write-only]
#'             \item can -- Canonical SMILES format
#'             \item car -- Accelrys/MSI Biosym/Insight II CAR format [Read-only]
#'             \item castep -- CASTEP format [Read-only]
#'             \item ccc -- CCC format [Read-only]
#'             \item cdx -- ChemDraw binary format [Read-only]
#'             \item cdxml -- ChemDraw CDXML format
#'             \item cht -- Chemtool format [Write-only]
#'             \item cif -- Crystallographic Information File
#'             \item ck -- ChemKin format
#'             \item cml -- Chemical Markup Language
#'             \item cmlr -- CML Reaction format
#'             \item com -- Gaussian 98/03 Input [Write-only]
#'             \item CONFIG -- DL-POLY CONFIG
#'             \item CONTCAR -- VASP format [Read-only]
#'             \item copy -- Copy raw text [Write-only]
#'             \item crk2d -- Chemical Resource Kit diagram(2D)
#'             \item crk3d -- Chemical Resource Kit 3D format
#'             \item csr -- Accelrys/MSI Quanta CSR format [Write-only]
#'             \item cssr -- CSD CSSR format [Write-only]
#'             \item ct -- ChemDraw Connection Table format
#'             \item cub -- Gaussian cube format
#'             \item cube -- Gaussian cube format
#'             \item dat -- Generic Output file format [Read-only]
#'             \item dmol -- DMol3 coordinates format
#'             \item dx -- OpenDX cube format for APBS
#'             \item ent -- Protein Data Bank format
#'             \item fa -- FASTA format
#'             \item fasta -- FASTA format
#'             \item fch -- Gaussian formatted checkpoint file format [Read-only]
#'             \item fchk -- Gaussian formatted checkpoint file format [Read-only]
#'             \item fck -- Gaussian formatted checkpoint file format [Read-only]
#'             \item feat -- Feature format
#'             \item fh -- Fenske-Hall Z-Matrix format [Write-only]
#'             \item fhiaims -- FHIaims XYZ format
#'             \item fix -- SMILES FIX format [Write-only]
#'             \item fpt -- Fingerprint format [Write-only]
#'             \item fract -- Free Form Fractional format
#'             \item fs -- Fastsearch format
#'             \item fsa -- FASTA format
#'             \item g03 -- Gaussian Output [Read-only]
#'             \item g09 -- Gaussian Output [Read-only]
#'             \item g92 -- Gaussian Output [Read-only]
#'             \item g94 -- Gaussian Output [Read-only]
#'             \item g98 -- Gaussian Output [Read-only]
#'             \item gal -- Gaussian Output [Read-only]
#'             \item gam -- GAMESS Output [Read-only]
#'             \item gamess -- GAMESS Output [Read-only]
#'             \item gamin -- GAMESS Input
#'             \item gamout -- GAMESS Output [Read-only]
#'             \item gau -- Gaussian 98/03 Input [Write-only]
#'             \item gjc -- Gaussian 98/03 Input [Write-only]
#'             \item gjf -- Gaussian 98/03 Input [Write-only]
#'             \item got -- GULP format [Read-only]
#'             \item gpr -- Ghemical format
#'             \item gr96 -- GROMOS96 format [Write-only]
#'             \item gro -- GRO format
#'             \item gukin -- GAMESS-UK Input
#'             \item gukout -- GAMESS-UK Output
#'             \item gzmat -- Gaussian Z-Matrix Input
#'             \item hin -- HyperChem HIN format
#'             \item HISTORY -- DL-POLY HISTORY [Read-only]
#'             \item inchi -- InChI format
#'             \item inchikey -- InChIKey [Write-only]
#'             \item inp -- GAMESS Input
#'             \item ins -- ShelX format [Read-only]
#'             \item jin -- Jaguar input format [Write-only]
#'             \item jout -- Jaguar output format [Read-only]
#'             \item k -- Compare molecules using InChI [Write-only]
#'             \item log -- Generic Output file format [Read-only]
#'             \item mcdl -- MCDL format
#'             \item mcif -- Macromolecular Crystallographic Info
#'             \item mdl -- MDL MOL format
#'             \item ml2 -- Sybyl Mol2 format
#'             \item mmcif -- Macromolecular Crystallographic Info
#'             \item mmd -- MacroModel format
#'             \item mmod -- MacroModel format
#'             \item mna -- Multilevel Neighborhoods of Atoms (MNA) [Write-only]
#'             \item mol -- MDL MOL format
#'             \item mol2 -- Sybyl Mol2 format
#'             \item mold -- Molden format
#'             \item molden -- Molden format
#'             \item molf -- Molden format
#'             \item molreport -- Open Babel molecule report [Write-only]
#'             \item moo -- MOPAC Output format [Read-only]
#'             \item mop -- MOPAC Cartesian format
#'             \item mopcrt -- MOPAC Cartesian format
#'             \item mopin -- MOPAC Internal
#'             \item mopout -- MOPAC Output format [Read-only]
#'             \item mp -- Molpro input format [Write-only]
#'             \item mpc -- MOPAC Cartesian format
#'             \item mpd -- MolPrint2D format [Write-only]
#'             \item mpo -- Molpro output format [Read-only]
#'             \item mpqc -- MPQC output format [Read-only]
#'             \item mpqcin -- MPQC simplified input format [Write-only]
#'             \item mrv -- Chemical Markup Language
#'             \item msi -- Accelrys/MSI Cerius II MSI format [Read-only]
#'             \item msms -- M.F. Sanner's MSMS input format [Write-only]
#'             \item nul -- Outputs nothing [Write-only]
#'             \item nw -- NWChem input format [Write-only]
#'             \item nwo -- NWChem output format [Read-only]
#'             \item out -- Generic Output file format [Read-only]
#'             \item outmol -- DMol3 coordinates format
#'             \item output -- Generic Output file format [Read-only]
#'             \item pc -- PubChem format [Read-only]
#'             \item pcm -- PCModel Format
#'             \item pdb -- Protein Data Bank format
#'             \item pdbqt -- AutoDock PDQBT format
#'             \item png -- PNG 2D depiction
#'             \item POSCAR -- VASP format [Read-only]
#'             \item pov -- POV-Ray input format [Write-only]
#'             \item pqr -- PQR format
#'             \item pqs -- Parallel Quantum Solutions format
#'             \item prep -- Amber Prep format [Read-only]
#'             \item pwscf -- PWscf format [Read-only]
#'             \item qcin -- Q-Chem input format [Write-only]
#'             \item qcout -- Q-Chem output format [Read-only]
#'             \item report -- Open Babel report format [Write-only]
#'             \item res -- ShelX format [Read-only]
#'             \item rsmi -- Reaction SMILES format
#'             \item rxn -- MDL RXN format
#'             \item sd -- MDL MOL format
#'             \item sdf -- MDL MOL format
#'             \item smi -- SMILES format
#'             \item smiles -- SMILES format
#'             \item svg -- SVG 2D depiction [Write-only]
#'             \item sy2 -- Sybyl Mol2 format
#'             \item t41 -- ADF TAPE41 format [Read-only]
#'             \item tdd -- Thermo format
#'             \item text -- Read and write raw text
#'             \item therm -- Thermo format
#'             \item tmol -- TurboMole Coordinate format
#'             \item txt -- Title format
#'             \item txyz -- Tinker XYZ format
#'             \item unixyz -- UniChem XYZ format
#'             \item vmol -- ViewMol format
#'             \item xed -- XED format [Write-only]
#'             \item xml -- General XML format [Read-only]
#'             \item xsf -- XCrySDen Structure Format [Read-only]
#'             \item xyz -- XYZ cartesian coordinates format
#'             \item yob -- YASARA.org YOB format
#'             \item zin -- ZINDO input format [Write-only]
#'             }
#'
#' @examples
#' sdf = system.file('sysdata/OptAA3d.sdf', package = 'Rcpi')
#' # SDF to SMILES
#' \dontrun{
#' convMolFormat(infile = sdf, outfile = 'aa.smi',
#'               from = 'sdf', to = 'smiles')}
#' # SMILES to MOPAC Cartesian format
#' \dontrun{
#' convMolFormat(infile = 'aa.smi', outfile = 'aa.mop',
#'               from = 'smiles', to = 'mop')}

convMolFormat = function (infile, outfile, from, to) {
    check_ob()
    eval(parse(text = "ChemmineOB::convertFormatFile(from = from, to = to, fromFile = infile, toFile = outfile)"))
    invisible()
}

check_ob <- function() {
    if (!is_pkg_available("ChemmineOB")) {
        stop("Must install the `ChemmineOB` package first.", call. = FALSE)
    } else {
        invisible(NULL)
    }
}

#' Calculate Holistic Descriptors Described by Todeschini et al.
#'
#' Calculate Holistic Descriptors Described by Todeschini et al.
#'
#' Holistic descriptors described by Todeschini et al, the descriptors
#' are based on a number of atom weightings.
#' There are six different possible weightings:
#' \itemize{
#' \item unit weights
#' \item atomic masses
#' \item van der Waals volumes
#' \item Mulliken atomic electronegativites
#' \item atomic polarizabilities
#' \item E-state values described by Kier and Hall
#' }
#'
#' Currently weighting schemes 1, 2, 3, 4 and 5 are implemented.
#' The weight values are taken from Todeschini et al.
#' and as a result 19 elements are considered.
#' For each weighting scheme we can obtain
#' \itemize{
#' \item 11 directional WHIM descriptors (lambda1 .. 3, nu1 .. 2, gamma1 .. 3, eta1 .. 3)
#' \item 6 non-directional WHIM descriptors (T, A, V, K, G, D)
#' }
#' Though Todeschini et al. mentions that for planar molecules
#' only 8 directional WHIM descriptors are required the current code will return all 11.
#'
#' @param molecules Parsed molucule object.
#' @param silent Logical. Whether the calculating process
#' should be shown or not, default is \code{TRUE}.
#'
#' @return A data frame, each row represents one of the molecules,
#' each column represents one feature.
#' This function returns 17 columns:
#' \itemize{
#' \item Wlambda1
#' \item Wlambda2
#' \item wlambda3
#' \item Wnu1
#' \item Wnu2
#' \item Wgamma1
#' \item Wgamma2
#' \item Wgamma3
#' \item Weta1
#' \item Weta2
#' \item Weta3
#' \item WT
#' \item WA
#' \item WV
#' \item WK
#' \item WG
#' \item WD
#' }
#'
#' Each name will have a suffix of the form \code{.X} where \code{X} indicates
#' the weighting scheme used. Possible values of \code{X} are
#' \itemize{
#' \item unity
#' \item mass
#' \item volume
#' \item eneg
#' \item polar
#' }
#'
#' @export extractDrugWHIM
#'
#' @references
#' Todeschini, R. and Gramatica, P.,
#' New 3D Molecular Descriptors: The WHIM theory and QAR Applications,
#' Persepectives in Drug Discovery and Design, 1998, ?:355-380.
#'
#' @examples
#' sdf = system.file('sysdata/OptAA3d.sdf', package = 'Rcpi')
#' \donttest{
#' mol = readMolFromSDF(sdf)
#' dat = extractDrugWHIM(mol)
#' head(dat)}

extractDrugWHIM = function (molecules, silent = TRUE) {
    evaluateDescriptor(molecules, type = 'WHIMDescriptor', silent = silent)
}

#' Geary Autocorrelation Descriptor
#'
#' Geary Autocorrelation Descriptor
#'
#' This function calculates the Geary
#' autocorrelation descriptor (Dim: \code{length(props) * nlag}).
#'
#' @param x A character vector, as the input protein sequence.
#'
#' @param props A character vector, specifying the
#'              Accession Number of the target properties.
#'              8 properties are used by default, as listed below:
#'              \describe{
#'              \item{AccNo. CIDH920105}{Normalized average hydrophobicity scales (Cid et al., 1992)}
#'              \item{AccNo. BHAR880101}{Average flexibility indices (Bhaskaran-Ponnuswamy, 1988)}
#'              \item{AccNo. CHAM820101}{Polarizability parameter (Charton-Charton, 1982)}
#'              \item{AccNo. CHAM820102}{Free energy of solution in water, kcal/mole (Charton-Charton, 1982)}
#'              \item{AccNo. CHOC760101}{Residue accessible surface area in tripeptide (Chothia, 1976)}
#'              \item{AccNo. BIGC670101}{Residue volume (Bigelow, 1967)}
#'              \item{AccNo. CHAM810101}{Steric parameter (Charton, 1981)}
#'              \item{AccNo. DAYM780201}{Relative mutability (Dayhoff et al., 1978b)}}
#'
#' @param nlag Maximum value of the lag parameter. Default is \code{30}.
#'
#' @param customprops A \code{n x 21} named data frame contains \code{n}
#'                    customize property. Each row contains one property.
#'                    The column order for different amino acid types is
#'                    \code{'AccNo'}, \code{'A'}, \code{'R'}, \code{'N'},
#'                    \code{'D'}, \code{'C'}, \code{'E'}, \code{'Q'},
#'                    \code{'G'}, \code{'H'}, \code{'I'}, \code{'L'},
#'                    \code{'K'}, \code{'M'}, \code{'F'}, \code{'P'},
#'                    \code{'S'}, \code{'T'}, \code{'W'}, \code{'Y'},
#'                    \code{'V'}, and the columns should also be \emph{exactly}
#'                    named like this.
#'                    The \code{AccNo} column contains the properties' names.
#'                    Then users should explicitly specify these properties
#'                    with these names in the argument \code{props}.
#'                    See the examples below for a demonstration.
#'                    The default value for \code{customprops} is \code{NULL}.
#'
#' @return A length \code{nlag} named vector
#'
#' @seealso See \code{\link{extractProtMoreauBroto}} and
#' \code{\link{extractProtMoran}}
#' for Moreau-Broto autocorrelation descriptors and
#' Moran autocorrelation descriptors.
#'
#' @export extractProtGeary
#'
#' @references
#' AAindex: Amino acid index database.
#' \url{https://www.genome.jp/dbget/aaindex.html}
#'
#' Feng, Z.P. and Zhang, C.T. (2000)
#' Prediction of membrane protein types based on the hydrophobic
#' index of amino acids.
#' \emph{Journal of Protein Chemistry}, 19, 269-275.
#'
#' Horne, D.S. (1988)
#' Prediction of protein helix content from
#' an autocorrelation analysis of sequence hydrophobicities.
#' \emph{Biopolymers}, 27, 451-477.
#'
#' Sokal, R.R. and Thomson, B.A. (2006)
#' Population structure inferred by local spatial autocorrelation:
#' an usage from an Amerindian tribal population.
#' \emph{American Journal of Physical Anthropology}, 129, 121-131.
#'
#' @examples
#' x = readFASTA(system.file('protseq/P00750.fasta', package = 'Rcpi'))[[1]]
#' extractProtGeary(x)
#'
#' myprops = data.frame(AccNo = c("MyProp1", "MyProp2", "MyProp3"),
#'                      A = c(0.62,  -0.5, 15),  R = c(-2.53,   3, 101),
#'                      N = c(-0.78,  0.2, 58),  D = c(-0.9,    3, 59),
#'                      C = c(0.29,    -1, 47),  E = c(-0.74,   3, 73),
#'                      Q = c(-0.85,  0.2, 72),  G = c(0.48,    0, 1),
#'                      H = c(-0.4,  -0.5, 82),  I = c(1.38, -1.8, 57),
#'                      L = c(1.06,  -1.8, 57),  K = c(-1.5,    3, 73),
#'                      M = c(0.64,  -1.3, 75),  F = c(1.19, -2.5, 91),
#'                      P = c(0.12,     0, 42),  S = c(-0.18, 0.3, 31),
#'                      T = c(-0.05, -0.4, 45),  W = c(0.81, -3.4, 130),
#'                      Y = c(0.26,  -2.3, 107), V = c(1.08, -1.5, 43))
#'
#' # Use 4 properties in the AAindex database, and 3 cutomized properties
#' extractProtGeary(x, customprops = myprops,
#'                  props = c('CIDH920105', 'BHAR880101',
#'                            'CHAM820101', 'CHAM820102',
#'                            'MyProp1', 'MyProp2', 'MyProp3'))
#'

extractProtGeary = function (
    x, props = c('CIDH920105', 'BHAR880101',
                 'CHAM820101', 'CHAM820102',
                 'CHOC760101', 'BIGC670101',
                 'CHAM810101', 'DAYM780201'),
    nlag = 30L, customprops = NULL) {

    if (checkProt(x) == FALSE)
        stop('x has unrecognized amino acid type')

    if (nchar(x) <= nlag)
        warning('extractGeary: length of the sequence is <= nlag; NAs will be generated')

    # 1. Compute Pr values for each type of property

    AAidx = read.csv(system.file('sysdata/AAidx.csv', package = 'Rcpi'), header = TRUE)

    if (!is.null(customprops)) AAidx = rbind(AAidx, customprops)

    aaidx = AAidx[, -1]
    row.names(aaidx) = AAidx[, 1]
    n = length(props)
    pmean = rowMeans(aaidx[props, ])
    psd   = apply(aaidx[props, ], 1, sd) * sqrt((20 - 1)/20) # sd() uses (n-1)

    Pr = data.frame(matrix(ncol = 20, nrow = n))
    for (i in 1:n) Pr[i, ] = (aaidx[props[i], ] - pmean[i])/psd[i]

    # 2. Replace character with numbers, also applies to less than 20 AA occured

    xSplitted = strsplit(x, split = '')[[1]]
    AADict = c('A', 'R', 'N', 'D', 'C', 'E', 'Q', 'G', 'H', 'I',
               'L', 'K', 'M', 'F', 'P', 'S', 'T', 'W', 'Y', 'V')
    names(Pr) = AADict

    P = vector('list', n)
    for (i in 1:n) P[[i]] = xSplitted

    for (i in 1:n) {
        for (j in AADict) {
            try(P[[i]][which(P[[i]] == j)] <- Pr[i, j], silent = TRUE)
        }
    }

    P = lapply(P, as.numeric)

    # 3. Compute Geary Autocorrelation Descriptor

    Geary = vector('list', n)
    N  = length(xSplitted)

    Pbar = sapply(P, mean)

    for (i in 1:n) {
        for (j in 1:nlag) {
            Geary[[i]][j] = ifelse(
                N - j > 0,
                ((N - 1)/(2 * (N - j))) * ((sum((P[[i]][1:(N - j)] - P[[i]][(1:(N - j)) + j])^2))/(sum((P[[i]] - Pbar[i])^2))),
                NA)
        }
    }

    Geary = unlist(Geary)

    names(Geary) = as.vector(t(outer(
        props,
        paste('.lag', 1:nlag, sep = ''),
        paste, sep = '')))

    return(Geary)

}

.getPPICombine = function (protmat1, protmat2) {

    return(cbind(protmat1, protmat2))

}

.getPPITensor = function (protmat1, protmat2, row, col) {

    return(array(.inner(t(protmat1), protmat2, '*'), c(row, col^2)))

}

.getPPIEntry = function (protmat1, protmat2) {

    return(cbind((protmat1 * protmat2), (protmat1 + protmat2)))

}

#' Generating Protein-Protein Interaction Descriptors
#'
#' Generating Protein-Protein Interaction Descriptors
#'
#' This function calculates the protein-protein interaction descriptors
#' by three types of interaction:
#' \itemize{
#' \item \code{combine} - combine the two descriptor matrix,
#' result has \code{(p + p)} columns
#' \item \code{tensorprod} - calculate column-by-column
#' (pseudo)-tensor product type interactions, result has \code{(p * p)} columns
#' \item \code{entrywise} - calculate entrywise product and
#' entrywise sum of the two matrices, then combine them,
#' result has \code{(p + p)} columns
#' }
#'
#' @param protmat1 The first protein descriptor matrix,
#' must have the same ncol with \code{protmat2}.
#' @param protmat2 The second protein descriptor matrix,
#' must have the same ncol with \code{protmat1}.
#' @param type The interaction type, one or more of
#' \code{"combine"}, \code{"tensorprod"}, and \code{"entrywise"}.
#'
#' @return A matrix containing the protein-protein interaction descriptors
#'
#' @seealso See \code{\link{getCPI}} for generating
#' compound-protein interaction descriptors.
#'
#' @export getPPI
#'
#' @examples
#' x = matrix(1:10, ncol = 2)
#' y = matrix(5:14, ncol = 2)
#'
#' getPPI(x, y, type = 'combine')
#' getPPI(x, y, type = 'tensorprod')
#' getPPI(x, y, type = 'entrywise')
#' getPPI(x, y, type = c('combine', 'tensorprod'))
#' getPPI(x, y, type = c('combine', 'entrywise'))
#' getPPI(x, y, type = c('entrywise', 'tensorprod'))
#' getPPI(x, y, type = c('combine', 'entrywise', 'tensorprod'))
#'

getPPI = function(
    protmat1, protmat2,
    type = c('combine', 'tensorprod', 'entrywise')) {

    if (!is.matrix(protmat1)) protmat1 = as.matrix(protmat1)
    if (!is.matrix(protmat2)) protmat2 = as.matrix(protmat2)

    protrow1 = nrow(protmat1)
    protrow2 = nrow(protmat2)

    if (protrow1 != protrow2) stop('Matrix row count must match')

    protcol1 = ncol(protmat1)
    protcol2 = ncol(protmat2)

    if (protcol1 != protcol2) stop('Matrix column count must match')

    if (missing(type)) stop('Must provide at least one interaction type')

    if (all(type == 'combine')) {

        result = .getPPICombine(protmat1, protmat2)

    } else if (all(type == 'tensorprod')) {

        result = .getPPITensor(protmat1, protmat2,
                               row = protrow1, col = protcol1)

    } else if (all(type == 'entrywise')) {

        result = .getPPIEntry(protmat1, protmat2)

    } else if (length(setdiff(type, c('tensorprod', 'combine'))) == 0L) {

        result = cbind(.getPPICombine(protmat1, protmat2),
                       .getPPITensor(protmat1, protmat2,
                                     row = protrow1, col = protcol1))

    } else if (length(setdiff(type, c('tensorprod', 'entrywise'))) == 0L) {

        result = cbind(.getPPITensor(protmat1, protmat2,
                                     row = protrow1,
                                     col = protcol1),
                       .getPPIEntry(protmat1, protmat2))

    } else if (length(setdiff(type, c('combine', 'entrywise'))) == 0L) {

        result = cbind(.getPPICombine(protmat1, protmat2),
                       .getPPIEntry(protmat1, protmat2))

    } else if (length(setdiff(type, c('tensorprod',
                                      'combine',
                                      'entrywise'))) == 0L) {

        result = cbind(.getPPICombine(protmat1, protmat2),
                       .getPPITensor(protmat1, protmat2,
                                     row = protrow1,
                                     col = protcol1),
                       .getPPIEntry(protmat1, protmat2))

    } else {

        stop('Interaction type must be in "tensorprod", "combine" and "entrywise"')

    }

    return(result)

}

test_that("`getPPI()` works", {
    x = matrix(1:10, ncol = 2)
    y = matrix(5:14, ncol = 2)

    expect_equal(ncol(getPPI(x, y, type = 'combine')), 4L)
    expect_equal(ncol(getPPI(x, y, type = 'tensorprod')), 4L)
    expect_equal(ncol(getPPI(x, y, type = 'entrywise')), 4L)
    expect_equal(ncol(getPPI(x, y, type = c('combine', 'tensorprod'))), 8L)
    expect_equal(ncol(getPPI(x, y, type = c('combine', 'entrywise'))), 8L)
    expect_equal(ncol(getPPI(x, y, type = c('entrywise', 'tensorprod'))), 8L)
    expect_equal(ncol(getPPI(x, y, type = c('combine', 'entrywise', 'tensorprod'))), 12L)
})

#' Number of Hydrogen Bond Acceptors
#'
#' Number of Hydrogen Bond Acceptors
#'
#' This descriptor calculates the number of hydrogen bond acceptors
#' using a slightly simplified version of the PHACIR atom types.
#' The following groups are counted as hydrogen bond acceptors:
#' any oxygen where the formal charge of the oxygen is
#' non-positive (i.e. formal charge <= 0) except
#' \enumerate{
#' \item an aromatic ether oxygen (i.e. an ether oxygen that is
#' adjacent to at least one aromatic carbon)
#' \item an oxygen that is adjacent to a nitrogen
#' }
#' and any nitrogen where the formal charge of the nitrogen is
#' non-positive (i.e. formal charge <= 0) except a nitrogen
#' that is adjacent to an oxygen.
#'
#' @param molecules Parsed molucule object.
#' @param silent Logical. Whether the calculating process
#' should be shown or not, default is \code{TRUE}.
#'
#' @return A data frame, each row represents one of the molecules,
#' each column represents one feature.
#' This function returns one column named \code{nHBAcc}.
#'
#' @export extractDrugHBondAcceptorCount
#'
#' @examples
#' smi = system.file('vignettedata/FDAMDD.smi', package = 'Rcpi')
#' \donttest{
#' mol = readMolFromSmi(smi, type = 'mol')
#' dat = extractDrugHBondAcceptorCount(mol)
#' head(dat)}

extractDrugHBondAcceptorCount = function (molecules, silent = TRUE) {
    evaluateDescriptor(molecules, type = 'HBondAcceptorCountDescriptor', silent = silent)
}

#' Read Protein Sequences in FASTA Format
#'
#' Reads protein sequences in FASTA format.
#'
#' @param file The name of the file which the sequences in fasta format are
#'   to be read from. If it does not contain an absolute or
#'   relative path, the file name is relative to the current
#'   working directory, \code{\link{getwd}}.
#'   The default here is to read the \code{P00750.fasta} file which
#'   is present in the \code{protseq} directory of the Rcpi package.
#'
#' @param legacy.mode If set to \code{TRUE}, lines starting with a semicolon ';'
#'   are ignored. Default value is \code{TRUE}.
#' @param seqonly If set to \code{TRUE}, only sequences as returned without
#'   attempt to modify them or to get their names and
#'   annotations (execution time is divided approximately
#'   by a factor 3). Default value is \code{FALSE}.
#'
#' @return Character vector.
#'
#' @seealso
#' See \code{\link{readPDB}} for reading protein sequences
#' in PDB format.
#'
#' @export readFASTA
#'
#' @references
#' Pearson, W.R. and Lipman, D.J. (1988)
#' Improved tools for biological sequence comparison.
#' \emph{Proceedings of the National Academy of Sciences
#' of the United States of America}, 85: 2444-2448.
#'
#' @examples
#' P00750 = readFASTA(system.file('protseq/P00750.fasta', package = 'Rcpi'))
#' P00750

readFASTA = function (file = system.file('protseq/P00750.fasta',
                                         package = 'Rcpi'),
                      legacy.mode = TRUE, seqonly = FALSE) {

    # Read the fasta file as a vector of strings
    lines = readLines(file)

    # Remove comment lines starting with a semicolon ';'
    if (legacy.mode) {
        comments = grep("^;", lines)
        if (length(comments) > 0) {
            lines = lines[-comments]
        }
    }

    # Get the line numbers where sequences names are
    ind = which(substr(lines, 1L, 1L) == ">")

    # Compute the total number of sequences
    nseq = length(ind)

    if (nseq == 0) stop("no line starting with a > character found")

    # Localize sequence data
    start = ind + 1
    end = ind - 1
    end = c(end[-1], length(lines))

    # Read in sequences
    sequences = lapply(seq_len(nseq),
                       function(i) paste(lines[start[i]:end[i]], collapse = ""))

    if (seqonly) return(sequences)

    # Read in sequence names
    nomseq = lapply(seq_len(nseq), function (i) {
        firstword = strsplit(lines[ind[i]], " ")[[1]][1]
        substr(firstword, 2, nchar(firstword))
    })

    # Give the sequences names to the list elements
    names(sequences) = nomseq

    return(sequences)

}

#' Read Protein Sequences in PDB Format
#'
#' Read Protein Sequences in PDB Format
#'
#' This function reads protein sequences in PDB (Protein Data Bank) format,
#' and return the amino acid sequences represented by single-letter code.
#'
#' @param file   The name of the file which the sequences in PDB format are
#'               to be read from. If it does not contain an absolute or
#'               relative path, the file name is relative to the current
#'               working directory, \code{\link{getwd}}.
#'               The default here is to read the \code{4HHB.PDB} file which
#'               is present in the \code{protseq} directory of the Rcpi package.
#'
#' @return A character vector, representing the amino acid sequence
#' of the single-letter code.
#'
#' @seealso See \code{\link{readFASTA}} for reading protein sequences
#' in FASTA format.
#'
#' @export readPDB
#'
#' @references
#' Protein Data Bank Contents Guide: Atomic Coordinate Entry Format Description,
#' Version 3.30. Accessed 2013-06-26.
#' \url{https://files.wwpdb.org/pub/pdb/doc/format_descriptions/Format_v33_Letter.pdf}
#'
#' @examples
#' Seq4HHB = readPDB(system.file('protseq/4HHB.pdb', package = 'Rcpi'))
#' Seq4HHB

readPDB = function(file = system.file('protseq/4HHB.pdb', package = 'Rcpi')) {

    pdb = scan(file, sep = '\n', what = 'complex', quiet = TRUE)

    category = gsub(' ', '', unlist(lapply(pdb, substring, 1, 6)))

    atomt  = unlist(lapply(pdb[category == 'ATOM'], substring, 14, 16))
    aminoa = as.character(unlist(lapply(pdb[category == 'ATOM'], substring, 18, 20)))
    chain  = unlist(lapply(pdb[category == 'ATOM'], substring, 22, 22))
    namino = as.numeric(unlist(lapply(pdb[category == 'ATOM'], substring, 23, 26)))
    atom   = data.frame(atom = atomt, aa = aminoa, chain = chain, naa = namino)

    uch = unique(chain)
    n   = length(uch)
    aaseq = vector('list', n)  # Each element in the list is a chain

    for(i in 1:n) {

        subatom = atom[atom$chain == uch[i], ]
        uaa     = unique(subatom$naa)
        aaseq[[i]] = as.factor(as.character(subatom$aa[unlist(
            lapply(uaa, FUN = function(X) { grep(X, subatom$naa)[1]} ))]))
        names(aaseq)[i] = paste('chain_', uch[i], sep = '')

    }

    dict = c(GLY = 'G', PRO = 'P', ALA = 'A', VAL = 'V', LEU = 'L',
             ILE = 'I', MET = 'M', CYS = 'C', PHE = 'F', TYR = 'Y',
             TRP = 'W', HIS = 'H', LYS = 'K', ARG = 'R', GLN = 'Q',
             ASN = 'N', GLU = 'E', ASP = 'D', SER = 'S', THR = 'T')

    for (i in 1:n) {

        pos = match(levels(aaseq[[i]]), names(dict))
        levels(aaseq[[i]]) = dict[pos]
        aaseq[[i]] = paste(as.character(aaseq[[i]]), collapse = '')

    }

    return(aaseq)

}

#' Number of Hydrogen Bond Donors
#'
#' Number of Hydrogen Bond Donors
#'
#' This descriptor calculates the number of hydrogen bond donors using
#' a slightly simplified version of the PHACIR atom types
#' (\url{https://bit.ly/3qXQELf}).
#' The following groups are counted as hydrogen bond donors:
#' \itemize{
#' \item Any-OH where the formal charge of the oxygen is non-negative
#' (i.e. formal charge >= 0)
#' \item Any-NH where the formal charge of the nitrogen is non-negative
#' (i.e. formal charge >= 0)
#' }
#'
#' @param molecules Parsed molucule object.
#' @param silent Logical. Whether the calculating process
#' should be shown or not, default is \code{TRUE}.
#'
#' @return A data frame, each row represents one of the molecules,
#' each column represents one feature.
#' This function returns one column named \code{nHBDon}.
#'
#' @export extractDrugHBondDonorCount
#'
#' @examples
#' smi = system.file('vignettedata/FDAMDD.smi', package = 'Rcpi')
#' \donttest{
#' mol = readMolFromSmi(smi, type = 'mol')
#' dat = extractDrugHBondDonorCount(mol)
#' head(dat)}

extractDrugHBondDonorCount = function (molecules, silent = TRUE) {
    evaluateDescriptor(molecules, type = 'HBondDonorCountDescriptor', silent = silent)
}

#' Amino Acid Composition Descriptor
#'
#' Amino Acid Composition Descriptor
#'
#' This function calculates the Amino Acid Composition descriptor (Dim: 20).
#'
#' @param x A character vector, as the input protein sequence.
#'
#' @return A length 20 named vector
#'
#' @seealso See \code{\link{extractProtDC}} and \code{\link{extractProtTC}}
#'          for Dipeptide Composition and Tripeptide Composition descriptors.
#'
#' @export extractProtAAC
#'
#' @references
#' M. Bhasin, G. P. S. Raghava.
#' Classification of Nuclear Receptors Based on
#' Amino Acid Composition and Dipeptide Composition.
#' \emph{Journal of Biological Chemistry}, 2004, 279, 23262.
#'
#' @examples
#' x = readFASTA(system.file('protseq/P00750.fasta', package = 'Rcpi'))[[1]]
#' extractProtAAC(x)
#'

extractProtAAC = function (x) {

    if (checkProt(x) == FALSE) stop('x has unrecognized amino acid type')

    AADict = c('A', 'R', 'N', 'D', 'C', 'E', 'Q', 'G', 'H', 'I',
               'L', 'K', 'M', 'F', 'P', 'S', 'T', 'W', 'Y', 'V')

    AAC = summary(factor(strsplit(x, split = '')[[1]], levels = AADict),
                  maxsum = 21)/nchar(x)

    return(AAC)

}

test_that("`extractProtAAC()` works", {
    x = paste0(
        'MDAMKRGLCCVLLLCGAVFVSPSQEIHARFRRGARSYQVICRDEKTQMIYQQHQSWLRP',
        'VLRSNRVEYCWCNSGRAQCHSVPVKSCSEPRCFNGGTCQQALYFSDFVCQCPEGFAGKCC',
        'EIDTRATCYEDQGISYRGTWSTAESGAECTNWNSSALAQKPYSGRRPDAIRLGLGNHNYC',
        'RNPDRDSKPWCYVFKAGKYSSEFCSTPACSEGNSDCYFGNGSAYRGTHSLTESGASCLPW',
        'NSMILIGKVYTAQNPSAQALGLGKHNYCRNPDGDAKPWCHVLKNRRLTWEYCDVPSCSTC',
        'GLRQYSQPQFRIKGGLFADIASHPWQAAIFAKHRRSPGERFLCGGILISSCWILSAAHCF',
        'QERFPPHHLTVILGRTYRVVPGEEEQKFEVEKYIVHKEFDDDTYDNDIALLQLKSDSSRC',
        'AQESSVVRTVCLPPADLQLPDWTECELSGYGKHEALSPFYSERLKEAHVRLYPSSRCTSQ',
        'HLLNRTVTDNMLCAGDTRSGGPQANLHDACQGDSGGPLVCLNDGRMTLVGIISWGLGCGQ',
        'KDVPGVYTKVTNYLDWIRDNMRP'
    )

    expect_equal(sum(extractProtAAC(x)), 1L, tolerance = 1e-4)
})

test_extractProtAAC = function() {
    x = paste(
        'MDAMKRGLCCVLLLCGAVFVSPSQEIHARFRRGARSYQVICRDEKTQMIYQQHQSWLRP',
        'VLRSNRVEYCWCNSGRAQCHSVPVKSCSEPRCFNGGTCQQALYFSDFVCQCPEGFAGKCC',
        'EIDTRATCYEDQGISYRGTWSTAESGAECTNWNSSALAQKPYSGRRPDAIRLGLGNHNYC',
        'RNPDRDSKPWCYVFKAGKYSSEFCSTPACSEGNSDCYFGNGSAYRGTHSLTESGASCLPW',
        'NSMILIGKVYTAQNPSAQALGLGKHNYCRNPDGDAKPWCHVLKNRRLTWEYCDVPSCSTC',
        'GLRQYSQPQFRIKGGLFADIASHPWQAAIFAKHRRSPGERFLCGGILISSCWILSAAHCF',
        'QERFPPHHLTVILGRTYRVVPGEEEQKFEVEKYIVHKEFDDDTYDNDIALLQLKSDSSRC',
        'AQESSVVRTVCLPPADLQLPDWTECELSGYGKHEALSPFYSERLKEAHVRLYPSSRCTSQ',
        'HLLNRTVTDNMLCAGDTRSGGPQANLHDACQGDSGGPLVCLNDGRMTLVGIISWGLGCGQ',
        'KDVPGVYTKVTNYLDWIRDNMRP', sep = '')
    checkEqualsNumeric(sum(extractProtAAC(x)), 1L, tolerance = 1e-4)
}

#' Calculate Molecular Distance Edge (MDE) Descriptors for C, N and O
#'
#' Calculate Molecular Distance Edge (MDE) Descriptors for C, N and O
#'
#' This descriptor calculates the 10 molecular distance edge (MDE) descriptor
#' described in Liu, S., Cao, C., & Li, Z, and in addition it calculates
#' variants where O and N are considered.
#'
#' @param molecules Parsed molucule object.
#' @param silent Logical. Whether the calculating process
#' should be shown or not, default is \code{TRUE}.
#'
#' @return A data frame, each row represents one of the molecules,
#' each column represents one feature.
#' This function returns one column named \code{nAtomLAC}.
#'
#' @export extractDrugMDE
#'
#' @references
#' Liu, S., Cao, C., & Li, Z. (1998).
#' Approach to estimation and prediction for normal boiling point (NBP)
#' of alkanes based on a novel molecular distance-edge (MDE) vector, lambda.
#' Journal of chemical information and computer sciences, 38(3), 387-394.
#'
#' @examples
#' smi = system.file('vignettedata/FDAMDD.smi', package = 'Rcpi')
#' \donttest{
#' mol = readMolFromSmi(smi, type = 'mol')
#' dat = extractDrugMDE(mol)
#' head(dat)}

extractDrugMDE = function (molecules, silent = TRUE) {
    evaluateDescriptor(molecules, type = 'MDEDescriptor', silent = silent)
}

#' Descriptor that Calculates the Petitjean Shape Indices
#'
#' Descriptor that Calculates the Petitjean Shape Indices
#'
#' The topological and geometric shape indices described Petitjean
#' and Bath et al. respectively. Both measure the anisotropy in a molecule.
#'
#' @param molecules Parsed molucule object.
#' @param silent Logical. Whether the calculating process
#' should be shown or not, default is \code{TRUE}.
#'
#' @return A data frame, each row represents one of the molecules,
#' each column represents one feature.
#' This function returns two columns named
#' \code{topoShape} (Topological Shape Index) and
#' \code{geomShape} (Geometric Shape Index).
#'
#' @export extractDrugPetitjeanShapeIndex
#'
#' @references
#' Petitjean, M.,
#' Applications of the radius-diameter diagram to the classification of
#' topological and geometrical shapes of chemical compounds,
#' Journal of Chemical Information and Computer Science,
#' 1992, 32:331-337
#'
#' Bath, P.A. and Poirette, A.R. and Willet, P. and Allen, F.H. ,
#' The Extent of the Relationship between the Graph-Theoretical
#' and the Geometrical Shape Coefficients of Chemical Compounds,
#' Journal of Chemical Information and Computer Science, 1995, 35:714-716.
#'
#' @examples
#' sdf = system.file('sysdata/OptAA3d.sdf', package = 'Rcpi')
#' \donttest{
#' mol = readMolFromSDF(sdf)
#' dat = extractDrugPetitjeanShapeIndex(mol)
#' head(dat)}

extractDrugPetitjeanShapeIndex = function (molecules, silent = TRUE) {
    evaluateDescriptor(molecules, type = 'PetitjeanShapeIndexDescriptor', silent = silent)
}

.calcSeqPairSim = function(
    twoid, protlist = protlist, type = type, submat = submat) {
    pwa = resolve_pwa()

    id1 = twoid[1]
    id2 = twoid[2]

    if ( protlist[[id1]] == '' | protlist[[id2]] == '' ) {

        sim = 0L

    } else {

        s1  = try(Biostrings::AAString(protlist[[id1]]), silent = TRUE)
        s2  = try(Biostrings::AAString(protlist[[id2]]), silent = TRUE)
        s12 = try(pwa(s1, s2, type = type, substitutionMatrix = submat, scoreOnly = TRUE), silent = TRUE)
        s11 = try(pwa(s1, s1, type = type, substitutionMatrix = submat, scoreOnly = TRUE), silent = TRUE)
        s22 = try(pwa(s2, s2, type = type, substitutionMatrix = submat, scoreOnly = TRUE), silent = TRUE)

        if ( is.numeric(s12) == FALSE | is.numeric(s11) == FALSE | is.numeric(s22) == FALSE ) {
            sim = 0L
        } else if ( abs(s11) < .Machine$double.eps | abs(s22) < .Machine$double.eps ) {
            sim = 0L
        } else {
            sim = s12/sqrt(s11 * s22)
        }

    }

    return(sim)

}

#' Parallellized Protein Sequence Similarity Calculation based on Sequence Alignment
#'
#' Parallellized Protein Sequence Similarity Calculation based on Sequence Alignment
#'
#' This function implemented the parallellized version for calculating
#' protein sequence similarity based on sequence alignment.
#'
#' @param protlist A length \code{n} list containing \code{n} protein sequences,
#' each component of the list is a character string,
#' storing one protein sequence. Unknown sequences should be represented as
#' \code{''}.
#' @param cores Integer. The number of CPU cores to use for parallel execution,
#'        default is \code{2}. Users could use the \code{detectCores()} function
#'        in the \code{parallel} package to see how many cores they could use.
#' @param type Type of alignment, default is \code{'local'},
#' could be \code{'global'} or \code{'local'},
#' where \code{'global'} represents Needleman-Wunsch global alignment;
#' \code{'local'} represents Smith-Waterman local alignment.
#' @param submat Substitution matrix, default is \code{'BLOSUM62'},
#' could be one of \code{'BLOSUM45'}, \code{'BLOSUM50'}, \code{'BLOSUM62'},
#' \code{'BLOSUM80'}, \code{'BLOSUM100'}, \code{'PAM30'}, \code{'PAM40'},
#' \code{'PAM70'}, \code{'PAM120'}, \code{'PAM250'}.
#'
#' @return A \code{n} x \code{n} similarity matrix.
#'
#' @seealso See \code{calcTwoProtSeqSim} for protein sequence alignment
#' for two protein sequences. See \code{\link{calcParProtGOSim}} for
#' protein similarity calculation based on
#' Gene Ontology (GO) semantic similarity.
#'
#' @export calcParProtSeqSim
#'
#' @examples
#' s1 = readFASTA(system.file('protseq/P00750.fasta', package = 'Rcpi'))[[1]]
#' s2 = readFASTA(system.file('protseq/P08218.fasta', package = 'Rcpi'))[[1]]
#' s3 = readFASTA(system.file('protseq/P10323.fasta', package = 'Rcpi'))[[1]]
#' s4 = readFASTA(system.file('protseq/P20160.fasta', package = 'Rcpi'))[[1]]
#' s5 = readFASTA(system.file('protseq/Q9NZP8.fasta', package = 'Rcpi'))[[1]]
#' plist = list(s1, s2, s3, s4, s5)
#' \donttest{
#' psimmat = calcParProtSeqSim(plist, cores = 2, type = 'local',
#'                             submat = 'BLOSUM62')
#' print(psimmat)}

calcParProtSeqSim = function(
    protlist, cores = 2, type = 'local', submat = 'BLOSUM62') {
    invisible(resolve_pwa())

    doParallel::registerDoParallel(cores)

    # generate lower matrix index
    idx = combn(1:length(protlist), 2)

    # then use foreach parallelization
    # input is all pair combination
    seqsimlist = vector('list', ncol(idx))

    seqsimlist <- foreach (i = 1:length(seqsimlist), .errorhandling = 'pass') %dopar% {
        tmp <- .calcSeqPairSim(rev(idx[, i]), protlist = protlist, type = type, submat = submat)
    }

    # convert any error objects into length-1 message
    seqsimlist = as.list(unlist(seqsimlist))
    # convert list to matrix
    seqsimmat = matrix(0, length(protlist), length(protlist))
    for (i in 1:length(seqsimlist)) seqsimmat[idx[2, i], idx[1, i]] = seqsimlist[[i]]
    seqsimmat[upper.tri(seqsimmat)] = t(seqsimmat)[upper.tri(t(seqsimmat))]
    diag(seqsimmat) = 1

    return(seqsimmat)

}

#' Protein Sequence Alignment for Two Protein Sequences
#'
#' Protein Sequence Alignment for Two Protein Sequences
#'
#' This function implements the sequence alignment between two protein sequences.
#'
#' @param seq1 A character string, containing one protein sequence.
#' @param seq2 A character string, containing another protein sequence.
#' @param type Type of alignment, default is \code{'local'},
#' could be \code{'global'} or \code{'local'},
#' where \code{'global'} represents Needleman-Wunsch global alignment;
#' \code{'local'} represents Smith-Waterman local alignment.
#' @param submat Substitution matrix, default is \code{'BLOSUM62'},
#' could be one of \code{'BLOSUM45'}, \code{'BLOSUM50'}, \code{'BLOSUM62'},
#' \code{'BLOSUM80'}, \code{'BLOSUM100'}, \code{'PAM30'}, \code{'PAM40'},
#' \code{'PAM70'}, \code{'PAM120'}, \code{'PAM250'}.
#'
#' @return An Biostrings object containing the scores and other
#' alignment information.
#'
#' @seealso See \code{\link{calcParProtSeqSim}} for paralleled pairwise
#' protein similarity calculation based on sequence alignment.
#' See \code{\link{calcTwoProtGOSim}} for calculating the
#' GO semantic similarity between two groups of GO terms or two Entrez gene IDs.
#'
#' @export calcTwoProtSeqSim
#'
#' @examples
#' s1 = readFASTA(system.file('protseq/P00750.fasta', package = 'Rcpi'))[[1]]
#' s2 = readFASTA(system.file('protseq/P10323.fasta', package = 'Rcpi'))[[1]]
#' \donttest{
#' seqalign = calcTwoProtSeqSim(s1, s2)
#' seqalign
#' slot(seqalign, "score")}

calcTwoProtSeqSim = function(
    seq1, seq2, type = 'local', submat = 'BLOSUM62') {
    pwa = resolve_pwa()

    # sequence alignment for two protein sequences
    s1  = try(Biostrings::AAString(seq1), silent = TRUE)
    s2  = try(Biostrings::AAString(seq2), silent = TRUE)
    s12 = try(pwa(s1, s2, type = type, substitutionMatrix = submat), silent = TRUE)

    return(s12)

}

#' Retrieve Drug Molecules in MOL and SMILES Format from Databases
#'
#' Retrieve Drug Molecules in MOL and SMILES Format from Databases
#'
#' This function retrieves drug molecules in MOL and SMILES format from
#' five databases.
#'
#' @param id A character vector, as the drug ID(s).
#' @param from The database, one of \code{'pubchem'}, \code{'chembl'},
#' \code{'cas'}, \code{'kegg'}, \code{'drugbank'}.
#' @param type The returned molecule format, \code{mol} or \code{smile}.
#' @param parallel An integer, the parallel parameter, indicates how many
#'                 process the user would like to use for retrieving
#'                 the data (using RCurl), default is \code{5}.
#'                 For regular cases, we recommend a number less than \code{20}.
#'
#' @return A length of \code{id} character vector,
#' each element containing the corresponding drug molecule.
#'
#' @seealso See \code{\link{getProt}} for retrieving protein sequences
#' from three databases.
#'
#' @export getDrug
#'
#' @examples
#' id = c('DB00859', 'DB00860')
#' \donttest{
#' getDrug(id, 'drugbank', 'smile')}

getDrug = function(
    id,
    from = c('pubchem', 'chembl', 'cas', 'kegg', 'drugbank'),
    type = c('mol', 'smile'),
    parallel = 5) {

    if (is.null(from)) stop('Must specify a data source')
    if (is.null(type)) stop('Must specify a data type')

    # Exclude 1 special case from total 10 possible combinations

    if (from == 'cas' & type == 'smile')
        stop('CAS only supports type = "mol" (InChI)')

    FromDict = c('pubchem' = 'PubChem', 'chembl' = 'ChEMBL',
                 'cas' = 'CAS', 'kegg' = 'KEGG', 'drugbank' = 'DrugBank')

    TypeDict = c('mol' = 'Mol', 'smile' = 'Smi')

    NamePart1 = TypeDict[type]
    NamePart2 = FromDict[from]

    FunctionName = paste('get', NamePart1, 'From', NamePart2, sep = '')

    Drug = eval(parse(text = paste(
        FunctionName, '(',
        gsub('\\"', '\'', capture.output(dput(id))),
        ', ', parallel, ')', sep = '')))

    return(Drug)

}

#' Calculate the FMF Descriptor
#'
#' Calculate the FMF Descriptor
#'
#' Calculates the FMF descriptor characterizing molecular complexity
#' in terms of its Murcko framework. This descriptor is the ratio of
#' heavy atoms in the framework to the total number of heavy atoms
#' in the molecule. By definition, acyclic molecules which have no frameworks,
#' will have a value of 0. Note that the authors consider an isolated ring
#' system to be a framework (even though there is no linker).
#'
#' @param molecules Parsed molucule object.
#' @param silent Logical. Whether the calculating process
#' should be shown or not, default is \code{TRUE}.
#'
#' @return A data frame, each row represents one of the molecules,
#' each column represents one feature.
#' This function returns one column named \code{FMF}.
#'
#' @export extractDrugFMF
#'
#' @references
#' Yang, Y., Chen, H., Nilsson, I., Muresan, S., & Engkvist, O. (2010).
#' Investigation of the relationship between topology and selectivity
#' for druglike molecules. Journal of medicinal chemistry,
#' 53(21), 7709-7714.
#'
#' @examples
#' smi = system.file('vignettedata/FDAMDD.smi', package = 'Rcpi')
#' \donttest{
#' mol = readMolFromSmi(smi, type = 'mol')
#' dat = extractDrugFMF(mol)
#' head(dat)}

extractDrugFMF = function (molecules, silent = TRUE) {
    evaluateDescriptor(molecules, type = 'FMFDescriptor', silent = silent)
}

#' AAindex Data of 544 Physicochemical and Biological Properties
#' for 20 Amino Acids
#'
#' AAindex Data of 544 Physicochemical and Biological Properties
#' for 20 Amino Acids
#'
#' The data was extracted from the AAindex1 database ver 9.1
#' (\url{ftp://ftp.genome.jp/pub/db/community/aaindex/aaindex1}) as of
#' November 2012 (Data Last Modified 2006-08-14).
#'
#' With this data, users could investigate each property's accession number
#' and other details. Visit \url{https://www.genome.jp/dbget/aaindex.html}
#' for more information.
#'
#' @docType data
#' @name AAindex
#' @return AAindex data
#' @examples
#' data(AAindex)
#'
NULL

#' OptAA3d.sdf - 20 Amino Acids Optimized with MOE 2011.10 (Semiempirical AM1)
#'
#' OptAA3d.sdf - 20 Amino Acids Optimized with MOE 2011.10 (Semiempirical AM1)
#'
#' OptAA3d.sdf - 20 Amino Acids Optimized with MOE 2011.10 (Semiempirical AM1)
#'
#' @docType data
#' @name OptAA3d
#' @return OptAA3d data
#' @examples
#' # This example requires the rcdk package
#' # library('rcdk')
#' # optaa3d = load.molecules(system.file('sysdata/OptAA3d.sdf', package = 'Rcpi'))
#' # view.molecule.2d(optaa3d[[1]])  # view the first amino acid
NULL

#' Meta Information for the 20 Amino Acids
#'
#' Meta Information for the 20 Amino Acids
#'
#' This dataset includes the meta information of
#' the 20 amino acids used for the 2D and 3D descriptor
#' calculation in this package. Each column represents:
#' \describe{
#'   \item{\code{AAName}}{Amino acid name}
#'   \item{\code{Short}}{One-letter representation}
#'   \item{\code{Abbreviation}}{Three-letter representation}
#'   \item{\code{mol}}{SMILES representation}
#'   \item{\code{PUBCHEM_COMPOUND_CID}}{PubChem CID for the amino acid}
#'   \item{\code{PUBCHEM_LINK}}{PubChem link for the amino acid}
#' }
#'
#' @docType data
#' @name AAMetaInfo
#' @return AAMetaInfo data
#' @examples
#' data(AAMetaInfo)
NULL

#' 2D Descriptors for 20 Amino Acids calculated by MOE 2011.10
#'
#' 2D Descriptors for 20 Amino Acids calculated by MOE 2011.10
#'
#' This dataset includes the 2D descriptors of
#' the 20 amino acids calculated by MOE 2011.10
#' used for scales extraction in this package.
#'
#' @docType data
#' @name AAMOE2D
#' @return AAMOE2D data
#' @examples
#' data(AAMOE2D)
#'
NULL

#' 3D Descriptors for 20 Amino Acids calculated by MOE 2011.10
#'
#' 3D Descriptors for 20 Amino Acids calculated by MOE 2011.10
#'
#' This dataset includes the 3D descriptors of the 20 amino acids
#' calculated by MOE 2011.10 used for scales extraction in this package.
#' All amino acid molecules had also been optimized with MOE (semiempirical AM1)
#' before calculating these 3D descriptors.
#' The SDF file containing the information of the optimized amino acid molecules
#' is included in this package. See \code{\link{OptAA3d}} for more information.
#'
#' @docType data
#' @name AAMOE3D
#' @return AAMOE3D data
#' @examples
#' data(AAMOE3D)
#'
NULL

#' CPSA Descriptors for 20 Amino Acids calculated by Discovery Studio
#'
#' CPSA Descriptors for 20 Amino Acids calculated by Discovery Studio
#'
#' This dataset includes the CPSA descriptors of the 20 amino acids
#' calculated by Discovery Studio (version 2.5) used for scales extraction
#' in this package.
#' All amino acid molecules had also been optimized with
#' MOE 2011.10 (semiempirical AM1)
#' before calculating these CPSA descriptors.
#' The SDF file containing the information of the optimized amino acid molecules
#' is included in this package. See \code{\link{OptAA3d}} for more information.
#'
#' @docType data
#' @name AACPSA
#' @return AACPSA data
#' @examples
#' data(AACPSA)
#'
NULL

#' All 2D Descriptors for 20 Amino Acids calculated by Dragon
#'
#' All 2D Descriptors for 20 Amino Acids calculated by Dragon
#'
#' This dataset includes all the 2D descriptors of
#' the 20 amino acids calculated by Dragon (version 5.4)
#' used for scales extraction in this package.
#'
#' @docType data
#' @name AADescAll
#' @return AADescAll data
#' @examples
#' data(AADescAll)
#'
NULL



#' 2D Autocorrelations Descriptors for 20 Amino Acids calculated by Dragon
#'
#' 2D Autocorrelations Descriptors for 20 Amino Acids calculated by Dragon
#'
#' This dataset includes the 2D autocorrelations descriptors of
#' the 20 amino acids calculated by Dragon (version 5.4)
#' used for scales extraction in this package.
#'
#' @docType data
#' @name AA2DACOR
#' @return AA2DACOR data
#' @examples
#' data(AA2DACOR)
#'
NULL

#' 3D-MoRSE Descriptors for 20 Amino Acids calculated by Dragon
#'
#' 3D-MoRSE Descriptors for 20 Amino Acids calculated by Dragon
#'
#' This dataset includes the 3D-MoRSE descriptors of
#' the 20 amino acids calculated by Dragon (version 5.4)
#' used for scales extraction in this package.
#'
#' @docType data
#' @name AA3DMoRSE
#' @return AA3DMoRSE data
#' @examples
#' data(AA3DMoRSE)
#'
NULL

#' Atom-Centred Fragments Descriptors for 20 Amino Acids calculated by Dragon
#'
#' Atom-Centred Fragments Descriptors for 20 Amino Acids calculated by Dragon
#'
#' This dataset includes the atom-centred fragments descriptors of
#' the 20 amino acids calculated by Dragon (version 5.4)
#' used for scales extraction in this package.
#'
#' @docType data
#' @name AAACF
#' @return AAACF data
#' @examples
#' data(AAACF)
#'
NULL

#' Burden Eigenvalues Descriptors for 20 Amino Acids calculated by Dragon
#'
#' Burden Eigenvalues Descriptors for 20 Amino Acids calculated by Dragon
#'
#' This dataset includes the Burden eigenvalues descriptors of
#' the 20 amino acids calculated by Dragon (version 5.4)
#' used for scales extraction in this package.
#'
#' @docType data
#' @name AABurden
#' @return AABurden data
#' @examples
#' data(AABurden)
#'
NULL

#' Connectivity Indices Descriptors for 20 Amino Acids calculated by Dragon
#'
#' Connectivity Indices Descriptors for 20 Amino Acids calculated by Dragon
#'
#' This dataset includes the connectivity indices descriptors of
#' the 20 amino acids calculated by Dragon (version 5.4)
#' used for scales extraction in this package.
#'
#' @docType data
#' @name AAConn
#' @return AAConn data
#' @examples
#' data(AAConn)
#'
NULL

#' Constitutional Descriptors for 20 Amino Acids calculated by Dragon
#'
#' Constitutional Descriptors for 20 Amino Acids calculated by Dragon
#'
#' This dataset includes the constitutional descriptors of
#' the 20 amino acids calculated by Dragon (version 5.4)
#' used for scales extraction in this package.
#'
#' @docType data
#' @name AAConst
#' @return AAConst data
#' @examples
#' data(AAConst)
#'
NULL

#' Edge Adjacency Indices Descriptors for 20 Amino Acids calculated by Dragon
#'
#' Edge Adjacency Indices Descriptors for 20 Amino Acids calculated by Dragon
#'
#' This dataset includes the edge adjacency indices descriptors of
#' the 20 amino acids calculated by Dragon (version 5.4)
#' used for scales extraction in this package.
#'
#' @docType data
#' @name AAEdgeAdj
#' @return AAEdgeAdj data
#' @examples
#' data(AAEdgeAdj)
#'
NULL

#' Eigenvalue-Based Indices Descriptors for 20 Amino Acids calculated by Dragon
#'
#' Eigenvalue-Based Indices Descriptors for 20 Amino Acids calculated by Dragon
#'
#' This dataset includes the eigenvalue-based indices descriptors of
#' the 20 amino acids calculated by Dragon (version 5.4)
#' used for scales extraction in this package.
#'
#' @docType data
#' @name AAEigIdx
#' @return AAEigIdx data
#' @examples
#' data(AAEigIdx)
#'
NULL

#' Functional Group Counts Descriptors for 20 Amino Acids calculated by Dragon
#'
#' Functional Group Counts Descriptors for 20 Amino Acids calculated by Dragon
#'
#' This dataset includes the functional group counts descriptors of
#' the 20 amino acids calculated by Dragon (version 5.4)
#' used for scales extraction in this package.
#'
#' @docType data
#' @name AAFGC
#' @return AAFGC data
#' @examples
#' data(AAFGC)
#'
NULL

#' Geometrical Descriptors for 20 Amino Acids calculated by Dragon
#'
#' Geometrical Descriptors for 20 Amino Acids calculated by Dragon
#'
#' This dataset includes the geometrical descriptors of
#' the 20 amino acids calculated by Dragon (version 5.4)
#' used for scales extraction in this package.
#'
#' @docType data
#' @name AAGeom
#' @return AAGeom data
#' @examples
#' data(AAGeom)
#'
NULL

#' GETAWAY Descriptors for 20 Amino Acids calculated by Dragon
#'
#' GETAWAY Descriptors for 20 Amino Acids calculated by Dragon
#'
#' This dataset includes the GETAWAY descriptors of
#' the 20 amino acids calculated by Dragon (version 5.4)
#' used for scales extraction in this package.
#'
#' @docType data
#' @name AAGETAWAY
#' @return AAGETAWAY data
#' @examples
#' data(AAGETAWAY)
#'
NULL

#' Information Indices Descriptors for 20 Amino Acids calculated by Dragon
#'
#' Information Indices Descriptors for 20 Amino Acids calculated by Dragon
#'
#' This dataset includes the information indices descriptors of
#' the 20 amino acids calculated by Dragon (version 5.4)
#' used for scales extraction in this package.
#'
#' @docType data
#' @name AAInfo
#' @return AAInfo data
#' @examples
#' data(AAInfo)
#'
NULL

#' Molecular Properties Descriptors for 20 Amino Acids calculated by Dragon
#'
#' Molecular Properties Descriptors for 20 Amino Acids calculated by Dragon
#'
#' This dataset includes the molecular properties descriptors of
#' the 20 amino acids calculated by Dragon (version 5.4)
#' used for scales extraction in this package.
#'
#' @docType data
#' @name AAMolProp
#' @return AAMolProp data
#' @examples
#' data(AAMolProp)
#'
NULL

#' Randic Molecular Profiles Descriptors for 20 Amino Acids calculated by Dragon
#'
#' Randic Molecular Profiles Descriptors for 20 Amino Acids calculated by Dragon
#'
#' This dataset includes the Randic molecular profiles descriptors of
#' the 20 amino acids calculated by Dragon (version 5.4)
#' used for scales extraction in this package.
#'
#' @docType data
#' @name AARandic
#' @return AARandic data
#' @examples
#' data(AARandic)
#'
NULL

#' RDF Descriptors for 20 Amino Acids calculated by Dragon
#'
#' RDF Descriptors for 20 Amino Acids calculated by Dragon
#'
#' This dataset includes the RDF descriptors of
#' the 20 amino acids calculated by Dragon (version 5.4)
#' used for scales extraction in this package.
#'
#' @docType data
#' @name AARDF
#' @return AARDF data
#' @examples
#' data(AARDF)
#'
NULL

#' Topological Descriptors for 20 Amino Acids calculated by Dragon
#'
#' Topological Descriptors for 20 Amino Acids calculated by Dragon
#'
#' This dataset includes the topological descriptors of
#' the 20 amino acids calculated by Dragon (version 5.4)
#' used for scales extraction in this package.
#'
#' @docType data
#' @name AATopo
#' @return AATopo data
#' @examples
#' data(AATopo)
#'
NULL

#' Topological Charge Indices Descriptors for 20 Amino Acids
#' calculated by Dragon
#'
#' Topological Charge Indices Descriptors for 20 Amino Acids
#' calculated by Dragon
#'
#' This dataset includes the topological charge indices descriptors of
#' the 20 amino acids calculated by Dragon (version 5.4)
#' used for scales extraction in this package.
#'
#' @docType data
#' @name AATopoChg
#' @return AATopoChg data
#' @examples
#' data(AATopoChg)
#'
NULL

#' Walk and Path Counts Descriptors for 20 Amino Acids calculated by Dragon
#'
#' Walk and Path Counts Descriptors for 20 Amino Acids calculated by Dragon
#'
#' This dataset includes the walk and path counts descriptors of
#' the 20 amino acids calculated by Dragon (version 5.4)
#' used for scales extraction in this package.
#'
#' @docType data
#' @name AAWalk
#' @return AAWalk data
#' @examples
#' data(AAWalk)
#'
NULL

#' WHIM Descriptors for 20 Amino Acids calculated by Dragon
#'
#' WHIM Descriptors for 20 Amino Acids calculated by Dragon
#'
#' This dataset includes the WHIM descriptors of
#' the 20 amino acids calculated by Dragon (version 5.4)
#' used for scales extraction in this package.
#'
#' @docType data
#' @name AAWHIM
#' @return AAWHIM data
#' @examples
#' data(AAWHIM)
#'
NULL



#' BLOSUM45 Matrix for 20 Amino Acids
#'
#' BLOSUM45 Matrix for 20 Amino Acids
#'
#' BLOSUM45 Matrix for the 20 amino acids. The matrix was extracted from the
#' \code{Biostrings} package of Bioconductor.
#'
#' @docType data
#' @name AABLOSUM45
#' @return AABLOSUM45 data
#' @examples
#' data(AABLOSUM45)
#'
NULL

#' BLOSUM50 Matrix for 20 Amino Acids
#'
#' BLOSUM50 Matrix for 20 Amino Acids
#'
#' BLOSUM50 Matrix for the 20 amino acids. The matrix was extracted from the
#' \code{Biostrings} package of Bioconductor.
#'
#' @docType data
#' @name AABLOSUM50
#' @return AABLOSUM50 data
#' @examples
#' data(AABLOSUM50)
#'
NULL

#' BLOSUM62 Matrix for 20 Amino Acids
#'
#' BLOSUM62 Matrix for 20 Amino Acids
#'
#' BLOSUM62 Matrix for the 20 amino acids. The matrix was extracted from the
#' \code{Biostrings} package of Bioconductor.
#'
#' @docType data
#' @name AABLOSUM62
#' @return AABLOSUM62 data
#' @examples
#' data(AABLOSUM62)
#'
NULL

#' BLOSUM80 Matrix for 20 Amino Acids
#'
#' BLOSUM80 Matrix for 20 Amino Acids
#'
#' BLOSUM80 Matrix for the 20 amino acids. The matrix was extracted from the
#' \code{Biostrings} package of Bioconductor.
#'
#' @docType data
#' @name AABLOSUM80
#' @return AABLOSUM80 data
#' @examples
#' data(AABLOSUM80)
#'
NULL

#' BLOSUM100 Matrix for 20 Amino Acids
#'
#' BLOSUM100 Matrix for 20 Amino Acids
#'
#' BLOSUM100 Matrix for the 20 amino acids. The matrix was extracted from the
#' \code{Biostrings} package of Bioconductor.
#'
#' @docType data
#' @name AABLOSUM100
#' @return AABLOSUM100 data
#' @examples
#' data(AABLOSUM100)
#'
NULL

#' PAM30 Matrix for 20 Amino Acids
#'
#' PAM30 Matrix for 20 Amino Acids
#'
#' PAM30 Matrix for the 20 amino acids. The matrix was extracted from the
#' \code{Biostrings} package of Bioconductor.
#'
#' @docType data
#' @name AAPAM30
#' @return AAPAM30 data
#' @examples
#' data(AAPAM30)
#'
NULL

#' PAM40 Matrix for 20 Amino Acids
#'
#' PAM40 Matrix for 20 Amino Acids
#'
#' PAM40 Matrix for the 20 amino acids. The matrix was extracted from the
#' \code{Biostrings} package of Bioconductor.
#'
#' @docType data
#' @name AAPAM40
#' @return AAPAM40 data
#' @examples
#' data(AAPAM40)
#'
NULL

#' PAM70 Matrix for 20 Amino Acids
#'
#' PAM70 Matrix for 20 Amino Acids
#'
#' PAM70 Matrix for the 20 amino acids. The matrix was extracted from the
#' \code{Biostrings} package of Bioconductor.
#'
#' @docType data
#' @name AAPAM70
#' @return AAPAM70 data
#' @examples
#' data(AAPAM70)
#'
NULL

#' PAM120 Matrix for 20 Amino Acids
#'
#' PAM120 Matrix for 20 Amino Acids
#'
#' PAM120 Matrix for the 20 amino acids. The matrix was extracted from the
#' \code{Biostrings} package of Bioconductor.
#'
#' @docType data
#' @name AAPAM120
#' @return AAPAM120 data
#' @examples
#' data(AAPAM120)
#'
NULL

#' PAM250 Matrix for 20 Amino Acids
#'
#' PAM250 Matrix for 20 Amino Acids
#'
#' PAM250 Matrix for the 20 amino acids. The matrix was extracted from the
#' \code{Biostrings} package of Bioconductor.
#'
#' @docType data
#' @name AAPAM250
#' @return AAPAM250 data
#' @examples
#' data(AAPAM250)
#'
NULL

#' Get URLs in parallel using httr2
#'
#' @param url A vector string of URLs.
#' @param total_con Max total number of concurrent connections.
#'
#' @return A list of response strings in UTF-8.
#'
#' @importFrom httr2 request req_perform_parallel resp_body_string
#' @importFrom curl new_pool
#'
#' @noRd
get_url_parallel <- function(url, total_con) {
  k <- length(url)
  reqs <- vector("list", k)
  for (i in seq_len(k)) reqs[[i]] <- httr2::request(url[i])
  resp <- httr2::req_perform_parallel(
    reqs,
    pool = curl::new_pool(total_con = total_con),
    on_error = "continue"
  )
  txt <- vector("list", k)
  for (i in seq_len(k)) txt[[i]] <- httr2::resp_body_string(resp[[i]])
  txt
}

#' Calculate the Eccentric Connectivity Index Descriptor
#'
#' Calculate the Eccentric Connectivity Index Descriptor
#'
#' Eccentric Connectivity Index (ECI) is a topological descriptor combining
#' distance and adjacency information. This descriptor is described by Sharma et al.
#' and has been shown to correlate well with a number of physical properties.
#' The descriptor is also reported to have good discriminatory ability.
#' The eccentric connectivity index for a hydrogen supressed molecular graph
#' is given by
#' \deqn{x_i^c = \sum_{i = 1}^{n} E(i) V(i)}
#' where E(i) is the eccentricity of the i-th atom
#' (path length from the i-th atom to the atom farthest from it)
#' and V(i) is the vertex degree of the i-th atom.
#'
#' @param molecules Parsed molucule object.
#' @param silent Logical. Whether the calculating process
#' should be shown or not, default is \code{TRUE}.
#'
#' @return A data frame, each row represents one of the molecules,
#' each column represents one feature.
#' This function returns one column named \code{ECCEN}.
#'
#' @export extractDrugECI
#'
#' @references
#' Sharma, V. and Goswami, R. and Madan, A.K. (1997),
#' Eccentric Connectivity Index: A Novel Highly Discriminating
#' Topological Descriptor for Structure-Property and Structure-Activity Studies,
#' Journal of Chemical Information and Computer Sciences, 37:273-282
#'
#' @examples
#' smi = system.file('vignettedata/FDAMDD.smi', package = 'Rcpi')
#' \donttest{
#' mol = readMolFromSmi(smi, type = 'mol')
#' dat = extractDrugECI(mol)
#' head(dat)}

extractDrugECI = function (molecules, silent = TRUE) {
    evaluateDescriptor(molecules, type = 'EccentricConnectivityIndexDescriptor', silent = silent)
}

#' Dipeptide Composition Descriptor
#'
#' Dipeptide Composition Descriptor
#'
#' This function calculates the Dipeptide Composition descriptor (Dim: 400).
#'
#' @param x A character vector, as the input protein sequence.
#'
#' @return A length 400 named vector
#'
#' @seealso See \code{\link{extractProtAAC}} and \code{\link{extractProtTC}}
#'          for Amino Acid Composition and Tripeptide Composition descriptors.
#'
#' @export extractProtDC
#'
#' @references
#' M. Bhasin, G. P. S. Raghava.
#' Classification of Nuclear Receptors Based on
#' Amino Acid Composition and Dipeptide Composition.
#' \emph{Journal of Biological Chemistry}, 2004, 279, 23262.
#'
#' @examples
#' x = readFASTA(system.file('protseq/P00750.fasta', package = 'Rcpi'))[[1]]
#' extractProtDC(x)
#'

extractProtDC = function (x) {

    if (checkProt(x) == FALSE) stop('x has unrecognized amino acid type')

    AADict = c('A', 'R', 'N', 'D', 'C', 'E', 'Q', 'G', 'H', 'I',
               'L', 'K', 'M', 'F', 'P', 'S', 'T', 'W', 'Y', 'V')
    DCDict = as.vector((outer(AADict, AADict, paste, sep = '')))

    xSplitted = strsplit(x, split = '')[[1]]
    n  = nchar(x)
    DC = summary(factor(paste(xSplitted[-n], xSplitted[-1], sep = ''),
                        levels = DCDict), maxsum = 401)/(n-1)

    return(DC)

}

#' Retrieve Protein Sequence in FASTA Format from the UniProt Database
#'
#' Retrieve Protein Sequence in FASTA Format from the UniProt Database
#'
#' This function retrieves protein sequences in FASTA format
#' from the UniProt database.
#'
#' @param id A character vector, as the protein ID.
#' @param parallel An integer, the parallel parameter, indicates how many
#'                 process the user would like to use for retrieving
#'                 the data (using RCurl), default is \code{5}.
#'                 For regular cases, we recommend a number less than \code{20}.
#'
#' @return A list, each component contains one of the protein sequences
#' in FASTA format.
#'
#' @seealso See \code{\link{getSeqFromUniProt}} for retrieving protein
#' represented by amino acid sequence from the UniProt database.
#' See \code{\link{readFASTA}} for reading FASTA format files.
#'
#' @export getFASTAFromUniProt
#'
#' @references
#' UniProt. \url{https://www.uniprot.org/}
#'
#' UniProt REST API Documentation. \url{https://www.uniprot.org/help/api}
#'
#' @examples
#' id = c('P00750', 'P00751', 'P00752')
#' \donttest{
#' getFASTAFromUniProt(id)}

getFASTAFromUniProt = function (id, parallel = 5) {

  # example id:  P00750
  # example url: https://rest.uniprot.org/uniprotkb/P00750.fasta

  fastaURL = paste0('https://rest.uniprot.org/uniprotkb/', id, '.fasta')

  fastaTxt = get_url_parallel(url = fastaURL, total_con = parallel)

  return(fastaTxt)

}

#' Retrieve Protein Sequence from the UniProt Database
#'
#' Retrieve Protein Sequence from the UniProt Database
#'
#' This function retrieves protein represented by amino acid sequence
#' from the UniProt database.
#'
#' @param id A character vector, as the protein ID.
#' @param parallel An integer, the parallel parameter, indicates how many
#'                 process the user would like to use for retrieving
#'                 the data (using RCurl), default is \code{5}.
#'                 For regular cases, we recommend a number less than \code{20}.
#'
#' @return A list, each component contains one of the protein
#' represented by amino acid sequence(s).
#'
#' @seealso See \code{\link{getFASTAFromUniProt}} for retrieving protein
#' sequences in FASTA format from the UniProt database.
#'
#' @export getSeqFromUniProt
#'
#' @references
#' UniProt. \url{https://www.uniprot.org/}
#'
#' UniProt REST API Documentation. \url{https://www.uniprot.org/help/api}
#'
#' @examples
#' id = c('P00750', 'P00751', 'P00752')
#' \donttest{
#' getSeqFromUniProt(id)}

getSeqFromUniProt = function (id, parallel = 5) {

  # example id:  P00750
  # example url: https://rest.uniprot.org/uniprotkb/P00750.fasta

  fastaTxt = getFASTAFromUniProt(id, parallel)

  tmpfile = tempfile(pattern = paste0(id, '-'), fileext = 'fasta')
  for (i in 1:length(id)) write(fastaTxt[[i]], tmpfile[i])

  AASeq = lapply(tmpfile, readFASTA)

  unlink(tmpfile)

  return(AASeq)

}

#' Parallelized Drug Molecule Similarity Search by
#' Molecular Fingerprints Similarity or Maximum Common Substructure Search
#'
#' Parallelized Drug Molecule Similarity Search by
#' Molecular Fingerprints Similarity or Maximum Common Substructure Search
#'
#' This function does compound similarity search derived by
#' various molecular fingerprints with various similarity measures or
#' derived by maximum common substructure search.
#' This function runs for a query compound against a set of molecules.
#'
#' @param mol The query molecule. The location of a \code{sdf} file
#' containing one molecule.
#' @param moldb The molecule database. The location of a \code{sdf} file
#' containing all the molecules to be searched with.
#' @param cores Integer. The number of CPU cores to use for parallel search,
#'        default is \code{2}. Users could use the \code{detectCores()} function
#'        in the \code{parallel} package to see how many cores they could use.
#' @param method \code{'fp'} or \code{'mcs'}. Search by molecular fingerprints
#'               or by maximum common substructure searching.
#' @param fptype The fingerprint type, only available when \code{method = 'fp'}.
#'               Rcpi supports 13 types of fingerprints, including
#'               \code{'standard'}, \code{'extended'}, \code{'graph'},
#'               \code{'hybrid'}, \code{'maccs'}, \code{'estate'},
#'               \code{'pubchem'}, \code{'kr'}, \code{'shortestpath'},
#'               \code{'fp2'}, \code{'fp3'}, \code{'fp4'}, \code{'obmaccs'}.
#' @param fpsim Similarity measure type for fingerprint,
#'              only available when \code{method = 'fp'}.
#'              Including \code{'tanimoto'}, \code{'euclidean'},
#'              \code{'cosine'}, \code{'dice'} and \code{'hamming'}.
#'              See \code{calcDrugFPSim} for details.
#' @param mcssim Similarity measure type for maximum common substructure search,
#'               only available when \code{method = 'mcs'}.
#'               Including \code{'tanimoto'} and \code{'overlap'}.
#' @param ... Other possible parameter for maximum common substructure search,
#'            see \code{calcDrugMCSSim} for available options.
#'
#' @return Named numerical vector.
#' With the decreasing similarity value of the molecules in the database.
#'
#' @export searchDrug
#'
#' @examples
#' mol = system.file('compseq/DB00530.sdf', package = 'Rcpi')
#' # DrugBank ID DB00530: Erlotinib
#' moldb = system.file('compseq/tyrphostin.sdf', package = 'Rcpi')
#' # Database composed by searching 'tyrphostin' in PubChem and filtered by Lipinski's Rule of Five
#' \donttest{
#' searchDrug(mol, moldb, cores = 4, method = 'fp', fptype = 'maccs', fpsim = 'hamming')
#' searchDrug(mol, moldb, cores = 4, method = 'fp', fptype = 'fp2', fpsim = 'tanimoto')
#' searchDrug(mol, moldb, cores = 4, method = 'mcs', mcssim = 'tanimoto')}

searchDrug = function(
    mol, moldb, cores = 2,
    method = c('fp', 'mcs'),
    fptype = c('standard', 'extended', 'graph',
               'hybrid', 'maccs', 'estate',
               'pubchem', 'kr', 'shortestpath',
               'fp2', 'fp3', 'fp4', 'obmaccs'),
    fpsim = c('tanimoto', 'euclidean', 'cosine',
              'dice', 'hamming'),
    mcssim = c('tanimoto', 'overlap'), ...) {

    doParallel::registerDoParallel(cores)

    if (method == 'fp') {

        if ( fptype %in% c('standard', 'extended', 'graph',
                           'hybrid',   'maccs',    'estate',
                           'pubchem',  'kr',       'shortestpath') ) {

            mol   = loadMolecules(mol)
            moldb = loadMolecules(moldb)

        }

        if ( fptype %in% c('fp2', 'fp3', 'fp4', 'obmaccs') ) {

            mol   = readChar(mol, nchars = file.info(mol)['size'])
            moldb = readChar(moldb, nchars = file.info(moldb)['size'])

        }

        if (fptype == 'standard') {

            molfp   = extractDrugStandardComplete(mol[[1]])
            moldbfp = extractDrugStandardComplete(moldb)

        }

        if (fptype == 'extended') {

            molfp   = extractDrugExtendedComplete(mol[[1]])
            moldbfp = extractDrugExtendedComplete(moldb)

        }

        if (fptype == 'graph') {

            molfp   = extractDrugGraphComplete(mol[[1]])
            moldbfp = extractDrugGraphComplete(moldb)

        }

        if (fptype == 'hybrid') {

            molfp   = extractDrugHybridizationComplete(mol[[1]])
            moldbfp = extractDrugHybridizationComplete(moldb)

        }

        if (fptype == 'maccs') {

            molfp   = extractDrugMACCSComplete(mol[[1]])
            moldbfp = extractDrugMACCSComplete(moldb)

        }

        if (fptype == 'estate') {

            molfp   = extractDrugEstateComplete(mol[[1]])
            moldbfp = extractDrugEstateComplete(moldb)

        }

        if (fptype == 'pubchem') {

            molfp   = extractDrugPubChemComplete(mol[[1]])
            moldbfp = extractDrugPubChemComplete(moldb)

        }

        if (fptype == 'kr') {

            molfp   = extractDrugKRComplete(mol[[1]])
            moldbfp = extractDrugKRComplete(moldb)

        }

        if (fptype == 'shortestpath') {

            molfp   = extractDrugShortestPathComplete(mol[[1]])
            moldbfp = extractDrugShortestPathComplete(moldb)

        }

        if (fptype == 'fp2') {

            molfp   = extractDrugOBFP2(mol, type = 'sdf')
            moldbfp = extractDrugOBFP2(moldb, type = 'sdf')

        }

        if (fptype == 'fp3') {

            molfp   = extractDrugOBFP3(mol, type = 'sdf')
            moldbfp = extractDrugOBFP3(moldb, type = 'sdf')

        }

        if (fptype == 'fp4') {

            molfp   = extractDrugOBFP4(mol, type = 'sdf')
            moldbfp = extractDrugOBFP4(moldb, type = 'sdf')

        }

        if (fptype == 'obmaccs') {

            molfp   = extractDrugOBMACCS(mol, type = 'sdf')
            moldbfp = extractDrugOBMACCS(moldb, type = 'sdf')

        }

        i = NULL

        rankvec = rep(NA, nrow(moldbfp))

        rankvec <- foreach (i = 1:nrow(moldbfp), .combine = 'c', .errorhandling = 'pass') %dopar% {
            tmp <- calcDrugFPSim(as.vector(molfp), as.vector(moldbfp[i, ]),
                                 fptype = 'complete', metric = fpsim)
        }

        rankvec.ord = order(rankvec, decreasing = TRUE)
        rankvec = rankvec[rankvec.ord]
        names(rankvec) = as.character(rankvec.ord)

    }

    if (method == 'mcs') {

        if (!is_pkg_available("ChemmineR")) {
            stop ("Must install the `ChemmineR` package to use the 'mcs' method.", call. = FALSE)
        }

        if (!is_pkg_available("fmcsR")) {
            stop ("Must install the `fmcsR` package to use the 'mcs' method.", call. = FALSE)
        }

        mol = eval(parse(text = "ChemmineR::read.SDFset(mol)"))
        moldb = eval(parse(text = "ChemmineR::read.SDFset(moldb)"))

        fmcsresult = eval(parse(text = "fmcsR::fmcsBatch(mol, moldb, ...)"))

        if (mcssim == 'tanimoto') {
            rankvec = fmcsresult[order(fmcsresult[, 'Tanimoto_Coefficient'],
                                       decreasing = TRUE), 'Tanimoto_Coefficient']
        }

        if (mcssim == 'overlap') {
            rankvec = fmcsresult[order(fmcsresult[, 'Overlap_Coefficient'],
                                       decreasing = TRUE), 'Overlap_Coefficient']
        }

        names(rankvec) = gsub('CMP', '', names(rankvec))

    }

    return(rankvec)

}

is_pkg_available <- function(x) requireNamespace(x, quietly = TRUE)

#' Calculate the Descriptor that Describes the Sum of the Absolute
#' Value of the Difference between Atomic Polarizabilities of
#' All Bonded Atoms in the Molecule
#'
#' Calculates the Descriptor that Describes the Sum of the Absolute
#' Value of the Difference between Atomic Polarizabilities of
#' All Bonded Atoms in the Molecule
#'
#' This descriptor calculates the sum of the absolute value of the
#' difference between atomic polarizabilities of all bonded atoms
#' in the molecule (including implicit hydrogens) with polarizabilities
#' taken from \url{https://bit.ly/3PvNbhe}.
#' This descriptor assumes 2-centered bonds.
#'
#' @param molecules Parsed molucule object.
#' @param silent Logical. Whether the calculating process
#' should be shown or not, default is \code{TRUE}.
#'
#' @return A data frame, each row represents one of the molecules,
#' each column represents one feature.
#' This function returns one column named \code{bpol}.
#'
#' @export extractDrugBPol
#'
#' @examples
#' smi = system.file('vignettedata/FDAMDD.smi', package = 'Rcpi')
#' \donttest{
#' mol = readMolFromSmi(smi, type = 'mol')
#' dat = extractDrugBPol(mol)
#' head(dat)}

extractDrugBPol = function (molecules, silent = TRUE) {
    evaluateDescriptor(molecules, type = 'BPolDescriptor', silent = silent)
}

#' CTD Descriptors - Transition
#'
#' CTD Descriptors - Transition
#'
#' This function calculates the Transition descriptor of the
#' CTD descriptors (Dim: 21).
#'
#' @param x A character vector, as the input protein sequence.
#'
#' @return A length 21 named vector
#'
#' @seealso See \code{\link{extractProtCTDC}} and \code{\link{extractProtCTDD}}
#' for the Composition and Distribution descriptors.
#'
#' @export extractProtCTDT
#'
#' @references
#' Inna Dubchak, Ilya Muchink, Stephen R. Holbrook and Sung-Hou Kim.
#' Prediction of protein folding class using global description of
#' amino acid sequence. \emph{Proceedings of the National Academy of Sciences}.
#' USA, 1995, 92, 8700-8704.
#'
#' Inna Dubchak, Ilya Muchink, Christopher Mayor, Igor Dralyuk and Sung-Hou Kim.
#' Recognition of a Protein Fold in the Context of the SCOP classification.
#' \emph{Proteins: Structure, Function and Genetics}, 1999, 35, 401-407.
#'
#' @examples
#' x = readFASTA(system.file('protseq/P00750.fasta', package = 'Rcpi'))[[1]]
#' extractProtCTDT(x)

extractProtCTDT = function (x) {

    if (checkProt(x) == FALSE) stop('x has unrecognized amino acid type')

    group1 = list(
        hydrophobicity  = c('R', 'K', 'E', 'D', 'Q', 'N'),
        normwaalsvolume = c('G', 'A', 'S', 'T', 'P', 'D', 'C'),
        polarity        = c('L', 'I', 'F', 'W', 'C', 'M', 'V', 'Y'),
        polarizability  = c('G', 'A', 'S', 'D', 'T'),
        charge          = c('K', 'R'),
        secondarystruct = c('E', 'A', 'L', 'M', 'Q', 'K', 'R', 'H'),
        solventaccess   = c('A', 'L', 'F', 'C', 'G', 'I', 'V', 'W'))

    group2 = list(
        hydrophobicity  = c('G', 'A', 'S', 'T', 'P', 'H', 'Y'),
        normwaalsvolume = c('N', 'V', 'E', 'Q', 'I', 'L'),
        polarity        = c('P', 'A', 'T', 'G', 'S'),
        polarizability  = c('C', 'P', 'N', 'V', 'E', 'Q', 'I', 'L'),
        charge          = c('A', 'N', 'C', 'Q', 'G', 'H', 'I', 'L',
                            'M', 'F', 'P', 'S', 'T', 'W', 'Y', 'V'),
        secondarystruct = c('V', 'I', 'Y', 'C', 'W', 'F', 'T'),
        solventaccess   = c('R', 'K', 'Q', 'E', 'N', 'D'))

    group3 = list(
        hydrophobicity  = c('C', 'L', 'V', 'I', 'M', 'F', 'W'),
        normwaalsvolume = c('M', 'H', 'K', 'F', 'R', 'Y', 'W'),
        polarity        = c('H', 'Q', 'R', 'K', 'N', 'E', 'D'),
        polarizability  = c('K', 'M', 'H', 'F', 'R', 'Y', 'W'),
        charge          = c('D', 'E'),
        secondarystruct = c('G', 'N', 'P', 'S', 'D'),
        solventaccess   = c('M', 'S', 'P', 'T', 'H', 'Y'))

    xSplitted = strsplit(x, split = '')[[1]]
    n  = nchar(x)

    G = vector('list', 7)
    for (i in 1:7) G[[i]] = rep(NA, n)

    # Get groups for each property & each amino acid

    for (i in 1:7) {
        try(G[[i]][which(xSplitted %in% group1[[i]])] <- 'G1')
        try(G[[i]][which(xSplitted %in% group2[[i]])] <- 'G2')
        try(G[[i]][which(xSplitted %in% group3[[i]])] <- 'G3')
    }

    # Combine single amino acids by a 2-length step

    for (i in 1:7) G[[i]] = paste(G[[i]][-n], G[[i]][-1], sep = '')
    G = lapply(G, function(x) factor(x, levels = c(
        'G1G2', 'G2G1', 'G1G3',
        'G3G1', 'G2G3', 'G3G2',
        'G1G1', 'G2G2', 'G3G3')))

    GSummary = lapply(G, summary)

    # Compute (n_rs + n_sr) / (N - 1)

    CTDT = vector('list', 7)

    for (i in 1:7) {
        CTDT[[i]][1] = sum(GSummary[[i]][c('G1G2', 'G2G1')])/(n - 1)
        CTDT[[i]][2] = sum(GSummary[[i]][c('G1G3', 'G3G1')])/(n - 1)
        CTDT[[i]][3] = sum(GSummary[[i]][c('G2G3', 'G3G2')])/(n - 1)
    }

    CTDT = unlist(CTDT)

    names(CTDT) = paste(
        'prop', rep(1:7, each = 3), '.',
        rep(c('Tr1221', 'Tr1331', 'Tr2332'), times = 7) , sep = '')

    return(CTDT)

}

#' Descriptor that Calculates the Petitjean Number of a Molecule
#'
#' Descriptor that Calculates the Petitjean Number of a Molecule
#'
#' This descriptor calculates the Petitjean number of a molecule.
#' According to the Petitjean definition, the eccentricity of a vertex
#' corresponds to the distance from that vertex to the most remote vertex
#' in the graph.
#'
#' The distance is obtained from the distance matrix as the count of edges
#' between the two vertices. If \code{r(i)} is the largest matrix entry
#' in row \code{i} of the distance matrix \code{D}, then the radius is defined
#' as the smallest of the \code{r(i)}. The graph diameter \code{D} is defined as
#' the largest vertex eccentricity in the graph.
#' (\url{http://www.edusoft-lc.com/molconn/manuals/400/chaptwo.html})
#'
#' @param molecules Parsed molucule object.
#' @param silent Logical. Whether the calculating process should be shown or not, default is \code{TRUE}.
#'
#' @return A data frame, each row represents one of the molecules,
#' each column represents one feature.
#' This function returns one column named \code{PetitjeanNumber}.
#'
#' @export extractDrugPetitjeanNumber
#'
#' @examples
#' smi = system.file('vignettedata/FDAMDD.smi', package = 'Rcpi')
#' \donttest{
#' mol = readMolFromSmi(smi, type = 'mol')
#' dat = extractDrugPetitjeanNumber(mol)
#' head(dat)}

extractDrugPetitjeanNumber = function (molecules, silent = TRUE) {
    evaluateDescriptor(molecules, type = 'PetitjeanNumberDescriptor', silent = silent)
}

#' Descriptor that Characterizing Molecular Complexity
#' in Terms of Carbon Hybridization States
#'
#' Descriptor that Characterizing Molecular Complexity
#' in Terms of Carbon Hybridization States
#'
#' This descriptor calculates the fraction of sp3 carbons to sp2 carbons.
#' Note that it only considers carbon atoms and rather than use a simple
#' ratio it reports the value of Nsp3/(Nsp3 + Nsp2).
#' The original form of the descriptor (i.e., simple ratio)
#' has been used to characterize molecular complexity,
#' especially in the are of natural products,
#' which usually have a high value of the sp3 to sp2 ratio.
#'
#' @param molecules Parsed molucule object.
#' @param silent Logical. Whether the calculating process
#' should be shown or not, default is \code{TRUE}.
#'
#' @return A data frame, each row represents one of the molecules,
#' each column represents one feature.
#' This function returns one column named \code{HybRatio}.
#'
#' @export extractDrugHybridizationRatio
#'
#' @examples
#' smi = system.file('vignettedata/FDAMDD.smi', package = 'Rcpi')
#' \donttest{
#' mol = readMolFromSmi(smi, type = 'mol')
#' dat = extractDrugHybridizationRatio(mol)
#' head(dat)}

extractDrugHybridizationRatio = function (molecules, silent = TRUE) {
    evaluateDescriptor(molecules, type = 'HybridizationRatioDescriptor', silent = silent)
}

---
title: "Rcpi Quick Reference Card"
author: "Nan Xiao <<https://nanx.me>>"
output:
  rmarkdown::html_document:
    toc: true
    toc_float: true
    toc_depth: 4
    number_sections: false
    highlight: "textmate"
    css: "custom.css"
vignette: >
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteIndexEntry{Rcpi Quick Reference Card}
---

## Retrieve protein sequence data from online databases

  Function name           Function description
  ----------------------- ---------------------------------------------------------------------------------------
  getProt()               Retrieve protein sequence in FASTA format or PDB format from various online databases
  getFASTAFromUniProt()   Retrieve protein sequence in FASTA format from UniProt
  getFASTAFromKEGG()      Retrieve protein sequence in FASTA format from KEGG
  getPDBFromRCSBPDB()     Retrieve protein sequence in PDB Format from RCSB PDB
  getSeqFromUniProt()     Retrieve protein sequence from UniProt
  getSeqFromKEGG()        Retrieve protein sequence from KEGG
  getSeqFromRCSBPDB()     Retrieve protein sequence from RCSB PDB

  : Table 1: Retrieving protein sequence data from various online databases

## Retrieve drug molecular data from online databases

  Function name          Function description
  ---------------------- ---------------------------------------------------------------------------------------
  getDrug()              Retrieve drug molecules in MOL format and SMILES format from various online databases
  getMolFromDrugBank()   Retrieve drug molecules in MOL format from DrugBank
  getMolFromPubChem()    Retrieve drug molecules in MOL format from PubChem
  getMolFromChEMBL()     Retrieve drug molecules in MOL format from ChEMBL
  getMolFromKEGG()       Retrieve drug molecules in MOL format from the KEGG
  getMolFromCAS()        Retrieve drug molecules in InChI format from CAS
  getSmiFromDrugBank()   Retrieve drug molecules in SMILES format from DrugBank
  getSmiFromPubChem()    Retrieve drug molecules in SMILES format from PubChem
  getSmiFromChEMBL()     Retrieve drug molecules in SMILES format from ChEMBL
  getSmiFromKEGG()       Retrieve drug molecules in SMILES format from KEGG

  : Table 2: Retrieving drug molecular data from various online databases

## Calculate commonly used protein sequence derived descriptors

  Function name              Descriptor name                                                                    Descriptor group
  -------------------------- ---------------------------------------------------------------------------------- -------------------------------
  extractProtAAC()           Amino acid composition                                                             Amino acid composition
  extractProtDC()            Dipeptide composition
  extractProtTC()            Tripeptide composition
  extractProtMoreauBroto()   Normalized Moreau-Broto autocorrelation                                            Autocorrelation
  extractProtMoran()         Moran autocorrelation
  extractProtGeary()         Geary autocorrelation
  extractProtCTDC()          Composition                                                                        CTD
  extractProtCTDT()          Transition
  extractProtCTDD()          Distribution
  extractProtCTriad()        Conjoint Triad                                                                     Conjoint Triad
  extractProtSOCN()          Sequence-order-coupling number                                                     Quasi-sequence-order
  extractProtQSO()           Quasi-sequence-order descriptors
  extractProtPAAC()          Pseudo-amino acid composition                                                      Pseudo-amino acid composition
  extractProtAPAAC()         Amphiphilic pseudo-amino acid composition
  AAindex                    AAindex data of 544 physicochemical and biological properties for 20 amino acids   Dataset

  : Table 3: Calculating commonly used protein sequence derived descriptors

## Generate profile-based protein representations

  Function name              Function description
  -------------------------- ----------------------------------------------------------------------------------------
  extractProtPSSM()          Compute PSSM (Position-Specific Scoring Matrix) for given protein sequence or peptides
  extractProtPSSMFeature()   Profile-based protein representation derived by PSSM
  extractProtPSSMAcc()       Profile-based protein representation derived by PSSM and auto cross covariance (ACC)

  : Table 4: Generating profile-based protein representations

## Generate scales-based descriptors for proteochemometrics modeling

  Function name            Descriptor class                                                                                                  Derived by
  ------------------------ ----------------------------------------------------------------------------------------------------------------- -------------------------------
  extractPCMScales()       Generalized scales-based descriptors derived by principal components analysis (PCA)                               Principal components analysis
  extractPCMPropScales()   Generalized scales-based descriptors derived by amino acid properties (AAindex)                                   
  extractPCMDescScales()   Generalized scales-based descriptors derived by 2D and 3D molecular descriptors (Topological, WHIM, VHSE, etc.)   
  extractPCMFAScales()     Generalized scales-based descriptors derived by factor analysis                                                   Factor analysis
  extractPCMMDSScales()    Generalized scales-based descriptors derived by multidimensional scaling (MDS)                                    Multidimensional scaling
  extractPCMBLOSUM()       Generalized BLOSUM and PAM matrix-derived descriptors                                                             Substitution matrix
  acc()                    Auto cross covariance (ACC) for generating scales-based descriptors of the same length                            

  : Table 5: Generating scales-based descriptors for proteochemometrics modeling

## Molecular descriptor sets of the 20 amino acids for generating scales-based descriptors

  Dataset name   Dataset description                           Dimensionality   Calculated by
  -------------- --------------------------------------------- ---------------- ---------------------------
  OptAA3d        Optimized 20 amino acids                      –                MOE
  AA2DACOR       2D autocorrelations descriptors               92               Dragon
  AA3DMoRSE      3D-MoRSE descriptors                          160              Dragon
  AAACF          Atom-centred fragments descriptors            6                Dragon
  AABurden       Burden Eigenvalues descriptors                62               Dragon
  AAConn         Connectivity indices descriptors              33               Dragon
  AAConst        Constitutional descriptors                    23               Dragon
  AAEdgeAdj      Edge adjacency indices descriptors            97               Dragon
  AAEigIdx       Eigenvalue-based indices descriptors          44               Dragon
  AAFGC          Functional group counts descriptors           5                Dragon
  AAGeom         Geometrical descriptors                       41               Dragon
  AAGETAWAY      GETAWAY descriptors                           194              Dragon
  AAInfo         Information indices descriptors               47               Dragon
  AAMolProp      Molecular properties descriptors              12               Dragon
  AARandic       Randic molecular profiles descriptors         41               Dragon
  AARDF          RDF descriptors                               82               Dragon
  AATopo         Topological descriptors                       78               Dragon
  AATopoChg      Topological charge indices descriptors        15               Dragon
  AAWalk         Walk and path counts descriptors              40               Dragon
  AAWHIM         WHIM descriptors                              99               Dragon
  AACPSA         CPSA descriptors                              41               Accelrys Discovery Studio
  AADescAll      All the 2D descriptors calculated by Dragon   1171             Dragon
  AAMOE2D        All the 2D descriptors calculated by MOE      148              MOE
  AAMOE3D        All the 3D descriptors calculated by MOE      143              MOE
  AABLOSUM45     BLOSUM45 matrix for 20 amino acids            $20 \times 20$   Biostrings
  AABLOSUM50     BLOSUM50 matrix for 20 amino acids            $20 \times 20$   Biostrings
  AABLOSUM62     BLOSUM62 matrix for 20 amino acids            $20 \times 20$   Biostrings
  AABLOSUM80     BLOSUM80 matrix for 20 amino acids            $20 \times 20$   Biostrings
  AABLOSUM100    BLOSUM100 matrix for 20 amino acids           $20 \times 20$   Biostrings
  AAPAM30        PAM30 matrix for 20 amino acids               $20 \times 20$   Biostrings
  AAPAM40        PAM40 matrix for 20 amino acids               $20 \times 20$   Biostrings
  AAPAM70        PAM70 matrix for 20 amino acids               $20 \times 20$   Biostrings
  AAPAM120       PAM120 matrix for 20 amino acids              $20 \times 20$   Biostrings
  AAPAM250       PAM250 matrix for 20 amino acids              $20 \times 20$   Biostrings

  : Table 6: Pre-calculated molecular descriptor sets of the 20 amino
  acids in for generating scales-based descriptors for proteochemometrics
  modeling.

**Note**: non-informative descriptors (e.g. descriptors with only one value across all the 20 amino acids) in these datasets have been filtered out.

## Molecular descriptors

  Function name                                Descriptor name
  -------------------------------------------- -----------------------------------------------------------------------------------------------------------------
  extractDrugAIO()                             All the molecular descriptors in the package
  extractDrugALOGP()                           Atom additive logP and molar refractivity values descriptor
  extractDrugAminoAcidCount()                  Number of amino acids
  extractDrugApol()                            Sum of the atomic polarizabilities
  extractDrugAromaticAtomsCount()              Number of aromatic atoms
  extractDrugAromaticBondsCount()              Number of aromatic bonds
  extractDrugAtomCount()                       Number of atom descriptor
  extractDrugAutocorrelationCharge()           Moreau-Broto autocorrelation descriptors using partial charges
  extractDrugAutocorrelationMass()             Moreau-Broto autocorrelation descriptors using atomic weight
  extractDrugAutocorrelationPolarizability()   Moreau-Broto autocorrelation descriptors using polarizability
  extractDrugBCUT()                            BCUT, the eigenvalue based descriptor
  extractDrugBondCount()                       Number of bonds of a certain bond order
  extractDrugBPol()                            Sum of the absolute value of the difference between atomic polarizabilities of all bonded atoms in the molecule
  extractDrugCarbonTypes()                     Topological descriptor characterizing the carbon connectivity in terms of hybridization
  extractDrugChiChain()                        Kier & Hall Chi chain indices of orders 3, 4, 5, 6 and 7
  extractDrugChiCluster()                      Kier & Hall Chi cluster indices of orders 3, 4, 5 and 6
  extractDrugChiPath()                         Kier & Hall Chi path indices of orders 0 to 7
  extractDrugChiPathCluster()                  Kier & Hall Chi path cluster indices of orders 4, 5 and 6
  extractDrugCPSA()                            Descriptors combining surface area and partial charge information
  extractDrugDescOB()                          Molecular descriptors provided by OpenBabel
  extractDrugECI()                             Eccentric connectivity index descriptor
  extractDrugFMF()                             FMF descriptor
  extractDrugFragmentComplexity()              Complexity of a system
  extractDrugGravitationalIndex()              Mass distribution of the molecule
  extractDrugHBondAcceptorCount()              Number of hydrogen bond acceptors
  extractDrugHBondDonorCount()                 Number of hydrogen bond donors
  extractDrugHybridizationRatio()              Molecular complexity in terms of carbon hybridization states
  extractDrugIPMolecularLearning()             Ionization potential
  extractDrugKappaShapeIndices()               Kier & Hall Kappa molecular shape indices
  extractDrugKierHallSmarts()                  Number of occurrences of the E-State fragments
  extractDrugLargestChain()                    Number of atoms in the largest chain
  extractDrugLargestPiSystem()                 Number of atoms in the largest Pi chain
  extractDrugLengthOverBreadth()               Ratio of length to breadth descriptor
  extractDrugLongestAliphaticChain()           Number of atoms in the longest aliphatic chain
  extractDrugMannholdLogP()                    LogP based on the number of carbons and hetero atoms
  extractDrugMDE()                             Molecular Distance Edge (MDE) descriptors for C, N and O
  extractDrugMomentOfInertia()                 Principal moments of inertia and ratios of the principal moments
  extractDrugPetitjeanNumber()                 Petitjean number of a molecule
  extractDrugPetitjeanShapeIndex()             Petitjean shape indices
  extractDrugRotatableBondsCount()             Number of non-rotatable bonds on a molecule
  extractDrugRuleOfFive()                      Number failures of the Lipinski’s Rule Of Five
  extractDrugTPSA()                            Topological Polar Surface Area (TPSA)
  extractDrugVABC()                            Volume of a molecule
  extractDrugVAdjMa()                          Vertex adjacency information of a molecule
  extractDrugWeight()                          Total weight of atoms
  extractDrugWeightedPath()                    Weighted path (Molecular ID)
  extractDrugWHIM()                            Holistic descriptors described by Todeschini et al.
  extractDrugWienerNumbers()                   Wiener path number and wiener polarity number
  extractDrugXLogP()                           Prediction of logP based on the atom-type method called XLogP
  extractDrugZagrebIndex()                     Sum of the squared atom degrees of all heavy atoms

  : Table 7: Molecular descriptors

## Molecular fingerprints

  Function name                        Fingerprint type
  ------------------------------------ -------------------------------------------------------------------
  extractDrugStandard()                Standard molecular fingerprints (in compact format)
  extractDrugStandardComplete()        Standard molecular fingerprints (in complete format)
  extractDrugExtended()                Extended molecular fingerprints (in compact format)
  extractDrugExtendedComplete()        Extended molecular fingerprints (in complete format)
  extractDrugGraph()                   Graph molecular fingerprints (in compact format)
  extractDrugGraphComplete()           Graph molecular fingerprints (in complete format)
  extractDrugHybridization()           Hybridization molecular fingerprints (in compact format)
  extractDrugHybridizationComplete()   Hybridization molecular fingerprints (in complete format)
  extractDrugMACCS()                   MACCS molecular fingerprints (in compact format)
  extractDrugMACCSComplete()           MACCS molecular fingerprints (in complete format)
  extractDrugEstate()                  E-State molecular fingerprints (in compact format)
  extractDrugEstateComplete()          E-State molecular fingerprints (in complete format)
  extractDrugPubChem()                 PubChem molecular fingerprints (in compact format)
  extractDrugPubChemComplete()         PubChem molecular fingerprints (in complete format)
  extractDrugKR()                      KR (Klekota and Roth) molecular fingerprints (in compact format)
  extractDrugKRComplete()              KR (Klekota and Roth) molecular fingerprints (in complete format)
  extractDrugShortestPath()            Shortest Path molecular fingerprints (in compact format)
  extractDrugShortestPathComplete()    Shortest Path molecular fingerprints (in complete format)
  extractDrugOBFP2()                   FP2 molecular fingerprints
  extractDrugOBFP3()                   FP3 molecular fingerprints
  extractDrugOBFP4()                   FP4 molecular fingerprints
  extractDrugOBMACCS()                 MACCS molecular fingerprints

  : Table 8: Molecular fingerprints

## Protein-protein and compound-protein interation descriptors

  Function name   Function description
  --------------- -----------------------------------------------------
  getPPI()        Generating protein-protein interaction descriptors
  getCPI()        Generating compound-protein interaction descriptors

  : Table 9: Protein-protein and compound-protein interation descriptors

## Similarity and similarity searching

  Function name         Function description
  --------------------- -------------------------------------------------------------------------------------------------------------------------
  calcDrugFPSim()       Calculate drug molecule similarity derived by molecular fingerprints
  calcDrugMCSSim()      Calculate drug molecule similarity derived by maximum common substructure search
  searchDrug()          Parallelized drug molecule similarity search by molecular fingerprints similarity or maximum common substructure search
  calcTwoProtSeqSim()   Similarity calculation based on sequence alignment for a pair of protein sequences
  calcParProtSeqSim()   Parallellized protein sequence similarity calculation based on sequence alignment
  calcTwoProtGOSim()    Similarity calculation based on Gene Ontology (GO) similarity between two proteins
  calcParProtGOSim()    Protein similarity calculation based on Gene Ontology (GO) similarity

  : Table 10: Similarity and similarity searching

## Protein sequence data manipulation

  Function name   Function description
  --------------- ---------------------------------------------------------------------------
  readFASTA()     Read protein sequences in FASTA format
  readPDB()       Read protein sequences in PDB format
  segProt()       Protein sequence segmentation
  checkProt()     Check if the protein sequence’s amino acid types are the 20 default types

  : Table 11: Protein sequence data manipulation

## Molecular data manipulation

  Function name      Function description
  ------------------ ---------------------------------------------------------------------------------------------
  readMolFromSDF()   Read molecules from SDF files and return parsed Java molecular object
  readMolFromSmi()   Read molecules from SMILES files and return parsed Java molecular object or plain text list
  convMolFormat()    Chemical file formats conversion

  : Table 12: Molecular data manipulation

---
title: "Rcpi: R/Bioconductor Package as an Integrated Informatics Platform for Drug Discovery"
author: "Nan Xiao <<https://nanx.me>>"
bibliography: Rcpi.bib
csl: bioinformatics.csl
output:
  rmarkdown::html_document:
    toc: true
    toc_float: true
    toc_depth: 4
    number_sections: false
    highlight: "textmate"
    css: "custom.css"
vignette: >
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteIndexEntry{Rcpi: R/Bioconductor Package as an Integrated Informatics Platform for Drug Discovery}
---

## Introduction

The Rcpi package @Rcpi2015 offers an R/Bioconductor package emphasizing
the comprehensive integration of bioinformatics and chemoinformatics
into a molecular informatics platform for drug discovery.

Rcpi implemented and integrated the state-of-the-art protein sequence
descriptors and molecular descriptors/fingerprints with R. For protein
sequences, the Rcpi package can

- Calculate six protein descriptor groups composed of fourteen types of commonly used structural and physicochemical descriptors that include 9,920 descriptors.
- Calculate profile-based protein representation derived by PSSM (Position-Specific Scoring Matrix).
- Calculate six types of generalized scales-based descriptors derived by various dimensionality reduction methods for proteochemometric (PCM) modeling.
- Parallellized pairwise similarity computation derived by protein sequence alignment and Gene Ontology (GO) semantic similarity measures within a list of proteins.

For small molecules, the Rcpi package can

- Calculate 307 molecular descriptors (2D/3D), including constitutional, topological, geometrical, and electronic descriptors, etc.
- Calculate more than ten types of molecular fingerprints, including FP4 keys, E-state fingerprints, MACCS keys, etc., and parallelized chemical similarity search.
- Parallelized pairwise similarity computation derived by fingerprints and maximum common substructure search within a list of small molecules.

By combining various types of descriptors for drugs and proteins in
different methods, interaction descriptors representing protein-protein
or compound-protein interactions can be conveniently generated with Rcpi,
including:

- Two types of compound-protein interaction (CPI) descriptors
- Three types of protein-protein interaction (PPI) descriptors

Several useful auxiliary utilities are also shipped with Rcpi:

- Parallelized molecule and protein sequence retrieval from several online databases, like PubChem, ChEMBL, KEGG, DrugBank, UniProt, RCSB PDB, etc.
- Loading molecules stored in SMILES/SDF files and loading protein sequences from FASTA/PDB files
- Molecular file format conversion

The computed protein sequence descriptors, molecular descriptors/fingerprints,
interaction descriptors and pairwise similarities are widely used in various
research fields relevant to drug disvery, such as, bioinformatics,
chemoinformatics, proteochemometrics and chemogenomics.

### Installation

To install the Rcpi package, use:

```{r, eval = FALSE}
install.packages("BiocManager")
BiocManager::install("Rcpi")
```

To make the Rcpi package fully functional (especially the Open Babel
related functionalities), we recommend the users also install
the _Enhances_ packages by:

```{r, eval = FALSE}
BiocManager::install("Rcpi", dependencies = c("Imports", "Enhances"))
```

Several dependencies of the Rcpi package may require some system-level
libraries, check the corresponding manuals of these packages for
detailed installation guides.

### How to cite Rcpi

If you feel Rcpi is useful in your research, please cite our paper:

> Dong-Sheng Cao, Nan Xiao, Qing-Song Xu, and Alex F. Chen. (2015).
> Rcpi: R/Bioconductor package to generate various descriptors of proteins,
> compounds and their interactions. _Bioinformatics_ 31 (2), 279-281.

BibTeX entry:

```bibtex
@article{Rcpi2015,
author = {Cao, Dong-Sheng and Xiao, Nan and Xu, Qing-Song and Alex F. Chen.},
title = {{Rcpi: R/Bioconductor package to generate various descriptors
  of proteins, compounds and their interactions}},
journal = {Bioinformatics},
year = {2015},
volume = {31},
number = {2},
pages = {279--281},
doi = {10.1093/bioinformatics/btu624},
issn = {1367-4803},
url = {http://bioinformatics.oxfordjournals.org/content/31/2/279}
}
```

## Applications in bioinformatics

For bioinformatics research, Rcpi calculates commonly used descriptors
and proteochemometric (PCM) modeling descriptors for protein sequences.
Rcpi also computes pairwise similarities derived by GO semantic
similarity and sequence alignment.

### Predicting protein subcellular localization

Protein subcellular localization prediction involves the computational
prediction of where a protein resides in a cell. It is an important
component of bioinformatics-based prediction of protein function and
genome annotation, and can also aid us to identify novel drug targets.

Here we use the subcellular localization dataset of human proteins
presented in the study of @chou2008cell for a demonstration.
The complete dataset includes 3,134 protein sequences (2,750 different
proteins), classified into 14 human subcellular locations. We selected
two classes of proteins as our benchmark dataset. Class 1 contains
325 _extracell_ proteins, and class 2 includes 307 _mitochondrion_ proteins.

First, we load the Rcpi package, then read the protein sequences stored
in two separated FASTA files with `readFASTA()`:

```{r, eval = FALSE}
library("Rcpi")

# Load FASTA files
extracell <- readFASTA(system.file(
  "vignettedata/extracell.fasta",
  package = "Rcpi"
))
mitonchon <- readFASTA(system.file(
  "vignettedata/mitochondrion.fasta",
  package = "Rcpi"
))
```

The loaded sequences are stored as two lists in R, and each component
in the list is a character string representing one protein sequence.
In this case, there are 325 _extracell_ protein sequences and
306 _mitonchon_ protein sequences:

```{r, eval = FALSE}
length(extracell)
```

```
># [1] 325
```

```{r, eval = FALSE}
length(mitonchon)
```

```
># [1] 306
```

To assure that the protein sequences only have the twenty standard
amino acid types which is required for the descriptor computation,
we use the `checkProt()` function to do the amino acid type sanity
checking and remove the _non-standard_ protein sequences:

```{r, eval = FALSE}
extracell <- extracell[(sapply(extracell, checkProt))]
mitonchon <- mitonchon[(sapply(mitonchon, checkProt))]
```

```{r, eval = FALSE}
length(extracell)
```

```
># [1] 323
```

```{r, eval = FALSE}
length(mitonchon)
```

```
># [1] 304
```

Two protein sequences were removed from each class. For the remaining
sequences, we calculate the amphiphilic pseudo amino acid composition
(APAAC) descriptor @chouapaac and create class labels for the random
forest classification modeling.

```{r, eval = FALSE}
# Calculate APAAC descriptors
x1 <- t(sapply(extracell, extractProtAPAAC))
x2 <- t(sapply(mitonchon, extractProtAPAAC))
x <- rbind(x1, x2)

# Make class labels
labels <- as.factor(c(rep(0, length(extracell)), rep(1, length(mitonchon))))
```

In Rcpi, the functions of commonly used descriptors for protein sequences
and proteochemometric (PCM) modeling descriptors are named after
`extractProt...()` and `extractPCM...()`.

Next, we will split the data into a 75% training set and a 25% test set.

```{r, eval = FALSE}
set.seed(1001)

# Split training and test set
tr.idx <- c(
  sample(1:nrow(x1), round(nrow(x1) * 0.75)),
  sample(nrow(x1) + 1:nrow(x2), round(nrow(x2) * 0.75))
)
te.idx <- setdiff(1:nrow(x), tr.idx)

x.tr <- x[tr.idx, ]
x.te <- x[te.idx, ]
y.tr <- labels[tr.idx]
y.te <- labels[te.idx]
```

We will train a random forest classification model on the training set with 5-fold cross-validation, using the \pkg{randomForest} package.

```{r, eval = FALSE}
library("randomForest")
rf.fit <- randomForest(x.tr, y.tr, cv.fold = 5)
print(rf.fit)
```

The training result is:

```
># Call:
>#  randomForest(x = x.tr, y = y.tr, cv.fold = 5)
>#                Type of random forest: classification
>#                      Number of trees: 500
># No. of variables tried at each split: 8
>#
>#         OOB estimate of  error rate: 25.11%
># Confusion matrix:
>#     0   1 class.error
># 0 196  46   0.1900826
># 1  72 156   0.3157895
```

With the model trained on the training set, we predict on the test set
and plot the ROC curve with the \pkg{pROC} package, as is shown in
Figure 1.

```{r, eval = FALSE}
# Predict on test set
rf.pred <- predict(rf.fit, newdata = x.te, type = "prob")[, 1]

# Plot ROC curve
library("pROC")
plot.roc(y.te, rf.pred, grid = TRUE, print.auc = TRUE)
```

```{r, echo=FALSE, out.width="65%", fig.cap="Figure 1: ROC curve for the test set of protein subcellular localization data."}
knitr::include_graphics("figures/ex1-1.png")
```

The area under the ROC curve (AUC) is:

```
># Call:
># plot.roc.default(x = y.te, predictor = rf.pred, col = "#0080ff",
>#                  grid = TRUE, print.auc = TRUE)
>#
># Data: rf.pred in 81 controls (y.te 0) > 76 cases (y.te 1).
># Area under the curve: 0.8697
```

## Applications in chemoinformatics

For chemoinformatics research, Rcpi calculates various types of molecular
descriptors/fingerprints, and computes pairwise similarities derived by
fingerprints and maximum common substructure search. Rcpi also provides
the `searchDrug()` function for parallelized molecular similarity
search based on these similarity types.

### Regression modeling in QSRR study of retention indices

In @yan2012comparison, a quantitative structure-retention relationship
study was performed for 656 flavor compounds on four stationary phases
of different polarities, using constitutional, topological and geometrical
molecular descriptors. The gas chromatographic retention indices (RIs)
of these compounds were accurately predicted using linear models.
Here we choose the molecules and their RIs of one stationary phase
(OV101) as our benchmark dataset.

Since it would be rather tedious to implement the complete cross-validation
procedures, the R package `caret` is used here. To run the R code below,
users need to install the \pkg{caret} package and the required predictive
modeling packages first. The \pkg{caret} package provides a unified
interface for the modeling tuning task across different statistical
machine learning packages. It is particularly helpful in QSAR modeling,
for it contains tools for data splitting, pre-processing, feature selection,
model tuning and other functionalities.

Just like the last section, we load the Rcpi package, and read the
molecules stored in a SMILES file:

```{r, eval = FALSE}
library("Rcpi")

RI.smi <- system.file(
  "vignettedata/RI.smi",
  package = "Rcpi"
)
RI.csv <- system.file(
  "vignettedata/RI.csv",
  package = "Rcpi"
)

x.mol <- readMolFromSmi(RI.smi, type = "mol")
x.tab <- read.table(RI.csv, sep = "\t", header = TRUE)
y <- x.tab$RI
```

The `readMolFromSmi()` function is used for reading molecules from
SMILES files, for molecules stored in SDF files, use `readMolFromSDF()` instead.

The CSV file `RI.csv` contains tabular data for the retention indices,
compound name, and odor information of the compounds. Here we only
extracted the RI values by calling `x.tab$RI`.

After the molecules were properly loaded, we calculate several selected
molecular descriptors. The corresponding functions for molecular descriptor
calculation are all named after `extractDrug...()` in `Rcpi`:

```{r, eval = FALSE}
# Calculate selected molecular descriptors
x <- suppressWarnings(cbind(
  extractDrugALOGP(x.mol),
  extractDrugApol(x.mol),
  extractDrugECI(x.mol),
  extractDrugTPSA(x.mol),
  extractDrugWeight(x.mol),
  extractDrugWienerNumbers(x.mol),
  extractDrugZagrebIndex(x.mol)
))
```

After the descriptors were calculated, the result `x` will be a data frame,
each row represents one molecule, and each column is one descriptor (predictor).
The Rcpi package integrated the molecular descriptors and chemical fingerprints
calculated by the `rcdk` package @steinbeck2003chemistry and the
ChemmineOB package @chemmineob.

Next, a partial least squares model will be fitted with the `pls` and
the `caret` package. The cross-validation setting is 5-fold repeated
cross-validation (repeat for 10 times).

```{r, eval = FALSE}
# Run regression on training set
library("caret")
library("pls")

# Cross-validation settings
ctrl <- trainControl(
  method = "repeatedcv", number = 5, repeats = 10,
  summaryFunction = defaultSummary
)

# Train a PLS model
set.seed(1002)
pls.fit <- train(
  x, y,
  method = "pls", tuneLength = 10, trControl = ctrl,
  metric = "RMSE", preProc = c("center", "scale")
)

# Print cross-validation results
print(pls.fit)
```

The cross-validation result is:

```
Partial Least Squares 

297 samples
 10 predictor

Pre-processing: centered (10), scaled (10) 
Resampling: Cross-Validated (5 fold, repeated 10 times) 
Summary of sample sizes: 237, 239, 238, 237, 237, 238, ... 
Resampling results across tuning parameters:

  ncomp  RMSE       Rsquared   MAE     
  1      104.19653  0.8822135  81.30798
  2       88.79911  0.9153172  69.67190
  3       87.65849  0.9169335  68.90654
  4       87.03159  0.9180740  68.45516
  5       84.66035  0.9227619  66.65136
  6       80.29620  0.9309492  62.57300
  7       79.06348  0.9333719  61.51886
  8       78.17443  0.9346922  59.81325
  9       77.68815  0.9353269  59.48581

RMSE was used to select the optimal model using the smallest value.
The final value used for the model was ncomp = 9.
```

We see that the RMSE of the PLS regression model was decreasing when
the number of principal components (`ncomp`) was increasing.
We can plot the components and RMSE to helps us select the desired
number of principal components used in the model.

```{r, eval = FALSE}
# Number of components vs. RMSE
print(plot(pls.fit, asp = 0.5))
```

```{r, echo=FALSE, out.width="85%", fig.cap="Figure 2: Number of principal components vs. RMSE for the PLS regression model."}
knitr::include_graphics("figures/ex2-1.png")
```

From Figure 2, we consider that selecting six or seven components is acceptable.
At last, we plot the experimental RIs and the predicted RIs to see if the model
fits well on the training set (Figure 3):

```{r, eval = FALSE}
# Plot experimental RIs vs predicted RIs
plot(y, predict(pls.fit, x),
  xlim = range(y), ylim = range(y),
  xlab = "Experimental RIs", ylab = "Predicted RIs"
)
abline(a = 0, b = 1)
```

```{r, echo=FALSE, out.width="65%", fig.cap="Figure 3: Experimental RIs vs. predicted RIs."}
knitr::include_graphics("figures/ex2-2.png")
```

### _In silico_ toxicity classification for drug discovery

In the perspective of quantitative pharmacology, the successful discovery
of novel drugs depends on the pharmacokinetics properties, like
**a**bsorption, **d**istribution, **m**etabolism, and **e**xcretion.
In addition, the potential **t**oxicity of chemical compounds is taken
into account. QSAR or QSPR methods are usually employed to predict the
ADME/T qualities of potential drug candidates.

In @cao2012silico, quantitative structure-toxicity relationship (QSTR)
models were established for classifying five toxicity datasets.
Here we use the maximum recommended daily dose dataset (FDAMDD)
from FDA Center for Drug Evaluation and Research as the benchmark dataset.

First, load the drug molecules stored in a SMILES file into R:

```{r, eval = FALSE}
library("Rcpi")

fdamdd.smi <- system.file("vignettedata/FDAMDD.smi", package = "Rcpi")
fdamdd.csv <- system.file("vignettedata/FDAMDD.csv", package = "Rcpi")

x.mol <- readMolFromSmi(fdamdd.smi, type = "mol")
x.smi <- readMolFromSmi(fdamdd.smi, type = "text")
y <- as.factor(paste0("class", scan(fdamdd.csv)))
```

The object `x.mol` is used for computing the MACCS and E-state fingerprints;
the object `x.smi` is used for computing the FP4 fingerprints.
The 0-1 class labels stored in file `FDAMDD.csv` indicates whether
the drug molecule has high toxicity or not.

Then we calculate three different types of molecular fingerprints
(E-state, MACCS, and FP4) for the drug molecules:

```{r, eval = FALSE}
# Calculate molecular fingerprints
x1 <- extractDrugEstateComplete(x.mol)
x2 <- extractDrugMACCSComplete(x.mol)
x3 <- extractDrugOBFP4(x.smi, type = "smile")
```

As the nature of fingerprint-based structure representation,
the calculated 0-1 matrix `x1`, `x2`, and `x3` will be very sparse.
Since there are several columns have nearly exactly the same value
for all the molecules, we should remove them with `nearZeroVar()`
in `caret` before modeling, and split our training set and test set:

```{r, eval = FALSE}
library("caret")

# Remove near-zero variance variables
x1 <- x1[, -nearZeroVar(x1)]
x2 <- x2[, -nearZeroVar(x2)]
x3 <- x3[, -nearZeroVar(x3)]

# Split training and test set
set.seed(1003)
tr.idx <- sample(1:nrow(x1), round(nrow(x1) * 0.75))
te.idx <- setdiff(1:nrow(x1), tr.idx)
x1.tr <- x1[tr.idx, ]
x1.te <- x1[te.idx, ]
x2.tr <- x2[tr.idx, ]
x2.te <- x2[te.idx, ]
x3.tr <- x3[tr.idx, ]
x3.te <- x3[te.idx, ]
y.tr <- y[tr.idx]
y.te <- y[te.idx]
```

On the training sets, we will train three classification models separately
using SVM (RBF kernel), using the `kernlab` package and the `caret` package.
The cross-validation setting is 5-fold repeated CV (repeat for 10 times).

```{r, eval = FALSE}
# SVM classification on training sets
library("kernlab")

# Cross-validation settings
ctrl <- trainControl(
  method = "cv", number = 5, repeats = 10,
  classProbs = TRUE,
  summaryFunction = twoClassSummary
)

# SVM with RBF kernel
svm.fit1 <- train(
  x1.tr, y.tr,
  method = "svmRadial", trControl = ctrl,
  metric = "ROC", preProc = c("center", "scale")
)
svm.fit2 <- train(
  x2.tr, y.tr,
  method = "svmRadial", trControl = ctrl,
  metric = "ROC", preProc = c("center", "scale")
)
svm.fit3 <- train(
  x3.tr, y.tr,
  method = "svmRadial", trControl = ctrl,
  metric = "ROC", preProc = c("center", "scale")
)

# Print cross-validation results
print(svm.fit1)
print(svm.fit2)
print(svm.fit3)
```

The training result when using E-state fingerprints:

```
># Support Vector Machines with Radial Basis Function Kernel
>#
># 597 samples
>#  23 predictors
>#   2 classes: "class0", "class1"
>#
># Pre-processing: centered, scaled
># Resampling: Cross-Validated (5 fold)
>#
># Summary of sample sizes: 478, 479, 477, 477, 477
>#
># Resampling results across tuning parameters:
>#
>#   C     ROC    Sens   Spec   ROC SD  Sens SD  Spec SD
>#   0.25  0.797  0.7    0.765  0.0211  0.0442   0.00666
>#   0.5   0.808  0.696  0.79   0.0173  0.059    0.0236
>#   1     0.812  0.703  0.781  0.0191  0.0664   0.0228
>#
># Tuning parameter "sigma" was held constant at a value of 0.02921559
># ROC was used to select the optimal model using  the largest value.
># The final values used for the model were sigma = 0.0292 and C = 1.
```

We can see that, after removing the near zero variance predictors,
there were only 23 predictors left for the original 79 E-state fingerprints.

The training result when using MACCS keys:

```
># Support Vector Machines with Radial Basis Function Kernel
>#
># 597 samples
># 126 predictors
>#   2 classes: "class0", "class1"
>#
># Pre-processing: centered, scaled
># Resampling: Cross-Validated (5 fold)
>#
># Summary of sample sizes: 477, 477, 477, 478, 479
>#
># Resampling results across tuning parameters:
>#
>#   C     ROC    Sens   Spec   ROC SD  Sens SD  Spec SD
>#   0.25  0.834  0.715  0.775  0.0284  0.0994   0.0589
>#   0.5   0.848  0.726  0.79   0.0299  0.065    0.0493
>#   1     0.863  0.769  0.793  0.0307  0.0229   0.0561
>#
># Tuning parameter "sigma" was held constant at a value of 0.004404305
># ROC was used to select the optimal model using  the largest value.
># The final values used for the model were sigma = 0.0044 and C = 1.
```

There are 126 predictors left for the original 166 MACCS keys
after removing the near-zero variance predictors.
The model performance by AUC values is slightly
better than using the E-state fingerprints.

The training result when using FP4 fingerprints:

```
># Support Vector Machines with Radial Basis Function Kernel
>#
># 597 samples
>#  58 predictors
>#   2 classes: "class0", "class1"
>#
># Pre-processing: centered, scaled
># Resampling: Cross-Validated (5 fold)
>#
># Summary of sample sizes: 478, 478, 477, 478, 477
>#
># Resampling results across tuning parameters:
>#
>#   C     ROC    Sens   Spec   ROC SD  Sens SD  Spec SD
>#   0.25  0.845  0.769  0.746  0.0498  0.0458   0.0877
>#   0.5   0.856  0.744  0.777  0.0449  0.0148   0.0728
>#   1     0.863  0.751  0.777  0.0428  0.036    0.0651
>#
># Tuning parameter "sigma" was held constant at a value of 0.01077024
># ROC was used to select the optimal model using  the largest value.
># The final values used for the model were sigma = 0.0108 and C = 1.
```

There are 58 predictors left for the original 512 FP4
fingerprints after the screening. The model performance
by AUC values is almost the same comparing to using MACCS keys,
and better than using E-state fingerprints.

We predict on the test sets with the established models,
and plot the ROC curves in one figure, as is shown in Figure 4.

```{r, eval = FALSE}
# Predict on test set
svm.pred1 <- predict(svm.fit1, newdata = x1.te, type = "prob")[, 1]
svm.pred2 <- predict(svm.fit2, newdata = x2.te, type = "prob")[, 1]
svm.pred3 <- predict(svm.fit3, newdata = x3.te, type = "prob")[, 1]

# Generate colors
library("RColorBrewer")
pal <- brewer.pal(3, "Set1")

# ROC curves of different fingerprints
library("pROC")
plot(smooth(roc(y.te, svm.pred1)), col = pal[1], grid = TRUE)
plot(smooth(roc(y.te, svm.pred2)), col = pal[2], grid = TRUE, add = TRUE)
plot(smooth(roc(y.te, svm.pred3)), col = pal[3], grid = TRUE, add = TRUE)
```

```{r, echo=FALSE, out.width="65%", fig.cap="Figure 4: Smoothed ROC curves for different fingerprint types."}
knitr::include_graphics("figures/ex3-1.png")
```

### Clustering of molecules based on structural similarities

Apart from supervised methods (classification and regression),
unsupervised approaches, like clustering, is also widely applied
in the quantitative research of drugs.

In reality, there are usually too many chemical compounds available
for identifying drug-like molecules. Thus it would be attractive
using clustering methods to aid the selection of a representative
subset of all available compounds. For a clustering approach that
groups compounds together by their structural similarity, applying
the principle _similar compounds have similar properties_ means that
we only need to test the representative compounds from each individual
cluster, rather than do the time-consuming complete set of experiments,
and this should be sufficient to understand the structure-activity
relationships of the whole compound set.

The Rcpi package provides easy-to-use functions for computing
the similarity between small molecules derived by molecular
fingerprints and maximum common substructure search.

As a example, the SDF file `tyrphostin.sdf` below is a database
composed by searching _tyrphostin_ in PubChem and filtered
by _Lipinski"s rule of five_. We load this SDF file
using `readMolFromSDF()`:

```{r, eval = FALSE}
library("Rcpi")
mols <- readMolFromSDF(system.file(
  "compseq/tyrphostin.sdf",
  package = "Rcpi"
))
```

Then we compute the E-state fingerprints for all the molecules using
`extractDrugEstate()`, and calculate their pairwise similarity matrix
with `calcDrugFPSim()`:

```{r, eval = FALSE}
simmat <- diag(length(mols))

for (i in 1:length(mols)) {
  for (j in i:length(mols)) {
    fp1 <- extractDrugEstate(mols[[i]])
    fp2 <- extractDrugEstate(mols[[j]])
    tmp <- calcDrugFPSim(fp1, fp2, fptype = "compact", metric = "tanimoto")
    simmat[i, j] <- tmp
    simmat[j, i] <- tmp
  }
}
```

With the computed similarity matrix `simmat`, we will try to
cluster the molecules using hierarchical clustering, then
visualize the clustering result:

```{r, eval = FALSE}
mol.hc <- hclust(as.dist(1 - simmat), method = "ward.D")

library("ape") # Tree visualization of clusters
clus5 <- cutree(mol.hc, 5) # Cut dendrogram into 5 clusters

# Generate colors
library("RColorBrewer")
pal5 <- brewer.pal(5, "Set1")
plot(as.phylo(mol.hc),
  type = "fan",
  tip.color = pal5[clus5],
  label.offset = 0.1, cex = 0.7
)
```

The hierarchical clustering result for these molecules is shown in Figure 5.

```{r, echo=FALSE, out.width="65%", fig.cap="Figure 5: Tree visualization of the molecular clustering result."}
knitr::include_graphics("figures/ex4-1.png")
```

### Structure-based chemical similarity searching

Structure-based chemical similarity searching ranks molecules in a
database by their similarity degree to one query molecule structure.
The numerical similarity value is usually computed based on the molecular
fingerprints with selected metrics or by maximum common structure search.
It is one of the core techniques for ligand-based virtual screening
in drug discovery.

The SDF file `DB00530.sdf` below is retrieved from DrugBank,
the drug ID DB00530 is _Erlotinib_, which is a reversible
tyrosine kinase inhibitor. Given this molecule as the query molecule,
we will do a similarity searching in the database `tyrphostin.sdf`
presented in the last subsection.

```{r, eval = FALSE}
library("Rcpi")

mol <- system.file("compseq/DB00530.sdf", package = "Rcpi")
moldb <- system.file("compseq/tyrphostin.sdf", package = "Rcpi")
```

We can do parallelized drug molecular similarity search with the
`searchDrug()` function in Rcpi. Here we choose the
search criterion to be MACCS keys with cosine similarity, FP2
fingerprints with tanimoto similarity, and maximum common
substructure search with tanimoto similarity.

```{r, eval = FALSE}
rank1 <- searchDrug(
  mol, moldb,
  cores = 4, method = "fp",
  fptype = "maccs", fpsim = "tanimoto"
)
rank2 <- searchDrug(
  mol, moldb,
  cores = 4, method = "fp",
  fptype = "fp2", fpsim = "cosine"
)
rank3 <- searchDrug(
  mol, moldb,
  cores = 4, method = "mcs",
  mcssim = "tanimoto"
)
```

The returned search result is stored as a numerical vector,
the name of each element is the molecule number in the database,
and the value is the similarity value between the query molecule
and this molecule. We print the top search results here:

```{r, eval = FALSE}
head(rank1)
```

```
>#        92       100        83       101         1        36
># 0.6491228 0.6491228 0.5882353 0.5660377 0.5000000 0.4861111
```

```{r, eval = FALSE}
head(rank2)
```

```
>#       100        92        83       101        94        16
># 0.8310005 0.8208663 0.5405856 0.5033150 0.4390790 0.4274081
```

```{r, eval = FALSE}
head(rank3)
```

```
>#        92       100        23        39        94        64
># 0.7000000 0.7000000 0.4000000 0.4000000 0.4000000 0.3783784
```

The Rcpi package also integrated the functionality of converting
molecular file formats. For example, we can convert the SDF files
to SMILES files using `convMolFormat()`. Since the #92 molecule
ranks the highest in the three searches performed, we
will calculate the similarity derived by maximum common substructure
search between the query molecule and the #92 molecule using
`calcDrugMCSSim()`:

```{r, eval = FALSE}
# Convert SDF format to SMILES format
convMolFormat(
  infile = mol, outfile = "DB00530.smi", from = "sdf", to = "smiles"
)
convMolFormat(
  infile = moldb, outfile = "tyrphostin.smi", from = "sdf", to = "smiles"
)

smi1 <- readLines("DB00530.smi")
smi2 <- readLines("tyrphostin.smi")[92] # Select the #92 molecule
calcDrugMCSSim(smi1, smi2, type = "smile", plot = TRUE)
```

The MCS search result is stored in a list, which contains the original
MCS result provided by the `fmcsR` package @wang2013fmcsr, the Tanimoto
coefficient and the overlap coefficient.

```
># [[1]]
># An instance of "MCS"
>#  Number of MCSs: 1
>#  530: 29 atoms
>#  4705: 22 atoms
>#  MCS: 18 atoms
>#  Tanimoto Coefficient: 0.54545
>#  Overlap Coefficient: 0.81818
>#
># [[2]]
># Tanimoto_Coefficient
>#            0.5454545
>#
># [[3]]
># Overlap_Coefficient
>#           0.8181818
```

By using `calcDrugMCSSim(..., plot = TRUE)`, the maximum common
substructure of the two molecules is presented in Figure 6.

```{r, echo=FALSE, out.width="50%", fig.cap="Figure 6: Maximum common structure of the query molecule and the #92 molecule in the chemical database."}
knitr::include_graphics("figures/ex5-1.png")
```

## Applications in chemogenomics

For chemogenomics modeling, Rcpi calculates compound-protein interaction
(CPI) descriptors and protein-protein interaction (PPI) descriptors.

### Predicting drug-target interaction by integrating chemical and genomic spaces

The prediction of novel interactions between drugs and target proteins
is a key area in genomic drug discovery. In this example, we use the
G Protein-Coupled Receptor (GPCR) dataset provided by
@yamanishi2008prediction as our benchmark dataset.

A drug-target interaction network can be naturally modeled as a
bipartite graph, where the nodes are target proteins or drug
molecules and edges (only drugs and proteins could be connected
by edges) represent drug-target interactions. Initially,
the graph only contains edges describing the _real_ drug-target
interactions determined by experiments or other ways. In this example,
all real drug-target interaction pairs (i.e., 635 drug-target interactions)
are used as the positive samples. For negative samples we select random,
non-interacting pairs from these drugs and proteins.
They are constructed as follows:

1. Separate the pairs in the above positive samples into single drugs and proteins;
2. Re-couple these singles into pairs in a way that none of them occurs in the corresponding positive dataset.

Ten generated negative sets were used in @cao2012large, here we only used
one of them for a demonstration. The drug ID and target ID is stored in
`GPCR.csv`. The first column is KEGG protein ID, and the second column
is KEGG drug ID. The first 635 rows form the positive set, and the last
635 rows form the negative set.

```{r, eval = FALSE}
library("Rcpi")

gpcr <- read.table(system.file(
  "vignettedata/GPCR.csv",
  package = "Rcpi"
),
header = FALSE, as.is = TRUE
)
```

Take a look at the data:

```{r, eval = FALSE}
head(gpcr)
```

```
>#          V1     V2
># 1 hsa:10161 D00528
># 2 hsa:10800 D00411
># 3 hsa:10800 D01828
># 4 hsa:10800 D05129
># 5 hsa:11255 D00234
># 6 hsa:11255 D00300
```

We will visualize the network first. Figure 7 shows the connection
pattern for the GPCR drug-target interaction network in the form
of an _arc diagram_.

```{r, eval = FALSE}
library("igraph")
library("reshape")
# remotes::install_github("gastonstat/arcdiagram")
library("arcdiagram")

g <- graph.data.frame(gpcr[1:(nrow(gpcr) / 2), ], directed = FALSE)
edgelist <- get.edgelist(g)
vlabels <- V(g)$name
vgroups <- c(rep(0, 95), rep(1, 223))
vfill <- c(rep("#8B91D4", 95), rep("#B2C771", 223))
vborders <- c(rep("#6F74A9", 95), rep("#8E9F5A", 223))
degrees <- degree(g)

xx <- data.frame(vgroups, degrees, vlabels, ind = 1:vcount(g))
yy <- arrange(xx, desc(vgroups), desc(degrees))
new.ord <- yy$ind

arcplot(
  edgelist,
  ordering = new.ord, labels = vlabels,
  cex.labels = 0.1, show.nodes = TRUE,
  col.nodes = vborders, bg.nodes = vfill,
  cex.nodes = log10(degrees) + 0.1,
  pch.nodes = 21, line = -0.5, col.arcs = hsv(0, 0, 0.2, 0.25)
)
```

```{r, echo=FALSE, out.width="85%", fig.cap="Figure 7: Arc diagram visualization of the GPCR drug-target interaction network."}
knitr::include_graphics("figures/ex6-1.png")
```

An arc diagram visualize the nodes in the network in a one-dimensional
layout, while using circular arcs to represent edges. With a good ordering
of nodes, it is easy to identify cliques and bridges.

Next, we will download the target protein sequences (in FASTA format) and
drug molecule (in SMILES format) from the KEGG database, in parallel:

```{r, eval = FALSE}
library("Rcpi")

gpcr <- read.table(system.file(
  "vignettedata/GPCR.csv",
  package = "Rcpi"
),
header = FALSE, as.is = TRUE
)

protid <- unique(gpcr[, 1])
drugid <- unique(gpcr[, 2])

protseq <- getSeqFromKEGG(protid, parallel = 5)
drugseq <- getSmiFromKEGG(drugid, parallel = 50)
```

If the connection is slow or accidentally interrupts,
just try a few more times until success.

The functions in Rcpi named after `getMolFrom...()` and `getSmiFrom...()`
supports the parallelized retrieval of (drug) molecules from PubChem,
ChEMBL, CAS, KEGG, and DrugBank. The functions named after `getSeqFrom...()`,
`getFASTAFrom...()`, and `getPDBFrom...()` supports the parallelized
retrieval of proteins from UniProt, KEGG and RCSB PDB.
The functions `getDrug()` and `getProt()` are two integrated wrapper
functions for downloading the molecules and protein sequences from
these online databases.

After the sequences were downloaded, we can calculate the protein
sequence descriptors and molecular descriptors for the targets and drugs:

```{r, eval = FALSE}
x0.prot <- cbind(
  t(sapply(unlist(protseq), extractProtAPAAC)),
  t(sapply(unlist(protseq), extractProtCTriad))
)

x0.drug <- cbind(
  extractDrugEstateComplete(readMolFromSmi(textConnection(drugseq))),
  extractDrugMACCSComplete(readMolFromSmi(textConnection(drugseq))),
  extractDrugOBFP4(drugseq, type = "smile")
)
```

Since the descriptors is only for the _deduplicated_ drug and target list,
we need to generate the full descriptor matrix for the training data:

```{r, eval = FALSE}
# Generate drug x / protein x / y
x.prot <- matrix(NA, nrow = nrow(gpcr), ncol = ncol(x0.prot))
x.drug <- matrix(NA, nrow = nrow(gpcr), ncol = ncol(x0.drug))
for (i in 1:nrow(gpcr)) x.prot[i, ] <- x0.prot[which(gpcr[, 1][i] == protid), ]
for (i in 1:nrow(gpcr)) x.drug[i, ] <- x0.drug[which(gpcr[, 2][i] == drugid), ]

y <- as.factor(c(rep("pos", nrow(gpcr) / 2), rep("neg", nrow(gpcr) / 2)))
```

Generate drug-target interaction descriptors using `getCPI()`.

```{r, eval = FALSE}
x <- getCPI(x.prot, x.drug, type = "combine")
```

The pairwise interaction is another useful type of representation in
drug-target prediction, protein-protein interaction prediction and
related research. Rcpi also provides `getPPI()` to generate
protein-protein interaction descriptors. `getPPI()` provides
three types of interactions while `getCPI()` provides two types.
The argument `type` is used to control this.

#### Compound-protein interaction (CPI) descriptors

For compound descriptor vector $d_1^{1 \times p_1}$ and the protein
descriptor vector $d_2^{1 \times p_2}$, there are two methods for
construction of descriptor vector $d$ for compound-protein interaction:

1. `type = "combine"` - combine the two feature matrix, $d$ has $p_1 + p_2$ columns;
2. `type = "tensorprod"` - column-by-column (pseudo)-tensor product type interactions, $d$ has $p_1 \times p_2$ columns.

#### Protein-protein interaction (PPI) descriptors

For interaction protein A and protein B, let $d_1^{1 \times p}$ and
$d_2^{1 \times p}$ be the descriptor vectors. There are three methods
to construct the protein-protein interaction descriptor $d$:

1. `type = "combine"` - combine the two descriptor matrix, $d$ has $p + p$ columns;
2. `type = "tensorprod"` - column-by-column (pseudo)-tensor product type interactions, $d$ has $p \times p$ columns;
3. `type = "entrywise"` - entrywise product and entrywise sum of the two matrices, then combine them, $d$ has $p + p$ columns.

Train a random forest classification model with 5-fold repeated CV:

```{r, eval = FALSE}
library("caret")
x <- x[, -nearZeroVar(x)]

# Cross-validation settings
ctrl <- trainControl(
  method = "cv", number = 5, repeats = 10,
  classProbs = TRUE,
  summaryFunction = twoClassSummary
)

# Train a random forest classifier
library("randomForest")

set.seed(1006)
rf.fit <- train(
  x, y,
  method = "rf", trControl = ctrl,
  metric = "ROC", preProc = c("center", "scale")
)
```

Print the cross-validation result:

```
print(rf.fit)
```

```
># Random Forest
>#
># 1270 samples
>#  562 predictors
>#    2 classes: "neg", "pos"
>#
># Pre-processing: centered, scaled
># Resampling: Cross-Validated (5 fold)
>#
># Summary of sample sizes: 1016, 1016, 1016, 1016, 1016
>#
># Resampling results across tuning parameters:
>#
>#   mtry  ROC    Sens   Spec   ROC SD  Sens SD  Spec SD
>#   2     0.83   0.726  0.778  0.0221  0.044    0.0395
>#   33    0.882  0.795  0.82   0.018   0.0522   0.0443
>#   562   0.893  0.822  0.844  0.0161  0.0437   0.0286
>#
># ROC was used to select the optimal model using  the largest value.
># The final value used for the model was mtry = 562.
```

Predict on the training set (for demonstration purpose only) and plot ROC curve.

```{r, eval = FALSE}
rf.pred <- predict(rf.fit$finalModel, x, type = "prob")[, 1]

library("pROC")
plot(smooth(roc(y, rf.pred)), grid = TRUE, print.auc = TRUE)
```

The ROC curve is shown in Figure 8.

```{r, echo=FALSE, out.width="65%", fig.cap="Figure 8: ROC curve for predicting on the training set of the GPCR drug-target interaction dataset using random forest."}
knitr::include_graphics("figures/ex6-2.png")
```

## References

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Rcpi-datalist.R
\docType{data}
\name{AAMOE2D}
\alias{AAMOE2D}
\title{2D Descriptors for 20 Amino Acids calculated by MOE 2011.10}
\value{
AAMOE2D data
}
\description{
2D Descriptors for 20 Amino Acids calculated by MOE 2011.10
}
\details{
This dataset includes the 2D descriptors of
the 20 amino acids calculated by MOE 2011.10
used for scales extraction in this package.
}
\examples{
data(AAMOE2D)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/323-extractDrugFragmentComplexity.R
\name{extractDrugFragmentComplexity}
\alias{extractDrugFragmentComplexity}
\title{Calculate Complexity of a System}
\usage{
extractDrugFragmentComplexity(molecules, silent = TRUE)
}
\arguments{
\item{molecules}{Parsed molucule object.}

\item{silent}{Logical. Whether the calculating process
should be shown or not, default is \code{TRUE}.}
}
\value{
A data frame, each row represents one of the molecules,
each column represents one feature.
This function returns one column named \code{fragC}.
}
\description{
Calculate Complexity of a System
}
\details{
This descriptor calculates the complexity of a system.
The complexity is defined in Nilakantan, R. et al. as:
\deqn{C = abs(B^2 - A^2 + A) + \frac{H}{100}}
where C is complexity, A is the number of non-hydrogen atoms,
B is the number of bonds and H is the number of heteroatoms.
}
\examples{
smi = system.file('vignettedata/FDAMDD.smi', package = 'Rcpi')
\donttest{
mol = readMolFromSmi(smi, type = 'mol')
dat = extractDrugFragmentComplexity(mol)
head(dat)}
}
\references{
Nilakantan, R. and Nunn, D.S. and Greenblatt,
L. and Walker, G. and Haraki, K. and Mobilio, D.,
A family of ring system-based structural fragments
for use in structure-activity studies:
database mining and recursive partitioning.,
Journal of chemical information and modeling, 2006, 46:1069-1077
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/330-extractDrugKierHallSmarts.R
\name{extractDrugKierHallSmarts}
\alias{extractDrugKierHallSmarts}
\title{Descriptor that Counts the Number of Occurrences of the E-State Fragments}
\usage{
extractDrugKierHallSmarts(molecules, silent = TRUE)
}
\arguments{
\item{molecules}{Parsed molucule object.}

\item{silent}{Logical. Whether the calculating process
should be shown or not, default is \code{TRUE}.}
}
\value{
A data frame, each row represents one of the molecules,
each column represents one feature.
This function returns 79 columns:
\tabular{ccc}{
ID \tab Name \tab Pattern\cr
\code{0} \tab \code{khs.sLi} \tab \code{[LiD1]-*}\cr
\code{1} \tab \code{khs.ssBe} \tab \code{[BeD2](-*)-*}\cr
\code{2} \tab \code{khs.ssssBe} \tab \code{[BeD4](-*)(-*)(-*)-*}\cr
\code{3} \tab \code{khs.ssBH} \tab \code{[BD2H](-*)-*}\cr
\code{4} \tab \code{khs.sssB} \tab \code{[BD3](-*)(-*)-*}\cr
\code{5} \tab \code{khs.ssssB} \tab \code{[BD4](-*)(-*)(-*)-*}\cr
\code{6} \tab \code{khs.sCH3} \tab \code{[CD1H3]-*}\cr
\code{7} \tab \code{khs.dCH2} \tab \code{[CD1H2]=*}\cr
\code{8} \tab \code{khs.ssCH2} \tab \code{[CD2H2](-*)-*}\cr
\code{9} \tab \code{khs.tCH} \tab \code{[CD1H]#*}\cr
\code{10} \tab \code{khs.dsCH} \tab \code{[CD2H](=*)-*}\cr
\code{11} \tab \code{khs.aaCH} \tab \code{[C,c;D2H](:*):*}\cr
\code{12} \tab \code{khs.sssCH} \tab \code{[CD3H](-*)(-*)-*}\cr
\code{13} \tab \code{khs.ddC} \tab \code{[CD2H0](=*)=*}\cr
\code{14} \tab \code{khs.tsC} \tab \code{[CD2H0](#*)-*}\cr
\code{15} \tab \code{khs.dssC} \tab \code{[CD3H0](=*)(-*)-*}\cr
\code{16} \tab \code{khs.aasC} \tab \code{[C,c;D3H0](:*)(:*)-*}\cr
\code{17} \tab \code{khs.aaaC} \tab \code{[C,c;D3H0](:*)(:*):*}\cr
\code{18} \tab \code{khs.ssssC} \tab \code{[CD4H0](-*)(-*)(-*)-*}\cr
\code{19} \tab \code{khs.sNH3} \tab \code{[ND1H3]-*}\cr
\code{20} \tab \code{khs.sNH2} \tab \code{[ND1H2]-*}\cr
\code{21} \tab \code{khs.ssNH2} \tab \code{[ND2H2](-*)-*}\cr
\code{22} \tab \code{khs.dNH} \tab \code{[ND1H]=*}\cr
\code{23} \tab \code{khs.ssNH} \tab \code{[ND2H](-*)-*}\cr
\code{24} \tab \code{khs.aaNH} \tab \code{[N,nD2H](:*):*}\cr
\code{25} \tab \code{khs.tN} \tab \code{[ND1H0]#*}\cr
\code{26} \tab \code{khs.sssNH} \tab \code{[ND3H](-*)(-*)-*}\cr
\code{27} \tab \code{khs.dsN} \tab \code{[ND2H0](=*)-*}\cr
\code{28} \tab \code{khs.aaN} \tab \code{[N,nD2H0](:*):*}\cr
\code{29} \tab \code{khs.sssN} \tab \code{[ND3H0](-*)(-*)-*}\cr
\code{30} \tab \code{khs.ddsN} \tab \code{[ND3H0](~[OD1H0])(~[OD1H0])-,:*}\cr
\code{31} \tab \code{khs.aasN} \tab \code{[N,nD3H0](:*)(:*)-,:*}\cr
\code{32} \tab \code{khs.ssssN} \tab \code{[ND4H0](-*)(-*)(-*)-*}\cr
\code{33} \tab \code{khs.sOH} \tab \code{[OD1H]-*}\cr
\code{34} \tab \code{khs.dO} \tab \code{[OD1H0]=*}\cr
\code{35} \tab \code{khs.ssO} \tab \code{[OD2H0](-*)-*}\cr
\code{36} \tab \code{khs.aaO} \tab \code{[O,oD2H0](:*):*}\cr
\code{37} \tab \code{khs.sF} \tab \code{[FD1]-*}\cr
\code{38} \tab \code{khs.sSiH3} \tab \code{[SiD1H3]-*}\cr
\code{39} \tab \code{khs.ssSiH2} \tab \code{[SiD2H2](-*)-*}\cr
\code{40} \tab \code{khs.sssSiH} \tab \code{[SiD3H1](-*)(-*)-*}\cr
\code{41} \tab \code{khs.ssssSi} \tab \code{[SiD4H0](-*)(-*)(-*)-*}\cr
\code{42} \tab \code{khs.sPH2} \tab \code{[PD1H2]-*}\cr
\code{43} \tab \code{khs.ssPH} \tab \code{[PD2H1](-*)-*}\cr
\code{44} \tab \code{khs.sssP} \tab \code{[PD3H0](-*)(-*)-*}\cr
\code{45} \tab \code{khs.dsssP} \tab \code{[PD4H0](=*)(-*)(-*)-*}\cr
\code{46} \tab \code{khs.sssssP} \tab \code{[PD5H0](-*)(-*)(-*)(-*)-*}\cr
\code{47} \tab \code{khs.sSH} \tab \code{[SD1H1]-*}\cr
\code{48} \tab \code{khs.dS} \tab \code{[SD1H0]=*}\cr
\code{49} \tab \code{khs.ssS} \tab \code{[SD2H0](-*)-*}\cr
\code{50} \tab \code{khs.aaS} \tab \code{[S,sD2H0](:*):*}\cr
\code{51} \tab \code{khs.dssS} \tab \code{[SD3H0](=*)(-*)-*}\cr
\code{52} \tab \code{khs.ddssS} \tab \code{[SD4H0](~[OD1H0])(~[OD1H0])(-*)-*}\cr
\code{53} \tab \code{khs.sCl} \tab \code{[ClD1]-*}\cr
\code{54} \tab \code{khs.sGeH3} \tab \code{[GeD1H3](-*)}\cr
\code{55} \tab \code{khs.ssGeH2} \tab \code{[GeD2H2](-*)-*}\cr
\code{56} \tab \code{khs.sssGeH} \tab \code{[GeD3H1](-*)(-*)-*}\cr
\code{57} \tab \code{khs.ssssGe} \tab \code{[GeD4H0](-*)(-*)(-*)-*}\cr
\code{58} \tab \code{khs.sAsH2} \tab \code{[AsD1H2]-*}\cr
\code{59} \tab \code{khs.ssAsH} \tab \code{[AsD2H1](-*)-*}\cr
\code{60} \tab \code{khs.sssAs} \tab \code{[AsD3H0](-*)(-*)-*}\cr
\code{61} \tab \code{khs.sssdAs} \tab \code{[AsD4H0](=*)(-*)(-*)-*}\cr
\code{62} \tab \code{khs.sssssAs} \tab \code{[AsD5H0](-*)(-*)(-*)(-*)-*}\cr
\code{63} \tab \code{khs.sSeH} \tab \code{[SeD1H1]-*}\cr
\code{64} \tab \code{khs.dSe} \tab \code{[SeD1H0]=*}\cr
\code{65} \tab \code{khs.ssSe} \tab \code{[SeD2H0](-*)-*}\cr
\code{66} \tab \code{khs.aaSe} \tab \code{[SeD2H0](:*):*}\cr
\code{67} \tab \code{khs.dssSe} \tab \code{[SeD3H0](=*)(-*)-*}\cr
\code{68} \tab \code{khs.ddssSe} \tab \code{[SeD4H0](=*)(=*)(-*)-*}\cr
\code{69} \tab \code{khs.sBr} \tab \code{[BrD1]-*}\cr
\code{70} \tab \code{khs.sSnH3} \tab \code{[SnD1H3]-*}\cr
\code{71} \tab \code{khs.ssSnH2} \tab \code{[SnD2H2](-*)-*}\cr
\code{72} \tab \code{khs.sssSnH} \tab \code{[SnD3H1](-*)(-*)-*}\cr
\code{73} \tab \code{khs.ssssSn} \tab \code{[SnD4H0](-*)(-*)(-*)-*}\cr
\code{74} \tab \code{khs.sI} \tab \code{[ID1]-*}\cr
\code{75} \tab \code{khs.sPbH3} \tab \code{[PbD1H3]-*}\cr
\code{76} \tab \code{khs.ssPbH2} \tab \code{[PbD2H2](-*)-*}\cr
\code{77} \tab \code{khs.sssPbH} \tab \code{[PbD3H1](-*)(-*)-*}\cr
\code{78} \tab \code{khs.ssssPb} \tab \code{[PbD4H0](-*)(-*)(-*)-*}
}
}
\description{
Descriptor that Counts the Number of Occurrences of the E-State Fragments
}
\details{
A fragment count descriptor that uses e-state fragments.
Traditionally the e-state descriptors identify the relevant
fragments and then evaluate the actual e-state value.
However it has been shown in Butina et al.
that simply using the counts of the e-state fragments can
lead to QSAR models that exhibit similar performance to those
built using the actual e-state indices.

Atom typing and aromaticity perception should be
performed prior to calling this descriptor.
The atom type definitions are taken from Hall et al.
The SMARTS definitions were obtained from RDKit.
}
\examples{
smi = system.file('vignettedata/FDAMDD.smi', package = 'Rcpi')
\donttest{
mol = readMolFromSmi(smi, type = 'mol')
dat = extractDrugKierHallSmarts(mol)
head(dat)}
}
\references{
Butina, D. ,
Performance of Kier-Hall E-state Descriptors
in Quantitative Structure Activity Relationship (QSAR)
Studies of Multifunctional Molecules,
Molecules, 2004, 9:1004-1009.

Hall, L.H. and Kier, L.B. ,
Electrotopological State Indices for Atom Types:
A Novel Combination of Electronic, Topological,
and Valence State Information,
Journal of Chemical Information and Computer Science, 1995, 35:1039-1045.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/415-extractPCMScales.R
\name{extractPCMScales}
\alias{extractPCMScales}
\title{Generalized Scales-Based Descriptors derived by Principal Components Analysis}
\usage{
extractPCMScales(x, propmat, pc, lag, scale = TRUE, silent = TRUE)
}
\arguments{
\item{x}{A character vector, as the input protein sequence.}

\item{propmat}{A matrix containing the properties for the amino acids.
Each row represent one amino acid type, each column represents
one property.
Note that the one-letter row names must be provided for we need
them to seek the properties for each AA type.}

\item{pc}{Integer. Use the first pc principal components as the scales.
Must be no greater than the number of AA properties provided.}

\item{lag}{The lag parameter. Must be less than the amino acids.}

\item{scale}{Logical. Should we auto-scale the property matrix
(\code{propmat}) before PCA? Default is \code{TRUE}.}

\item{silent}{Logical. Whether we print the standard deviation,
proportion of variance and the cumulative proportion of
the selected principal components or not.
Default is \code{TRUE}.}
}
\value{
A length \code{lag * p^2} named vector,
\code{p} is the number of scales (principal components) selected.
}
\description{
Generalized Scales-Based Descriptors derived by Principal Components Analysis
}
\details{
This function calculates the generalized scales-based descriptors
derived by Principal Components Analysis (PCA).
Users could provide customized amino acid property matrices.
This function implements the core computation procedure needed for
the generalized scales-based descriptors derived by AA-Properties (AAindex)
and generalized scales-based descriptors derived by 20+ classes of 2D and 3D
molecular descriptors (Topological, WHIM, VHSE, etc.).
}
\examples{
x = readFASTA(system.file('protseq/P00750.fasta', package = 'Rcpi'))[[1]]
data(AAindex)
AAidxmat = t(na.omit(as.matrix(AAindex[, 7:26])))
scales = extractPCMScales(x, propmat = AAidxmat, pc = 5, lag = 7, silent = FALSE)
}
\seealso{
See \code{\link{extractPCMDescScales}} for generalized
AA property based scales descriptors, and \code{\link{extractPCMPropScales}}
for (19 classes) AA descriptor based scales descriptors.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/410-extractProtCTriad.R
\name{extractProtCTriad}
\alias{extractProtCTriad}
\title{Conjoint Triad Descriptor}
\usage{
extractProtCTriad(x)
}
\arguments{
\item{x}{A character vector, as the input protein sequence.}
}
\value{
A length 343 named vector
}
\description{
Conjoint Triad Descriptor
}
\details{
This function calculates the Conjoint Triad descriptor (Dim: 343).
}
\examples{
x = readFASTA(system.file('protseq/P00750.fasta', package = 'Rcpi'))[[1]]
extractProtCTriad(x)
}
\references{
J.W. Shen, J. Zhang, X.M. Luo, W.L. Zhu,
K.Q. Yu, K.X. Chen, Y.X. Li, H.L. Jiang.
Predicting Protein-protein Interactions Based Only on Sequences Information.
\emph{Proceedings of the National Academy of Sciences}. 007, 104, 4337--4341.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/308-extractDrugAutocorrelationCharge.R
\name{extractDrugAutocorrelationCharge}
\alias{extractDrugAutocorrelationCharge}
\title{Calculate the Moreau-Broto Autocorrelation Descriptors using Partial Charges}
\usage{
extractDrugAutocorrelationCharge(molecules, silent = TRUE)
}
\arguments{
\item{molecules}{Parsed molucule object.}

\item{silent}{Logical. Whether the calculating process
should be shown or not, default is \code{TRUE}.}
}
\value{
A data frame, each row represents one of the molecules,
each column represents one feature.
This function returns 5 columns named
\code{ATSc1}, \code{ATSc2}, \code{ATSc3}, \code{ATSc4}, \code{ATSc5}.
}
\description{
Calculate the Moreau-Broto Autocorrelation Descriptors using Partial Charges
}
\details{
Calculates the ATS autocorrelation descriptor,
where the weight equal to the charges.
}
\examples{
smi = system.file('vignettedata/FDAMDD.smi', package = 'Rcpi')
\donttest{
mol = readMolFromSmi(smi, type = 'mol')
dat = extractDrugAutocorrelationCharge(mol)
head(dat)}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/306-extractDrugAromaticBondsCount.R
\name{extractDrugAromaticBondsCount}
\alias{extractDrugAromaticBondsCount}
\title{Calculate the Number of Aromatic Bonds Descriptor}
\usage{
extractDrugAromaticBondsCount(molecules, silent = TRUE)
}
\arguments{
\item{molecules}{Parsed molucule object.}

\item{silent}{Logical. Whether the calculating process
should be shown or not, default is \code{TRUE}.}
}
\value{
A data frame, each row represents one of the molecules,
each column represents one feature.
This function returns one column named \code{nAromBond}.
}
\description{
Calculate the Number of Aromatic Bonds Descriptor
}
\details{
Calculates the number of aromatic bonds of a molecule.
}
\examples{
smi = system.file('vignettedata/FDAMDD.smi', package = 'Rcpi')
\donttest{
mol = readMolFromSmi(smi, type = 'mol')
dat = extractDrugAromaticBondsCount(mol)
head(dat)}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/340-extractDrugRotatableBondsCount.R
\name{extractDrugRotatableBondsCount}
\alias{extractDrugRotatableBondsCount}
\title{Descriptor that Calculates the Number of Nonrotatable Bonds on A Molecule}
\usage{
extractDrugRotatableBondsCount(molecules, silent = TRUE)
}
\arguments{
\item{molecules}{Parsed molucule object.}

\item{silent}{Logical. Whether the calculating process
should be shown or not, default is \code{TRUE}.}
}
\value{
A data frame, each row represents one of the molecules,
each column represents one feature.
This function returns one column named \code{nRotB}.
}
\description{
Descriptor that Calculates the Number of Nonrotatable Bonds on A Molecule
}
\details{
The number of rotatable bonds is given by the SMARTS specified by
Daylight on SMARTS tutorial
(\url{http://www.daylight.com/dayhtml_tutorials/languages/smarts/smarts_examples.html#EXMPL})
}
\examples{
smi = system.file('vignettedata/FDAMDD.smi', package = 'Rcpi')
\donttest{
mol = readMolFromSmi(smi, type = 'mol')
dat = extractDrugRotatableBondsCount(mol)
head(dat)}
}
\author{
Nan Xiao <\url{https://nanx.me}>
}
\keyword{Bonds}
\keyword{Count}
\keyword{Rotatable}
\keyword{extractDrugRotatableBondsCount}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/701-calcDrugFPSim.R
\name{calcDrugFPSim}
\alias{calcDrugFPSim}
\title{Calculate Drug Molecule Similarity Derived by Molecular Fingerprints}
\usage{
calcDrugFPSim(
  fp1,
  fp2,
  fptype = c("compact", "complete"),
  metric = c("tanimoto", "euclidean", "cosine", "dice", "hamming")
)
}
\arguments{
\item{fp1}{The first molecule's fingerprints,
could be extracted by \code{extractDrugMACCS()},
\code{extractDrugMACCSComplete()} etc.}

\item{fp2}{The second molecule's fingerprints.}

\item{fptype}{The fingerprint type, must be one of \code{"compact"} or
\code{"complete"}.}

\item{metric}{The similarity metric,
one of \code{"tanimoto"}, \code{"euclidean"}, \code{"cosine"},
\code{"dice"} and \code{"hamming"}.}
}
\value{
The numeric similarity value.
}
\description{
Calculate Drug Molecule Similarity Derived by Molecular Fingerprints
}
\details{
This function calculate drug molecule fingerprints similarity.
Define \code{a} as the features of object A, \code{b} is the
features of object B, \code{c} is the number of common features to A and B:
\itemize{
\item Tanimoto: aka Jaccard - \eqn{c/a+b+c}
\item Euclidean: \eqn{\sqrt(a + b)}
\item Dice: aka Sorensen, Czekanowski, Hodgkin-Richards -
\eqn{c/0.5[(a+c) + (b+c)]}
\item Cosine: aka Ochiai, Carbo - \eqn{c/\sqrt((a + c)(b + c))}
\item Hamming: aka Manhattan, taxi-cab, city-block distance - \eqn{(a + b)}
}
}
\examples{
\donttest{
mols = readMolFromSDF(system.file('compseq/tyrphostin.sdf', package = 'Rcpi'))

fp1 = extractDrugEstate(mols[[1]])
fp2 = extractDrugEstate(mols[[2]])
calcDrugFPSim(fp1, fp2, fptype = 'compact', metric = 'tanimoto')
calcDrugFPSim(fp1, fp2, fptype = 'compact', metric = 'euclidean')
calcDrugFPSim(fp1, fp2, fptype = 'compact', metric = 'cosine')
calcDrugFPSim(fp1, fp2, fptype = 'compact', metric = 'dice')
calcDrugFPSim(fp1, fp2, fptype = 'compact', metric = 'hamming')

fp3 = extractDrugEstateComplete(mols[[1]])
fp4 = extractDrugEstateComplete(mols[[2]])
calcDrugFPSim(fp3, fp4, fptype = 'complete', metric = 'tanimoto')
calcDrugFPSim(fp3, fp4, fptype = 'complete', metric = 'euclidean')
calcDrugFPSim(fp3, fp4, fptype = 'complete', metric = 'cosine')
calcDrugFPSim(fp3, fp4, fptype = 'complete', metric = 'dice')
calcDrugFPSim(fp3, fp4, fptype = 'complete', metric = 'hamming')}
}
\references{
Gasteiger, Johann, and Thomas Engel, eds.
Chemoinformatics. Wiley.com, 2006.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/335-extractDrugMDE.R
\name{extractDrugMDE}
\alias{extractDrugMDE}
\title{Calculate Molecular Distance Edge (MDE) Descriptors for C, N and O}
\usage{
extractDrugMDE(molecules, silent = TRUE)
}
\arguments{
\item{molecules}{Parsed molucule object.}

\item{silent}{Logical. Whether the calculating process
should be shown or not, default is \code{TRUE}.}
}
\value{
A data frame, each row represents one of the molecules,
each column represents one feature.
This function returns one column named \code{nAtomLAC}.
}
\description{
Calculate Molecular Distance Edge (MDE) Descriptors for C, N and O
}
\details{
This descriptor calculates the 10 molecular distance edge (MDE) descriptor
described in Liu, S., Cao, C., & Li, Z, and in addition it calculates
variants where O and N are considered.
}
\examples{
smi = system.file('vignettedata/FDAMDD.smi', package = 'Rcpi')
\donttest{
mol = readMolFromSmi(smi, type = 'mol')
dat = extractDrugMDE(mol)
head(dat)}
}
\references{
Liu, S., Cao, C., & Li, Z. (1998).
Approach to estimation and prediction for normal boiling point (NBP)
of alkanes based on a novel molecular distance-edge (MDE) vector, lambda.
Journal of chemical information and computer sciences, 38(3), 387-394.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/311-extractDrugBCUT.R
\name{extractDrugBCUT}
\alias{extractDrugBCUT}
\title{BCUT -- Eigenvalue Based Descriptor}
\usage{
extractDrugBCUT(molecules, silent = TRUE)
}
\arguments{
\item{molecules}{Parsed molucule object.}

\item{silent}{Logical. Whether the calculating process
should be shown or not, default is \code{TRUE}.}
}
\value{
A data frame, each row represents one of the molecules,
each column represents one feature. This function returns 6 columns:
\itemize{
\item \code{BCUTw-1l, BCUTw-2l ...} - n high lowest atom weighted BCUTS
\item \code{BCUTw-1h, BCUTw-2h ...} - n low highest atom weighted BCUTS
\item \code{BCUTc-1l, BCUTc-2l ...} - n high lowest partial charge weighted BCUTS
\item \code{BCUTc-1h, BCUTc-2h ...} - n low highest partial charge weighted BCUTS
\item \code{BCUTp-1l, BCUTp-2l ...} - n high lowest polarizability weighted BCUTS
\item \code{BCUTp-1h, BCUTp-2h ...} - n low highest polarizability weighted BCUTS
}
}
\description{
BCUT -- Eigenvalue Based Descriptor
}
\details{
Eigenvalue based descriptor noted for its utility in chemical diversity.
Described by Pearlman et al.
The descriptor is based on a weighted version of the Burden matrix which
takes into account both the connectivity as well as atomic properties
of a molecule. The weights are a variety of atom properties placed along
the diagonal of the Burden matrix.
Currently three weighting schemes are employed:
\itemize{
\item Atomic Weight
\item Partial Charge (Gasteiger Marsilli)
\item Polarizability (Kang et al.)
}
}
\note{
By default, the descriptor will return the highest and lowest eigenvalues
for the three classes of descriptor in a single ArrayList
(in the order shown above). However it is also possible to supply a parameter
list indicating how many of the highest and lowest eigenvalues
(for each class of descriptor) are required. The descriptor works with
the hydrogen depleted molecule.

A side effect of specifying the number of highest and lowest eigenvalues
is that it is possible to get two copies of all the eigenvalues. That is,
if a molecule has 5 heavy atoms, then specifying the 5 highest eigenvalues
returns all of them, and specifying the 5 lowest eigenvalues returns all of
them, resulting in two copies of all the eigenvalues.

Note that it is possible to specify an arbitrarily large number of
eigenvalues to be returned. However if the number (i.e., nhigh or nlow)
is larger than the number of heavy atoms, the remaining eignevalues
will be \code{NaN}.

Given the above description, if the aim is to gt all the eigenvalues for
a molecule, you should set nlow to 0 and specify the number of heavy atoms
(or some large number) for nhigh (or vice versa).
}
\examples{
smi = system.file('vignettedata/FDAMDD.smi', package = 'Rcpi')
\donttest{
mol = readMolFromSmi(smi, type = 'mol')
dat = extractDrugBCUT(mol)
head(dat)}
}
\references{
Pearlman, R.S. and Smith, K.M.,
Metric Validation and the Receptor-Relevant Subspace Concept,
J. Chem. Inf. Comput. Sci., 1999, 39:28-35.

Burden, F.R., Molecular identification number for substructure searches,
J. Chem. Inf. Comput. Sci., 1989, 29:225-227.

Burden, F.R., Chemically Intuitive Molecular Index,
Quant. Struct. -Act. Relat., 1997, 16:309-314

Kang, Y.K. and Jhon, M.S.,
Additivity of Atomic Static Polarizabilities and Dispersion Coefficients,
Theoretica Chimica Acta, 1982, 61:41-48
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/349-extractDrugXLogP.R
\name{extractDrugXLogP}
\alias{extractDrugXLogP}
\title{Descriptor that Calculates the Prediction of logP
Based on the Atom-Type Method Called XLogP}
\usage{
extractDrugXLogP(molecules, silent = TRUE)
}
\arguments{
\item{molecules}{Parsed molucule object.}

\item{silent}{Logical. Whether the calculating process
should be shown or not, default is \code{TRUE}.}
}
\value{
A data frame, each row represents one of the molecules,
each column represents one feature.
This function returns one column named \code{XLogP}.
}
\description{
Descriptor that Calculates the Prediction of logP
Based on the Atom-Type Method Called XLogP
}
\details{
Prediction of logP based on the atom-type method called XLogP.
}
\examples{
smi = system.file('vignettedata/FDAMDD.smi', package = 'Rcpi')
\donttest{
mol = readMolFromSmi(smi, type = 'mol')
dat = extractDrugXLogP(mol)
head(dat)}
}
\references{
Wang, R., Fu, Y., and Lai, L.,
A New Atom-Additive Method for Calculating Partition Coefficients,
Journal of Chemical Information and Computer Sciences, 1997, 37:615-621.

Wang, R., Gao, Y., and Lai, L.,
Calculating partition coefficient by atom-additive method,
Perspectives in Drug Discovery and Design, 2000, 19:47-66.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/350-extractDrugZagrebIndex.R
\name{extractDrugZagrebIndex}
\alias{extractDrugZagrebIndex}
\title{Descriptor that Calculates the Sum of the Squared Atom Degrees
of All Heavy Atoms}
\usage{
extractDrugZagrebIndex(molecules, silent = TRUE)
}
\arguments{
\item{molecules}{Parsed molucule object.}

\item{silent}{Logical. Whether the calculating process
should be shown or not, default is \code{TRUE}.}
}
\value{
A data frame, each row represents one of the molecules,
each column represents one feature.
This function returns one column named \code{Zagreb}.
}
\description{
Descriptor that Calculates the Sum of the Squared Atom Degrees
of All Heavy Atoms
}
\details{
Zagreb index: the sum of the squares of atom degree over
all heavy atoms \code{i}.
}
\examples{
smi = system.file('vignettedata/FDAMDD.smi', package = 'Rcpi')
\donttest{
mol = readMolFromSmi(smi, type = 'mol')
dat = extractDrugZagrebIndex(mol)
head(dat)}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Rcpi-datalist.R
\docType{data}
\name{AACPSA}
\alias{AACPSA}
\title{CPSA Descriptors for 20 Amino Acids calculated by Discovery Studio}
\value{
AACPSA data
}
\description{
CPSA Descriptors for 20 Amino Acids calculated by Discovery Studio
}
\details{
This dataset includes the CPSA descriptors of the 20 amino acids
calculated by Discovery Studio (version 2.5) used for scales extraction
in this package.
All amino acid molecules had also been optimized with
MOE 2011.10 (semiempirical AM1)
before calculating these CPSA descriptors.
The SDF file containing the information of the optimized amino acid molecules
is included in this package. See \code{\link{OptAA3d}} for more information.
}
\examples{
data(AACPSA)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/103-getDrugCAS.R
\name{getMolFromCAS}
\alias{getMolFromCAS}
\title{Retrieve Drug Molecules in InChI Format from the CAS Database}
\usage{
getMolFromCAS(id, parallel = 5)
}
\arguments{
\item{id}{A character vector, as the CAS drug ID.}

\item{parallel}{An integer, the parallel parameter, indicates how many
process the user would like to use for retrieving
the data (using RCurl), default is \code{5}.
For regular cases, we recommend a number less than \code{20}.}
}
\value{
A length of \code{id} character vector,
each element containing the corresponding drug molecule.
}
\description{
Retrieve Drug Molecules in InChI Format from the CAS Database
}
\details{
This function retrieves drug molecules in InChI format from the CAS database.
CAS database only provides InChI data, so here we return the molecule
in InChI format, users could convert them to SMILES format using
Open Babel or other third-party tools.
}
\examples{
id = '52-67-5'  # Penicillamine
\donttest{
getMolFromCAS(id)}
}
\seealso{
See \code{\link{getDrug}} for retrieving drug molecules
in MOL and SMILES Format from other databases.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/508-acc.R
\name{acc}
\alias{acc}
\title{Auto Cross Covariance (ACC) for Generating Scales-Based Descriptors
of the Same Length}
\usage{
acc(mat, lag)
}
\arguments{
\item{mat}{A \code{p * n} matrix. Each row represents one scale
(total \code{p} scales), each column represents one amino acid position
(total \code{n} amino acids).}

\item{lag}{The lag parameter. Must be less than the amino acids.}
}
\value{
A length \code{lag * p^2} named vector, the element names are
  constructed by: the scales index (crossed scales index) and
  lag index.
}
\description{
Calculates auto covariance and auto cross covariance
for generating scale-based descriptors of the same length.
}
\note{
To see more details about auto cross covariance, check the references.
}
\examples{
p = 8    # p is the scales number
n = 200  # n is the amino acid number
lag = 7  # lag parameter
mat = matrix(rnorm(p * n), nrow = p, ncol = n)
acc(mat, lag)
}
\references{
Wold, S., Jonsson, J., Sjörström, M., Sandberg, M., & Rännar, S. (1993).
DNA and peptide sequences and chemical processes multivariately modelled
by principal component analysis and partial least-squares projections
to latent structures.
\emph{Analytica chimica acta}, 277(2), 239--253.

Sjöström, M., Rännar, S., & Wieslander, Å. (1995).
Polypeptide sequence property relationships in \emph{Escherichia coli}
based on auto cross covariances.
\emph{Chemometrics and intelligent laboratory systems}, 29(2), 295--305.
}
\seealso{
See \code{\link{extractPCMScales}} for
generalized scales-based descriptors.
For more details, see \code{\link{extractPCMDescScales}}
and \code{\link{extractPCMPropScales}}.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/382-extractDrugOBFP4.R
\name{extractDrugOBFP4}
\alias{extractDrugOBFP4}
\title{Calculate the FP4 Molecular Fingerprints}
\usage{
extractDrugOBFP4(molecules, type = c("smile", "sdf"))
}
\arguments{
\item{molecules}{R character string object containing the molecules.
See the example section for details.}

\item{type}{\code{'smile'} or \code{'sdf'}.}
}
\value{
A matrix. Each row represents one molecule,
the columns represent the fingerprints.
}
\description{
Calculate the FP4 Molecular Fingerprints
}
\details{
Calculate the 512 bit FP4 fingerprints provided by OpenBabel.
}
\examples{
mol1 = 'C1CCC1CC(CN(C)(C))CC(=O)CC'  # one molecule SMILE in a vector
mol2 = c('CCC', 'CCN', 'CCN(C)(C)', 'c1ccccc1Cc1ccccc1',
         'C1CCC1CC(CN(C)(C))CC(=O)CC')  # multiple SMILEs in a vector
mol3 = readChar(system.file('compseq/DB00860.sdf', package = 'Rcpi'),
                nchars = 1e+6)  # single molecule in a sdf file
mol4 = readChar(system.file('sysdata/OptAA3d.sdf', package = 'Rcpi'),
                nchars = 1e+6)  # multiple molecules in a sdf file

\dontrun{
smifp0 = extractDrugOBFP4(mol1, type = 'smile')
smifp1 = extractDrugOBFP4(mol2, type = 'smile')
sdffp0 = extractDrugOBFP4(mol3, type = 'sdf')
sdffp1 = extractDrugOBFP4(mol4, type = 'sdf')}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Rcpi-datalist.R
\docType{data}
\name{AATopo}
\alias{AATopo}
\title{Topological Descriptors for 20 Amino Acids calculated by Dragon}
\value{
AATopo data
}
\description{
Topological Descriptors for 20 Amino Acids calculated by Dragon
}
\details{
This dataset includes the topological descriptors of
the 20 amino acids calculated by Dragon (version 5.4)
used for scales extraction in this package.
}
\examples{
data(AATopo)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/312-extractDrugBPol.R
\name{extractDrugBPol}
\alias{extractDrugBPol}
\title{Calculate the Descriptor that Describes the Sum of the Absolute
Value of the Difference between Atomic Polarizabilities of
All Bonded Atoms in the Molecule}
\usage{
extractDrugBPol(molecules, silent = TRUE)
}
\arguments{
\item{molecules}{Parsed molucule object.}

\item{silent}{Logical. Whether the calculating process
should be shown or not, default is \code{TRUE}.}
}
\value{
A data frame, each row represents one of the molecules,
each column represents one feature.
This function returns one column named \code{bpol}.
}
\description{
Calculates the Descriptor that Describes the Sum of the Absolute
Value of the Difference between Atomic Polarizabilities of
All Bonded Atoms in the Molecule
}
\details{
This descriptor calculates the sum of the absolute value of the
difference between atomic polarizabilities of all bonded atoms
in the molecule (including implicit hydrogens) with polarizabilities
taken from \url{https://bit.ly/3PvNbhe}.
This descriptor assumes 2-centered bonds.
}
\examples{
smi = system.file('vignettedata/FDAMDD.smi', package = 'Rcpi')
\donttest{
mol = readMolFromSmi(smi, type = 'mol')
dat = extractDrugBPol(mol)
head(dat)}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/421-extractProtPSSM.R
\name{extractProtPSSM}
\alias{extractProtPSSM}
\title{Compute PSSM (Position-Specific Scoring Matrix) for given protein sequence}
\usage{
extractProtPSSM(
  seq,
  start.pos = 1L,
  end.pos = nchar(seq),
  psiblast.path = NULL,
  makeblastdb.path = NULL,
  database.path = NULL,
  iter = 5,
  silent = TRUE,
  evalue = 10L,
  word.size = NULL,
  gapopen = NULL,
  gapextend = NULL,
  matrix = "BLOSUM62",
  threshold = NULL,
  seg = "no",
  soft.masking = FALSE,
  culling.limit = NULL,
  best.hit.overhang = NULL,
  best.hit.score.edge = NULL,
  xdrop.ungap = NULL,
  xdrop.gap = NULL,
  xdrop.gap.final = NULL,
  window.size = NULL,
  gap.trigger = 22L,
  num.threads = 1L,
  pseudocount = 0L,
  inclusion.ethresh = 0.002
)
}
\arguments{
\item{seq}{Character vector, as the input protein sequence.}

\item{start.pos}{Optional integer denoting the start position of the
fragment window. Default is \code{1},
i.e. the first amino acid of the given sequence.}

\item{end.pos}{Optional integer denoting the end position of the
fragment window. Default is \code{nchar(seq)},
i.e. the last amino acid of the given sequence.}

\item{psiblast.path}{Character string indicating the path of the
\code{psiblast} program.
If NCBI Blast+ was previously installed in the operation system,
the path will be automatically detected.}

\item{makeblastdb.path}{Character string indicating the path of the
\code{makeblastdb} program.
If NCBI Blast+ was previously installed in the system,
the path will be automatically detected.}

\item{database.path}{Character string indicating the path of
a reference database (a FASTA file).}

\item{iter}{Number of iterations to perform for PSI-Blast.}

\item{silent}{Logical. Whether the PSI-Blast running output
should be shown or not (May not work on some Windows versions and
PSI-Blast versions), default is \code{TRUE}.}

\item{evalue}{Expectation value (E) threshold for saving hits.
Default is \code{10}.}

\item{word.size}{Word size for wordfinder algorithm. An integer >= 2.}

\item{gapopen}{Integer. Cost to open a gap.}

\item{gapextend}{Integer. Cost to extend a gap.}

\item{matrix}{Character string. The scoring matrix name
(default is \code{'BLOSUM62'}).}

\item{threshold}{Minimum word score such that the word is added to
the BLAST lookup table. A real value >= 0.}

\item{seg}{Character string. Filter query sequence with SEG (\code{'yes'},
\code{'window locut hicut'}, or \code{'no'} to disable) Default is \code{'no'}.}

\item{soft.masking}{Logical. Apply filtering locations as soft masks?
Default is \code{FALSE}.}

\item{culling.limit}{An integer >= 0. If the query range of a hit is
enveloped by that of at least this many higher-scoring hits,
delete the hit. Incompatible with \code{best.hit.overhang} and
\code{best_hit_score_edge}.}

\item{best.hit.overhang}{Best Hit algorithm overhang value
(A real value >= 0 and =< 0.5, recommended value: 0.1).
Incompatible with \code{culling_limit}.}

\item{best.hit.score.edge}{Best Hit algorithm score edge value
(A real value >=0 and =< 0.5, recommended value: 0.1).
Incompatible with \code{culling_limit}.}

\item{xdrop.ungap}{X-dropoff value (in bits) for ungapped extensions.}

\item{xdrop.gap}{X-dropoff value (in bits) for preliminary gapped extensions.}

\item{xdrop.gap.final}{X-dropoff value (in bits) for final gapped alignment.}

\item{window.size}{An integer >= 0. Multiple hits window size,
To specify 1-hit algorithm, use \code{0}.}

\item{gap.trigger}{Number of bits to trigger gapping. Default is \code{22}.}

\item{num.threads}{Integer. Number of threads (CPUs) to use in the
BLAST search. Default is \code{1}.}

\item{pseudocount}{Integer. Pseudo-count value used when constructing PSSM.
Default is \code{0}.}

\item{inclusion.ethresh}{E-value inclusion threshold for pairwise alignments.
Default is \code{0.002}.}
}
\value{
The original PSSM, a numeric matrix which has
\code{end.pos - start.pos + 1} columns and \code{20} named rows.
}
\description{
Compute PSSM (Position-Specific Scoring Matrix) for given protein sequence
}
\details{
This function calculates the PSSM (Position-Specific Scoring Matrix) derived
by PSI-Blast for given protein sequence or peptides.
For given protein sequences or peptides, PSSM represents the
log-likelihood of the substitution of the 20 types of amino acids at that
position in the sequence. Note that the output value is not normalized.
}
\note{
The function requires the \code{makeblastdb} and \code{psiblast} programs
to be properly installed in the operation system or
their paths provided.

The two command-line programs are included in the NCBI-BLAST+
software package. To install NCBI Blast+, just open the NCBI FTP site
using web browser or FTP software:
\url{ftp://anonymous@ftp.ncbi.nlm.nih.gov:21/blast/executables/blast+/LATEST/}
then download the executable version of BLAST+ according to your
operation system, and compile or install the downloaded
source code or executable program.

Ubuntu/Debian users can directly use the command
\code{sudo apt-get install ncbi-blast+} to install NCBI Blast+.
For OS X users, download \code{ncbi-blast- ... .dmg} then install.
For Windows users, download \code{ncbi-blast- ... .exe} then install.
}
\examples{
x = readFASTA(system.file('protseq/P00750.fasta', package = 'Rcpi'))[[1]]
\donttest{
dbpath = tempfile('tempdb', fileext = '.fasta')
invisible(file.copy(from = system.file('protseq/Plasminogen.fasta', package = 'Rcpi'), to = dbpath))
pssmmat = extractProtPSSM(seq = x, database.path = dbpath)
dim(pssmmat)  # 20 x 562 (P00750: length 562, 20 Amino Acids)}
}
\references{
Altschul, Stephen F., et al.
"Gapped BLAST and PSI-BLAST: a new generation of protein database search programs."
\emph{Nucleic acids research} 25.17 (1997): 3389--3402.

Ye, Xugang, Guoli Wang, and Stephen F. Altschul.
"An assessment of substitution scores for protein profile-profile comparison."
\emph{Bioinformatics} 27.24 (2011): 3356--3363.

Rangwala, Huzefa, and George Karypis.
"Profile-based direct kernels for remote homology detection and fold recognition."
\emph{Bioinformatics} 21.23 (2005): 4239--4247.
}
\seealso{
\link{extractProtPSSMFeature} \link{extractProtPSSMAcc}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/203-getProtRCSBPDB.R
\name{getSeqFromRCSBPDB}
\alias{getSeqFromRCSBPDB}
\title{Retrieve Protein Sequence from RCSB PDB}
\usage{
getSeqFromRCSBPDB(id, parallel = 5)
}
\arguments{
\item{id}{A character vector, as the protein ID.}

\item{parallel}{An integer, the parallel parameter, indicates how many
process the user would like to use for retrieving
the data (using RCurl), default is \code{5}.
For regular cases, we recommend a number less than \code{20}.}
}
\value{
A list, each component contains one of the protein represented by
amino acid sequence(s).
}
\description{
Retrieve Protein Sequence from RCSB PDB
}
\details{
This function retrieves protein sequences from RCSB PDB.
}
\examples{
id = c('4HHB', '4FF9')
\donttest{
getSeqFromRCSBPDB(id)}
}
\seealso{
See \code{\link{getPDBFromRCSBPDB}} for retrieving protein
in PDB format from the RCSB PDB database.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/422-extractProtPSSMFeature.R
\name{extractProtPSSMFeature}
\alias{extractProtPSSMFeature}
\title{Profile-based protein representation derived by PSSM
(Position-Specific Scoring Matrix)}
\usage{
extractProtPSSMFeature(pssmmat)
}
\arguments{
\item{pssmmat}{The PSSM computed by \code{\link{extractProtPSSM}}.}
}
\value{
A numeric vector which has \code{20 x N} named elements,
where \code{N} is the size of the window (number of rows of the PSSM).
}
\description{
Profile-based protein representation derived by PSSM
(Position-Specific Scoring Matrix)
}
\details{
This function calculates the profile-based protein representation
derived by PSSM. The feature vector is based on the PSSM computed by
\code{\link{extractProtPSSM}}. For a given sequence,
The PSSM feature represents the log-likelihood of the substitution of the
20 types of amino acids at that position in the sequence.
Each PSSM feature value in the vector represents the degree of conservation
of a given amino acid type. The value is normalized to
interval (0, 1) by the transformation 1/(1+e^(-x)).
}
\examples{
x = readFASTA(system.file('protseq/P00750.fasta', package = 'Rcpi'))[[1]]
\donttest{
dbpath = tempfile('tempdb', fileext = '.fasta')
invisible(file.copy(from = system.file('protseq/Plasminogen.fasta', package = 'Rcpi'), to = dbpath))
pssmmat = extractProtPSSM(seq = x, database.path = dbpath)
pssmfeature = extractProtPSSMFeature(pssmmat)
head(pssmfeature)}
}
\references{
Ye, Xugang, Guoli Wang, and Stephen F. Altschul.
"An assessment of substitution scores for protein profile-profile comparison."
\emph{Bioinformatics} 27.24 (2011): 3356--3363.

Rangwala, Huzefa, and George Karypis.
"Profile-based direct kernels for remote homology detection and fold recognition."
\emph{Bioinformatics} 21.23 (2005): 4239--4247.
}
\seealso{
\link{extractProtPSSM} \link{extractProtPSSMAcc}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/417-extractPCMPropScales.R
\name{extractPCMPropScales}
\alias{extractPCMPropScales}
\title{Generalized AA-Properties Based Scales Descriptors}
\usage{
extractPCMPropScales(x, index = NULL, pc, lag, scale = TRUE, silent = TRUE)
}
\arguments{
\item{x}{A character vector, as the input protein sequence.}

\item{index}{Integer vector or character vector. Specify which
AAindex properties to select from the AAindex database by
specify the numerical or character index of the properties
in the AAindex database.
Default is \code{NULL}, means selecting all the AA properties
in the AAindex database.}

\item{pc}{Integer. Use the first pc principal components as the scales.
Must be no greater than the number of AA properties provided.}

\item{lag}{The lag parameter. Must be less than the amino acids.}

\item{scale}{Logical. Should we auto-scale the property matrix
before PCA? Default is \code{TRUE}.}

\item{silent}{Logical. Whether we print the standard deviation,
proportion of variance and the cumulative proportion of
the selected principal components or not.
Default is \code{TRUE}.}
}
\value{
A length \code{lag * p^2} named vector,
        \code{p} is the number of scales (principal components) selected.
}
\description{
Generalized AA-Properties Based Scales Descriptors
}
\details{
This function calculates the generalized amino acid properties based
scales descriptors.
Users could specify which AAindex properties to select from the
AAindex database by specify the numerical or character index of
the properties in the AAindex database.
}
\examples{
x = readFASTA(system.file('protseq/P00750.fasta', package = 'Rcpi'))[[1]]
propscales = extractPCMPropScales(x, index = c(160:165, 258:296), pc = 5, lag = 7, silent = FALSE)

}
\seealso{
See \code{\link{extractPCMScales}} for
generalized scales-based descriptors.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/703-calcProtGOSim.R
\name{calcParProtGOSim}
\alias{calcParProtGOSim}
\title{Protein Sequence Similarity Calculation based on Gene Ontology (GO) Similarity}
\usage{
calcParProtGOSim(
  golist,
  type = c("go", "gene"),
  ont = c("MF", "BP", "CC"),
  organism = "human",
  measure = "Resnik",
  combine = "BMA"
)
}
\arguments{
\item{golist}{A character vector, each component contains
a character vector of GO terms or one Entrez Gene ID.}

\item{type}{Input type of \code{golist}, \code{'go'} for GO Terms,
\code{'gene'} for gene ID.}

\item{ont}{Default is \code{'MF'}, could be one of
\code{'MF'}, \code{'BP'}, or \code{'CC'} subontologies.}

\item{organism}{Default is \code{'human'}, could be one of
\code{'anopheles'}, \code{'arabidopsis'}, \code{'bovine'}, \code{'canine'},
\code{'chicken'}, \code{'chimp'}, \code{'coelicolor'}, \code{'ecolik12'},
\code{'ecsakai'}, \code{'fly'}, \code{'human'}, \code{'malaria'},
\code{'mouse'}, \code{'pig'}, \code{'rat'}, \code{'rhesus'},
\code{'worm'}, \code{'xenopus'}, \code{'yeast'} or \code{'zebrafish'}.}

\item{measure}{Default is \code{'Resnik'}, could be one of
\code{'Resnik'}, \code{'Lin'}, \code{'Rel'}, \code{'Jiang'} or \code{'Wang'}.}

\item{combine}{Default is \code{'BMA'}, could be one of
\code{'max'}, \code{'average'}, \code{'rcmax'} or \code{'BMA'}
for combining semantic similarity scores of multiple GO terms
associated with protein.}
}
\value{
A \code{n} x \code{n} similarity matrix.
}
\description{
Protein Sequence Similarity Calculation based on Gene Ontology (GO) Similarity
}
\details{
This function calculates
protein sequence similarity based on Gene Ontology (GO) similarity.
}
\examples{
# By GO Terms
go1 = c('GO:0005215', 'GO:0005488', 'GO:0005515', 'GO:0005625', 'GO:0005802', 'GO:0005905')  # AP4B1
go2 = c('GO:0005515', 'GO:0005634', 'GO:0005681', 'GO:0008380', 'GO:0031202')  # BCAS2
go3 = c('GO:0003735', 'GO:0005622', 'GO:0005840', 'GO:0006412')  # PDE4DIP
glist = list(go1, go2, go3)
\donttest{calcParProtGOSim(glist, type = 'go', ont = 'CC', measure = 'Wang')}

# By Entrez gene id
genelist = list(c('150', '151', '152', '1814', '1815', '1816'))
\donttest{calcParProtGOSim(genelist, type = 'gene', ont = 'BP', measure = 'Wang')}
}
\seealso{
See \code{\link{calcTwoProtGOSim}} for calculating the
GO semantic similarity between two groups of GO terms or two Entrez gene IDs.
See \code{\link{calcParProtSeqSim}} for paralleled protein similarity
calculation based on sequence alignment.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/302-extractDrugApol.R
\name{extractDrugApol}
\alias{extractDrugApol}
\title{Calculate the Sum of the Atomic Polarizabilities Descriptor}
\usage{
extractDrugApol(molecules, silent = TRUE)
}
\arguments{
\item{molecules}{Parsed molucule object.}

\item{silent}{Logical. Whether the calculating process
should be shown or not, default is \code{TRUE}.}
}
\value{
A data frame, each row represents one of the molecules,
each column represents one feature.
This function returns one column named \code{apol}.
}
\description{
Calculate the Sum of the Atomic Polarizabilities Descriptor
}
\details{
Calculates the sum of the atomic polarizabilities
(including implicit hydrogens) descriptor.
Polarizabilities are taken from \url{https://bit.ly/3PvNbhe}.
}
\examples{
smi = system.file('vignettedata/FDAMDD.smi', package = 'Rcpi')
\donttest{
mol = readMolFromSmi(smi, type = 'mol')
dat = extractDrugApol(mol)
head(dat)}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/348-extractDrugWienerNumbers.R
\name{extractDrugWienerNumbers}
\alias{extractDrugWienerNumbers}
\title{Descriptor that Calculates Wiener Path Number and Wiener Polarity Number}
\usage{
extractDrugWienerNumbers(molecules, silent = TRUE)
}
\arguments{
\item{molecules}{Parsed molucule object.}

\item{silent}{Logical. Whether the calculating process
should be shown or not, default is \code{TRUE}.}
}
\value{
A data frame, each row represents one of the molecules,
each column represents one feature.
This function returns two columns named
\code{WPATH} (weiner path number) and \code{WPOL} (weiner polarity number).
}
\description{
Descriptor that Calculates Wiener Path Number and Wiener Polarity Number
}
\details{
This descriptor calculates the Wiener numbers, including the
Wiener Path number and the Wiener Polarity Number. Wiener path number:
half the sum of all the distance matrix entries; Wiener polarity number:
half the sum of all the distance matrix entries with a value of 3.
}
\examples{
smi = system.file('vignettedata/FDAMDD.smi', package = 'Rcpi')
\donttest{
mol = readMolFromSmi(smi, type = 'mol')
dat = extractDrugWienerNumbers(mol)
head(dat)}
}
\references{
Wiener, H. (1947).
Structural determination of paraffin boiling points.
Journal of the American Chemical Society, 69(1), 17-20.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Rcpi-package.R
\docType{package}
\name{Rcpi-package}
\alias{Rcpi}
\alias{Rcpi-package}
\title{Rcpi: Molecular Informatics Toolkit for Compound-Protein Interaction in Drug Discovery}
\description{
\if{html}{\figure{logo.png}{options: style='float: right' alt='logo' width='120'}}

A molecular informatics toolkit with an integration of bioinformatics and chemoinformatics tools for drug discovery.
}
\seealso{
Useful links:
\itemize{
  \item \url{https://nanx.me/Rcpi/}
  \item \url{https://github.com/nanxstats/Rcpi}
  \item Report bugs at \url{https://github.com/nanxstats/Rcpi/issues}
}

}
\author{
\strong{Maintainer}: Nan Xiao \email{me@nanx.me} (\href{https://orcid.org/0000-0002-0250-5673}{ORCID})

Authors:
\itemize{
  \item Dong-Sheng Cao
  \item Qing-Song Xu \email{qsxu@csu.edu.cn}
}

}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/704-calcProtSeqSim.R
\name{calcTwoProtSeqSim}
\alias{calcTwoProtSeqSim}
\title{Protein Sequence Alignment for Two Protein Sequences}
\usage{
calcTwoProtSeqSim(seq1, seq2, type = "local", submat = "BLOSUM62")
}
\arguments{
\item{seq1}{A character string, containing one protein sequence.}

\item{seq2}{A character string, containing another protein sequence.}

\item{type}{Type of alignment, default is \code{'local'},
could be \code{'global'} or \code{'local'},
where \code{'global'} represents Needleman-Wunsch global alignment;
\code{'local'} represents Smith-Waterman local alignment.}

\item{submat}{Substitution matrix, default is \code{'BLOSUM62'},
could be one of \code{'BLOSUM45'}, \code{'BLOSUM50'}, \code{'BLOSUM62'},
\code{'BLOSUM80'}, \code{'BLOSUM100'}, \code{'PAM30'}, \code{'PAM40'},
\code{'PAM70'}, \code{'PAM120'}, \code{'PAM250'}.}
}
\value{
An Biostrings object containing the scores and other
alignment information.
}
\description{
Protein Sequence Alignment for Two Protein Sequences
}
\details{
This function implements the sequence alignment between two protein sequences.
}
\examples{
s1 = readFASTA(system.file('protseq/P00750.fasta', package = 'Rcpi'))[[1]]
s2 = readFASTA(system.file('protseq/P10323.fasta', package = 'Rcpi'))[[1]]
\donttest{
seqalign = calcTwoProtSeqSim(s1, s2)
seqalign
slot(seqalign, "score")}
}
\seealso{
See \code{\link{calcParProtSeqSim}} for paralleled pairwise
protein similarity calculation based on sequence alignment.
See \code{\link{calcTwoProtGOSim}} for calculating the
GO semantic similarity between two groups of GO terms or two Entrez gene IDs.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/339-extractDrugPetitjeanShapeIndex.R
\name{extractDrugPetitjeanShapeIndex}
\alias{extractDrugPetitjeanShapeIndex}
\title{Descriptor that Calculates the Petitjean Shape Indices}
\usage{
extractDrugPetitjeanShapeIndex(molecules, silent = TRUE)
}
\arguments{
\item{molecules}{Parsed molucule object.}

\item{silent}{Logical. Whether the calculating process
should be shown or not, default is \code{TRUE}.}
}
\value{
A data frame, each row represents one of the molecules,
each column represents one feature.
This function returns two columns named
\code{topoShape} (Topological Shape Index) and
\code{geomShape} (Geometric Shape Index).
}
\description{
Descriptor that Calculates the Petitjean Shape Indices
}
\details{
The topological and geometric shape indices described Petitjean
and Bath et al. respectively. Both measure the anisotropy in a molecule.
}
\examples{
sdf = system.file('sysdata/OptAA3d.sdf', package = 'Rcpi')
\donttest{
mol = readMolFromSDF(sdf)
dat = extractDrugPetitjeanShapeIndex(mol)
head(dat)}
}
\references{
Petitjean, M.,
Applications of the radius-diameter diagram to the classification of
topological and geometrical shapes of chemical compounds,
Journal of Chemical Information and Computer Science,
1992, 32:331-337

Bath, P.A. and Poirette, A.R. and Willet, P. and Allen, F.H. ,
The Extent of the Relationship between the Graph-Theoretical
and the Geometrical Shape Coefficients of Chemical Compounds,
Journal of Chemical Information and Computer Science, 1995, 35:714-716.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/501-readFASTA.R
\name{readFASTA}
\alias{readFASTA}
\title{Read Protein Sequences in FASTA Format}
\usage{
readFASTA(
  file = system.file("protseq/P00750.fasta", package = "Rcpi"),
  legacy.mode = TRUE,
  seqonly = FALSE
)
}
\arguments{
\item{file}{The name of the file which the sequences in fasta format are
to be read from. If it does not contain an absolute or
relative path, the file name is relative to the current
working directory, \code{\link{getwd}}.
The default here is to read the \code{P00750.fasta} file which
is present in the \code{protseq} directory of the Rcpi package.}

\item{legacy.mode}{If set to \code{TRUE}, lines starting with a semicolon ';'
are ignored. Default value is \code{TRUE}.}

\item{seqonly}{If set to \code{TRUE}, only sequences as returned without
attempt to modify them or to get their names and
annotations (execution time is divided approximately
by a factor 3). Default value is \code{FALSE}.}
}
\value{
Character vector.
}
\description{
Reads protein sequences in FASTA format.
}
\examples{
P00750 = readFASTA(system.file('protseq/P00750.fasta', package = 'Rcpi'))
P00750
}
\references{
Pearson, W.R. and Lipman, D.J. (1988)
Improved tools for biological sequence comparison.
\emph{Proceedings of the National Academy of Sciences
of the United States of America}, 85: 2444-2448.
}
\seealso{
See \code{\link{readPDB}} for reading protein sequences
in PDB format.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/416-extractPCMDescScales.R
\name{extractPCMDescScales}
\alias{extractPCMDescScales}
\title{Scales-Based Descriptors with 20+ classes of Molecular Descriptors}
\usage{
extractPCMDescScales(
  x,
  propmat,
  index = NULL,
  pc,
  lag,
  scale = TRUE,
  silent = TRUE
)
}
\arguments{
\item{x}{A character vector, as the input protein sequence.}

\item{propmat}{The matrix containing the descriptor set for the amino acids,
which could be chosen from
\code{AAMOE2D}, \code{AAMOE3D}, \code{AACPSA},
\code{AADescAll}, \code{AA2DACOR}, \code{AA3DMoRSE},
\code{AAACF}, \code{AABurden}, \code{AAConn},
\code{AAConst}, \code{AAEdgeAdj}, \code{AAEigIdx},
\code{AAFGC}, \code{AAGeom}, \code{AAGETAWAY},
\code{AAInfo}, \code{AAMolProp}, \code{AARandic},
\code{AARDF}, \code{AATopo}, \code{AATopoChg},
\code{AAWalk}, \code{AAWHIM}.}

\item{index}{Integer vector or character vector. Specify which molecular
descriptors to select from one of these deseriptor sets by specify the
numerical or character index of the molecular descriptors in the
descriptor set.
Default is \code{NULL}, means selecting all the molecular descriptors
in this descriptor set.}

\item{pc}{Integer. The maximum dimension of the space which the data
are to be represented in.
Must be no greater than the number of AA properties provided.}

\item{lag}{The lag parameter. Must be less than the amino acids.}

\item{scale}{Logical. Should we auto-scale the property matrix
(\code{propmat}) before doing MDS? Default is \code{TRUE}.}

\item{silent}{Logical. Whether we print the standard deviation,
proportion of variance and the cumulative proportion of
the selected principal components or not.
Default is \code{TRUE}.}
}
\value{
A length \code{lag * p^2} named vector,
        \code{p} is the number of scales selected.
}
\description{
Scales-Based Descriptors with 20+ classes of Molecular Descriptors
}
\details{
This function calculates the scales-based descriptors with
molecular descriptors sets calculated by
Dragon, Discovery Studio and MOE.
Users could specify which molecular descriptors to select from one of these
deseriptor sets by specify the numerical or character index of the
molecular descriptors in the descriptor set.
}
\examples{
x = readFASTA(system.file('protseq/P00750.fasta', package = 'Rcpi'))[[1]]
descscales = extractPCMDescScales(x, propmat = 'AATopo', index = c(37:41, 43:47),
                                  pc = 5, lag = 7, silent = FALSE)

}
\seealso{
See \code{\link{extractPCMScales}} for generalized
AA-descriptor based scales descriptors.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/328-extractDrugIPMolecularLearning.R
\name{extractDrugIPMolecularLearning}
\alias{extractDrugIPMolecularLearning}
\title{Calculate the Descriptor that Evaluates the Ionization Potential}
\usage{
extractDrugIPMolecularLearning(molecules, silent = TRUE)
}
\arguments{
\item{molecules}{Parsed molucule object.}

\item{silent}{Logical. Whether the calculating process
should be shown or not, default is \code{TRUE}.}
}
\value{
A data frame, each row represents one of the molecules,
each column represents one feature.
This function returns one column named \code{MolIP}.
}
\description{
Calculate the Descriptor that Evaluates the Ionization Potential
}
\details{
Calculate the ionization potential of a molecule.
The descriptor assumes that explicit hydrogens have been added to the molecules.
}
\examples{
smi = system.file('vignettedata/FDAMDD.smi', package = 'Rcpi')
\donttest{
mol = readMolFromSmi(smi, type = 'mol')
dat = extractDrugIPMolecularLearning(mol)
head(dat)}
}
\author{
Nan Xiao <\url{https://nanx.me}>
}
\keyword{Ionization}
\keyword{Potential}
\keyword{extractDrugIPMolecularLearning}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/326-extractDrugHBondDonorCount.R
\name{extractDrugHBondDonorCount}
\alias{extractDrugHBondDonorCount}
\title{Number of Hydrogen Bond Donors}
\usage{
extractDrugHBondDonorCount(molecules, silent = TRUE)
}
\arguments{
\item{molecules}{Parsed molucule object.}

\item{silent}{Logical. Whether the calculating process
should be shown or not, default is \code{TRUE}.}
}
\value{
A data frame, each row represents one of the molecules,
each column represents one feature.
This function returns one column named \code{nHBDon}.
}
\description{
Number of Hydrogen Bond Donors
}
\details{
This descriptor calculates the number of hydrogen bond donors using
a slightly simplified version of the PHACIR atom types
(\url{https://bit.ly/3qXQELf}).
The following groups are counted as hydrogen bond donors:
\itemize{
\item Any-OH where the formal charge of the oxygen is non-negative
(i.e. formal charge >= 0)
\item Any-NH where the formal charge of the nitrogen is non-negative
(i.e. formal charge >= 0)
}
}
\examples{
smi = system.file('vignettedata/FDAMDD.smi', package = 'Rcpi')
\donttest{
mol = readMolFromSmi(smi, type = 'mol')
dat = extractDrugHBondDonorCount(mol)
head(dat)}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/376-extractDrugEstate.R
\name{extractDrugEstate}
\alias{extractDrugEstate}
\title{Calculate the E-State Molecular Fingerprints (in Compact Format)}
\usage{
extractDrugEstate(molecules, silent = TRUE)
}
\arguments{
\item{molecules}{Parsed molucule object.}

\item{silent}{Logical. Whether the calculating process
should be shown or not, default is \code{TRUE}.}
}
\value{
A list, each component represents one of the molecules, each element
in the component represents the index of which element in the fingerprint is 1.
Each component's name is the length of the fingerprints.
}
\description{
Calculate the E-State Molecular Fingerprints (in Compact Format)
}
\details{
79 bit fingerprints corresponding to the E-State atom types
described by Hall and Kier.
}
\examples{
smi = system.file('vignettedata/FDAMDD.smi', package = 'Rcpi')
\donttest{
mol = readMolFromSmi(smi, type = 'mol')
fp  = extractDrugEstate(mol)
head(fp)}
}
\seealso{
\link{extractDrugEstateComplete}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/702-calcDrugMCSSim.R
\name{calcDrugMCSSim}
\alias{calcDrugMCSSim}
\title{Calculate Drug Molecule Similarity Derived by
Maximum Common Substructure Search}
\usage{
calcDrugMCSSim(
  mol1,
  mol2,
  type = c("smile", "sdf"),
  plot = FALSE,
  al = 0,
  au = 0,
  bl = 0,
  bu = 0,
  matching.mode = "static",
  ...
)
}
\arguments{
\item{mol1}{The first molecule. R character string object
containing the molecule. See examples.}

\item{mol2}{The second molecule. R character string object
containing the molecule. See examples.}

\item{type}{The input molecule format, 'smile' or 'sdf'.}

\item{plot}{Logical. Should we plot the two molecules and
their maximum common substructure?}

\item{al}{Lower bound for the number of atom mismatches. Default is 0.}

\item{au}{Upper bound for the number of atom mismatches. Default is 0.}

\item{bl}{Lower bound for the number of bond mismatches. Default is 0.}

\item{bu}{Upper bound for the number of bond mismatches. Default is 0.}

\item{matching.mode}{Three modes for bond matching are supported:
\code{'static'}, \code{'aromatic'}, and \code{'ring'}.}

\item{...}{Other graphical parameters}
}
\value{
A list containing the detail MCS information and similarity values.
        The numeric similarity value includes Tanimoto coefficient
        and overlap coefficient.
}
\description{
Calculate Drug Molecule Similarity Derived by
Maximum Common Substructure Search
}
\details{
This function calculate drug molecule similarity derived by
maximum common substructure search. The maximum common substructure
search algorithm is provided by the \code{fmcsR} package.
}
\examples{
mol1 = 'CC(C)CCCCCC(=O)NCC1=CC(=C(C=C1)O)OC'
mol2 = 'O=C(NCc1cc(OC)c(O)cc1)CCCC/C=C/C(C)C'
mol3 = readChar(system.file('compseq/DB00859.sdf', package = 'Rcpi'), nchars = 1e+6)
mol4 = readChar(system.file('compseq/DB00860.sdf', package = 'Rcpi'), nchars = 1e+6)
\dontrun{
sim1 = calcDrugMCSSim(mol1, mol2, type = 'smile')
sim2 = calcDrugMCSSim(mol3, mol4, type = 'sdf', plot = TRUE)
print(sim1[[2]])  # Tanimoto Coefficient
print(sim2[[3]])  # Overlap Coefficient
}
}
\references{
Wang, Y., Backman, T. W., Horan, K., & Girke, T. (2013).
fmcsR: mismatch tolerant maximum common substructure searching in R.
Bioinformatics, 29(21), 2792--2794.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/102-getDrugChEMBL.R
\name{getSmiFromChEMBL}
\alias{getSmiFromChEMBL}
\title{Retrieve Drug Molecules in SMILES Format from the ChEMBL Database}
\usage{
getSmiFromChEMBL(id, parallel = 5)
}
\arguments{
\item{id}{A character vector, as the ChEMBL drug ID.}

\item{parallel}{An integer, the parallel parameter, indicates how many
process the user would like to use for retrieving
the data (using RCurl), default is \code{5}.
For regular cases, we recommend a number less than \code{20}.}
}
\value{
A length of \code{id} character vector,
each element containing the corresponding drug molecule.
}
\description{
Retrieve Drug Molecules in SMILES Format from the ChEMBL Database
}
\details{
This function retrieves drug molecules in SMILES format from the
ChEMBL database.
}
\examples{
id = 'CHEMBL1430'  # Penicillamine
\donttest{
getSmiFromChEMBL(id)}
}
\seealso{
See \code{\link{getMolFromChEMBL}} for retrieving drug molecules
in MOL format from the ChEMBL database.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/379-extractDrugShortestPath.R
\name{extractDrugShortestPathComplete}
\alias{extractDrugShortestPathComplete}
\title{Calculate the Shortest Path Molecular Fingerprints (in Complete Format)}
\usage{
extractDrugShortestPathComplete(
  molecules,
  depth = 6,
  size = 1024,
  silent = TRUE
)
}
\arguments{
\item{molecules}{Parsed molucule object.}

\item{depth}{The search depth. Default is \code{6}.}

\item{size}{The length of the fingerprint bit string. Default is \code{1024}.}

\item{silent}{Logical. Whether the calculating process
should be shown or not, default is \code{TRUE}.}
}
\value{
An integer vector or a matrix. Each row represents one molecule,
the columns represent the fingerprints.
}
\description{
Calculate the Shortest Path Molecular Fingerprints (in Complete Format)
}
\details{
Calculate the fingerprint based on the shortest paths between pairs
of atoms and takes into account ring systems, charges etc.
}
\examples{
smi = system.file('vignettedata/FDAMDD.smi', package = 'Rcpi')
\donttest{
mol = readMolFromSmi(smi, type = 'mol')
fp  = extractDrugShortestPathComplete(mol)
dim(fp)}
}
\seealso{
\link{extractDrugShortestPath}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/409-extractProtCTDD.R
\name{extractProtCTDD}
\alias{extractProtCTDD}
\title{CTD Descriptors - Distribution}
\usage{
extractProtCTDD(x)
}
\arguments{
\item{x}{A character vector, as the input protein sequence.}
}
\value{
A length 105 named vector
}
\description{
CTD Descriptors - Distribution
}
\details{
This function calculates the Distribution descriptor of the
CTD descriptors (Dim: 105).
}
\examples{
x = readFASTA(system.file('protseq/P00750.fasta', package = 'Rcpi'))[[1]]
extractProtCTDD(x)
}
\references{
Inna Dubchak, Ilya Muchink, Stephen R. Holbrook and Sung-Hou Kim.
Prediction of protein folding class using global description of
amino acid sequence. \emph{Proceedings of the National Academy of Sciences}.
USA, 1995, 92, 8700-8704.

Inna Dubchak, Ilya Muchink, Christopher Mayor, Igor Dralyuk and Sung-Hou Kim.
Recognition of a Protein Fold in the Context of the SCOP classification.
\emph{Proteins: Structure, Function and Genetics}, 1999, 35, 401-407.
}
\seealso{
See \code{\link{extractProtCTDC}} and \code{\link{extractProtCTDT}}
for the Composition and Transition descriptors.
}
\author{
Nan Xiao <\url{https://nanx.me}>
}
\keyword{CTD}
\keyword{CTDD}
\keyword{Composition}
\keyword{extract}
\keyword{extractProtCTDD}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/402-extractProtDC.R
\name{extractProtDC}
\alias{extractProtDC}
\title{Dipeptide Composition Descriptor}
\usage{
extractProtDC(x)
}
\arguments{
\item{x}{A character vector, as the input protein sequence.}
}
\value{
A length 400 named vector
}
\description{
Dipeptide Composition Descriptor
}
\details{
This function calculates the Dipeptide Composition descriptor (Dim: 400).
}
\examples{
x = readFASTA(system.file('protseq/P00750.fasta', package = 'Rcpi'))[[1]]
extractProtDC(x)

}
\references{
M. Bhasin, G. P. S. Raghava.
Classification of Nuclear Receptors Based on
Amino Acid Composition and Dipeptide Composition.
\emph{Journal of Biological Chemistry}, 2004, 279, 23262.
}
\seealso{
See \code{\link{extractProtAAC}} and \code{\link{extractProtTC}}
         for Amino Acid Composition and Tripeptide Composition descriptors.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Rcpi-datalist.R
\docType{data}
\name{AAPAM30}
\alias{AAPAM30}
\title{PAM30 Matrix for 20 Amino Acids}
\value{
AAPAM30 data
}
\description{
PAM30 Matrix for 20 Amino Acids
}
\details{
PAM30 Matrix for the 20 amino acids. The matrix was extracted from the
\code{Biostrings} package of Bioconductor.
}
\examples{
data(AAPAM30)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/375-extractDrugMACCS.R
\name{extractDrugMACCSComplete}
\alias{extractDrugMACCSComplete}
\title{Calculate the MACCS Molecular Fingerprints (in Complete Format)}
\usage{
extractDrugMACCSComplete(molecules, silent = TRUE)
}
\arguments{
\item{molecules}{Parsed molucule object.}

\item{silent}{Logical. Whether the calculating process
should be shown or not, default is \code{TRUE}.}
}
\value{
An integer vector or a matrix. Each row represents one molecule,
the columns represent the fingerprints.
}
\description{
Calculate the MACCS Molecular Fingerprints (in Complete Format)
}
\details{
The popular 166 bit MACCS keys described by MDL.
}
\examples{
smi = system.file('vignettedata/FDAMDD.smi', package = 'Rcpi')
\donttest{
mol = readMolFromSmi(smi, type = 'mol')
fp  = extractDrugMACCSComplete(mol)
dim(fp)}
}
\seealso{
\link{extractDrugMACCS}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/371-extractDrugStandard.R
\name{extractDrugStandard}
\alias{extractDrugStandard}
\title{Calculate the Standard Molecular Fingerprints (in Compact Format)}
\usage{
extractDrugStandard(molecules, depth = 6, size = 1024, silent = TRUE)
}
\arguments{
\item{molecules}{Parsed molucule object.}

\item{depth}{The search depth. Default is \code{6}.}

\item{size}{The length of the fingerprint bit string. Default is \code{1024}.}

\item{silent}{Logical. Whether the calculating process
should be shown or not, default is \code{TRUE}.}
}
\value{
A list, each component represents one of the molecules, each element
in the component represents the index of which element in the fingerprint is 1.
Each component's name is the length of the fingerprints.
}
\description{
Calculate the Standard Molecular Fingerprints (in Compact Format)
}
\details{
Calculate the standard molecular fingerprints.
Considers paths of a given length.
This is hashed fingerprints, with a default length of 1024.
}
\examples{
smi = system.file('vignettedata/FDAMDD.smi', package = 'Rcpi')
\donttest{
mol = readMolFromSmi(smi, type = 'mol')
fp  = extractDrugStandard(mol)
head(fp)}
}
\seealso{
\link{extractDrugStandardComplete}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/327-extractDrugHybridizationRatio.R
\name{extractDrugHybridizationRatio}
\alias{extractDrugHybridizationRatio}
\title{Descriptor that Characterizing Molecular Complexity
in Terms of Carbon Hybridization States}
\usage{
extractDrugHybridizationRatio(molecules, silent = TRUE)
}
\arguments{
\item{molecules}{Parsed molucule object.}

\item{silent}{Logical. Whether the calculating process
should be shown or not, default is \code{TRUE}.}
}
\value{
A data frame, each row represents one of the molecules,
each column represents one feature.
This function returns one column named \code{HybRatio}.
}
\description{
Descriptor that Characterizing Molecular Complexity
in Terms of Carbon Hybridization States
}
\details{
This descriptor calculates the fraction of sp3 carbons to sp2 carbons.
Note that it only considers carbon atoms and rather than use a simple
ratio it reports the value of Nsp3/(Nsp3 + Nsp2).
The original form of the descriptor (i.e., simple ratio)
has been used to characterize molecular complexity,
especially in the are of natural products,
which usually have a high value of the sp3 to sp2 ratio.
}
\examples{
smi = system.file('vignettedata/FDAMDD.smi', package = 'Rcpi')
\donttest{
mol = readMolFromSmi(smi, type = 'mol')
dat = extractDrugHybridizationRatio(mol)
head(dat)}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/373-extractDrugGraph.R
\name{extractDrugGraphComplete}
\alias{extractDrugGraphComplete}
\title{Calculate the Graph Molecular Fingerprints (in Complete Format)}
\usage{
extractDrugGraphComplete(molecules, depth = 6, size = 1024,
  silent = TRUE)
}
\arguments{
\item{molecules}{Parsed molucule object.}

\item{depth}{The search depth. Default is \code{6}.}

\item{size}{The length of the fingerprint bit string. Default is \code{1024}.}

\item{silent}{Logical. Whether the calculating process
should be shown or not, default is \code{TRUE}.}
}
\value{
An integer vector or a matrix. Each row represents one molecule,
the columns represent the fingerprints.
}
\description{
Calculate the Graph Molecular Fingerprints (in Complete Format)
}
\details{
Calculate the graph molecular fingerprints.
Similar to the standard type by simply considers connectivity.
This is hashed fingerprints, with a default length of 1024.
}
\examples{
smi = system.file('vignettedata/FDAMDD.smi', package = 'Rcpi')
\donttest{
mol = readMolFromSmi(smi, type = 'mol')
fp  = extractDrugGraphComplete(mol)
dim(fp)}
}
\seealso{
\link{extractDrugGraph}
}
\author{
Nan Xiao <\url{https://nanx.me}>
}
\keyword{extractDrugGraphComplete}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/602-getPPI.R
\name{getPPI}
\alias{getPPI}
\title{Generating Protein-Protein Interaction Descriptors}
\usage{
getPPI(protmat1, protmat2, type = c("combine", "tensorprod", "entrywise"))
}
\arguments{
\item{protmat1}{The first protein descriptor matrix,
must have the same ncol with \code{protmat2}.}

\item{protmat2}{The second protein descriptor matrix,
must have the same ncol with \code{protmat1}.}

\item{type}{The interaction type, one or more of
\code{"combine"}, \code{"tensorprod"}, and \code{"entrywise"}.}
}
\value{
A matrix containing the protein-protein interaction descriptors
}
\description{
Generating Protein-Protein Interaction Descriptors
}
\details{
This function calculates the protein-protein interaction descriptors
by three types of interaction:
\itemize{
\item \code{combine} - combine the two descriptor matrix,
result has \code{(p + p)} columns
\item \code{tensorprod} - calculate column-by-column
(pseudo)-tensor product type interactions, result has \code{(p * p)} columns
\item \code{entrywise} - calculate entrywise product and
entrywise sum of the two matrices, then combine them,
result has \code{(p + p)} columns
}
}
\examples{
x = matrix(1:10, ncol = 2)
y = matrix(5:14, ncol = 2)

getPPI(x, y, type = 'combine')
getPPI(x, y, type = 'tensorprod')
getPPI(x, y, type = 'entrywise')
getPPI(x, y, type = c('combine', 'tensorprod'))
getPPI(x, y, type = c('combine', 'entrywise'))
getPPI(x, y, type = c('entrywise', 'tensorprod'))
getPPI(x, y, type = c('combine', 'entrywise', 'tensorprod'))

}
\seealso{
See \code{\link{getCPI}} for generating
compound-protein interaction descriptors.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/413-extractProtPAAC.R
\name{extractProtPAAC}
\alias{extractProtPAAC}
\title{Pseudo Amino Acid Composition Descriptor}
\usage{
extractProtPAAC(
  x,
  props = c("Hydrophobicity", "Hydrophilicity", "SideChainMass"),
  lambda = 30,
  w = 0.05,
  customprops = NULL
)
}
\arguments{
\item{x}{A character vector, as the input protein sequence.}

\item{props}{A character vector, specifying the properties used.
3 properties are used by default, as listed below:
\describe{
\item{\code{'Hydrophobicity'}}{Hydrophobicity value
of the 20 amino acids}
\item{\code{'Hydrophilicity'}}{Hydrophilicity value
of the 20 amino acids}
\item{\code{'SideChainMass'}}{Side-chain mass
of the 20 amino acids}}}

\item{lambda}{The lambda parameter for the PAAC descriptors, default is 30.}

\item{w}{The weighting factor, default is 0.05.}

\item{customprops}{A \code{n x 21} named data frame contains \code{n}
customize property. Each row contains one property.
The column order for different amino acid types is
\code{'AccNo'}, \code{'A'}, \code{'R'}, \code{'N'},
\code{'D'}, \code{'C'}, \code{'E'}, \code{'Q'},
\code{'G'}, \code{'H'}, \code{'I'}, \code{'L'},
\code{'K'}, \code{'M'}, \code{'F'}, \code{'P'},
\code{'S'}, \code{'T'}, \code{'W'}, \code{'Y'},
\code{'V'}, and the columns should also be \emph{exactly}
named like this.
The \code{AccNo} column contains the properties' names.
Then users should explicitly specify these properties
with these names in the argument \code{props}.
See the examples below for a demonstration.
The default value for \code{customprops} is \code{NULL}.}
}
\value{
A length \code{20 + lambda} named vector
}
\description{
Pseudo Amino Acid Composition Descriptor
}
\details{
This function calculates the Pseudo Amino Acid Composition (PAAC) descriptor
(Dim: \code{20 + lambda}, default is 50).
}
\note{
Note the default \code{20 * 3} \code{prop} values have been already
      independently given in the function. Users could also specify
      other (up to 544) properties with the Accession Number in
      the \code{\link{AAindex}} data, with or without the default
      three properties, which means users should explicitly specify
      the properties to use.
}
\examples{
x = readFASTA(system.file('protseq/P00750.fasta', package = 'Rcpi'))[[1]]
extractProtPAAC(x)

myprops = data.frame(AccNo = c("MyProp1", "MyProp2", "MyProp3"),
                     A = c(0.62,  -0.5, 15),  R = c(-2.53,   3, 101),
                     N = c(-0.78,  0.2, 58),  D = c(-0.9,    3, 59),
                     C = c(0.29,    -1, 47),  E = c(-0.74,   3, 73),
                     Q = c(-0.85,  0.2, 72),  G = c(0.48,    0, 1),
                     H = c(-0.4,  -0.5, 82),  I = c(1.38, -1.8, 57),
                     L = c(1.06,  -1.8, 57),  K = c(-1.5,    3, 73),
                     M = c(0.64,  -1.3, 75),  F = c(1.19, -2.5, 91),
                     P = c(0.12,     0, 42),  S = c(-0.18, 0.3, 31),
                     T = c(-0.05, -0.4, 45),  W = c(0.81, -3.4, 130),
                     Y = c(0.26,  -2.3, 107), V = c(1.08, -1.5, 43))

# Use 3 default properties, 4 properties in the AAindex database,
# and 3 cutomized properties
extractProtPAAC(x, customprops = myprops,
                props = c('Hydrophobicity', 'Hydrophilicity', 'SideChainMass',
                          'CIDH920105', 'BHAR880101',
                          'CHAM820101', 'CHAM820102',
                          'MyProp1', 'MyProp2', 'MyProp3'))

}
\references{
Kuo-Chen Chou. Prediction of Protein Cellular Attributes
Using Pseudo-Amino Acid Composition.
\emph{PROTEINS: Structure, Function, and Genetics}, 2001, 43: 246-255.

Type 1 pseudo amino acid composition.
\url{http://www.csbio.sjtu.edu.cn/bioinf/PseAAC/type1.htm}

Kuo-Chen Chou. Using Amphiphilic Pseudo Amino Acid Composition
to Predict Enzyme Subfamily Classes. \emph{Bioinformatics}, 2005, 21, 10-19.

JACS, 1962, 84: 4240-4246. (C. Tanford). (The hydrophobicity data)

PNAS, 1981, 78:3824-3828 (T.P.Hopp & K.R.Woods). (The hydrophilicity data)

CRC Handbook of Chemistry and Physics, 66th ed.,
CRC Press, Boca Raton, Florida (1985). (The side-chain mass data)

R.M.C. Dawson, D.C. Elliott, W.H. Elliott, K.M. Jones,
Data for Biochemical Research 3rd ed., Clarendon Press Oxford (1986).
(The side-chain mass data)
}
\seealso{
See \code{\link{extractProtAPAAC}} for amphiphilic pseudo
         amino acid composition descriptor.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/345-extractDrugWHIM.R
\name{extractDrugWHIM}
\alias{extractDrugWHIM}
\title{Calculate Holistic Descriptors Described by Todeschini et al.}
\usage{
extractDrugWHIM(molecules, silent = TRUE)
}
\arguments{
\item{molecules}{Parsed molucule object.}

\item{silent}{Logical. Whether the calculating process
should be shown or not, default is \code{TRUE}.}
}
\value{
A data frame, each row represents one of the molecules,
each column represents one feature.
This function returns 17 columns:
\itemize{
\item Wlambda1
\item Wlambda2
\item wlambda3
\item Wnu1
\item Wnu2
\item Wgamma1
\item Wgamma2
\item Wgamma3
\item Weta1
\item Weta2
\item Weta3
\item WT
\item WA
\item WV
\item WK
\item WG
\item WD
}

Each name will have a suffix of the form \code{.X} where \code{X} indicates
the weighting scheme used. Possible values of \code{X} are
\itemize{
\item unity
\item mass
\item volume
\item eneg
\item polar
}
}
\description{
Calculate Holistic Descriptors Described by Todeschini et al.
}
\details{
Holistic descriptors described by Todeschini et al, the descriptors
are based on a number of atom weightings.
There are six different possible weightings:
\itemize{
\item unit weights
\item atomic masses
\item van der Waals volumes
\item Mulliken atomic electronegativites
\item atomic polarizabilities
\item E-state values described by Kier and Hall
}

Currently weighting schemes 1, 2, 3, 4 and 5 are implemented.
The weight values are taken from Todeschini et al.
and as a result 19 elements are considered.
For each weighting scheme we can obtain
\itemize{
\item 11 directional WHIM descriptors (lambda1 .. 3, nu1 .. 2, gamma1 .. 3, eta1 .. 3)
\item 6 non-directional WHIM descriptors (T, A, V, K, G, D)
}
Though Todeschini et al. mentions that for planar molecules
only 8 directional WHIM descriptors are required the current code will return all 11.
}
\examples{
sdf = system.file('sysdata/OptAA3d.sdf', package = 'Rcpi')
\donttest{
mol = readMolFromSDF(sdf)
dat = extractDrugWHIM(mol)
head(dat)}
}
\references{
Todeschini, R. and Gramatica, P.,
New 3D Molecular Descriptors: The WHIM theory and QAR Applications,
Persepectives in Drug Discovery and Design, 1998, ?:355-380.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/411-extractProtSOCN.R
\name{extractProtSOCN}
\alias{extractProtSOCN}
\title{Sequence-Order-Coupling Numbers}
\usage{
extractProtSOCN(x, nlag = 30)
}
\arguments{
\item{x}{A character vector, as the input protein sequence.}

\item{nlag}{The maximum lag, defualt is 30.}
}
\value{
A length \code{nlag * 2} named vector
}
\description{
Sequence-Order-Coupling Numbers
}
\details{
This function calculates the Sequence-Order-Coupling Numbers
(Dim: \code{nlag * 2}, default is 60).
}
\examples{
x = readFASTA(system.file('protseq/P00750.fasta', package = 'Rcpi'))[[1]]
extractProtSOCN(x)

}
\references{
Kuo-Chen Chou. Prediction of Protein Subcellar Locations by
Incorporating Quasi-Sequence-Order Effect.
\emph{Biochemical and Biophysical Research Communications},
2000, 278, 477-483.

Kuo-Chen Chou and Yu-Dong Cai. Prediction of Protein Sucellular Locations by
GO-FunD-PseAA Predictor.
\emph{Biochemical and Biophysical Research Communications},
2004, 320, 1236-1239.

Gisbert Schneider and Paul Wrede. The Rational Design of
Amino Acid Sequences by Artifical Neural Networks and Simulated
Molecular Evolution: Do Novo Design of an Idealized Leader Cleavge Site.
\emph{Biophys Journal}, 1994, 66, 335-344.
}
\seealso{
See \code{\link{extractProtQSO}} for
quasi-sequence-order descriptors.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/333-extractDrugLengthOverBreadth.R
\name{extractDrugLengthOverBreadth}
\alias{extractDrugLengthOverBreadth}
\title{Calculate the Ratio of Length to Breadth Descriptor}
\usage{
extractDrugLengthOverBreadth(molecules, silent = TRUE)
}
\arguments{
\item{molecules}{Parsed molucule object.}

\item{silent}{Logical. Whether the calculating process
should be shown or not, default is \code{TRUE}.}
}
\value{
A data frame, each row represents one of the molecules,
each column represents one feature.
This function returns two columns named \code{LOBMAX} and \code{LOBMIN}:
\itemize{
\item \code{LOBMAX} - The maximum L/B ratio;
\item \code{LOBMIN} - The L/B ratio for the rotation that results in the
minimum area (defined by the product of the X & Y extents for that orientation).
}
}
\description{
Calculate the Ratio of Length to Breadth Descriptor
}
\details{
Calculates the Ratio of Length to Breadth, as a result ti does not perform
any orientation and only considers the X & Y
extents for a series of rotations about the Z axis
(in 10 degree increments).
}
\note{
The descriptor assumes that the atoms have been configured.
}
\examples{
sdf = system.file('sysdata/OptAA3d.sdf', package = 'Rcpi')
\donttest{
mol = readMolFromSDF(sdf)
dat = extractDrugLengthOverBreadth(mol)
head(dat)}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/305-extractDrugAromaticAtomsCount.R
\name{extractDrugAromaticAtomsCount}
\alias{extractDrugAromaticAtomsCount}
\title{Calculate the Number of Aromatic Atoms Descriptor}
\usage{
extractDrugAromaticAtomsCount(molecules, silent = TRUE)
}
\arguments{
\item{molecules}{Parsed molucule object.}

\item{silent}{Logical. Whether the calculating process
should be shown or not, default is \code{TRUE}.}
}
\value{
A data frame, each row represents one of the molecules,
each column represents one feature.
This function returns one column named \code{naAromAtom}.
}
\description{
Calculate the Number of Aromatic Atoms Descriptor
}
\details{
Calculates the number of aromatic atoms of a molecule.
}
\examples{
smi = system.file('vignettedata/FDAMDD.smi', package = 'Rcpi')
\donttest{
mol = readMolFromSmi(smi, type = 'mol')
dat = extractDrugAromaticAtomsCount(mol)
head(dat)}
}
\author{
Nan Xiao <\url{https://nanx.me}>
}
\keyword{Aromatic}
\keyword{Atoms}
\keyword{Count}
\keyword{extractDrugAromaticAtomsCount}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/314-extractDrugBondCount.R
\name{extractDrugBondCount}
\alias{extractDrugBondCount}
\title{Calculate the Descriptor Based on the Number of Bonds of a
Certain Bond Order}
\usage{
extractDrugBondCount(molecules, silent = TRUE)
}
\arguments{
\item{molecules}{Parsed molucule object.}

\item{silent}{Logical. Whether the calculating process
should be shown or not, default is \code{TRUE}.}
}
\value{
A data frame, each row represents one of the molecules,
each column represents one feature.
This function returns one column named \code{nB}.
}
\description{
Calculate the Descriptor Based on the Number of Bonds of a
Certain Bond Order
}
\details{
Calculates the descriptor based on the number of bonds of a
certain bond order.
}
\examples{
smi = system.file('vignettedata/FDAMDD.smi', package = 'Rcpi')
\donttest{
mol = readMolFromSmi(smi, type = 'mol')
dat = extractDrugBondCount(mol)
head(dat)}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/403-extractProtTC.R
\name{extractProtTC}
\alias{extractProtTC}
\title{Tripeptide Composition Descriptor}
\usage{
extractProtTC(x)
}
\arguments{
\item{x}{A character vector, as the input protein sequence.}
}
\value{
A length 8000 named vector
}
\description{
Tripeptide Composition Descriptor
}
\details{
This function calculates the Tripeptide Composition descriptor (Dim: 8000).
}
\examples{
x = readFASTA(system.file('protseq/P00750.fasta', package = 'Rcpi'))[[1]]
extractProtTC(x)

}
\references{
M. Bhasin, G. P. S. Raghava.
Classification of Nuclear Receptors Based on
Amino Acid Composition and Dipeptide Composition.
\emph{Journal of Biological Chemistry}, 2004, 279, 23262.
}
\seealso{
See \code{\link{extractProtAAC}} and \code{\link{extractProtDC}}
         for Amino Acid Composition and Dipeptide Composition descriptors.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Rcpi-datalist.R
\docType{data}
\name{AAindex}
\alias{AAindex}
\title{AAindex Data of 544 Physicochemical and Biological Properties
for 20 Amino Acids}
\value{
AAindex data
}
\description{
AAindex Data of 544 Physicochemical and Biological Properties
for 20 Amino Acids
}
\details{
The data was extracted from the AAindex1 database ver 9.1
(\url{ftp://ftp.genome.jp/pub/db/community/aaindex/aaindex1}) as of
November 2012 (Data Last Modified 2006-08-14).

With this data, users could investigate each property's accession number
and other details. Visit \url{https://www.genome.jp/dbget/aaindex.html}
for more information.
}
\examples{
data(AAindex)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/301-extractDrugALOGP.R
\name{extractDrugALOGP}
\alias{extractDrugALOGP}
\title{Calculate Atom Additive logP and Molar Refractivity Values Descriptor}
\usage{
extractDrugALOGP(molecules, silent = TRUE)
}
\arguments{
\item{molecules}{Parsed molucule object.}

\item{silent}{Logical. Whether the calculating process
should be shown or not, default is \code{TRUE}.}
}
\value{
A data frame, each row represents one of the molecules,
each column represents one feature. This function returns three columns
named \code{ALogP}, \code{ALogp2} and \code{AMR}.
}
\description{
Calculate Atom Additive logP and Molar Refractivity Values Descriptor
}
\details{
Calculates ALOGP (Ghose-Crippen LogKow) and the Ghose-Crippen molar
refractivity as described by Ghose, A.K. and Crippen, G.M.
Note the underlying code in CDK assumes that aromaticity
has been detected before evaluating this descriptor.
The code also expects that the molecule will have
hydrogens explicitly set. For SD files, this is
usually not a problem since hydrogens are explicit.
But for the case of molecules obtained from SMILES,
hydrogens must be made explicit.
}
\examples{
smi = system.file('vignettedata/FDAMDD.smi', package = 'Rcpi')
\donttest{
mol = readMolFromSmi(smi, type = 'mol')
dat = extractDrugALOGP(mol)
head(dat)}
}
\references{
Ghose, A.K. and Crippen, G.M. ,
Atomic physicochemical parameters for three-dimensional structure-directed
quantitative structure-activity relationships.
I. Partition coefficients as a measure of hydrophobicity,
Journal of Computational Chemistry, 1986, 7:565-577.

Ghose, A.K. and Crippen, G.M. ,
Atomic physicochemical parameters for three-dimensional-structure-directed
quantitative structure-activity relationships.
2. Modeling dispersive and hydrophobic interactions,
Journal of Chemical Information and Computer Science, 1987, 27:21-35.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/320-extractDrugChiPath.R
\name{extractDrugChiPath}
\alias{extractDrugChiPath}
\title{Calculate the Kier and Hall Chi Path Indices of Orders 0 to 7}
\usage{
extractDrugChiPath(molecules, silent = TRUE)
}
\arguments{
\item{molecules}{Parsed molucule object.}

\item{silent}{Logical. Whether the calculating process
should be shown or not, default is \code{TRUE}.}
}
\value{
A data frame, each row represents one of the molecules,
each column represents one feature.
This function returns 16 columns,
The order and names of the columns returned is:
\itemize{
\item \code{SP.0, SP.1, ..., SP.7} - Simple path, orders 0 to 7
\item \code{VP.0, VP.1, ..., VP.7} - Valence path, orders 0 to 7
}
}
\description{
Calculate the Kier and Hall Chi Path Indices of Orders 0 to 7
}
\details{
Evaluates chi path descriptors. This function utilizes the graph isomorphism
code of the CDK to find fragments matching SMILES strings representing the
fragments corresponding to each type of chain.
}
\note{
These descriptors are calculated using graph isomorphism to identify
the various fragments. As a result calculations may be slow.
In addition, recent versions of Molconn-Z use simplified fragment definitions
(i.e., rings without branches etc.) whereas these descriptors use the older
more complex fragment definitions.
}
\examples{
smi = system.file('vignettedata/FDAMDD.smi', package = 'Rcpi')
\donttest{
mol = readMolFromSmi(smi, type = 'mol')
dat = extractDrugChiPath(mol)
head(dat)}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/412-extractProtQSO.R
\name{extractProtQSO}
\alias{extractProtQSO}
\title{Quasi-Sequence-Order (QSO) Descriptor}
\usage{
extractProtQSO(x, nlag = 30, w = 0.1)
}
\arguments{
\item{x}{A character vector, as the input protein sequence.}

\item{nlag}{The maximum lag, defualt is 30.}

\item{w}{The weighting factor, default is 0.1.}
}
\value{
A length \code{20 + 20 + (2 * nlag)} named vector
}
\description{
Quasi-Sequence-Order (QSO) Descriptor
}
\details{
This function calculates the Quasi-Sequence-Order (QSO) descriptor
(Dim: \code{20 + 20 + (2 * nlag)}, default is 100).
}
\examples{
x = readFASTA(system.file('protseq/P00750.fasta', package = 'Rcpi'))[[1]]
extractProtQSO(x)

}
\references{
Kuo-Chen Chou. Prediction of Protein Subcellar Locations by
Incorporating Quasi-Sequence-Order Effect.
\emph{Biochemical and Biophysical Research Communications},
2000, 278, 477-483.

Kuo-Chen Chou and Yu-Dong Cai. Prediction of Protein Sucellular Locations by
GO-FunD-PseAA Predictor.
\emph{Biochemical and Biophysical Research Communications},
2004, 320, 1236-1239.

Gisbert Schneider and Paul Wrede. The Rational Design of
Amino Acid Sequences by Artifical Neural Networks and Simulated
Molecular Evolution: Do Novo Design of an Idealized Leader Cleavge Site.
\emph{Biophys Journal}, 1994, 66, 335-344.
}
\seealso{
See \code{\link{extractProtSOCN}}
for sequence-order-coupling numbers.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/418-extractPCMFAScales.R
\name{extractPCMFAScales}
\alias{extractPCMFAScales}
\title{Generalized Scales-Based Descriptors derived by Factor Analysis}
\usage{
extractPCMFAScales(
  x,
  propmat,
  factors,
  scores = "regression",
  lag,
  scale = TRUE,
  silent = TRUE
)
}
\arguments{
\item{x}{A character vector, as the input protein sequence.}

\item{propmat}{A matrix containing the properties for the amino acids.
Each row represent one amino acid type, each column represents
one property.
Note that the one-letter row names must be provided for we need
them to seek the properties for each AA type.}

\item{factors}{Integer. The number of factors to be fitted.
Must be no greater than the number of AA properties provided.}

\item{scores}{Type of scores to produce. The default is \code{"regression"},
which gives Thompson's scores, \code{"Bartlett"} given
Bartlett's weighted least-squares scores.}

\item{lag}{The lag parameter. Must be less than the amino acids number
in the protein sequence.}

\item{scale}{Logical. Should we auto-scale the property matrix
(\code{propmat}) before doing Factor Analysis? Default is \code{TRUE}.}

\item{silent}{Logical. Whether we print the SS loadings,
proportion of variance and the cumulative proportion of
the selected factors or not.
Default is \code{TRUE}.}
}
\value{
A length \code{lag * p^2} named vector,
        \code{p} is the number of scales (factors) selected.
}
\description{
Generalized Scales-Based Descriptors derived by Factor Analysis
}
\details{
This function calculates the generalized scales-based descriptors
derived by Factor Analysis (FA).
Users could provide customized amino acid property matrices.
}
\examples{
x = readFASTA(system.file('protseq/P00750.fasta', package = 'Rcpi'))[[1]]
data(AATopo)
tprops = AATopo[, c(37:41, 43:47)]  # select a set of topological descriptors
fa = extractPCMFAScales(x, propmat = tprops, factors = 5, lag = 7, silent = FALSE)

}
\references{
Atchley, W. R., Zhao, J., Fernandes, A. D., & Druke, T. (2005).
Solving the protein sequence metric problem.
Proceedings of the National Academy of Sciences of the
United States of America,
102(18), 6395-6400.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/704-calcProtSeqSim.R
\name{calcParProtSeqSim}
\alias{calcParProtSeqSim}
\title{Parallellized Protein Sequence Similarity Calculation based on Sequence Alignment}
\usage{
calcParProtSeqSim(protlist, cores = 2, type = "local", submat = "BLOSUM62")
}
\arguments{
\item{protlist}{A length \code{n} list containing \code{n} protein sequences,
each component of the list is a character string,
storing one protein sequence. Unknown sequences should be represented as
\code{''}.}

\item{cores}{Integer. The number of CPU cores to use for parallel execution,
default is \code{2}. Users could use the \code{detectCores()} function
in the \code{parallel} package to see how many cores they could use.}

\item{type}{Type of alignment, default is \code{'local'},
could be \code{'global'} or \code{'local'},
where \code{'global'} represents Needleman-Wunsch global alignment;
\code{'local'} represents Smith-Waterman local alignment.}

\item{submat}{Substitution matrix, default is \code{'BLOSUM62'},
could be one of \code{'BLOSUM45'}, \code{'BLOSUM50'}, \code{'BLOSUM62'},
\code{'BLOSUM80'}, \code{'BLOSUM100'}, \code{'PAM30'}, \code{'PAM40'},
\code{'PAM70'}, \code{'PAM120'}, \code{'PAM250'}.}
}
\value{
A \code{n} x \code{n} similarity matrix.
}
\description{
Parallellized Protein Sequence Similarity Calculation based on Sequence Alignment
}
\details{
This function implemented the parallellized version for calculating
protein sequence similarity based on sequence alignment.
}
\examples{
s1 = readFASTA(system.file('protseq/P00750.fasta', package = 'Rcpi'))[[1]]
s2 = readFASTA(system.file('protseq/P08218.fasta', package = 'Rcpi'))[[1]]
s3 = readFASTA(system.file('protseq/P10323.fasta', package = 'Rcpi'))[[1]]
s4 = readFASTA(system.file('protseq/P20160.fasta', package = 'Rcpi'))[[1]]
s5 = readFASTA(system.file('protseq/Q9NZP8.fasta', package = 'Rcpi'))[[1]]
plist = list(s1, s2, s3, s4, s5)
\donttest{
psimmat = calcParProtSeqSim(plist, cores = 2, type = 'local',
                            submat = 'BLOSUM62')
print(psimmat)}
}
\seealso{
See \code{calcTwoProtSeqSim} for protein sequence alignment
for two protein sequences. See \code{\link{calcParProtGOSim}} for
protein similarity calculation based on
Gene Ontology (GO) semantic similarity.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/407-extractProtCTDC.R
\name{extractProtCTDC}
\alias{extractProtCTDC}
\title{CTD Descriptors - Composition}
\usage{
extractProtCTDC(x)
}
\arguments{
\item{x}{A character vector, as the input protein sequence.}
}
\value{
A length 21 named vector
}
\description{
CTD Descriptors - Composition
}
\details{
This function calculates the Composition descriptor of the
CTD descriptors (Dim: 21).
}
\examples{
x = readFASTA(system.file('protseq/P00750.fasta', package = 'Rcpi'))[[1]]
extractProtCTDC(x)
}
\references{
Inna Dubchak, Ilya Muchink, Stephen R. Holbrook and Sung-Hou Kim.
Prediction of protein folding class using global description of
amino acid sequence. \emph{Proceedings of the National Academy of Sciences}.
USA, 1995, 92, 8700-8704.

Inna Dubchak, Ilya Muchink, Christopher Mayor, Igor Dralyuk and Sung-Hou Kim.
Recognition of a Protein Fold in the Context of the SCOP classification.
\emph{Proteins: Structure, Function and Genetics}, 1999, 35, 401-407.
}
\seealso{
See \code{\link{extractProtCTDT}} and \code{\link{extractProtCTDD}}
for the Transition and Distribution descriptors.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/423-extractProtPSSMAcc.R
\name{extractProtPSSMAcc}
\alias{extractProtPSSMAcc}
\title{Profile-based protein representation derived by PSSM
(Position-Specific Scoring Matrix) and auto cross covariance}
\usage{
extractProtPSSMAcc(pssmmat, lag)
}
\arguments{
\item{pssmmat}{The PSSM computed by \code{\link{extractProtPSSM}}.}

\item{lag}{The lag parameter. Must be less than the number of amino acids
in the sequence (i.e. the number of columns in the PSSM matrix).}
}
\value{
A length \code{lag * 20^2} named numeric vector,
the element names are derived by the amino acid name abbreviation
(crossed amino acid name abbreviation) and lag index.
}
\description{
Profile-based protein representation derived by PSSM
(Position-Specific Scoring Matrix) and auto cross covariance
}
\details{
This function calculates the feature vector based on the PSSM
by running PSI-Blast and auto cross covariance tranformation.
}
\examples{
x = readFASTA(system.file('protseq/P00750.fasta', package = 'Rcpi'))[[1]]
\donttest{
dbpath = tempfile('tempdb', fileext = '.fasta')
invisible(file.copy(from = system.file('protseq/Plasminogen.fasta', package = 'Rcpi'), to = dbpath))
pssmmat = extractProtPSSM(seq = x, database.path = dbpath)
pssmacc = extractProtPSSMAcc(pssmmat, lag = 3)
tail(pssmacc)}
}
\references{
Wold, S., Jonsson, J., Sjörström, M., Sandberg, M., & Rännar, S. (1993).
DNA and peptide sequences and chemical processes multivariately modelled
by principal component analysis and partial least-squares projections
to latent structures.
\emph{Analytica chimica acta}, 277(2), 239--253.
}
\seealso{
\link{extractProtPSSM} \link{extractProtPSSMFeature}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/307-extractDrugAtomCount.R
\name{extractDrugAtomCount}
\alias{extractDrugAtomCount}
\title{Calculate the Number of Atom Descriptor}
\usage{
extractDrugAtomCount(molecules, silent = TRUE)
}
\arguments{
\item{molecules}{Parsed molucule object.}

\item{silent}{Logical. Whether the calculating process
should be shown or not, default is \code{TRUE}.}
}
\value{
A data frame, each row represents one of the molecules,
each column represents one feature.
This function returns one column named \code{nAtom}.
}
\description{
Calculate the Number of Atom Descriptor
}
\details{
Calculates the number of atoms of a certain element type in a molecule.
By default it returns the count of all atoms.
}
\examples{
smi = system.file('vignettedata/FDAMDD.smi', package = 'Rcpi')
\donttest{
mol = readMolFromSmi(smi, type = 'mol')
dat = extractDrugAtomCount(mol)
head(dat)}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/322-extractDrugFMF.R
\name{extractDrugFMF}
\alias{extractDrugFMF}
\title{Calculate the FMF Descriptor}
\usage{
extractDrugFMF(molecules, silent = TRUE)
}
\arguments{
\item{molecules}{Parsed molucule object.}

\item{silent}{Logical. Whether the calculating process
should be shown or not, default is \code{TRUE}.}
}
\value{
A data frame, each row represents one of the molecules,
each column represents one feature.
This function returns one column named \code{FMF}.
}
\description{
Calculate the FMF Descriptor
}
\details{
Calculates the FMF descriptor characterizing molecular complexity
in terms of its Murcko framework. This descriptor is the ratio of
heavy atoms in the framework to the total number of heavy atoms
in the molecule. By definition, acyclic molecules which have no frameworks,
will have a value of 0. Note that the authors consider an isolated ring
system to be a framework (even though there is no linker).
}
\examples{
smi = system.file('vignettedata/FDAMDD.smi', package = 'Rcpi')
\donttest{
mol = readMolFromSmi(smi, type = 'mol')
dat = extractDrugFMF(mol)
head(dat)}
}
\references{
Yang, Y., Chen, H., Nilsson, I., Muresan, S., & Engkvist, O. (2010).
Investigation of the relationship between topology and selectivity
for druglike molecules. Journal of medicinal chemistry,
53(21), 7709-7714.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Rcpi-datalist.R
\docType{data}
\name{AABLOSUM62}
\alias{AABLOSUM62}
\title{BLOSUM62 Matrix for 20 Amino Acids}
\value{
AABLOSUM62 data
}
\description{
BLOSUM62 Matrix for 20 Amino Acids
}
\details{
BLOSUM62 Matrix for the 20 amino acids. The matrix was extracted from the
\code{Biostrings} package of Bioconductor.
}
\examples{
data(AABLOSUM62)

}
\keyword{AABLOSUM62}
\keyword{BLOSUM}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/300-extractDrugAIO.R
\name{extractDrugAIO}
\alias{extractDrugAIO}
\title{Calculate All Molecular Descriptors in Rcpi at Once}
\usage{
extractDrugAIO(molecules, silent = TRUE, warn = TRUE)
}
\arguments{
\item{molecules}{Parsed molucule object.}

\item{silent}{Logical. Whether the calculating process should be
shown or not, default is \code{TRUE}.}

\item{warn}{Logical. Whether the warning about some descriptors
need the 3D coordinates should be shown or not after the calculation,
default is \code{TRUE}.}
}
\value{
A data frame, each row represents one of the molecules,
each column represents one descriptor.
Currently, this function returns total 293 descriptors
composed of 48 descriptor types.
}
\description{
Calculate All Molecular Descriptors in Rcpi at Once
}
\details{
This function calculates all the molecular descriptors
in the Rcpi package at once.
}
\note{
Note that we need 3-D coordinates of the molecules to calculate
some of the descriptors, if not provided, these descriptors
values will be \code{NA}.
}
\examples{
# Load 20 small molecules that have 3D coordinates
sdf = system.file('sysdata/OptAA3d.sdf', package = 'Rcpi')
\donttest{
mol = readMolFromSDF(sdf)
dat = extractDrugAIO(mol, warn = FALSE)}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/344-extractDrugVAdjMa.R
\name{extractDrugVAdjMa}
\alias{extractDrugVAdjMa}
\title{Descriptor that Calculates the Vertex Adjacency Information of A Molecule}
\usage{
extractDrugVAdjMa(molecules, silent = TRUE)
}
\arguments{
\item{molecules}{Parsed molucule object.}

\item{silent}{Logical. Whether the calculating process
should be shown or not, default is \code{TRUE}.}
}
\value{
A data frame, each row represents one of the molecules,
each column represents one feature.
This function returns one column named \code{VAdjMat}.
}
\description{
Descriptor that Calculates the Vertex Adjacency Information of A Molecule
}
\details{
Vertex adjacency information (magnitude):
\eqn{1 + \log_2^m} where \eqn{m} is the number of heavy-heavy bonds.
If \eqn{m} is zero, then \code{0} is returned.
}
\examples{
smi = system.file('vignettedata/FDAMDD.smi', package = 'Rcpi')
\donttest{
mol = readMolFromSmi(smi, type = 'mol')
dat = extractDrugVAdjMa(mol)
head(dat)}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/404-extractProtMoreauBroto.R
\name{extractProtMoreauBroto}
\alias{extractProtMoreauBroto}
\title{Normalized Moreau-Broto Autocorrelation Descriptor}
\usage{
extractProtMoreauBroto(
  x,
  props = c("CIDH920105", "BHAR880101", "CHAM820101", "CHAM820102", "CHOC760101",
    "BIGC670101", "CHAM810101", "DAYM780201"),
  nlag = 30L,
  customprops = NULL
)
}
\arguments{
\item{x}{A character vector, as the input protein sequence.}

\item{props}{A character vector, specifying the Accession Number
of the target properties.
8 properties are used by default, as listed below:
\describe{
\item{AccNo. CIDH920105}{Normalized average hydrophobicity scales (Cid et al., 1992)}
\item{AccNo. BHAR880101}{Average flexibility indices (Bhaskaran-Ponnuswamy, 1988)}
\item{AccNo. CHAM820101}{Polarizability parameter (Charton-Charton, 1982)}
\item{AccNo. CHAM820102}{Free energy of solution in water, kcal/mole (Charton-Charton, 1982)}
\item{AccNo. CHOC760101}{Residue accessible surface area in tripeptide (Chothia, 1976)}
\item{AccNo. BIGC670101}{Residue volume (Bigelow, 1967)}
\item{AccNo. CHAM810101}{Steric parameter (Charton, 1981)}
\item{AccNo. DAYM780201}{Relative mutability (Dayhoff et al., 1978b)}}}

\item{nlag}{Maximum value of the lag parameter. Default is \code{30}.}

\item{customprops}{A \code{n x 21} named data frame contains \code{n}
customize property. Each row contains one property.
The column order for different amino acid types is
\code{'AccNo'}, \code{'A'}, \code{'R'}, \code{'N'},
\code{'D'}, \code{'C'}, \code{'E'}, \code{'Q'},
\code{'G'}, \code{'H'}, \code{'I'}, \code{'L'},
\code{'K'}, \code{'M'}, \code{'F'}, \code{'P'},
\code{'S'}, \code{'T'}, \code{'W'}, \code{'Y'},
\code{'V'}, and the columns should also be \emph{exactly}
named like this.
The \code{AccNo} column contains the properties' names.
Then users should explicitly specify these properties
with these names in the argument \code{props}.
See the examples below for a demonstration.
The default value for \code{customprops} is \code{NULL}.}
}
\value{
A length \code{nlag} named vector
}
\description{
Normalized Moreau-Broto Autocorrelation Descriptor
}
\details{
This function calculates the normalized Moreau-Broto
autocorrelation descriptor (Dim: \code{length(props) * nlag}).
}
\examples{
x = readFASTA(system.file('protseq/P00750.fasta', package = 'Rcpi'))[[1]]
extractProtMoreauBroto(x)

myprops = data.frame(AccNo = c("MyProp1", "MyProp2", "MyProp3"),
                     A = c(0.62,  -0.5, 15),  R = c(-2.53,   3, 101),
                     N = c(-0.78,  0.2, 58),  D = c(-0.9,    3, 59),
                     C = c(0.29,    -1, 47),  E = c(-0.74,   3, 73),
                     Q = c(-0.85,  0.2, 72),  G = c(0.48,    0, 1),
                     H = c(-0.4,  -0.5, 82),  I = c(1.38, -1.8, 57),
                     L = c(1.06,  -1.8, 57),  K = c(-1.5,    3, 73),
                     M = c(0.64,  -1.3, 75),  F = c(1.19, -2.5, 91),
                     P = c(0.12,     0, 42),  S = c(-0.18, 0.3, 31),
                     T = c(-0.05, -0.4, 45),  W = c(0.81, -3.4, 130),
                     Y = c(0.26,  -2.3, 107), V = c(1.08, -1.5, 43))

# Use 4 properties in the AAindex database, and 3 cutomized properties
extractProtMoreauBroto(x, customprops = myprops,
                       props = c('CIDH920105', 'BHAR880101',
                                 'CHAM820101', 'CHAM820102',
                                 'MyProp1', 'MyProp2', 'MyProp3'))

}
\references{
AAindex: Amino acid index database.
\url{https://www.genome.jp/dbget/aaindex.html}

Feng, Z.P. and Zhang, C.T. (2000)
Prediction of membrane protein types based on the hydrophobic
index of amino acids.
\emph{Journal of Protein Chemistry}, 19, 269-275.

Horne, D.S. (1988)
Prediction of protein helix content from
an autocorrelation analysis of sequence hydrophobicities.
\emph{Biopolymers}, 27, 451-477.

Sokal, R.R. and Thomson, B.A. (2006)
Population structure inferred by local spatial autocorrelation:
an usage from an Amerindian tribal population.
\emph{American Journal of Physical Anthropology}, 129, 121-131.
}
\seealso{
See \code{\link{extractProtMoran}} and \code{\link{extractProtGeary}}
         for Moran autocorrelation descriptors and
         Geary autocorrelation descriptors.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/329-extractDrugKappaShapeIndices.R
\name{extractDrugKappaShapeIndices}
\alias{extractDrugKappaShapeIndices}
\title{Descriptor that Calculates Kier and Hall Kappa Molecular Shape Indices}
\usage{
extractDrugKappaShapeIndices(molecules, silent = TRUE)
}
\arguments{
\item{molecules}{Parsed molucule object.}

\item{silent}{Logical. Whether the calculating process
should be shown or not, default is \code{TRUE}.}
}
\value{
A data frame, each row represents one of the molecules,
each column represents one feature.
This function returns 3 columns named
\code{Kier1}, \code{Kier2} and \code{Kier3}:
\itemize{
\item \code{Kier1} - First kappa shape index
\item \code{Kier2} - Second kappa shape index
\item \code{Kier3} - Third kappa shape index
}
}
\description{
Descriptor that Calculates Kier and Hall Kappa Molecular Shape Indices
}
\details{
Kier and Hall Kappa molecular shape indices compare the molecular graph
with minimal and maximal molecular graphs;
see \url{https://bit.ly/3ramdBy} for details:
"they are intended to capture different aspects of molecular shape.
Note that hydrogens are ignored. In the following description,
n denotes the number of atoms in the hydrogen suppressed graph,
m is the number of bonds in the hydrogen suppressed graph.
Also, let p2 denote the number of paths of length 2
and let p3 denote the number of paths of length 3".
}
\examples{
smi = system.file('vignettedata/FDAMDD.smi', package = 'Rcpi')
\donttest{
mol = readMolFromSmi(smi, type = 'mol')
dat = extractDrugKappaShapeIndices(mol)
head(dat)}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Rcpi-datalist.R
\docType{data}
\name{AAPAM120}
\alias{AAPAM120}
\title{PAM120 Matrix for 20 Amino Acids}
\value{
AAPAM120 data
}
\description{
PAM120 Matrix for 20 Amino Acids
}
\details{
PAM120 Matrix for the 20 amino acids. The matrix was extracted from the
\code{Biostrings} package of Bioconductor.
}
\examples{
data(AAPAM120)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/420-extractPCMBLOSUM.R
\name{extractPCMBLOSUM}
\alias{extractPCMBLOSUM}
\title{Generalized BLOSUM and PAM Matrix-Derived Descriptors}
\usage{
extractPCMBLOSUM(x, submat = "AABLOSUM62", k, lag, scale = TRUE, silent = TRUE)
}
\arguments{
\item{x}{A character vector, as the input protein sequence.}

\item{submat}{Substitution matrix for the 20 amino acids. Should be one of
\code{AABLOSUM45}, \code{AABLOSUM50}, \code{AABLOSUM62},
\code{AABLOSUM80}, \code{AABLOSUM100}, \code{AAPAM30},
\code{AAPAM40}, \code{AAPAM70}, \code{AAPAM120}, \code{AAPAM250}.
Default is \code{'AABLOSUM62'}.}

\item{k}{Integer. The number of selected scales (i.e. the first
\code{k} scales) derived by the substitution matrix.
This could be selected according to the printed relative
importance values.}

\item{lag}{The lag parameter. Must be less than the amino acids.}

\item{scale}{Logical. Should we auto-scale the substitution matrix
(\code{submat}) before doing eigen decomposition? Default is
\code{TRUE}.}

\item{silent}{Logical. Whether we print the relative importance of
each scales (diagnal value of the eigen decomposition result matrix B)
or not.
Default is \code{TRUE}.}
}
\value{
A length \code{lag * p^2} named vector,
        \code{p} is the number of scales selected.
}
\description{
Generalized BLOSUM and PAM Matrix-Derived Descriptors
}
\details{
This function calculates the generalized BLOSUM matrix-derived descriptors.
For users' convenience, \code{Rcpi} provides the
BLOSUM45, BLOSUM50, BLOSUM62, BLOSUM80, BLOSUM100,
PAM30, PAM40, PAM70, PAM120, and PAM250 matrices
for the 20 amino acids to select.
}
\examples{
x = readFASTA(system.file('protseq/P00750.fasta', package = 'Rcpi'))[[1]]
blosum = extractPCMBLOSUM(x, submat = 'AABLOSUM62', k = 5, lag = 7, scale = TRUE, silent = FALSE)

}
\references{
Georgiev, A. G. (2009).
Interpretable numerical descriptors of amino acid space.
Journal of Computational Biology, 16(5), 703--723.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/204-getProt.R
\name{getProt}
\alias{getProt}
\title{Retrieve Protein Sequence in various Formats from Databases}
\usage{
getProt(
  id,
  from = c("uniprot", "kegg", "pdb"),
  type = c("fasta", "pdb", "aaseq"),
  parallel = 5
)
}
\arguments{
\item{id}{A character vector, as the protein ID(s).}

\item{from}{The database, one of \code{'uniprot'}, \code{'kegg'},
or \code{'pdb'}.}

\item{type}{The returned protein format, one of \code{fasta}, \code{pdb},
or \code{aaseq}.}

\item{parallel}{An integer, the parallel parameter, indicates how many
process the user would like to use for retrieving
the data (using RCurl), default is \code{5}.
For regular cases, we recommend a number less than \code{20}.}
}
\value{
A length of \code{id} character list, each element
containing the corresponding protein sequence(s) or file(s).
}
\description{
Retrieve Protein Sequence in various Formats from Databases
}
\details{
This function retrieves protein sequence in various formats from
three databases.
}
\examples{
id = c('P00750', 'P00751', 'P00752')
\donttest{
getProt(id, from = 'uniprot', type = 'aaseq')}
}
\seealso{
See \code{\link{getDrug}} for retrieving drug molecules
from five databases.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Rcpi-datalist.R
\docType{data}
\name{OptAA3d}
\alias{OptAA3d}
\title{OptAA3d.sdf - 20 Amino Acids Optimized with MOE 2011.10 (Semiempirical AM1)}
\value{
OptAA3d data
}
\description{
OptAA3d.sdf - 20 Amino Acids Optimized with MOE 2011.10 (Semiempirical AM1)
}
\details{
OptAA3d.sdf - 20 Amino Acids Optimized with MOE 2011.10 (Semiempirical AM1)
}
\examples{
# This example requires the rcdk package
# library('rcdk')
# optaa3d = load.molecules(system.file('sysdata/OptAA3d.sdf', package = 'Rcpi'))
# view.molecule.2d(optaa3d[[1]])  # view the first amino acid
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Rcpi-datalist.R
\docType{data}
\name{AAMetaInfo}
\alias{AAMetaInfo}
\title{Meta Information for the 20 Amino Acids}
\value{
AAMetaInfo data
}
\description{
Meta Information for the 20 Amino Acids
}
\details{
This dataset includes the meta information of
the 20 amino acids used for the 2D and 3D descriptor
calculation in this package. Each column represents:
\describe{
  \item{\code{AAName}}{Amino acid name}
  \item{\code{Short}}{One-letter representation}
  \item{\code{Abbreviation}}{Three-letter representation}
  \item{\code{mol}}{SMILES representation}
  \item{\code{PUBCHEM_COMPOUND_CID}}{PubChem CID for the amino acid}
  \item{\code{PUBCHEM_LINK}}{PubChem link for the amino acid}
}
}
\examples{
data(AAMetaInfo)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/507-segProt.R
\name{segProt}
\alias{segProt}
\title{Protein Sequence Segmentation}
\usage{
segProt(
  x,
  aa = c("A", "R", "N", "D", "C", "E", "Q", "G", "H", "I", "L", "K", "M", "F", "P", "S",
    "T", "W", "Y", "V"),
  k = 7
)
}
\arguments{
\item{x}{A character vector, as the input protein sequence.}

\item{aa}{A character, the amino acid type. one of
\code{'A'}, \code{'R'}, \code{'N'}, \code{'D'}, \code{'C'},
\code{'E'}, \code{'Q'}, \code{'G'}, \code{'H'},
\code{'I'}, \code{'L'}, \code{'K'}, \code{'M'},
\code{'F'}, \code{'P'}, \code{'S'}, \code{'T'},
\code{'W'}, \code{'Y'}, \code{'V'}.}

\item{k}{A positive integer, specifys the window size (half of the window),
default is 7.}
}
\value{
A named list, each component contains one of the
        segmentations (a character string), names of the list components
        are the positions of the specified amino acid in the sequence.
}
\description{
Protein Sequence Segmentation
}
\details{
This function extracts the segmentations from the protein sequence.
}
\examples{
x = readFASTA(system.file('protseq/P00750.fasta', package = 'Rcpi'))[[1]]
segProt(x, aa = 'R', k = 5)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/505-convMolFormat.R
\name{convMolFormat}
\alias{convMolFormat}
\title{Chemical File Formats Conversion}
\usage{
convMolFormat(infile, outfile, from, to)
}
\arguments{
\item{infile}{A character string. Indicating the input file location.}

\item{outfile}{A character string. Indicating the output file location.}

\item{from}{The format of \code{infile}.
A character string supported by OpenBabel.
See the note section for the supported formats.}

\item{to}{The desired format of \code{outfile}.
A character string supported by OpenBabel.
See the note section for the supported formats.}
}
\value{
\code{NULL}
}
\description{
Chemical File Formats Conversion
}
\details{
This function converts between various chemical file formats via OpenBabel.
The complete supported file format list could be found at
\url{https://openbabel.org/docs/FileFormats/Overview.html}.
}
\note{
The supported formats include:
            \itemize{
            \item abinit -- ABINIT Output Format [Read-only]
            \item acr -- ACR format [Read-only]
            \item adf -- ADF cartesian input format [Write-only]
            \item adfout -- ADF output format [Read-only]
            \item alc -- Alchemy format
            \item arc -- Accelrys/MSI Biosym/Insight II CAR format [Read-only]
            \item axsf -- XCrySDen Structure Format [Read-only]
            \item bgf -- MSI BGF format
            \item box -- Dock 3.5 Box format
            \item bs -- Ball and Stick format
            \item c3d1 -- Chem3D Cartesian 1 format
            \item c3d2 -- Chem3D Cartesian 2 format
            \item cac -- CAChe MolStruct format [Write-only]
            \item caccrt -- Cacao Cartesian format
            \item cache -- CAChe MolStruct format [Write-only]
            \item cacint -- Cacao Internal format [Write-only]
            \item can -- Canonical SMILES format
            \item car -- Accelrys/MSI Biosym/Insight II CAR format [Read-only]
            \item castep -- CASTEP format [Read-only]
            \item ccc -- CCC format [Read-only]
            \item cdx -- ChemDraw binary format [Read-only]
            \item cdxml -- ChemDraw CDXML format
            \item cht -- Chemtool format [Write-only]
            \item cif -- Crystallographic Information File
            \item ck -- ChemKin format
            \item cml -- Chemical Markup Language
            \item cmlr -- CML Reaction format
            \item com -- Gaussian 98/03 Input [Write-only]
            \item CONFIG -- DL-POLY CONFIG
            \item CONTCAR -- VASP format [Read-only]
            \item copy -- Copy raw text [Write-only]
            \item crk2d -- Chemical Resource Kit diagram(2D)
            \item crk3d -- Chemical Resource Kit 3D format
            \item csr -- Accelrys/MSI Quanta CSR format [Write-only]
            \item cssr -- CSD CSSR format [Write-only]
            \item ct -- ChemDraw Connection Table format
            \item cub -- Gaussian cube format
            \item cube -- Gaussian cube format
            \item dat -- Generic Output file format [Read-only]
            \item dmol -- DMol3 coordinates format
            \item dx -- OpenDX cube format for APBS
            \item ent -- Protein Data Bank format
            \item fa -- FASTA format
            \item fasta -- FASTA format
            \item fch -- Gaussian formatted checkpoint file format [Read-only]
            \item fchk -- Gaussian formatted checkpoint file format [Read-only]
            \item fck -- Gaussian formatted checkpoint file format [Read-only]
            \item feat -- Feature format
            \item fh -- Fenske-Hall Z-Matrix format [Write-only]
            \item fhiaims -- FHIaims XYZ format
            \item fix -- SMILES FIX format [Write-only]
            \item fpt -- Fingerprint format [Write-only]
            \item fract -- Free Form Fractional format
            \item fs -- Fastsearch format
            \item fsa -- FASTA format
            \item g03 -- Gaussian Output [Read-only]
            \item g09 -- Gaussian Output [Read-only]
            \item g92 -- Gaussian Output [Read-only]
            \item g94 -- Gaussian Output [Read-only]
            \item g98 -- Gaussian Output [Read-only]
            \item gal -- Gaussian Output [Read-only]
            \item gam -- GAMESS Output [Read-only]
            \item gamess -- GAMESS Output [Read-only]
            \item gamin -- GAMESS Input
            \item gamout -- GAMESS Output [Read-only]
            \item gau -- Gaussian 98/03 Input [Write-only]
            \item gjc -- Gaussian 98/03 Input [Write-only]
            \item gjf -- Gaussian 98/03 Input [Write-only]
            \item got -- GULP format [Read-only]
            \item gpr -- Ghemical format
            \item gr96 -- GROMOS96 format [Write-only]
            \item gro -- GRO format
            \item gukin -- GAMESS-UK Input
            \item gukout -- GAMESS-UK Output
            \item gzmat -- Gaussian Z-Matrix Input
            \item hin -- HyperChem HIN format
            \item HISTORY -- DL-POLY HISTORY [Read-only]
            \item inchi -- InChI format
            \item inchikey -- InChIKey [Write-only]
            \item inp -- GAMESS Input
            \item ins -- ShelX format [Read-only]
            \item jin -- Jaguar input format [Write-only]
            \item jout -- Jaguar output format [Read-only]
            \item k -- Compare molecules using InChI [Write-only]
            \item log -- Generic Output file format [Read-only]
            \item mcdl -- MCDL format
            \item mcif -- Macromolecular Crystallographic Info
            \item mdl -- MDL MOL format
            \item ml2 -- Sybyl Mol2 format
            \item mmcif -- Macromolecular Crystallographic Info
            \item mmd -- MacroModel format
            \item mmod -- MacroModel format
            \item mna -- Multilevel Neighborhoods of Atoms (MNA) [Write-only]
            \item mol -- MDL MOL format
            \item mol2 -- Sybyl Mol2 format
            \item mold -- Molden format
            \item molden -- Molden format
            \item molf -- Molden format
            \item molreport -- Open Babel molecule report [Write-only]
            \item moo -- MOPAC Output format [Read-only]
            \item mop -- MOPAC Cartesian format
            \item mopcrt -- MOPAC Cartesian format
            \item mopin -- MOPAC Internal
            \item mopout -- MOPAC Output format [Read-only]
            \item mp -- Molpro input format [Write-only]
            \item mpc -- MOPAC Cartesian format
            \item mpd -- MolPrint2D format [Write-only]
            \item mpo -- Molpro output format [Read-only]
            \item mpqc -- MPQC output format [Read-only]
            \item mpqcin -- MPQC simplified input format [Write-only]
            \item mrv -- Chemical Markup Language
            \item msi -- Accelrys/MSI Cerius II MSI format [Read-only]
            \item msms -- M.F. Sanner's MSMS input format [Write-only]
            \item nul -- Outputs nothing [Write-only]
            \item nw -- NWChem input format [Write-only]
            \item nwo -- NWChem output format [Read-only]
            \item out -- Generic Output file format [Read-only]
            \item outmol -- DMol3 coordinates format
            \item output -- Generic Output file format [Read-only]
            \item pc -- PubChem format [Read-only]
            \item pcm -- PCModel Format
            \item pdb -- Protein Data Bank format
            \item pdbqt -- AutoDock PDQBT format
            \item png -- PNG 2D depiction
            \item POSCAR -- VASP format [Read-only]
            \item pov -- POV-Ray input format [Write-only]
            \item pqr -- PQR format
            \item pqs -- Parallel Quantum Solutions format
            \item prep -- Amber Prep format [Read-only]
            \item pwscf -- PWscf format [Read-only]
            \item qcin -- Q-Chem input format [Write-only]
            \item qcout -- Q-Chem output format [Read-only]
            \item report -- Open Babel report format [Write-only]
            \item res -- ShelX format [Read-only]
            \item rsmi -- Reaction SMILES format
            \item rxn -- MDL RXN format
            \item sd -- MDL MOL format
            \item sdf -- MDL MOL format
            \item smi -- SMILES format
            \item smiles -- SMILES format
            \item svg -- SVG 2D depiction [Write-only]
            \item sy2 -- Sybyl Mol2 format
            \item t41 -- ADF TAPE41 format [Read-only]
            \item tdd -- Thermo format
            \item text -- Read and write raw text
            \item therm -- Thermo format
            \item tmol -- TurboMole Coordinate format
            \item txt -- Title format
            \item txyz -- Tinker XYZ format
            \item unixyz -- UniChem XYZ format
            \item vmol -- ViewMol format
            \item xed -- XED format [Write-only]
            \item xml -- General XML format [Read-only]
            \item xsf -- XCrySDen Structure Format [Read-only]
            \item xyz -- XYZ cartesian coordinates format
            \item yob -- YASARA.org YOB format
            \item zin -- ZINDO input format [Write-only]
            }
}
\examples{
sdf = system.file('sysdata/OptAA3d.sdf', package = 'Rcpi')
# SDF to SMILES
\dontrun{
convMolFormat(infile = sdf, outfile = 'aa.smi',
              from = 'sdf', to = 'smiles')}
# SMILES to MOPAC Cartesian format
\dontrun{
convMolFormat(infile = 'aa.smi', outfile = 'aa.mop',
              from = 'smiles', to = 'mop')}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/315-extractDrugCPSA.R
\name{extractDrugCPSA}
\alias{extractDrugCPSA}
\title{A Variety of Descriptors Combining Surface Area and Partial Charge Information}
\usage{
extractDrugCPSA(molecules, silent = TRUE)
}
\arguments{
\item{molecules}{Parsed molucule object.}

\item{silent}{Logical. Whether the calculating process
should be shown or not, default is \code{TRUE}.}
}
\value{
A data frame, each row represents one of the molecules,
each column represents one feature. This function returns 29 columns:
\itemize{
\item \code{PPSA.1} - partial positive surface area --
sum of surface area on positive parts of molecule
\item \code{PPSA.2} - partial positive surface area *
total positive charge on the molecule
\item \code{PPSA.3} - charge weighted partial positive surface area
\item \code{PNSA.1} - partial negative surface area --
sum of surface area on negative parts of molecule
\item \code{PNSA.2} - partial negative surface area *
total negative charge on the molecule
\item \code{PNSA.3} - charge weighted partial negative surface area
\item \code{DPSA.1} - difference of PPSA.1 and PNSA.1
\item \code{DPSA.2} - difference of FPSA.2 and PNSA.2
\item \code{DPSA.3} - difference of PPSA.3 and PNSA.3
\item \code{FPSA.1} - PPSA.1 / total molecular surface area
\item \code{FFSA.2} - PPSA.2 / total molecular surface area
\item \code{FPSA.3} - PPSA.3 / total molecular surface area
\item \code{FNSA.1} - PNSA.1 / total molecular surface area
\item \code{FNSA.2} - PNSA.2 / total molecular surface area
\item \code{FNSA.3} - PNSA.3 / total molecular surface area
\item \code{WPSA.1} - PPSA.1 * total molecular surface area / 1000
\item \code{WPSA.2} - PPSA.2 * total molecular surface area /1000
\item \code{WPSA.3} - PPSA.3 * total molecular surface area / 1000
\item \code{WNSA.1} - PNSA.1 * total molecular surface area /1000
\item \code{WNSA.2} - PNSA.2 * total molecular surface area / 1000
\item \code{WNSA.3} - PNSA.3 * total molecular surface area / 1000
\item \code{RPCG} - relative positive charge --
most positive charge / total positive charge
\item \code{RNCG} - relative negative charge --
most negative charge / total negative charge
\item \code{RPCS} - relative positive charge surface area --
most positive surface area * RPCG
\item \code{RNCS} - relative negative charge surface area --
most negative surface area * RNCG
\item \code{THSA} - sum of solvent accessible surface areas of
atoms with absolute value of partial charges less than 0.2
\item \code{TPSA} - sum of solvent accessible surface areas of
atoms with absolute value of partial charges greater than or equal 0.2
\item \code{RHSA} - THSA / total molecular surface area
\item \code{RPSA} - TPSA / total molecular surface area
}
}
\description{
A Variety of Descriptors Combining Surface Area and Partial Charge Information
}
\details{
Calculates 29 Charged Partial Surface Area (CPSA) descriptors.
The CPSA's were developed by Stanton et al.
}
\examples{
sdf = system.file('sysdata/OptAA3d.sdf', package = 'Rcpi')
\donttest{
mol = readMolFromSDF(sdf)
dat = extractDrugCPSA(mol)
head(dat)}
}
\references{
Stanton, D.T. and Jurs, P.C. ,
Development and Use of Charged Partial Surface
Area Structural Descriptors in Computer Assissted
Quantitative Structure Property Relationship Studies,
Analytical Chemistry, 1990, 62:2323.2329.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/703-calcProtGOSim.R
\name{calcTwoProtGOSim}
\alias{calcTwoProtGOSim}
\title{Protein Similarity Calculation based on Gene Ontology (GO) Similarity}
\usage{
calcTwoProtGOSim(
  id1,
  id2,
  type = c("go", "gene"),
  ont = c("MF", "BP", "CC"),
  organism = "human",
  measure = "Resnik",
  combine = "BMA"
)
}
\arguments{
\item{id1}{A character vector. length > 1: each element is a GO term;
length = 1: the Entrez Gene ID.}

\item{id2}{A character vector. length > 1: each element is a GO term;
length = 1: the Entrez Gene ID.}

\item{type}{Input type of id1 and id2, \code{'go'} for GO Terms,
\code{'gene'} for gene ID.}

\item{ont}{Default is \code{'MF'}, could be one of
\code{'MF'}, \code{'BP'}, or \code{'CC'} subontologies.}

\item{organism}{Default is \code{'human'}, could be one of
\code{'anopheles'}, \code{'arabidopsis'}, \code{'bovine'}, \code{'canine'},
\code{'chicken'}, \code{'chimp'}, \code{'coelicolor'}, \code{'ecolik12'},
\code{'ecsakai'}, \code{'fly'}, \code{'human'}, \code{'malaria'},
\code{'mouse'}, \code{'pig'}, \code{'rat'}, \code{'rhesus'},
\code{'worm'}, \code{'xenopus'}, \code{'yeast'} or \code{'zebrafish'}.}

\item{measure}{Default is \code{'Resnik'}, could be one of
\code{'Resnik'}, \code{'Lin'}, \code{'Rel'}, \code{'Jiang'} or \code{'Wang'}.}

\item{combine}{Default is \code{'BMA'}, could be one of
\code{'max'}, \code{'average'}, \code{'rcmax'} or \code{'BMA'}
for combining semantic similarity scores of multiple GO terms
associated with protein.}
}
\value{
A n x n matrix.
}
\description{
Protein Similarity Calculation based on Gene Ontology (GO) Similarity
}
\details{
This function calculates the Gene Ontology (GO) similarity
between two groups of GO terms or two Entrez gene IDs.
}
\examples{
# By GO terms
go1 = c("GO:0004022", "GO:0004024", "GO:0004023")
go2 = c("GO:0009055", "GO:0020037")
\donttest{calcTwoProtGOSim(go1, go2, type = 'go', ont = 'MF', measure = 'Wang')}

# By Entrez gene id
gene1 = '241'
gene2 = '251'
\donttest{calcTwoProtGOSim(gene1, gene2, type = 'gene', ont = 'CC', measure = 'Lin')}
}
\seealso{
See \code{\link{calcParProtGOSim}} for
protein similarity calculation based on
Gene Ontology (GO) semantic similarity.
See \code{\link{calcParProtSeqSim}} for paralleled protein similarity
calculation based on sequence alignment.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/201-getProtUniProt.R
\name{getFASTAFromUniProt}
\alias{getFASTAFromUniProt}
\title{Retrieve Protein Sequence in FASTA Format from the UniProt Database}
\usage{
getFASTAFromUniProt(id, parallel = 5)
}
\arguments{
\item{id}{A character vector, as the protein ID.}

\item{parallel}{An integer, the parallel parameter, indicates how many
process the user would like to use for retrieving
the data (using RCurl), default is \code{5}.
For regular cases, we recommend a number less than \code{20}.}
}
\value{
A list, each component contains one of the protein sequences
in FASTA format.
}
\description{
Retrieve Protein Sequence in FASTA Format from the UniProt Database
}
\details{
This function retrieves protein sequences in FASTA format
from the UniProt database.
}
\examples{
id = c('P00750', 'P00751', 'P00752')
\donttest{
getFASTAFromUniProt(id)}
}
\references{
UniProt. \url{https://www.uniprot.org/}

UniProt REST API Documentation. \url{https://www.uniprot.org/help/api}
}
\seealso{
See \code{\link{getSeqFromUniProt}} for retrieving protein
represented by amino acid sequence from the UniProt database.
See \code{\link{readFASTA}} for reading FASTA format files.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/378-extractDrugKR.R
\name{extractDrugKR}
\alias{extractDrugKR}
\title{Calculate the KR (Klekota and Roth) Molecular Fingerprints (in Compact Format)}
\usage{
extractDrugKR(molecules, silent = TRUE)
}
\arguments{
\item{molecules}{Parsed molucule object.}

\item{silent}{Logical. Whether the calculating process
should be shown or not, default is \code{TRUE}.}
}
\value{
A list, each component represents one of the molecules, each element
in the component represents the index of which element in the fingerprint is 1.
Each component's name is the length of the fingerprints.
}
\description{
Calculate the KR (Klekota and Roth) Molecular Fingerprints (in Compact Format)
}
\details{
Calculate the 4860 bit fingerprint defined by Klekota and Roth.
}
\examples{
smi = system.file('vignettedata/FDAMDD.smi', package = 'Rcpi')
\donttest{
mol = readMolFromSmi(smi, type = 'mol')
fp  = extractDrugKR(mol)
head(fp)}
}
\seealso{
\link{extractDrugKRComplete}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/337-extractDrugMomentOfInertia.R
\name{extractDrugMomentOfInertia}
\alias{extractDrugMomentOfInertia}
\title{Descriptor that Calculates the Principal Moments of
Inertia and Ratios of the Principal Moments}
\usage{
extractDrugMomentOfInertia(molecules, silent = TRUE)
}
\arguments{
\item{molecules}{Parsed molucule object.}

\item{silent}{Logical. Whether the calculating process
should be shown or not, default is \code{TRUE}.}
}
\value{
A data frame, each row represents one of the molecules,
each column represents one feature.
This function returns 7 columns named
\code{MOMI.X}, \code{MOMI.Y}, \code{MOMI.Z},
\code{MOMI.XY}, \code{MOMI.XZ}, \code{MOMI.YZ}, \code{MOMI.R}:
\itemize{
\item \code{MOMI.X} - MI along X axis
\item \code{MOMI.Y} - MI along Y axis
\item \code{MOMI.Z} - MI along Z axis
\item \code{MOMI.XY} - X/Y
\item \code{MOMI.XZ} - X/Z
\item \code{MOMI.YZ} - Y/Z
\item \code{MOMI.R} - Radius of gyration
}
One important aspect of the algorithm is that if the eigenvalues
of the MI tensor are below \code{1e-3},
then the ratio's are set to a default of 1000.
}
\description{
Descriptor that Calculates the Principal Moments of
Inertia and Ratios of the Principal Moments
}
\details{
A descriptor that calculates the moment of inertia and radius of gyration.
Moment of inertia (MI) values characterize the mass distribution of a molecule.
Related to the MI values, ratios of the MI values along the three principal
axes are also well know modeling variables.
This descriptor calculates the MI values along the
X, Y and Z axes as well as the ratio's X/Y, X/Z and Y/Z.
Finally it also calculates the radius of
gyration of the molecule.
}
\examples{
sdf = system.file('sysdata/OptAA3d.sdf', package = 'Rcpi')
\donttest{
mol = readMolFromSDF(sdf)
dat = extractDrugMomentOfInertia(mol)
head(dat)}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/336-extractDrugMannholdLogP.R
\name{extractDrugMannholdLogP}
\alias{extractDrugMannholdLogP}
\title{Descriptor that Calculates the LogP Based on a Simple Equation
Using the Number of Carbons and Hetero Atoms}
\usage{
extractDrugMannholdLogP(molecules, silent = TRUE)
}
\arguments{
\item{molecules}{Parsed molucule object.}

\item{silent}{Logical. Whether the calculating process
should be shown or not, default is \code{TRUE}.}
}
\value{
A data frame, each row represents one of the molecules,
each column represents one feature.
This function returns one column named \code{MLogP}.
}
\description{
Descriptor that Calculates the LogP Based on a Simple Equation
Using the Number of Carbons and Hetero Atoms
}
\details{
This descriptor calculates the LogP based on a simple equation using
the number of carbons and hetero atoms.
The implemented equation was proposed in Mannhold et al.
}
\examples{
smi = system.file('vignettedata/FDAMDD.smi', package = 'Rcpi')
\donttest{
mol = readMolFromSmi(smi, type = 'mol')
dat = extractDrugMannholdLogP(mol)
head(dat)}
}
\references{
Mannhold, R., Poda, G. I., Ostermann, C., & Tetko, I. V. (2009).
Calculation of molecular lipophilicity: State-of-the-art and
comparison of log P methods on more than 96,000 compounds.
Journal of pharmaceutical sciences, 98(3), 861-893.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/338-extractDrugPetitjeanNumber.R
\name{extractDrugPetitjeanNumber}
\alias{extractDrugPetitjeanNumber}
\title{Descriptor that Calculates the Petitjean Number of a Molecule}
\usage{
extractDrugPetitjeanNumber(molecules, silent = TRUE)
}
\arguments{
\item{molecules}{Parsed molucule object.}

\item{silent}{Logical. Whether the calculating process should be shown or not, default is \code{TRUE}.}
}
\value{
A data frame, each row represents one of the molecules,
each column represents one feature.
This function returns one column named \code{PetitjeanNumber}.
}
\description{
Descriptor that Calculates the Petitjean Number of a Molecule
}
\details{
This descriptor calculates the Petitjean number of a molecule.
According to the Petitjean definition, the eccentricity of a vertex
corresponds to the distance from that vertex to the most remote vertex
in the graph.

The distance is obtained from the distance matrix as the count of edges
between the two vertices. If \code{r(i)} is the largest matrix entry
in row \code{i} of the distance matrix \code{D}, then the radius is defined
as the smallest of the \code{r(i)}. The graph diameter \code{D} is defined as
the largest vertex eccentricity in the graph.
(\url{http://www.edusoft-lc.com/molconn/manuals/400/chaptwo.html})
}
\examples{
smi = system.file('vignettedata/FDAMDD.smi', package = 'Rcpi')
\donttest{
mol = readMolFromSmi(smi, type = 'mol')
dat = extractDrugPetitjeanNumber(mol)
head(dat)}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/504-readMolFromSmi.R
\name{readMolFromSmi}
\alias{readMolFromSmi}
\title{Read Molecules from SMILES Files and Return Parsed Java
Molecular Object or Plain Text List}
\usage{
readMolFromSmi(smifile, type = c("mol", "text"))
}
\arguments{
\item{smifile}{Character vector, containing SMILES file location(s).}

\item{type}{\code{'mol'} or \code{'text'}. \code{'mol'} returns parsed
Java molecular object, used for \code{'text'} returns (plain-text)
character string list. For common molecular descriptors and
fingerprints, use \code{'mol'}.
For descriptors and fingerprints calculated by OpenBabel,
i.e. functions named \code{extractDrugOB...()} , use \code{'text'}.}
}
\value{
A list, containing parsed Java molecular object or character strings.
}
\description{
Read Molecules from SMILES Files and Return Parsed Java
Molecular Object or Plain Text List
}
\details{
This function reads molecules from SMILES strings and return
parsed Java molecular object or plain text list
needed by \code{extractDrug...()} functions.
}
\examples{
smi = system.file('vignettedata/FDAMDD.smi', package = 'Rcpi')
\donttest{
mol1 = readMolFromSmi(smi, type = 'mol')
mol2 = readMolFromSmi(smi, type = 'text')}
}
\seealso{
See \code{\link{readMolFromSDF}} for reading molecules
from SDF files and returning parsed Java molecular object.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/316-extractDrugCarbonTypes.R
\name{extractDrugCarbonTypes}
\alias{extractDrugCarbonTypes}
\title{Topological Descriptor Characterizing the Carbon Connectivity
in Terms of Hybridization}
\usage{
extractDrugCarbonTypes(molecules, silent = TRUE)
}
\arguments{
\item{molecules}{Parsed molucule object.}

\item{silent}{Logical. Whether the calculating process
should be shown or not, default is \code{TRUE}.}
}
\value{
A data frame, each row represents one of the molecules,
each column represents one feature.
This function returns 9 columns named
\code{C1SP1}, \code{C2SP1}, \code{C1SP2}, \code{C2SP2}, \code{C3SP2},
\code{C1SP3}, \code{C2SP3}, \code{C3SP3} and \code{C4SP3}.
}
\description{
Topological Descriptor Characterizing the Carbon Connectivity
in Terms of Hybridization
}
\details{
Calculates the carbon connectivity in terms of hybridization.
The function calculates 9 descriptors in the following order:

\itemize{
\item \code{C1SP1} - triply hound carbon bound to one other carbon
\item \code{C2SP1} - triply bound carbon bound to two other carbons
\item \code{C1SP2} - doubly hound carbon bound to one other carbon
\item \code{C2SP2} - doubly bound carbon bound to two other carbons
\item \code{C3SP2} - doubly bound carbon bound to three other carbons
\item \code{C1SP3} - singly bound carbon bound to one other carbon
\item \code{C2SP3} - singly bound carbon bound to two other carbons
\item \code{C3SP3} - singly bound carbon bound to three other carbons
\item \code{C4SP3} - singly bound carbon bound to four other carbons
}
}
\examples{
smi = system.file('vignettedata/FDAMDD.smi', package = 'Rcpi')
\donttest{
mol = readMolFromSmi(smi, type = 'mol')
dat = extractDrugCarbonTypes(mol)
head(dat)}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/319-extractDrugChiPathCluster.R
\name{extractDrugChiPathCluster}
\alias{extractDrugChiPathCluster}
\title{Calculate the Kier and Hall Chi Path Cluster Indices of Orders 4, 5 and 6}
\usage{
extractDrugChiPathCluster(molecules, silent = TRUE)
}
\arguments{
\item{molecules}{Parsed molucule object.}

\item{silent}{Logical. Whether the calculating process
should be shown or not, default is \code{TRUE}.}
}
\value{
A data frame, each row represents one of the molecules,
each column represents one feature.
This function returns 6 columns named
\code{SPC.4}, \code{SPC.5}, \code{SPC.6},
\code{VPC.4}, \code{VPC.5}, \code{VPC.6}:
\itemize{
\item \code{SPC.4} - Simple path cluster, order 4
\item \code{SPC.5} - Simple path cluster, order 5
\item \code{SPC.6} - Simple path cluster, order 6
\item \code{VPC.4} - Valence path cluster, order 4
\item \code{VPC.5} - Valence path cluster, order 5
\item \code{VPC.6} - Valence path cluster, order 6
}
}
\description{
Calculate the Kier and Hall Chi Path Cluster Indices of Orders 4, 5 and 6
}
\details{
Evaluates chi path cluster descriptors.
The code currently evluates the simple and
valence chi chain descriptors of orders 4, 5 and 6.
It utilizes the graph isomorphism code of the CDK to find
fragments matching SMILES strings representing the fragments
corresponding to each type of chain.
}
\note{
These descriptors are calculated using graph isomorphism
      to identify the various fragments. As a result calculations may
      be slow. In addition, recent versions of Molconn-Z use simplified
      fragment definitions (i.e., rings without branches etc.)
      whereas these descriptors use the older more complex
      fragment definitions.
}
\examples{
smi = system.file('vignettedata/FDAMDD.smi', package = 'Rcpi')
\donttest{
mol = readMolFromSmi(smi, type = 'mol')
dat = extractDrugChiPathCluster(mol)
head(dat)}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/342-extractDrugTPSA.R
\name{extractDrugTPSA}
\alias{extractDrugTPSA}
\title{Descriptor of Topological Polar Surface Area Based on
Fragment Contributions (TPSA)}
\usage{
extractDrugTPSA(molecules, silent = TRUE)
}
\arguments{
\item{molecules}{Parsed molucule object.}

\item{silent}{Logical. Whether the calculating process
should be shown or not, default is \code{TRUE}.}
}
\value{
A data frame, each row represents one of the molecules,
each column represents one feature.
This function returns one column named \code{TopoPSA}.
}
\description{
Descriptor of Topological Polar Surface Area Based on
Fragment Contributions (TPSA)
}
\details{
Calculate the descriptor of topological polar surface area
based on fragment contributions (TPSA).
}
\examples{
smi = system.file('vignettedata/FDAMDD.smi', package = 'Rcpi')
\donttest{
mol = readMolFromSmi(smi, type = 'mol')
dat = extractDrugTPSA(mol)
head(dat)}
}
\references{
Ertl, P., Rohde, B., & Selzer, P. (2000).
Fast calculation of molecular polar surface area as a sum of
fragment-based contributions and its application to the prediction
of drug transport properties.
Journal of medicinal chemistry, 43(20), 3714-3717.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/101-getDrugPubChem.R
\name{getSmiFromPubChem}
\alias{getSmiFromPubChem}
\title{Retrieve Drug Molecules in SMILES Format from the PubChem Database}
\usage{
getSmiFromPubChem(id, parallel = 5)
}
\arguments{
\item{id}{A character vector, as the PubChem drug ID.}

\item{parallel}{An integer, the parallel parameter, indicates how many
processes the user would like to use for retrieving
the data (using RCurl), default is \code{5}.
For regular cases, we recommend a number less than \code{20}.}
}
\value{
A length of \code{id} character vector,
each element containing the corresponding drug molecule.
}
\description{
Retrieve Drug Molecules in SMILES Format from the PubChem Database
}
\details{
This function retrieves drug molecules in SMILES format from
the PubChem database.
}
\examples{
id = c('7847562', '7847563')  # Penicillamine
\donttest{
getSmiFromPubChem(id)}
}
\seealso{
See \code{\link{getMolFromPubChem}} for retrieving drug molecules
in MOL format from the PubChem database.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/318-extractDrugChiCluster.R
\name{extractDrugChiCluster}
\alias{extractDrugChiCluster}
\title{Evaluates the Kier and Hall Chi cluster indices of orders 3, 4, 5 and 6}
\usage{
extractDrugChiCluster(molecules, silent = TRUE)
}
\arguments{
\item{molecules}{Parsed molucule object.}

\item{silent}{Logical. Whether the calculating process
should be shown or not, default is \code{TRUE}.}
}
\value{
A data frame, each row represents one of the molecules,
each column represents one feature.
This function returns 8 columns,
the order and names of the columns returned is:
\itemize{
\item SC.3 - Simple cluster, order 3
\item SC.4 - Simple cluster, order 4
\item SC.5 - Simple cluster, order 5
\item SC.6 - Simple cluster, order 6
\item VC.3 - Valence cluster, order 3
\item VC.4 - Valence cluster, order 4
\item VC.5 - Valence cluster, order 5
\item VC.6 - Valence cluster, order 6
}
}
\description{
Evaluates the Kier and Hall Chi cluster indices of orders 3, 4, 5 and 6
}
\details{
Evaluates chi cluster descriptors.
It utilizes the graph isomorphism code of the CDK
to find fragments matching SMILES strings
representing the fragments corresponding to each type of chain.
}
\note{
These descriptors are calculated using graph isomorphism to identify
the various fragments. As a result calculations may be slow.
In addition, recent versions of Molconn-Z use simplified fragment
definitions (i.e., rings without branches etc.)
whereas these descriptors use the older more complex fragment definitions.
}
\examples{
smi = system.file('vignettedata/FDAMDD.smi', package = 'Rcpi')
\donttest{
mol = readMolFromSmi(smi, type = 'mol')
dat = extractDrugChiCluster(mol)
head(dat)}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/321-extractDrugECI.R
\name{extractDrugECI}
\alias{extractDrugECI}
\title{Calculate the Eccentric Connectivity Index Descriptor}
\usage{
extractDrugECI(molecules, silent = TRUE)
}
\arguments{
\item{molecules}{Parsed molucule object.}

\item{silent}{Logical. Whether the calculating process
should be shown or not, default is \code{TRUE}.}
}
\value{
A data frame, each row represents one of the molecules,
each column represents one feature.
This function returns one column named \code{ECCEN}.
}
\description{
Calculate the Eccentric Connectivity Index Descriptor
}
\details{
Eccentric Connectivity Index (ECI) is a topological descriptor combining
distance and adjacency information. This descriptor is described by Sharma et al.
and has been shown to correlate well with a number of physical properties.
The descriptor is also reported to have good discriminatory ability.
The eccentric connectivity index for a hydrogen supressed molecular graph
is given by
\deqn{x_i^c = \sum_{i = 1}^{n} E(i) V(i)}
where E(i) is the eccentricity of the i-th atom
(path length from the i-th atom to the atom farthest from it)
and V(i) is the vertex degree of the i-th atom.
}
\examples{
smi = system.file('vignettedata/FDAMDD.smi', package = 'Rcpi')
\donttest{
mol = readMolFromSmi(smi, type = 'mol')
dat = extractDrugECI(mol)
head(dat)}
}
\references{
Sharma, V. and Goswami, R. and Madan, A.K. (1997),
Eccentric Connectivity Index: A Novel Highly Discriminating
Topological Descriptor for Structure-Property and Structure-Activity Studies,
Journal of Chemical Information and Computer Sciences, 37:273-282
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/502-readPDB.R
\name{readPDB}
\alias{readPDB}
\title{Read Protein Sequences in PDB Format}
\usage{
readPDB(file = system.file("protseq/4HHB.pdb", package = "Rcpi"))
}
\arguments{
\item{file}{The name of the file which the sequences in PDB format are
to be read from. If it does not contain an absolute or
relative path, the file name is relative to the current
working directory, \code{\link{getwd}}.
The default here is to read the \code{4HHB.PDB} file which
is present in the \code{protseq} directory of the Rcpi package.}
}
\value{
A character vector, representing the amino acid sequence
of the single-letter code.
}
\description{
Read Protein Sequences in PDB Format
}
\details{
This function reads protein sequences in PDB (Protein Data Bank) format,
and return the amino acid sequences represented by single-letter code.
}
\examples{
Seq4HHB = readPDB(system.file('protseq/4HHB.pdb', package = 'Rcpi'))
Seq4HHB
}
\references{
Protein Data Bank Contents Guide: Atomic Coordinate Entry Format Description,
Version 3.30. Accessed 2013-06-26.
\url{https://files.wwpdb.org/pub/pdb/doc/format_descriptions/Format_v33_Letter.pdf}
}
\seealso{
See \code{\link{readFASTA}} for reading protein sequences
in FASTA format.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Rcpi-datalist.R
\docType{data}
\name{AAPAM40}
\alias{AAPAM40}
\title{PAM40 Matrix for 20 Amino Acids}
\value{
AAPAM40 data
}
\description{
PAM40 Matrix for 20 Amino Acids
}
\details{
PAM40 Matrix for the 20 amino acids. The matrix was extracted from the
\code{Biostrings} package of Bioconductor.
}
\examples{
data(AAPAM40)

}
\keyword{AAPAM40}
\keyword{PAM}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/347-extractDrugWeightedPath.R
\name{extractDrugWeightedPath}
\alias{extractDrugWeightedPath}
\title{Descriptor that Calculates the Weighted Path (Molecular ID)}
\usage{
extractDrugWeightedPath(molecules, silent = TRUE)
}
\arguments{
\item{molecules}{Parsed molucule object.}

\item{silent}{Logical. Whether the calculating process
should be shown or not, default is \code{TRUE}.}
}
\value{
A data frame, each row represents one of the molecules,
each column represents one feature.
This function returns 5 columns named
\code{WTPT.1}, \code{WTPT.2}, \code{WTPT.3}, \code{WTPT.4}, \code{WTPT.5}:
\itemize{
\item \code{WTPT.1} - molecular ID
\item \code{WTPT.2} - molecular ID / number of atoms
\item \code{WTPT.3} - sum of path lengths starting from heteroatoms
\item \code{WTPT.4} - sum of path lengths starting from oxygens
\item \code{WTPT.5} - sum of path lengths starting from nitrogens
}
}
\description{
Descriptor that Calculates the Weighted Path (Molecular ID)
}
\details{
This descriptor calculates the weighted path (molecular ID)
described by Randic, characterizing molecular branching.
Five descriptors are calculated, based on the implementation in the ADAPT
software package. Note that the descriptor is based on identifying all paths
between pairs of atoms and so is NP-hard.
This means that it can take some time for large, complex molecules.
}
\examples{
smi = system.file('vignettedata/FDAMDD.smi', package = 'Rcpi')
\donttest{
mol = readMolFromSmi(smi, type = 'mol')
dat = extractDrugWeightedPath(mol)
head(dat)}
}
\references{
Randic, M., On molecular identification numbers (1984).
Journal of Chemical Information and Computer Science, 24:164-175.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Rcpi-datalist.R
\docType{data}
\name{AABLOSUM45}
\alias{AABLOSUM45}
\title{BLOSUM45 Matrix for 20 Amino Acids}
\value{
AABLOSUM45 data
}
\description{
BLOSUM45 Matrix for 20 Amino Acids
}
\details{
BLOSUM45 Matrix for the 20 amino acids. The matrix was extracted from the
\code{Biostrings} package of Bioconductor.
}
\examples{
data(AABLOSUM45)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/310-extractDrugAutocorrelationPolarizability.R
\name{extractDrugAutocorrelationPolarizability}
\alias{extractDrugAutocorrelationPolarizability}
\title{Calculate the Moreau-Broto Autocorrelation Descriptors using Polarizability}
\usage{
extractDrugAutocorrelationPolarizability(molecules, silent = TRUE)
}
\arguments{
\item{molecules}{Parsed molucule object.}

\item{silent}{Logical. Whether the calculating process
should be shown or not, default is \code{TRUE}.}
}
\value{
A data frame, each row represents one of the molecules,
each column represents one feature. This function returns 5 columns named
\code{ATSp1}, \code{ATSp2}, \code{ATSp3}, \code{ATSp4}, \code{ATSp5}.
}
\description{
Calculate the Moreau-Broto Autocorrelation Descriptors using Polarizability
}
\details{
Calculates the ATS autocorrelation descriptor using polarizability.
}
\examples{
smi = system.file('vignettedata/FDAMDD.smi', package = 'Rcpi')
\donttest{
mol = readMolFromSmi(smi, type = 'mol')
dat = extractDrugAutocorrelationPolarizability(mol)
head(dat)}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Rcpi-datalist.R
\docType{data}
\name{AATopoChg}
\alias{AATopoChg}
\title{Topological Charge Indices Descriptors for 20 Amino Acids
calculated by Dragon}
\value{
AATopoChg data
}
\description{
Topological Charge Indices Descriptors for 20 Amino Acids
calculated by Dragon
}
\details{
This dataset includes the topological charge indices descriptors of
the 20 amino acids calculated by Dragon (version 5.4)
used for scales extraction in this package.
}
\examples{
data(AATopoChg)

}
\keyword{AATopoChg}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/384-extractDrugDescOB.R
\name{extractDrugDescOB}
\alias{extractDrugDescOB}
\title{Calculate Molecular Descriptors Provided by OpenBabel}
\usage{
extractDrugDescOB(molecules, type = c("smile", "sdf"))
}
\arguments{
\item{molecules}{R character string object containing the molecules.
See the example section for details.}

\item{type}{\code{'smile'} or \code{'sdf'}.}
}
\value{
A data frame, each row represents one of the molecules,
each column represents one descriptor.
This function returns 14 columns named
\code{abonds}, \code{atoms}, \code{bonds}, \code{dbonds},
\code{HBA1}, \code{HBA2}, \code{HBD}, \code{logP},
\code{MR}, \code{MW}, \code{nF}, \code{sbonds}, \code{tbonds}, \code{TPSA}:
        \itemize{
        \item \code{abonds} - Number of aromatic bonds
        \item \code{atoms} - Number of atoms
        \item \code{bonds} - Number of bonds
        \item \code{dbonds} - Number of double bonds
        \item \code{HBA1} - Number of Hydrogen Bond Acceptors 1
        \item \code{HBA2} - Number of Hydrogen Bond Acceptors 2
        \item \code{HBD} - Number of Hydrogen Bond Donors
        \item \code{logP} - Octanol/Water Partition Coefficient
        \item \code{MR} - Molar Refractivity
        \item \code{MW} - Molecular Weight Filter
        \item \code{nF} - Number of Fluorine Atoms
        \item \code{sbonds} - Number of single bonds
        \item \code{tbonds} - Number of triple bonds
        \item \code{TPSA} - Topological Polar Surface Area
        }
}
\description{
Calculate Molecular Descriptors Provided by OpenBabel
}
\details{
This function calculates 14 types of the \emph{numerical}
molecular descriptors provided in OpenBabel.
}
\examples{
mol1 = 'CC(=O)NCCC1=CNc2c1cc(OC)cc2'  # one molecule SMILE in a vector
mol2 = c('OCCc1c(C)[n+](=cs1)Cc2cnc(C)nc(N)2',
         'CCc(c1)ccc2[n+]1ccc3c2Nc4c3cccc4',
         '[Cu+2].[O-]S(=O)(=O)[O-]')  # multiple SMILEs in a vector
mol3 = readChar(system.file('compseq/DB00860.sdf', package = 'Rcpi'),
                nchars = 1e+6)  # single molecule in a sdf file
mol4 = readChar(system.file('sysdata/OptAA3d.sdf', package = 'Rcpi'),
                nchars = 1e+6)  # multiple molecules in a sdf file

\dontrun{
smidesc0 = extractDrugDescOB(mol1, type = 'smile')
smidesc1 = extractDrugDescOB(mol2, type = 'smile')
sdfdesc0 = extractDrugDescOB(mol3, type = 'sdf')
sdfdesc1 = extractDrugDescOB(mol4, type = 'sdf')}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/324-extractDrugGravitationalIndex.R
\name{extractDrugGravitationalIndex}
\alias{extractDrugGravitationalIndex}
\title{Descriptor Characterizing the Mass Distribution of the Molecule.}
\usage{
extractDrugGravitationalIndex(molecules, silent = TRUE)
}
\arguments{
\item{molecules}{Parsed molucule object.}

\item{silent}{Logical. Whether the calculating process
should be shown or not, default is \code{TRUE}.}
}
\value{
A data frame, each row represents one of the molecules,
each column represents one feature.
This function returns 9 columns:
\itemize{
\item \code{GRAV.1} - gravitational index of heavy atoms
\item \code{GRAV.2} - square root of gravitational index of heavy atoms
\item \code{GRAV.3} - cube root of gravitational index of heavy atoms
\item \code{GRAVH.1} - gravitational index - hydrogens included
\item \code{GRAVH.2} - square root of hydrogen-included gravitational index
\item \code{GRAVH.3} - cube root of hydrogen-included gravitational index
\item \code{GRAV.4} - grav1 for all pairs of atoms (not just bonded pairs)
\item \code{GRAV.5} - grav2 for all pairs of atoms (not just bonded pairs)
\item \code{GRAV.6} - grav3 for all pairs of atoms (not just bonded pairs)
}
}
\description{
Descriptor Characterizing the Mass Distribution of the Molecule.
}
\details{
Descriptor characterizing the mass distribution of the molecule described by
Katritzky et al. For modelling purposes the value of the descriptor is
calculated both with and without H atoms.
Furthermore the square and cube roots of the descriptor
are also generated as described by Wessel et al.
}
\examples{
sdf = system.file('sysdata/OptAA3d.sdf', package = 'Rcpi')
\donttest{
mol = readMolFromSDF(sdf)
dat = extractDrugGravitationalIndex(mol)
head(dat)}
}
\references{
Katritzky, A.R. and Mu, L. and Lobanov, V.S. and Karelson, M.,
Correlation of Boiling Points With Molecular Structure.
1. A Training Set of 298 Diverse Organics and a
Test Set of 9 Simple Inorganics,
J. Phys. Chem., 1996, 100:10400-10407.

Wessel, M.D. and Jurs, P.C. and Tolan, J.W. and Muskal, S.M. ,
Prediction of Human Intestinal Absorption of Drug Compounds
From Molecular Structure,
Journal of Chemical Information and Computer Sciences, 1998, 38:726-735.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/309-extractDrugAutocorrelationMass.R
\name{extractDrugAutocorrelationMass}
\alias{extractDrugAutocorrelationMass}
\title{Calculate the Moreau-Broto Autocorrelation Descriptors using Atomic Weight}
\usage{
extractDrugAutocorrelationMass(molecules, silent = TRUE)
}
\arguments{
\item{molecules}{Parsed molucule object.}

\item{silent}{Logical. Whether the calculating process
should be shown or not, default is \code{TRUE}.}
}
\value{
A data frame, each row represents one of the molecules,
each column represents one feature. This function returns 5 columns named
\code{ATSm1}, \code{ATSm2}, \code{ATSm3}, \code{ATSm4}, \code{ATSm5}.
}
\description{
Calculate the Moreau-Broto Autocorrelation Descriptors using Atomic Weight
}
\details{
Calculates the ATS autocorrelation descriptor,
where the weight equal to the scaled atomic mass.
}
\examples{
smi = system.file('vignettedata/FDAMDD.smi', package = 'Rcpi')
\donttest{
mol = readMolFromSmi(smi, type = 'mol')
dat = extractDrugAutocorrelationMass(mol)
head(dat)}
}
\references{
Moreau, Gilles, and Pierre Broto.
The autocorrelation of a topological structure: a new molecular descriptor.
Nouv. J. Chim 4 (1980): 359-360.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/106-getDrug.R
\name{getDrug}
\alias{getDrug}
\title{Retrieve Drug Molecules in MOL and SMILES Format from Databases}
\usage{
getDrug(
  id,
  from = c("pubchem", "chembl", "cas", "kegg", "drugbank"),
  type = c("mol", "smile"),
  parallel = 5
)
}
\arguments{
\item{id}{A character vector, as the drug ID(s).}

\item{from}{The database, one of \code{'pubchem'}, \code{'chembl'},
\code{'cas'}, \code{'kegg'}, \code{'drugbank'}.}

\item{type}{The returned molecule format, \code{mol} or \code{smile}.}

\item{parallel}{An integer, the parallel parameter, indicates how many
process the user would like to use for retrieving
the data (using RCurl), default is \code{5}.
For regular cases, we recommend a number less than \code{20}.}
}
\value{
A length of \code{id} character vector,
each element containing the corresponding drug molecule.
}
\description{
Retrieve Drug Molecules in MOL and SMILES Format from Databases
}
\details{
This function retrieves drug molecules in MOL and SMILES format from
five databases.
}
\examples{
id = c('DB00859', 'DB00860')
\donttest{
getDrug(id, 'drugbank', 'smile')}
}
\seealso{
See \code{\link{getProt}} for retrieving protein sequences
from three databases.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Rcpi-datalist.R
\docType{data}
\name{AAMOE3D}
\alias{AAMOE3D}
\title{3D Descriptors for 20 Amino Acids calculated by MOE 2011.10}
\value{
AAMOE3D data
}
\description{
3D Descriptors for 20 Amino Acids calculated by MOE 2011.10
}
\details{
This dataset includes the 3D descriptors of the 20 amino acids
calculated by MOE 2011.10 used for scales extraction in this package.
All amino acid molecules had also been optimized with MOE (semiempirical AM1)
before calculating these 3D descriptors.
The SDF file containing the information of the optimized amino acid molecules
is included in this package. See \code{\link{OptAA3d}} for more information.
}
\examples{
data(AAMOE3D)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/506-checkProt.R
\name{checkProt}
\alias{checkProt}
\title{Check if the protein sequence's amino acid types are the 20 default types}
\usage{
checkProt(x)
}
\arguments{
\item{x}{A character vector, as the input protein sequence.}
}
\value{
Logical. \code{TRUE} if all of the amino acid types of the sequence
        are within the 20 default types.
}
\description{
Check if the protein sequence's amino acid types are the 20 default types
}
\details{
This function checks if the protein sequence's amino acid types are
the 20 default types.
}
\examples{
x = readFASTA(system.file('protseq/P00750.fasta', package = 'Rcpi'))[[1]]
checkProt(x)  # TRUE
checkProt(paste(x, 'Z', sep = ''))  # FALSE
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/203-getProtRCSBPDB.R
\name{getPDBFromRCSBPDB}
\alias{getPDBFromRCSBPDB}
\title{Retrieve Protein Sequence in PDB Format from RCSB PDB}
\usage{
getPDBFromRCSBPDB(id, parallel = 5)
}
\arguments{
\item{id}{A character vector, as the protein ID.}

\item{parallel}{An integer, the parallel parameter, indicates how many
process the user would like to use for retrieving
the data (using RCurl), default is \code{5}.
For regular cases, we recommend a number less than \code{20}.}
}
\value{
A list, each component contains one of the protein sequences
in PDB format.
}
\description{
Retrieve Protein Sequence in PDB Format from RCSB PDB
}
\details{
This function retrieves protein sequences in PDB format from RCSB PDB.
}
\examples{
id = c('4HHB', '4FF9')
\donttest{
getPDBFromRCSBPDB(id)}
}
\seealso{
See \code{\link{getSeqFromRCSBPDB}} for retrieving protein
represented by amino acid sequence from the RCSB PDB database.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/601-getCPI.R
\name{getCPI}
\alias{getCPI}
\title{Generating Compound-Protein Interaction Descriptors}
\usage{
getCPI(drugmat, protmat, type = c("combine", "tensorprod"))
}
\arguments{
\item{drugmat}{The compound descriptor matrix.}

\item{protmat}{The protein descriptor matrix.}

\item{type}{The interaction type, one or two of
\code{"combine"} and \code{"tensorprod"}.}
}
\value{
A matrix containing the compound-protein interaction descriptors
}
\description{
Generating Compound-Protein Interaction Descriptors
}
\details{
This function calculates the compound-protein interaction descriptors
by three types of interaction:
\itemize{
\item \code{combine} - combine the two descriptor matrix,
result has \code{(p1 + p2)} columns
\item \code{tensorprod} - calculate column-by-column
(pseudo)-tensor product type interactions, result has
\code{(p1 * p2)} columns
}
}
\examples{
x = matrix(1:10, ncol = 2)
y = matrix(1:15, ncol = 3)

getCPI(x, y, 'combine')
getCPI(x, y, 'tensorprod')
getCPI(x, y, type = c('combine', 'tensorprod'))
getCPI(x, y, type = c('tensorprod', 'combine'))

}
\seealso{
See \code{\link{getPPI}} for generating
protein-protein interaction descriptors.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/503-readMolFromSDF.R
\name{readMolFromSDF}
\alias{readMolFromSDF}
\title{Read Molecules from SDF Files and Return Parsed Java Molecular Object}
\usage{
readMolFromSDF(sdffile)
}
\arguments{
\item{sdffile}{Character vector, containing SDF file location(s).}
}
\value{
A list, containing parsed Java molecular object.
}
\description{
Read Molecules from SDF Files and Return Parsed Java Molecular Object
}
\details{
This function reads molecules from SDF files and return
parsed Java molecular object needed by \code{extractDrug...} functions.
}
\examples{
sdf  = system.file('compseq/DB00859.sdf', package = 'Rcpi')
sdfs = c(system.file('compseq/DB00859.sdf', package = 'Rcpi'),
         system.file('compseq/DB00860.sdf', package = 'Rcpi'))
\donttest{
mol  = readMolFromSDF(sdf)
mols = readMolFromSDF(sdfs)}
}
\seealso{
See \code{\link{readMolFromSmi}} for reading molecules by SMILES
string and returning parsed Java molecular object.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/401-extractProtAAC.R
\name{extractProtAAC}
\alias{extractProtAAC}
\title{Amino Acid Composition Descriptor}
\usage{
extractProtAAC(x)
}
\arguments{
\item{x}{A character vector, as the input protein sequence.}
}
\value{
A length 20 named vector
}
\description{
Amino Acid Composition Descriptor
}
\details{
This function calculates the Amino Acid Composition descriptor (Dim: 20).
}
\examples{
x = readFASTA(system.file('protseq/P00750.fasta', package = 'Rcpi'))[[1]]
extractProtAAC(x)

}
\references{
M. Bhasin, G. P. S. Raghava.
Classification of Nuclear Receptors Based on
Amino Acid Composition and Dipeptide Composition.
\emph{Journal of Biological Chemistry}, 2004, 279, 23262.
}
\seealso{
See \code{\link{extractProtDC}} and \code{\link{extractProtTC}}
         for Dipeptide Composition and Tripeptide Composition descriptors.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/325-extractDrugHBondAcceptorCount.R
\name{extractDrugHBondAcceptorCount}
\alias{extractDrugHBondAcceptorCount}
\title{Number of Hydrogen Bond Acceptors}
\usage{
extractDrugHBondAcceptorCount(molecules, silent = TRUE)
}
\arguments{
\item{molecules}{Parsed molucule object.}

\item{silent}{Logical. Whether the calculating process
should be shown or not, default is \code{TRUE}.}
}
\value{
A data frame, each row represents one of the molecules,
each column represents one feature.
This function returns one column named \code{nHBAcc}.
}
\description{
Number of Hydrogen Bond Acceptors
}
\details{
This descriptor calculates the number of hydrogen bond acceptors
using a slightly simplified version of the PHACIR atom types.
The following groups are counted as hydrogen bond acceptors:
any oxygen where the formal charge of the oxygen is
non-positive (i.e. formal charge <= 0) except
\enumerate{
\item an aromatic ether oxygen (i.e. an ether oxygen that is
adjacent to at least one aromatic carbon)
\item an oxygen that is adjacent to a nitrogen
}
and any nitrogen where the formal charge of the nitrogen is
non-positive (i.e. formal charge <= 0) except a nitrogen
that is adjacent to an oxygen.
}
\examples{
smi = system.file('vignettedata/FDAMDD.smi', package = 'Rcpi')
\donttest{
mol = readMolFromSmi(smi, type = 'mol')
dat = extractDrugHBondAcceptorCount(mol)
head(dat)}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/317-extractDrugChiChain.R
\name{extractDrugChiChain}
\alias{extractDrugChiChain}
\title{Calculate the Kier and Hall Chi Chain Indices of Orders 3, 4, 5, 6 and 7}
\usage{
extractDrugChiChain(molecules, silent = TRUE)
}
\arguments{
\item{molecules}{Parsed molucule object.}

\item{silent}{Logical. Whether the calculating process
should be shown or not, default is \code{TRUE}.}
}
\value{
A data frame, each row represents one of the molecules,
each column represents one feature.
This function returns 10 columns, in the following order:
\itemize{
\item \code{SCH.3} - Simple chain, order 3
\item \code{SCH.4} - Simple chain, order 4
\item \code{SCH.5} - Simple chain, order 5
\item \code{SCH.6} - Simple chain, order 6
\item \code{SCH.7} - Simple chain, order 7
\item \code{VCH.3} - Valence chain, order 3
\item \code{VCH.4} - Valence chain, order 4
\item \code{VCH.5} - Valence chain, order 5
\item \code{VCH.6} - Valence chain, order 6
\item \code{VCH.7} - Valence chain, order 7
}
}
\description{
Calculate the Kier and Hall Chi Chain Indices of Orders 3, 4, 5, 6 and 7
}
\details{
Evaluates chi chain descriptors.
The code currently evluates the simple and valence chi chain descriptors
of orders 3, 4, 5, 6 and 7.
It utilizes the graph isomorphism code of the CDK to find fragments matching
SMILES strings representing the fragments corresponding to each type of chain.
}
\note{
These descriptors are calculated using graph isomorphism to identify
the various fragments. As a result calculations may be slow. In addition,
recent versions of Molconn-Z use simplified fragment definitions
(i.e., rings without branches etc.) whereas these descriptors use
the older more complex fragment definitions.
}
\examples{
smi = system.file('vignettedata/FDAMDD.smi', package = 'Rcpi')
\donttest{
mol = readMolFromSmi(smi, type = 'mol')
dat = extractDrugChiChain(mol)
head(dat)}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/202-getProtKEGG.R
\name{getFASTAFromKEGG}
\alias{getFASTAFromKEGG}
\title{Retrieve Protein Sequence in FASTA Format from the KEGG Database}
\usage{
getFASTAFromKEGG(id, parallel = 5)
}
\arguments{
\item{id}{A character vector, as the protein ID.}

\item{parallel}{An integer, the parallel parameter, indicates how many
process the user would like to use for retrieving
the data (using RCurl), default is \code{5}.
For regular cases, we recommend a number less than \code{20}.}
}
\value{
A list, each component contains one of the protein sequences
in FASTA format.
}
\description{
Retrieve Protein Sequence in FASTA Format from the KEGG Database
}
\details{
This function retrieves protein sequences in FASTA format
from the KEGG database.
}
\examples{
id = c('hsa:10161', 'hsa:10162')
\donttest{
getFASTAFromKEGG(id)}
}
\seealso{
See \code{\link{getSeqFromKEGG}} for retrieving protein
represented by amino acid sequence from the KEGG database.
See \code{\link{readFASTA}} for reading FASTA format files.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/419-extractPCMMDSScales.R
\name{extractPCMMDSScales}
\alias{extractPCMMDSScales}
\title{Generalized Scales-Based Descriptors derived by Multidimensional Scaling}
\usage{
extractPCMMDSScales(x, propmat, k, lag, scale = TRUE, silent = TRUE)
}
\arguments{
\item{x}{A character vector, as the input protein sequence.}

\item{propmat}{A matrix containing the properties for the amino acids.
Each row represent one amino acid type, each column represents
one property.
Note that the one-letter row names must be provided for we
need them to seek the properties for each AA type.}

\item{k}{Integer. The maximum dimension of the space which the data
are to be represented in.
Must be no greater than the number of AA properties provided.}

\item{lag}{The lag parameter. Must be less than the amino acids.}

\item{scale}{Logical. Should we auto-scale the property matrix
(\code{propmat}) before doing MDS? Default is \code{TRUE}.}

\item{silent}{Logical. Whether we print the \code{k} eigenvalues
computed during the scaling process or not.
Default is \code{TRUE}.}
}
\value{
A length \code{lag * p^2} named vector,
        \code{p} is the number of scales (dimensionality) selected.
}
\description{
Generalized Scales-Based Descriptors derived by Multidimensional Scaling
}
\details{
This function calculates the generalized scales-based descriptors
derived by Multidimensional Scaling (MDS).
Users could provide customized amino acid property matrices.
}
\examples{
x = readFASTA(system.file('protseq/P00750.fasta', package = 'Rcpi'))[[1]]
data(AATopo)
tprops = AATopo[, c(37:41, 43:47)]  # select a set of topological descriptors
mds = extractPCMMDSScales(x, propmat = tprops, k = 5, lag = 7, silent = FALSE)

}
\references{
Venkatarajan, M. S., & Braun, W. (2001).
New quantitative descriptors of amino acids based on multidimensional scaling
of a large number of physical-chemical properties.
Molecular modeling annual, 7(12), 445--453.
}
\seealso{
See \code{\link{extractPCMScales}} for generalized scales-based
descriptors derived by Principal Components Analysis.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/304-extractDrugAminoAcidCount.R
\name{extractDrugAminoAcidCount}
\alias{extractDrugAminoAcidCount}
\title{Calculate the Number of Amino Acids Descriptor}
\usage{
extractDrugAminoAcidCount(molecules, silent = TRUE)
}
\arguments{
\item{molecules}{Parsed molucule object.}

\item{silent}{Logical. Whether the calculating process
should be shown or not, default is \code{TRUE}.}
}
\value{
A data frame, each row represents one of the molecules,
each column represents one feature.
This function returns 20 columns named
\code{nA}, \code{nR}, \code{nN}, \code{nD}, \code{nC},
\code{nF}, \code{nQ}, \code{nE}, \code{nG}, \code{nH},
\code{nI}, \code{nP}, \code{nL} \code{nK}, \code{nM},
\code{nS}, \code{nT}, \code{nY} \code{nV}, \code{nW}.
}
\description{
Calculate the Number of Amino Acids Descriptor
}
\details{
Calculates the number of each amino acids (total 20 types)
found in the molecues.
}
\examples{
smi = system.file('vignettedata/FDAMDD.smi', package = 'Rcpi')
\donttest{
mol = readMolFromSmi(smi, type = 'mol')
dat = extractDrugAminoAcidCount(mol)
head(dat)}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/705-searchDrug.R
\name{searchDrug}
\alias{searchDrug}
\title{Parallelized Drug Molecule Similarity Search by
Molecular Fingerprints Similarity or Maximum Common Substructure Search}
\usage{
searchDrug(
  mol,
  moldb,
  cores = 2,
  method = c("fp", "mcs"),
  fptype = c("standard", "extended", "graph", "hybrid", "maccs", "estate", "pubchem",
    "kr", "shortestpath", "fp2", "fp3", "fp4", "obmaccs"),
  fpsim = c("tanimoto", "euclidean", "cosine", "dice", "hamming"),
  mcssim = c("tanimoto", "overlap"),
  ...
)
}
\arguments{
\item{mol}{The query molecule. The location of a \code{sdf} file
containing one molecule.}

\item{moldb}{The molecule database. The location of a \code{sdf} file
containing all the molecules to be searched with.}

\item{cores}{Integer. The number of CPU cores to use for parallel search,
default is \code{2}. Users could use the \code{detectCores()} function
in the \code{parallel} package to see how many cores they could use.}

\item{method}{\code{'fp'} or \code{'mcs'}. Search by molecular fingerprints
or by maximum common substructure searching.}

\item{fptype}{The fingerprint type, only available when \code{method = 'fp'}.
Rcpi supports 13 types of fingerprints, including
\code{'standard'}, \code{'extended'}, \code{'graph'},
\code{'hybrid'}, \code{'maccs'}, \code{'estate'},
\code{'pubchem'}, \code{'kr'}, \code{'shortestpath'},
\code{'fp2'}, \code{'fp3'}, \code{'fp4'}, \code{'obmaccs'}.}

\item{fpsim}{Similarity measure type for fingerprint,
only available when \code{method = 'fp'}.
Including \code{'tanimoto'}, \code{'euclidean'},
\code{'cosine'}, \code{'dice'} and \code{'hamming'}.
See \code{calcDrugFPSim} for details.}

\item{mcssim}{Similarity measure type for maximum common substructure search,
only available when \code{method = 'mcs'}.
Including \code{'tanimoto'} and \code{'overlap'}.}

\item{...}{Other possible parameter for maximum common substructure search,
see \code{calcDrugMCSSim} for available options.}
}
\value{
Named numerical vector.
With the decreasing similarity value of the molecules in the database.
}
\description{
Parallelized Drug Molecule Similarity Search by
Molecular Fingerprints Similarity or Maximum Common Substructure Search
}
\details{
This function does compound similarity search derived by
various molecular fingerprints with various similarity measures or
derived by maximum common substructure search.
This function runs for a query compound against a set of molecules.
}
\examples{
mol = system.file('compseq/DB00530.sdf', package = 'Rcpi')
# DrugBank ID DB00530: Erlotinib
moldb = system.file('compseq/tyrphostin.sdf', package = 'Rcpi')
# Database composed by searching 'tyrphostin' in PubChem and filtered by Lipinski's Rule of Five
\donttest{
searchDrug(mol, moldb, cores = 4, method = 'fp', fptype = 'maccs', fpsim = 'hamming')
searchDrug(mol, moldb, cores = 4, method = 'fp', fptype = 'fp2', fpsim = 'tanimoto')
searchDrug(mol, moldb, cores = 4, method = 'mcs', mcssim = 'tanimoto')}
}
